procedure cancen(image, xin, yin)

string  image = "ngc3034j004_I"	 {prompt="Input image"}
real	xin   = 300. 	 {prompt="X coordinate of a star in Input image"}
real	yin   = 300.	 {prompt="Y coordinate of a star in Input image"}
real	xout  = 300. 	 {prompt="X centroid of the star in Input image"}
real	yout  = 300.	 {prompt="Y centroid of the star in Input image"}
string  shifil= ""	 {prompt="XY shift file [shi=ref-in]"}
bool	checkmag = no    {prompt="Check the magnitude difference?"}
real	refmag= 10.	 {prompt="Magnitude of the reference star"}
real	difmag= 1.0	 {prompt="Maximum difference in magnitudes"}
bool	verbose  = yes {prompt="Verbose output?"}
int     boxsize  = 7    {prompt="imcentroid boxsize"}
int     bigbox   = 11    {prompt="imcentroid bigbox"}
real    step     = 0.30  {prompt="Step size of boxsize and bigbox"}
int     niter    = 6     {prompt="Maximum number of imcentroid iterations"}
bool	cfound   = no    {prompt="Centroid found?"}

begin
	string infili, coofil, coofil2, magfil, shift
	real	x0, y0, starmag, refemag, tolmag, fstep
	int	nlin, nword, iter, maxit, boxs, bigb
	bool	check, found, verb

	infil = image; x0 = xin; y0 = yin; shift = shifil 
	check = checkmag; refemag=refmag; tolmag=difmag; verb = verbose
	boxs = boxsize; bigb = bigbox; maxit = niter; fstep = 1.0 + step
	magfil = "cancen_temp1.mag"
	coofil = "cancen_temp1.coo"
	coofil2 = "cancen_temp2.coo"
        delete(coofil, ver-, >& "dev$null")
        #delete(coofil2, ver-, >& "dev$null")

	found = no; iter = 0
	print (x0, y0, > coofil)
	while (!found && iter < maxit) {
        delete(coofil2, ver-, >& "dev$null")
	iter = iter + 1
	bigb = 2*nint((fstep*real(bigb))/2.0) + 1
	boxs = 2*nint((fstep*real(boxs))/2.0) + 1
	#bigb = fstep*bigb  #(1.0 + real(iter-1)*0.1)*bigb
	#boxs = fstep*boxs  #(1.0 + real(iter-1)*0.1)*boxs
	imcentroid (infil, refere="", coord=coofil, shifts=shift, boxsize=boxs, bigbox=bigb, verbos+, >> coofil2)
	type (coofil2) | wc | scan (nlin, nword)
	if (nlin > 1 && nword > 7) {found = yes}
	#print (iter, boxs, bigb, found, " ",nlin, nword)
	}
	if (found) {
          delete(magfil, ver-, >& "dev$null")
          delete(coofil, ver-, >& "dev$null")
	  fields (coofil2, field="2,4", line=2, >> coofil) 

	starmag = refemag + 2.0*tolmag
phot (infil, "", coords=coofil, output=magfil, plotfile="",
scale=1.0, fwhmpsf=5.0, epadu=10.0, readnoise=3.0, filter="FILTER2",
exposur="", airmass="", xairmas=1.0, itime=1.0, salgorithm="median",
annulus =20, dannulus =10, cbox=5, calgorithm="centroid",
apertures="15", zmag=20, interactive=no, radplots=no,
verify=no, update=no, verbose=yes, graphics="stdgraph", display="stdimage",
icommands="", gcommands="") | fields (field=5) | scan(starmag)
	if (check && abs(starmag - refemag) > tolmag) {
		delete(coofil, ver-, >& "dev$null"); print (x0, y0, > coofil)
		found = no
		}
		}
	if (!found) {print ("Centroid not found at ", x0, y0, " in image ", infil)}
	#type(coofil)
	type(coofil) | scan(x0, y0)
	cancen.xout = x0; cancen.yout = y0
	if (verb && found) {
	print ("Centroid found at ", x0, y0, " in image ", infil, " with del_mag=",abs(starmag - refemag))}
	if (!check && found) {cancen.refmag = starmag}
	cfound = found

end
