procedure canmos(root, imbeg, imend)

string  root     = "can"             {prompt="Root Image Name"}
int     imbeg    = 1                 {prompt="First Image Number"}
int     imend    = 6                 {prompt="Last Image Number"}
string	ofile    = "default"         {prompt="Output Image Name (default=root_imbeg_imend)"}
string  datadir  = "FFdata/"         {prompt="Data Directory"}
bool    centroid = yes               {prompt="Find centroids in images?"}
int     iref     = 1                 {prompt="ref star image number"}
bool    disp     = yes               {prompt="Display before imcombine? "}
int     idisp    = 1                 {prompt="Display Frame No [1-4] o 0 for cycle thru all"}
bool    immos    = yes               {prompt="Mosaic the images?"}
bool    dophot   = yes               {prompt="Do photometry?"}
real    boxsize  = 25              {prompt="imalign boxsize"}
real    bigbox   = 25             {prompt="imalign bigbox"}
#string  jhkzp    = "20.60 20.40 20.20"   {prompt="JHK Zeropoints"}
string  suffix   = ".fits"              {prompt="Image ending name (after the numbers)"}

begin
	string  froot, suffix1, coofil, refim, shiftfil, mosfil, cm[99], cmn, cmd[99]
        string  tmpobjsfa, tmpxxx, tmpalb, ans, xyfil, ddir
	real	exptime, xref, yref, xin, yin, xdif, ydif
	int	n1, n2, ntv, itv, n, iref0, nim
        bool    find_centroid

	suffix1 = suffix; ddir = datadir
	froot = root; n1 = imbeg; n2=imend
	ntv = idisp; itv = ntv
	find_centroid = centroid
	mosfil = ofile
	if (mosfil == "default") {mosfil = froot//"_"//str(n1)//"_"//str(n2)}

	coofil = froot//"_canmos_imexam.log"
	shiftfil = "canmos_shiftfil.coo"
	xyfil = "canmos_shiftfil.xy"
        tmpobjsfa = "tmpobjsfa"   
        tmpxxx = "tmpala"   
        tmpalb = "tmpalb"   
	delete (shiftfil, ver-, >& "dev$null")
	delete (tmpobjsfa, ver-, >& "dev$null")
	delete (tmpxxx, ver-, >& "dev$null")
	delete (tmpalb, ver-, >& "dev$null")

        	n = 0
          for (i=n1; i <= n2; i +=1) {
                n = n + 1
                cmn = froot//str(i)
                if (i < 1000) cmn = froot//"0"//str(i)
                if (i < 100) cmn = froot//"00"//str(i)
                if (i < 10) cmn = froot//"000"//str(i)
                cmd[n] = ddir//cmn
                cm[n] = cmn
                #print("0.0   0.0", >> shiftfil)
		}

        if (disp) {
	delete (coofil, ver-, >& "dev$null")
	print("Displaying images for identifying reference star --- ")
	print("-----to write xy pixels of a star, put the cursor on a star and type a ")
	print("-----to quit, type q ")
          ans = "yes"
        	n = 0
          for (i=n1; i <= n2; i +=1) {
		n = n + 1
                if (ntv == 0){itv = mod(i,4)};if (itv == 0){itv = 4}
                display (cmd[n]//suffix1, itv, zs+, fill+)
                imexam (logfile=coofil, keeplog+, wcs="logical")

        print ("Is the image ",cmd[n]//suffix1, " OK? [yes,no] [",ans,"] ")
            scan (ans)
            #if (ans=="no") {
                #imdelete(cmd[n]//suffix1, ver-, >& "dev$null")
            #    } else {
            if (ans=="yes") {
                print(ddir//cm[n],  >> tmpobjsfa)
                print(cm[n]//"_a",  >> tmpxxx)
                print(cm[n]//"_a.mag.1",  >> tmpalb)
            }   #ans==no endif
            }   #end for for all objects

        #delete (tmpobjsf, ver-, >& "dev$null")
        #tmpobjsf = tmpobjsfa

        } else {
	n = 0
          for (i=n1; i <= n2; i +=1) {
                n = n + 1
                print(ddir//cm[n],  >> tmpobjsfa)
                print(cm[n]//"_a",  >> tmpxxx)
                print(cm[n]//"_a.mag.1",  >> tmpalb)
		}
          } #end display

        #---------------------------------------------------------------
        #Combine step 2: align the images
        #---------------------------------------------------------------

	iref0  = iref; refim = cm[iref0] 
        print("Aligning images ")
        #type (tmpobjsf)

        #type (shiftfil)

        imdelete("@"//tmpxxx, ver-, >& "dev$null")

        delete("imalign.log", ver-, >& "dev$null")

        delete (xyfil, ver-, >& "dev$null")
	fields (coofil, fields="1-2") | fields (fields="1-2", line=1, > xyfil)
	type (xyfil)

	fields (coofil, fields="1-2") | wc | scan (nim)
	fields (coofil, fields="1-2") | fields (fields="1-2", line=1) | scan (xref, yref)

          for (i=1; i <= nim; i +=1) {
	fields (coofil, fields="1-2") | fields (fields="1-2", line=i) | scan (xin, yin)
	  xdif = xref - xin; ydif = yref - yin
	  print (xdif, " ", ydif, >> shiftfil)
	  }

cimalign ("@"//tmpobjsfa, refim, xyfil, "@"//tmpxxx, find_centroid,
shifts=shiftfil, boxsize=boxsize, bigbox=bigbox, negative=no, background=INDEF,
lower=INDEF, upper=INDEF, niterate=3, tolerance=0, shiftimages=yes,
interp_type="linear", boundary_typ="constant", consta=0., trimimages=no,
verbose=yes, list="")

#       type ("imalign.log") | cat >> froot//"-canica.log"

        imdelete(mosfil, ver-, >& "dev$null")

        #---------------------------------------------------------------
        #Combine step 3: align the images
        #---------------------------------------------------------------

 if (immos) { 
        print("Combining the aligned images ")
        type (tmpal)

#imcombine ("@"//tmpal, mosfil, combine="median", zero="median", logfile=logfil)
imcombine ("@"//tmpxxx, mosfil, combine="average", scale="none", zero="median", reject="minmax", nlow=1, nhigh=1)

        #imdelete("@"//tmpobjsf, ver-, >& "dev$null")
#}
        print(mosfil,  >> tmpxxx)
        print(mosfil//".mag.1",  >> tmpalb)
        delete (tmpobjsf, ver-, >& "dev$null")

	 }

#------------------------------------------------------------------------
#       Do photometry of the reference star(s) is asked to do so
#------------------------------------------------------------------------


if (dophot) {
        print("Doing aperture photometry on aligned images")
        delete ("@"//tmpalb, ver-, >& "dev$null")
        exptime = 1.0
        #if (ra_key == "RA") exptime=cexptime    #New version with total counts


phot ("@"//tmpxxx, "", coords=xyfil, output="@"//tmpalb, plotfile="",
scale=1.0, fwhmpsf=5.0, epadu=10.0, readnoise=3.0, filter="FILTER2",
exposur="", airmass="", xairmas=1.0, itime=exptime, salgorithm="median",
annulus =20, dannulus =10, cbox=5, calgorithm="centroid",
apertures="5,10,14,17,20", zmag=20.0, wcsin="logical", interactive=no, radplots=no,
verify=no, update=no, verbose=no, graphics="stdgraph", display="stdimage",
icommands="", gcommands="")

} #phot

txdump ("@"//tmpalb, "MERR[4],MAG[2-5],XCEN,YCEN,IFIL,IMAGE",
"ID=1", headers=no, parameters=yes)

end

