procedure canphot(image, coolist)

#the image should have WCS information (run cancalib before)
#DO differential photometry of stars in a list
#Star coordinates can be in radec or xy. 
#The first star in the list is considered as REFERENCE for differential photometry.
#Second star is the "object". Subsequent stars are taken as control stars
#The output differential magnitude is written with a time stamp, suitable for plotting light curves
#
string  image  	= "sHa3141"            {prompt="Image Name"}
string  coolist = "canphot.coo"        {prompt="List containing xy or radec of stars to find photometry"}
string  listtyp = "radec"              {prompt="Type of the List"}
string  raunits = "hours"         	{prompt="Units of RA in coolist [hours/degrees] "}
#string  dbfile  = "ccmap.db"           {prompt="Database file containing the xy to radec system"}
string  resfile = "canphot.res"        {prompt="Output file containing data of light-curves"}
string  fitsext = ".fits"               {prompt="Extensions of fits file [.fits]"}
real    zeromag = 0.0                  {prompt="Zeropoint"}

begin
	string  imfil, catfil, cootyp, c1, regfil, filt, creg,cid[999], c2, c3, c4
	string  daomag,photmag,photcoo, cref, obsdate, filthd, raobj,decobj,jd
	string	tsections1, tsections2, tcname, tcoords, imfiltemp, canres, dbfil
	string  eqtoxy, photcoo1, raunit, filnam[99]
	real	zpmag, fwhmpsf, refmag, difmag, exptime, nadd, efftime,xin,yin
	real	magobj, xobj,yobj,magctrl_1,magctrl_2,magctrl_3, magcor
        #real    raref,decref,xin,yin,mag_dif,exptime, nadd, refmag, jkcol, jhcol, raddist
	int     itv, nx, ny, nimages, i2, i1, len, i3
	bool	disp
        struct  line

	imfiltemp = image; 
	catfil = coolist; cootyp = listtyp
	zpmag = zeromag
	disp = yes; itv = 1
	dbfil = "ccmap.db"  #dbfile; 
	canres = resfile       #"canphot.log"
	raunit = raunits
	if (raunit != "hours") {raunit = "native"}
	eqtoxy = "skyxy"     #"cctran"

        tsections1 = mktemp ("tmps1")
        tsections2 = mktemp ("tmps2")

	sections (imfiltemp,  option="fullname", > tsections1)
        nimages = sections.nimages
	print(nimages)
	#see wregister.cl for the use of "sections" and "file" commands

	list = tsections1
	for (i = 1; i <= nimages; i = i + 1) {
	i2 = fscan(list, imfil) 
	filnam[i] = imfil
	}

	for (i = 1; i <= nimages; i = i + 1) {
	c1 = fitsext
	imfil = filnam[i]  
	#len = strlen(imfil); i1 = strlstr(".fits",imfil) 
	i1 = strlstr(c1,imfil); if (i1 > 0) {imfil = substr(imfil,1,i1-1)}
	#print (len,i1,imfil)
        photcoo1 = imfil//"_phot1.coo"; delete(photcoo1, ver-, >& "dev$null")
        photcoo = imfil//"_phot.coo"; delete(photcoo, ver-, >& "dev$null")
	hselect (imfil, "i_naxis1, i_naxis2, EXPTIME, FILTER2, DATE-OBS, COADDS", yes) | scan (nx, ny, exptime, filthd, obsdate, nadd)
	len = strlen(obsdate); c3 = substr(obsdate,len,len); c4 = substr(obsdate,len-1,len)
        c2 = obsdate; delete("cmds.tempjd", ver-, >& "dev$null")
	i1 = strlstr("-",obsdate); len = strlen(obsdate); i2 = strlstr("T",obsdate)
	if (i1 == 7) {c2 = substr(obsdate,1,5); c1=substr(obsdate,6,len); c2=c2//"0"//c1}
	if (i2-i1 == 2) {c1=substr(c2,9,len); c2=substr(c2,1,8); c2=c2//"0"//c1}
	obsdate = c2
	len = strlen(obsdate); if (len==18) {obsdate=obsdate//c3}; if (len==17) {obsdate=obsdate//c4}
	#print (i1, " ", i2, " ", len, " ", c2, obsdate )
	c2 = 'jd = julday ("'//obsdate//'")'
	print(c2, > "cmds.tempjd")
	asthedit (imfil, "cmds.tempjd", table="", colname="", verbose-)
	hselect (imfil, "jd", yes) | scan (jd)
	#print("Julian Date=",jd)
        c1 = substr(obsdate,1,4); 
	if (int(c1) < 2005) {nadd = 1; exptime = 1.0}


        if (filthd == "1"){filt = "J"} else if (filthd == "2") {filt = "H"} else if (filthd == "3") {filt = "K"} else {filt = "X"} 
        efftime = exptime*real(nadd)
        #print("Image size in ",imfil," is =",nx, ny, exptime, nadd, filthd,"=",filt, " ", obsdate)
        #inmag[i3] = apmag + 2.5*log10(efftime)

	list = catfil
	for (j=1; j <= 1; j +=1) { 
	i2 = fscan(list,raobj,decobj) 
	}
        #txdump (catfil, "RA DEC", "ID=2", headers-, paramet-) | scan (raobj,decobj)
	
#cctran Ha_6568_BB_ccmap.res forward- xco=3 ycol=4
if (eqtoxy == "cctran") {
cctran (catfil, photcoo, dbfil,
imfil, geometry="geometric", forward=no,
xref=INDEF, yref=INDEF, xmag=INDEF, ymag=INDEF, xrotation=INDEF,
yrotation=INDEF, lngref=INDEF, latref=INDEF, lngunits="", latunits="",
projection="tan", xcolumn=1, ycolumn=2, lngformat="", latformat="",
min_sigdigit=7)
} else {
	#raunit = "hours"
#skyxymatch sHa3141a sHa3141 test4 coords=canphot.coo xunits=hours
skyxymatch (imfil, imfil, photcoo1, coords=catfil, xmin=INDEF, xmax=INDEF, ymin=INDEF,
ymax=INDEF, nx=10, ny=10, wcs="world", xcolumn=1, ycolumn=2, xunits=raunit,
yunits="", xformat="%10.3f", yformat="%10.3f", rwxformat="", rwyformat="",
wxformat="", wyformat="", min_sigdigit=7, verbose=no)

        i3 = 0
        list = photcoo1
        for (j=1; j <= 18; j +=1) { i3 = fscan(list,line) }
        while( fscan(list,line) != EOF ) {
        i3 = fscan(line,xin,yin)
	print (xin, yin, >> photcoo)
	}
        delete(photcoo1, ver-, >& "dev$null")
}

        photmag = imfil//"_phot.mag"; delete(photmag, ver-, >& "dev$null")
        daomag = imfil//"_dao.mag";   delete(daomag, ver-, >& "dev$null")
   
	fwhmpsf = 5.5
        phot (imfil, skyfile="", coords=photcoo, output=photmag, plotfile="",
                scale=1.0, fwhmpsf=fwhmpsf, epadu=10.0, readnoise=3.0, filter="FILTER2",
                exposur="", airmass="", xairmas=1.0, itime=1.0, salgorithm="median",
                annulus =20, dannulus =10, cbox=5, calgorithm="centroid",
                apertures="5,10,14,17,20", zmag=zpmag, interactive=no, radplots=no,
                verify=no, update=no, verbose=no, graphics="stdgraph", display="stdimage",
                icommands="", gcommands="")
        #txdump (photmag, "MAG[3],MAG[5]", "ID=1", headers-, paramet-) | scan (refmag,magcor)
        txdump (photmag, "MAG[3],MAG[5]", "ID=2", headers-, paramet-) | scan (refmag,magcor)
	magcor = magcor - refmag 
	cref = "MAG[3]-"//str(refmag)
	pcalc (photmag, "MAG[5]", cref)
        txdump (photmag, "XCENTER YCENTER MAG[3]  ID", "MAG[3]!=INDEF", headers-, paramet-, >> daomag)
        #txdump (photmag, "MAG[3] MAG[5] XCENTER YCENTER", "ID=2", headers-, paramet-) | scan (magobj,difmag,xobj,yobj)
        txdump (photmag, "MAG[3] MAG[5] XCENTER YCENTER", "ID=1", headers-, paramet-) | scan (magobj,difmag,xobj,yobj)
        txdump (photmag, "MAG[5]", "ID=3", headers-, paramet-) | scan (magctrl_1)
        txdump (photmag, "MAG[5]", "ID=4", headers-, paramet-) | scan (magctrl_2)
        txdump (photmag, "MAG[5]", "ID=5", headers-, paramet-) | scan (magctrl_3)
	#print ("==================================================")
	magobj = magobj + magcor
	print (imfil," DATE=", obsdate, " JD=", jd, " Reference_MAG=", refmag, " DIF_MAG=",difmag, " Mag_cor=",magcor)
	#print (magobj, difmag, obsdate, " ",xobj,yobj,raobj," ",decobj," ",magctrl_1,magctrl_2,magctrl_3)  #," ",magcon)
	print (jd," ", magobj, difmag, " ",magctrl_1,magctrl_2,magctrl_3," ", filt, " ", obsdate, " ",xobj,yobj,raobj," ",decobj, " ",imfil, >> canres) 

        itv = 1
        if (disp){
                display (imfil, itv, zs+, fill+, >& "dev$null")
                tvmark (itv, daomag, mark="circle", radii=10, number+, nxoff=3, nyoff=3, txsize=2)
                }
	}
        delete (tsections1, go_ahead+, verify-, default_action+, allversions+, subfiles+, > "dev$null")
        #delete (tsections2, go_ahead+, verify-, default_action+, allversions+, subfiles+, > "dev$null")

end


