procedure canslide(infile, ofile)

string  infile   = "as40k"      {prompt="Input Image"}
string  ofile    = "as40k_md"   {prompt="Output Image"}
real    window1  = 55           {prompt="Size of the first sliding window[55]"}
real    window2  = 33           {prompt="Size of the second sliding window[33]"}
real    ksigma   = 3            {prompt="Clipping factor in rms units [3]"}

begin
	string	filein, fileout, tfile1, tfile2, tfile3
	real	win1, win2, median, rms, nsig, lrej

	filein = infile
	fileout = ofile
	tfile1 = "ttemp1"; tfile2 = "ttemp2"; tfile3 = "ttemp3"
	#win1 = 55; win2=33; nsig = 3.0
	win1 = window1; win2=window2; nsig = ksigma

	imdelete(fileout, ver-, >& "dev$null")
	imdelete(tfile1, ver-, >& "dev$null")
	imdelete(tfile2, ver-, >& "dev$null")
	imdelete(tfile3, ver-, >& "dev$null")

	median (filein, tfile1, win1, 1, zloreject=INDEF, zhireject=INDEF, 
	boundary="nearest", constant=0., verbose=yes)

	#Now you subtract the two:
	imarith (filein, "-", tfile1, tfile2, title="", divzero=0., 
        hparams="", pixtype="", calctype="", verbose=no, noact=no) 

	#Now do the same, but in the Y direction, to data1:
	median (tfile2, tfile3, 1, win1, zloreject=INDEF, zhireject=INDEF, 
	boundary="nearest", constant=0., verbose=yes)

	#Now you subtract the two:
	imdelete(tfile1, ver-, >& "dev$null")
	imarith (tfile2, "-", tfile3, tfile1, title="", divzero=0., 
	hparams="", pixtype="", calctype="", verbose=no, noact=no)

	imstat (tfile1, fields="midpt, stddev", format-, nclip=3, lsigma=3., usigma=3. ) | scan (median, rms)
	lrej = nsig*rms
	print ("Median +/- rms = ",median,rms)

	imdelete(tfile2, ver-, >& "dev$null")
	median (tfile1, tfile2, win2, 1, zloreject=-lrej, zhireject=lrej, 
	boundary="nearest", constant=0., verbose=yes)

	imdelete(tfile3, ver-, >& "dev$null")
	imarith (tfile1, "-", tfile2, tfile3, title="", divzero=0., 
	hparams="", pixtype="", calctype="", verbose=no, noact=no)


	imdelete(tfile1, ver-, >& "dev$null")
	median (tfile3, tfile1, 1, win2, zloreject=-lrej, zhireject=lrej, 
	boundary="nearest", constant=0., verbose=yes)

	imarith (tfile3, "-", tfile1, fileout, title="", divzero=0., 
	hparams="", pixtype="", calctype="", verbose=no, noact=no)

	imdelete(tfile1, ver-, >& "dev$null")
	imdelete(tfile2, ver-, >& "dev$null")
	imdelete(tfile3, ver-, >& "dev$null")

end

