procedure asym(gal, tele, gausg)

string  gal                            {prompt="NGC Number   "}
string  tele = "lowell"                {prompt="Telescope (lowell|palomar)"}
real    gausg = 1.0                   {prompt="Sigma of smoothing Gaussian"}
string  dir    = "/home/ydm/data/"     {prompt="fits data dir "}
real    bsize  = 7.0                   {prompt="Imalign boxsize"}
bool    repcen = "no"              {prompt="Neglect Center while computing A?"}
bool    clean  = "yes"                 {prompt="Delete all intermediate files?"}

begin

string ngc,tel, fitsfil,input,tit,filt[3],beg, sec 
string im1, tarfil, repsec
real   x0, y0, fwhm, xm, ym, skyval, bg, gausig, xmag
int    n1, n2, nm1, nm2, nfil, ifil, dx, dy
bool   del


	dx = 0.0
	ngc = gal
	tel = tele
	gausig = gausg
	del = clean
		beg  = "l"
		filt[1] = "J"
		filt[2] = "R"
		nfil = 2
	if (tel=="palomar"){
		beg  = "p"
		filt[1] = "g"
		filt[2] = "r"
		filt[3] = "i"
		nfil = 3
	}
	tarfil = dir//tel//".fits.tar"
	ifil = 0
start:
	ifil = ifil + 1
	print("Analysing ",filt[ifil], " band image of NGC", ngc)
	#fitsfil = dir//beg//"_n"//ngc//"_"//filt[ifil]//"_1.fits"
	fitsfil = beg//"_n"//ngc//"_"//filt[ifil]//"_1.fits"
	rtar "-xvf"//" "//tarfil//" "//fitsfil
	input  = beg//ngc//filt[ifil]

         imdelete (input, ver-, >& "dev$null") 

       rfits (fits_fil=fitsfil, iraf_fil=input)  
	
         delete (fitsfil, ver-, >& "dev$null") 

       #display (input, inum, zs-, xmag=1.0,ymag=1.0) 

imgets (input, "i_naxis1")
n1 = int(imgets.value)
imgets (input, "i_naxis2")
n2 = int(imgets.value)
        fwhm = 2.0
imgets (input, "G_CENT_X")
x0 = real(imgets.value)
imgets (input, "G_CENT_Y")
y0 = real(imgets.value)
imgets (input, "SKY")
skyval = real(imgets.value)

	imarith (input, "-", skyval, input, title=" ")

nm1 = (n1 + 1)/2
nm2 = (n2 + 1)/2

print(input, " x0=", x0, " y0=", y0, " NX=", n1, " NY=", n2)
print(input, " XM=", nm1, " YM=", nm2, " FWHM=", fwhm, " SKY=", skyval)

       #imexam

xm = nm1 - x0
ym = nm2 - y0  

        delete ("asym.coo", ver-, >& "dev$null") 
	print(nm1,nm2) | cat > "asym.coo"
        delete ("asym.shi", ver-, >& "dev$null") 
	print(xm, ym) | cat > "asym.shi"

         imdelete (input//"gau", ver-, >& "dev$null") 

mkgauss (input//"gau",n1, n2, nm1, nm2, 
1., 0., 0., fwhm, fwhm, 0., seed=347951)

         imdelete ("rg"//input, ver-, >& "dev$null") 

imalign (input, "asym.coo", input//"gau", 
shifts="asym.shi", prefix="rg", shiftimages=yes,
trimimages=yes, verbose=no, boxsize=bsize, bigbox=11, negative=no,
background=INDEF, lower=INDEF, upper=INDEF, niterate=3, tolerance=0,
interp_type="spline3", boundary_typ="reflect", constant=0., list="")

         imdelete (input, ver-, >& "dev$null") 

if (gausig != 0.0) {
gauss ("rg"//input, input, gausig, ratio=1., theta=0., nsigma=4., bilinear=yes, boundary="nearest",
constant=0.)
} else {

	 imcopy ("rg"//input, input)
}

	xmag = 500.0/n1
	print("xmag = ",xmag)
        display (input, ifil, zs-, xmag=xmag, ymag=xmag, ztrans="log") 
	if (ifil > 1)print("Image Section to sum is ", sec)
	#print("Choose the cut-off value and Image Section to sum")
	print("Choose the cut-off value ")
	imexam (logfile="asym-imexam.log", keeplog=yes)
	scan(bg)
	#imexam
	if (ifil == 1){
	#print("Select the image section for summing [x1:x2,y1:y2]")
	#scan(sec)
	print("Select the box size for summing [half box size]")
	scan(dy) 
sec = "["//str(nm1-dy)//":"//str(nm1+dy)//","//str(nm2-dy)//":"//str(nm2+dy)//"]"
	}

         imdelete (input//"_0", ver-, >& "dev$null") 

imexpr.a = input
imexpr.z = bg
print("Replace all pixels in Image a with values < z by 0")
imexpr ("(a < z) ? 0 : a", input//"_0", ver-) 

if (repcen) {

	if (ifil == 1){
print("Select the size of the central square box (half side)")
scan(dx) 
	}

if (dx > 0){
repsec = "["//str(nm1-dx)//":"//str(nm1+dx)//","//str(nm2-dx)//":"//str(nm2+dx)//"]"
print("Replace section: ", repsec)
imreplace (input//"_0"//repsec, 0., imaginary=0., lower=INDEF, upper=INDEF)
}
}


         imdelete (input//"_180", ver-, >& "dev$null") 

rotate (input//"_0", input//"_180", 
180., xin=INDEF, yin=INDEF, xout=INDEF, yout=INDEF,
ncols=INDEF, nlines=INDEF, interpolant="linear", boundary="nearest",
constant=0., nxblock=256, nyblock=256)

         imdelete (input//"_n", ver-, >& "dev$null") 

imexpr.a = input//"_0"//sec
imexpr.b = input//"_180"//sec
print("Numerator: 0.5*(a-b)**2")
imexpr ("0.5*(a-b)**2", input//"_n", ver-) 

         imdelete (input//"_d", ver-, >& "dev$null") 

print("Denominator: a**2")
imexpr ("a**2", input//"_d", ver-)

	#xmag = 2.0*xmag
       display (input//"_n", 4, zs-, xmag=xmag, ymag=xmag, ztrans="log") 

#imstat (input//"_n", fields="image,npix,mean,stddev,min,max,midpt")
print("Sum of Numerator")
imexpr.a = input//"_n"
imexpr ("sum(a)", input//"_t1", ver-)
imcopy (input//"_t1[1:1,*]", input//"_t2", ver-)
#imexpr.a = input//"_t2"
#imexpr ("sum(a)", input//"_t3")
#imstat (input//"_t3", fields="image,npix,mean,stddev,min,max,midpt")

print("Sum of Denominator")
imexpr.a = input//"_d"
imexpr ("sum(a)", input//"_t4", ver-)
imcopy (input//"_t4[1:1,*]", input//"_t5", ver-)
#imexpr.a = input//"_t5"
#imexpr ("sum(a)", input//"_t6")

print("Sqrt(a/b)")
imexpr.a = input//"_t2"
imexpr.b = input//"_t5"
imexpr ("sqrt(sum(a)/sum(b))", input//"_t7", ver-)

imstat (input//"_t7", fields="image,npix,mean", 
lower=INDEF, upper=INDEF, binwidth=0.1, format=yes)

print (input//sec, " ", n1, " x ", n2, "SKY=", sky,"Cut-off=",bg, "Gau_Sig=", gausig, "DX=", dx) | cat >> "asym.sum"

if  (ifil == 1) im1 = input//"_t7"
if (ifil > 1)im1 = im1//","//input//"_t7"

         imdelete ("rg"//input, ver-, >& "dev$null") 
         imdelete (input//"gau", ver-, >& "dev$null") 

if (ifil < nfil)goto start

imstat (im1, fields="image,npix,mean", 
lower=INDEF, upper=INDEF, binwidth=0.1, format=yes) | cat >> "asym.sum"
#lower=INDEF, upper=INDEF, binwidth=0.1, format=yes) | cat >> beg//ngc//".sum"

         #imdelete (input//"_t*", ver-, >& "dev$null") 
for (i=1; i<=nfil; i +=1){
         imdelete (beg//ngc//filt[i]//"_t*", ver-, >& "dev$null") 
         if (del)imdelete (beg//ngc//filt[i]//"_*", ver-, >& "dev$null") 
}
print(" **** DONE **** ")

end

