procedure asym_par(intfil, resfil)

string  intfil = "bmod_176J"      {prompt="Intensity File Name (output of bmodel) "}
string  resfil = "residual_176J"      {prompt="Residual File Name"}
real	low_int=0.12	{prompt="Lower limit of image in image counts"}
real	hi_int=1.0	{prompt="Higher limit of image in image counts"}
real	int_bin=0.12	{prompt="Intensity bin size"}
real	rms   =0.12	{prompt="rms of image"}
real	krms  =3.0	{prompt="kclip in units of sigma"}
real	zerop =20.7	{prompt="Zeropoint of image"}
real	scale =0.85	{prompt="Image scale arc/pix"}
string	outfil= "asym_par.dat"  {prompt="Output asymmetry File"}

begin
        string file1, file2, comm1, datfil
	real	int1, int2, sig3, mu1, mu2, zp, iso_flux_tot, tot_res_frac, res_flux_tot
	real	iso_area, res_area , res_frac, npix, mean, dint
	int	nbin
	real	res_area_cumul, iso_area_cumul, res_frac_cumul, res_sb, sb_norm
	real	res_flux_cumul, iso_flux_cumul, frac_flux_cumul, res_sb_cumul

	file1 = intfil; file2 = resfil; datfil = outfil
	int1 = hi_int; int2 = low_int; dint=int_bin; sig3 = krms*rms
	zp = zerop + 5.0*log10(scale); nbin=(int1-int2)/dint
	#int1 = 1900.0; int2 = 100.0; sig3 = 3.0*5.0; dint=100.; nbin=(int1-int2)/dint
	#dint = (int1 - int2)/nbin; zp = 22.0
	
	#printf ("%g %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.3f %8.2f %8.3f \n", 
	#print ("BIN    INT1    INT2   mu1    mu2   TOT_A  RES_A Frac_A   TOT_F  RES_F Frac_F  Cum_A  Cum_F   SB   SB_CUM")

	iso_area_cumul = 0.0; res_area_cumul = 0.0
	res_flux_cumul = 0.0; iso_flux_cumul = 0.0
	int1 = int1 + dint
	delete (datfil, ver-, >& "dev$null")
	print ("#BIN   INT1    INT2   mu1    mu2   TOT_A  RES_A Frac_A   TOT_F  RES_F Frac_F  Cum_A  Cum_F   SB   SB_CUM", >> datfil)
	for (i = 1; i <= nbin; i = i + 1) {
	imdelete ("tttttt1", ver-, >& "dev$null")
	imdelete ("tttttt2", ver-, >& "dev$null")
	imdelete ("tttttt3", ver-, >& "dev$null")
	imdelete ("tttttt4", ver-, >& "dev$null")

	int1 = int1 - dint; int2 = int1 - dint
	mu1 = -2.5*log10(int1) + zp; mu2 = -2.5*log10(int2) + zp
	comm1 = "(a>"//str(int2)//" && a <"//str(int1)//") ? 1 : 0"
	imexpr (comm1, "tttttt1", file1, verb-)
	imstat ("tttttt1", fields="npix, mean") | fields (fields="1-2") | scan(npix, mean)
	iso_area = npix*mean
	iso_area_cumul = iso_area_cumul + iso_area
	comm1 = "(a>"//str(int2)//" && a <"//str(int1)//" && b >"//str(sig3)//") ? 1 : 0"
	#print (comm1, npix, mean, iso_area)
	imexpr (comm1, "tttttt2", file1, file2, verb-)
	imstat ("tttttt2", fields="npix,mean") | fields (fields="1-2") | scan(npix, mean)
	res_area = npix*mean
	res_area_cumul = res_area_cumul + res_area
	res_frac_cumul = res_area_cumul/iso_area_cumul
	res_frac = res_area/iso_area
	imexpr("(a*b)", "tttttt3", file1, "tttttt1", verb-)
	imexpr("(a*b)", "tttttt4", file2, "tttttt2", verb-)
	imstat ("tttttt3", fields="npix, mean") | fields (fields="1-2") | scan(npix, mean)
	iso_flux_tot = npix*mean
	imstat ("tttttt4", fields="npix, mean") | fields (fields="1-2") | scan(npix, mean)
	res_flux_tot = npix*mean
	tot_res_frac = res_flux_tot/iso_flux_tot
	res_flux_cumul = res_flux_cumul + res_flux_tot
	iso_flux_cumul = iso_flux_cumul + iso_flux_tot
	frac_flux_cumul = res_flux_cumul/iso_flux_cumul
	res_sb = res_flux_tot/res_area
	res_sb_cumul = res_flux_cumul/res_area_cumul
	#imexpr("(a*b/(c*d))", "tttttt3", file2, "tttttt2", file1, "tttttt1")
	#print (i," ",int1, int2, mu1, mu2, iso_area, res_area , res_frac)
	#print (i," ",int1, int2, mu1, mu2, iso_area, res_area , res_frac, iso_flux_tot, tot_res_frac)
	#printf ("%3.0f %7.2f %7.2f %6.2f %6.2f %6.0f %6.0f %6.2f %7.1f %6.1f %6.2f %6.2f %6.2f %6.2f %6.2f\n", i,int1, int2, mu1, mu2, iso_area, res_area , res_frac, iso_flux_tot, res_flux_tot, tot_res_frac, res_frac_cumul, frac_flux_cumul, res_sb, res_sb_cumul)
	printf ("%3.0f %7.2f %7.2f %6.2f %6.2f %6.0f %6.0f %6.2f %7.1f %6.1f %6.2f %6.2f %6.2f %6.2f %6.2f\n", i,int1, int2, mu1, mu2, iso_area, res_area , res_frac, iso_flux_tot, res_flux_tot, tot_res_frac, res_frac_cumul, frac_flux_cumul, res_sb, res_sb_cumul, >> datfil)
	#printf ("%g %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f %8.3f %8.2f %8.3f %8.3f %8.3f\n", i,int1, int2, mu1, mu2, iso_area, res_area , res_frac, iso_flux_tot, tot_res_frac, res_frac_cumul, frac_flux_cumul, >> datfil)
	}
	int1 = int2 + nbin*dint
	mu1 = -2.5*log10(int1) + zp; mu2 = -2.5*log10(int2) + zp
	sb_norm = res_sb_cumul/(iso_flux_cumul/iso_area_cumul)
	#print ("BIN    INT1    INT2   mu1    mu2   TOT_A  RES_A Frac_A   TOT_F  RES_F Frac_F  Cum_A  Cum_F   SB   SB_CUM")
	print ("#                                                                             -----  #####        ******", >> datfil)
	print ("#Global quantities", >> datfil   )
	printf ("#%3.0f %7.2f %7.2f %6.2f %6.2f %6.0f %6.0f %6.2f %7.1f %6.1f %6.2f %6.2f\n", 0,int1, int2, mu1, mu2, iso_area_cumul, res_area_cumul, res_frac_cumul, iso_flux_cumul, res_flux_cumul, frac_flux_cumul, res_sb_cumul, >> datfil)
	print ("#Summary", >> datfil)
	printf ("#Fraction of asymmetric pixels  = %6.2f\n", res_frac_cumul, >> datfil)
	printf ("#Fraction of asymmetric flux    = %6.2f\n", frac_flux_cumul, >> datfil)
	printf ("#Mean brightness of asymmetric pixels = %6.2f\n", res_sb_cumul, >> datfil)
	printf ("#Normalized brightness of asymmetric pixels = %6.2f\n", sb_norm, >> datfil)
	print ("#--------------------------------------------------------------------------")
	#print(res_area_cumul, iso_area_cumul, res_frac_cumul)
	type (datfil) #| cut   #//" -c2-120"
	fields (datfil, fields="5,8") | graph (xlab="mag/arcsec2", ylab="Area assymetry index")
	fields (datfil, fields="5,12") | graph (app+, ltype=2, color=1)
	fields (datfil, fields="5,11") | graph (app+, ltype=1, color=2)
	fields (datfil, fields="5,13") | graph (app+, ltype=2, color=2)

end
