#-----------------------------------------------------------------------
#       Author: ydm@inaoep.mx            Last modified: Nov 2000
#-----------------------------------------------------------------------
procedure contsub(lfile, cfile, linesky, contsky, Arbyh)

string  lfile              {prompt="Emission line image (H_alp,Br_gam etc) "}
string  cfile              {prompt="Continuum band image (R,K etc) "}
real    linesky            {prompt="Sky counts in emission line frame"}
real    contsky            {prompt="Sky counts in continuum frame"}
real    Arbyh  = -3.20     {prompt="(mag_cont - mag_line) from inframe stars"}
real    bwrbyh = 13.13     {prompt="(BW_cont/BW_line) from chart"}
string  expkey = "persec"  {prompt="Exposure time header KEYWORD or persec"}
bool    contlin = "yes"    {prompt="Continuum band includes line?"}

begin
	string hfil, rfil, htit, rtit, exphd, hsky, rsky, logfil
	string comm1, comm2, comm3, comm4, comm5, f1, f2, f3
	real   efrbyh, corr, drh, Alfrbyh
	int    htime, rtime
	
	logfil = "contsub.log"
	hfil  = lfile
	rfil  = cfile
	hsky  = linesky
	rsky  = contsky
	Alfrbyh = Arbyh
	exphd = expkey

	drh  = 10**(-Alfrbyh/2.5)     
	efrbyh = drh/bwrbyh
	corr = 1.0
	if (contlin) corr = 1 - 1/bwrbyh

	f1   = substr(str(drh), 1, 6)
	f2   = substr(str(corr), 1, 6)
	f3   = substr(str(efrbyh), 1, 6)
	
print ("                                     ", >> "contsub.log")
print (" --- CONTSUB REDUCTION PARAMETERS ---- ", >> "contsub.log")
print ("                                     ", >> "contsub.log")
print("Line_fil=",hfil, " Cont_fil=",rfil, " Line_sky=",hsky, " Cont_sky=",rsky, >> "contsub.log")
print("mag_cont - mag_line=", Alfrbyh, " BW_cont/BW_line=",bwrbyh, " Corr=", corr, >> "contsub.log")
imdelete ("temph*", verify- , >& "dev$null")
imdelete ("tempr*", verify- , >& "dev$null")
imdelete (hfil//"cnt", verify- , >& "dev$null")
imdelete (rfil//"cnt", verify- , >& "dev$null")

htime = 1.0
rtime = 1.0
htit = "  "
rtit = "  "

if (exphd!="persec") {

imgets (hfil, exphd, value="")
	htime = int(imgets.value)
imgets (hfil, "i_title", value="")
	htit = imgets.value

imgets (rfil, exphd, value="")
	rtime = int(imgets.value)
imgets (rfil, "i_title", value="")
	rtit = imgets.value

}

comm1 = "if im1 .gt. -9.0 then (im1 - "//str(hsky)//")/"//str(htime)//" else -9.0" 
print("im1=",hfil," : ",comm1, >> "contsub.log")
imcalc (hfil, "temph1", comm1, pixtype="old", nullval=0., verbose=no)

comm2 = "if im1 .gt. -9.0 then (im1 - "//str(rsky)//")/"//str(rtime)//" else -9.0" 
print("im1=",rfil," : ",comm2, >> "contsub.log")
imcalc (rfil, "tempr1", comm2, pixtype="old", nullval=0., verbose=no)

comm3 = "if im1 .ne. -9 .and. im2 .ne. -9 then (im1-im2/"//f1//") else -9" 
print("im1= temph1 & im2= tempr1 : ",comm3, >> "contsub.log")
imcalc ("temph1, tempr1", "temph2", comm3, pixtype="old", nullval=0., verbose=no)

comm4 = "if im1 .ne. -9.0 then (im1 /"//f2//") else -9.0" 
print("im1= temph2 : ",comm4, >> "contsub.log")
imcalc ("temph2", hfil//"cnt", comm4, pixtype="old", nullval=0., verbose=no)

comm5 = "if im1 .ne. -9 .and. im2 .ne. -9 then (im1-im2*"//f3//") else -9" 
print("im1= tempr1 & im2= temph1 : ",comm5, >> "contsub.log")
imcalc ("tempr1, temph1", "tempr2", comm5, pixtype="old", nullval=0., verbose=no)

print("im1= tempr2 : ",comm4, >> "contsub.log")
imcalc ("tempr2", rfil//"cnt", comm4, pixtype="old", nullval=0., verbose=no)

imdelete ("temph*", verify- , >& "dev$null")
imdelete ("tempr*", verify- , >& "dev$null")

end
