procedure  corpsf(imfile,xpos,ypos,xfwhm,yfwhm)

string imfile                          {prompt="Image to be psf matched"}
real   xpos                            {prompt="X position of psf star" }
real   ypos                            {prompt="Y position of psf star" }
real   xfwhm = "6.5"                   {prompt="Gaussian FWHM along X" }
real   yfwhm = "6.5"                   {prompt="Gaussian FWHM along Y" }
string refim = "psf"                   {prompt="Reference psf Image"}
#real   xin   = "1"                     {prompt="Starting X for geomap" }
#real   xout  = "385"                   {prompt="Ending X for geomap" }
#real   yin   = "1"                     {prompt="Starting X for geomap" }
#real   yout  = "578"                   {prompt="Ending X for geomap" }

begin

	string imfil, refpos, psftit
	string psfim
	real   x0, y0, Rx, Ry #,x1, x2, y1, y2
	int    nx, ny

	imfil = imfile
	psfim = refim 
	x0 = xpos
	y0 = ypos
	Rx = xfwhm
	Ry = yfwhm
	#x1 = xin
	#x2 = xout
	#y1 = yin
	#y2 = yout
	refpos = str(x0)//" "//str(y0)
	psftit = "PSFs matched("//str(Rx)//" x "//str(Ry)//")"


imgets (imfil, "i_naxis1", value="")
        nx = int(imgets.value)
imgets (imfil, "i_naxis2", value="")
        ny = int(imgets.value)
#imgets (imfil, "i_minpixval", value="")
imgets (imfil, "i_title", value="")
        = (imgets.value)

imdelete ("tempgau", ver-, >& "dev$null")
imdelete ("temppsf", ver-, >& "dev$null")
imdelete ("ker"//imfil, ver-, >& "dev$null")
imdelete (imfil//"psf", ver-, >& "dev$null")

if (psfim=="psf") {
mkgauss ("tempgau",
 nx, ny, x0, y0, 1., 0., 0., Rx, Ry, 0., seed=347951)
 psfim = "tempgau"
  } 

psfmatch (imfil, psfim, refpos,
 "", output="temppsf", convolution="image",
dnx=31, dny=31, pnx=15, pny=15, center=yes, background="median",
loreject=INDEF, hireject=INDEF, apodize=0., fluxratio="INDEF",
filter="replace", sx1=INDEF, sx2=INDEF, sy1=INDEF, sy2=INDEF, radsym=no,
threshold=0.2, normfactor=1., boundary="nearest", constant=0., interactive=no,
verbose=yes, graphics="stdgraph", display="stdimage", gcommands="",
icommands="")

imcalc ("temppsf", imfil//"psf", "if im1 .gt. -9.0 then im1 else -9.0", pixtype="old", nullval=0., verbose=yes)

hedit (imfil//"psf", "PSFMATCH", psftit, add=yes, delete=no, verify=no)
#show=yes, update=yes)

#    print("Displaying PSF corrected image: ", imfil//"psf") 
#	display (imfil//"psf")

imdelete ("tempgau", ver-, >& "dev$null")
imdelete ("temppsf", ver-, >& "dev$null")
imdelete ("ker"//imfil, ver-, >& "dev$null")

end

