procedure galphot (imroot, filter, coofil)
#procedure galphot (image, coofil, aperture)

#xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

string     imroot   = " "                 {prompt="Image name"}
string     filter   = "j1"                {prompt="filter code"}
string     coofil   = "file.coo"          {prompt="Coordinate file"}
string     subdir   = "file17/"           {prompt="subdir"}

begin
	string  imfil, image, xyfil, magfil, filt

	imfil = imroot
	filt  = filter
	image = subdir//imfil//filt
	xyfil  = coofil 
	magfil = imfil//filt//".mag.1"

	displ (image)

	cache datapars
	cache centerpars
	cache fitskypars
	cache photpars


	print("Doing aperture photometry on ", image, " using ", xyfil )  


datapars.scale=1.0
datapars.fwhmpsf=2.5
datapars.epadu=15.0
datapars.readnoise=40.0
datapars.filter="FILTER"
datapars.exposur=""
datapars.airmass=""
#datapars.=""
datapars.xairmas=1.0
datapars.itime=1.0
#datapars.=""
fitskypars.salgorithm="median"
fitskypars.annulus =15
fitskypars.dannulus =10
#fitskypars.annulus = 5
#fitskypars.dannulus = 5
centerpars.cbox=5
#centerpars.calgorithm="centroid"
centerpars.calgorithm="none"
photpars.apertures="3,4,5,6,8"
#photpars.apertures="3,5,8,10,12"
photpars.zmag=26.

        delete (magfil, ver-, >& "dev$null")
        #delete (imfil//filter//".mag.1", ver-, >& "dev$null")

phot (image, "", coords=xyfil, output="default", plotfile="", 
interactive=no, radplots=no,
verify=no, update=no, verbose=no, graphics="stdgraph", display="stdimage",
icommands="", gcommands="")

txdump (magfil,
"MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", "ID=1", headers=no,
parameters=yes) | cat >> imfil//".mag"

txdump (magfil, "MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", 
"ID=1", headers=no, parameters=yes) 

txdump (magfil,
"MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", "ID=2", headers=no,
parameters=yes) | cat >> imfil//".mag"

txdump (magfil, "MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", 
"ID=2", headers=no, parameters=yes) 

txdump (magfil,
"MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", "ID=3", headers=no,
parameters=yes) | cat >> imfil//".mag"

txdump (magfil, "MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", 
"ID=3", headers=no, parameters=yes) 

txdump (magfil,
"MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", "ID=4", headers=no,
parameters=yes) | cat >> imfil//".mag"

txdump (magfil, "MERR[4],MAG[1-4],XCEN,YCEN,IFIL,IMAGE", 
"ID=4", headers=no, parameters=yes) 

#print (" ----------------- ", >> imfil//".mag")


        print("***DONE***")

end

