procedure imcut(xcen, ycen)

int	xcen    = 6144                 {prompt="X center of image"}
int	ycen    = 6144                 {prompt="Y center of image"}
int	xsiz    = 2300                 {prompt="X size of sub-image"}
int	ysiz    = 2300                 {prompt="Y size of sub-image"}
real	pamaj   = 65                   {prompt="PA of the Maj axis"}
int	nxsub   = 3                    {prompt="X size of sub-image"}
int	nysub   = 1                    {prompt="X size of sub-image"}
int	ixsub   = 0                    {prompt="Position# along MA [-nxsub,nxsub]"}
int	iysub   = 0                    {prompt="Position# perp to MA [-nysub,nysub]"}
string  phot    = "all"		       {prompt="Do sexphot on all or the designated image only"}
string  step    = "sextract"		{prompt="Do imcut, sextract, all, exit"}
string	root    = "h_m82_"               {prompt="Root Image Name"}
#string  filter  = "i"                  {prompt="Reference Image Filter [i,h,v,b] "}
string  top     = "_s05_drz_sci"         {prompt="Image ending name"}
string  sex_fil = "h_m82_s05_I_stars.sex" {prompt="Sextractor parameter filename"}
string  in_file = "imcut_image.inputs" {prompt="File containing the filter code in filenames"}
string  weight  = "N"         		{prompt="Run SExtractor with an weight Image? "}
string  wei_top = "_s05_drz_weight"     {prompt="Weight Image ending name (_s05_drz_weight)"}
string  version = "v1_"         	{prompt="Run SExtractor with an weight Image? "}
real	area_l  = 72.0                 {prompt="Minimum area of a Supercluster"}

#---------------------------------------------------------------------------------------------
#Help: 
# xcen, ycen, xsiz, ysiz: the box parametrs for sextractor search
# pamaj: PA along which the sextractor boxes are to placed
# nxsub, nysub: Maximum number of boxes required along and perpendicular to the MA
#               If a part of a box is outside the image, the box is ignored from the analysis 
# ixsub, iysub: If CMD is required for only one box, then the number of that subimage in x & y
# phot: Do sexphot on all or the designated image only
# step: Run mode- Only "imcut" or do "sextract" also. "all" ==> Do "imcut" and "sextract" on all 
#                 valid boxes (overrides the ixsub, iysub values) 
# root, top: Image name parts before and after the "filter" characters.
# filter _ The image [i] that is used to search stars in sextractor
#          Changed....always taken as the first entry in in_file
# sex_fil: Sextractor parameter filename
# Date: 12-Sep-2007
#---------------------------------------------------------------------------------------------

begin
	string	regfil,imsec,infil,outfil[9],froot,ftop,fil,pass,comm,tstart,parfil
	string  sec,filt[9],zpt[9],sexpar_fil,sexphot,tmp,s1,s2,logfil,sexfil
	string  peso, wtop, weight_in, weight_out, com_weight, offfil, ver, work_dir
	string  ref_fil,comm_assoc,tab_fil,class[6]
	real 	deg_rad,pa,pa_deg,fwhm,area,area_lim
	bool	imdel
	int	Nx,Ny,x0,y0,x1,y1,x2,y2,y01,y02,y11,y12,y21,y22
	int	xmin, xmax, ymin, ymax, nim, nnx, nny, j, ifilt
	int	xl,xr,yl,yr,isel,jsel,nfilt,nx_sub,ny_sub,i1,i2,m,k
        struct  line

	ifilt = 1
	sexpar_fil = sex_fil; imdel = yes
	isel = ixsub; jsel = iysub; sexphot=phot
	x0 = xcen; y0 = ycen; Nx = xsiz; Ny = ysiz
	nx_sub = nxsub; ny_sub = nysub;
	froot = root; ftop = top; peso = weight; wtop = wei_top
	pass = step; ver = version
	area_lim = area_l
	date | scan (s1,s1,s1,tstart)
	if (pass == "all" || sexphot == "all") {imdel = yes} 

	i1 = 0
        list = in_file     #"imcut_image.inputs"
        while( fscan(list, line) != EOF ) {
            tmp = substr (line, 1, 1)
            if (tmp != "#") {
                i2 = fscanf(line,"%s %s", s1, s2)
		if (s1 != ""){
                i1=i1+1; filt[i1] = s1; zpt[i1] = s2
                } } } 
	nfilt = i1  
	
	fil = filt[ifilt]; infil  = froot//fil//ftop
	deg_rad = 3.1415/180.0; pa_deg = pamaj; pa = (90.0-pa_deg)*deg_rad
	if (pass == "exit") {goto exit}
	parfil = "imcut.param"
	delete(parfil, ver-, >& "dev$null")
	print(ver, " #Version", > parfil )
	print(nfilt, " ",ifil, " #No of filters and the Reference", >> parfil)
	for (k=1; k <= nfilt;  k += 1) {
	   print(zpt[k], " ",filt[k], " #ZP, Filter", >> parfil)
	}
	print(x0, y0, Nx, Ny, pa_deg, " #x0, y0, Nx, Ny, pa_deg", >> parfil )

	regfil = ver//froot//fil//ftop//"_imcut_box.reg"
	logfil = ver//froot//fil//ftop//"_imcut_log.com"
	sexfil = ver//froot//fil//ftop//"_imcut_sex.com"
	offfil = ver//froot//fil//ftop//"_imcut_off.set"
	delete(regfil, ver-, >& "dev$null")
	delete(logfil, ver-, >& "dev$null")
	delete(sexfil, ver-, >& "dev$null")
	delete(offfil, ver-, >& "dev$null")

	delete("imcut_default.param", ver-, >& "dev$null")
	copy ("default.param", "imcut_default.param", ver-)
	print ("VECTOR_ASSOC(1)    ", >> "imcut_default.param")

	print(offfil, " #Offset file", >> parfil )

	print(ver//"all_"//infil//"_sext", > offfil)
	pwd | scan (work_dir)
        print ("# Region file format: DS9 version 4.0", > regfil)
        print ("# Filename: ",work_dir//"/"//infil//".fits", >> regfil)
        printf ("global color=green font=\"helvetica 10 normal\" select=1 highlite=1 edit=1 move=1 delete=1 include=1 fixed=0 source \nphysical \n", >> regfil)
	#date | scan (s1,s1,s1,tstart)
	#goto exit

	#1 Find the number of sub-images that are possible
	#2 Find their xy center and the image sections
	imgets (infil, "i_naxis1") 
	nnx = int(imgets.value)
	imgets (infil, "i_naxis2") 
	nny = int(imgets.value)
	print ("#___________________________________ ", > logfil)
	print ("#___________________________________ ", > sexfil)
	print ("#",nnx, nny, >> logfil)
	nim = 0
	xmin = Nx/2 + 1; xmax = nnx - Nx/2
	ymin = Ny/2 + 1; ymax = nny - Ny/2
	for (i=-nx_sub; i <= nx_sub;  i += 1) {
	  for (j=-ny_sub; j <= ny_sub;  j += 1) {
	    x1 = x0 + i*Nx  
	    y1 = y0 - int(i*Nx*tan(pa)) + j*Ny
	  if (x1 > xmin && x1 < xmax && y1 > ymin && y1 < ymax ) { 
		nim = nim + 1
		if (i >= 0 && j >= 0) {sec = "_w"//str(abs(i))//"n"//str(abs(j))}
		if (i < 0 && j >= 0 ) {sec = "_e"//str(abs(i))//"n"//str(abs(j))}
		if (i >= 0 && j < 0 ) {sec = "_w"//str(abs(i))//"s"//str(abs(j))}
		if (i < 0 && j < 0 ) {sec = "_e"//str(abs(i))//"s"//str(abs(j))}
		xl = x1 - Nx/2 + 1; xr = x1 + Nx/2
		yl = y1 - Ny/2 + 1; yr = y1 + Ny/2
        	imsec = "["//str(xl)//":"//str(xr)//","//str(yl)//":"//str(yr)//"]"
		if ((i == isel && j == jsel) || pass == "all" ) {
        	printf ("box(%d,%d,%d,%d)\n",x1,y1,Nx,Ny,  >> regfil)
		print ("# ",x1,",",y1,",",Nx,",",Ny,  >> logfil)
		print (x1," ",y1," ",Nx," ",Ny,  >> offfil)
		#print (ver//"all_"//froot//fil//ftop//sec,  >> offfil)
		print (i, j, nim, x1, y1, sec, imsec)
				if (peso == "Y"){
					weight_in  = froot//fil//wtop//imsec
					weight_out = froot//fil//wtop//sec
				} else {com_weight = " -WEIGHT_GAIN N"}
			for (k=1; k <= nfilt;  k += 1) {
			infil  = froot//filt[k]//ftop//imsec
			outfil[k] = froot//filt[k]//ftop//sec
			comm = "imcopy "//infil//" "//outfil[k]//" verb+"
			print (comm, >> logfil)
			imdelete(outfil[k], ver-, >& "dev$null")
			imcopy (infil, outfil[k], verb+)	
			if (filt[k] == fil && peso == "Y") {
				imcopy (weight_in, weight_out, verb+)
				comm = "imcopy "//weight_in//" "//weight_out//" verb+"
				print (comm, >> logfil)
				com_weight = " -WEIGHT_GAIN Y -WEIGHT_IMAGE "//weight_out//".fits -WEIGHT_TYPE MAP_WEIGHT"
			}
			}
			if (pass == "imcut") {goto no_sextract} 
			for (k=1; k <= nfilt;  k += 1) {
			fil = filt[k]; ref_fil = froot//fil//ftop//sec//".fits"
			print (ver//"all_"//froot//fil//ftop//sec,  >> offfil)
			for (m=1; m <= nfilt;  m += 1) {
	comm = ref_fil//","//outfil[m]//".fits"//" -c "//sexpar_fil//" -CATALOG_NAME "//ver//fil//"det_"//outfil[m]//".cat -MAG_ZEROPOINT "//zpt[m]//com_weight
	comm_assoc = " "; if (k > 1){
	comm_assoc = " -ASSOC_NAME "//ver//"all_"//outfil[m]//".cat -PARAMETERS_NAME imcut_default.param -ASSOC_TYPE NEAREST -ASSOC_RADIUS 2.0 -ASSOC_PARAMS 21,22 -ASSOCSELEC_TYPE -MATCHED -ASSOC_DATA 2"
					}
			print ("sex ",comm, comm_assoc, >> sexfil)
			if (k > 1){
			#comm = comm//comm_assoc
			delete("imcut_default.sex", ver-, >& "dev$null")
			copy (sexpar_fil, "imcut_default.sex", ver-)
			print ("#----------------------------- Association   ---------------------------------", >> "imcut_default.sex")
			print ("ASSOC_NAME      ", ver//"all_"//outfil[m]//".cat", >> "imcut_default.sex")
			print ("ASSOC_TYPE      NEAREST", >> "imcut_default.sex")
			print ("ASSOC_RADIUS    2.0", >> "imcut_default.sex")
			print ("ASSOC_PARAMS    21,22", >> "imcut_default.sex")
			print ("ASSOC_DATA      2  ", >> "imcut_default.sex")
			print ("ASSOCSELEC_TYPE -MATCHED", >> "imcut_default.sex")

	comm = ref_fil//","//outfil[m]//".fits"//" -c imcut_default.sex"//" -CATALOG_NAME "//ver//fil//"det_"//outfil[m]//".cat -PARAMETERS_NAME imcut_default.param -MAG_ZEROPOINT "//zpt[m]//com_weight
			}
			sex comm//" "
			if (k == 1) {
				delete(ver//"all_"//outfil[m]//".cat", ver-, >& "dev$null")
				cat ver//fil//"det_"//outfil[m]//".cat > "//ver//"all_"//outfil[m]//".cat"
			}
			if (k > 1){ cat ver//fil//"det_"//outfil[m]//".cat >> "//ver//"all_"//outfil[m]//".cat" }
			if (imdel && k == nfilt) {
				imdelete(outfil[m], ver-, >& "dev$null")
				#imdelete(froot//fil//ftop//sec, ver-, >& "dev$null")
				if (peso == "Y"){imdelete(weight_out, ver-, >& "dev$null")}
			}
			}
			}
		}
		#print (i, j, nim, x1, y1, sec, imsec)
			no_sextract:
		}
	}
	}

	#if (pass == "exit") {goto exit}

exit:

        printf("Started at %s  Finished at ",tstart)
	date

	!source_class.out

	#plotting the relation between AREA and FWHM
	delete("sgraph.tbl", ver-, >& "dev$null")
	for (i=1; i <=60; i +=1){
	  fwhm = real(i-1)/2.0
	  area = 70.0 + 3.1415*(((fwhm-3.0)/1.3)**2) 
	  #area = max(area, area_lim)
	print (fwhm, area, >> "sgraph.tbl")
	}
	class[1] = "sscs" 
	class[2] = "mult" 
	class[3] = "star" 
	class[4] = "misc" 
	class[6] = "junk" 
	class[5] = "brst"
	for (i=1; i <=5; i +=1){
	k = i    #min(i,5) 
        #tab_fil = ver//"all_"//infil//"_sext_"//class[i] 
        tab_fil = ver//"all_"//froot//filt[ifilt]//ftop//"_sext_"//class[i] 
        #tab_fil_tab = ver//"all_"//infil//"_sext_"//class[i]//".tab" 
		print(k, tab_fil)
	delete(tab_fil//".tab", ver-, >& "dev$null")
	#delete(tab_fil_tab, ver-, >& "dev$null")
        tcreate (tab_fil, "source_class.head", tab_fil//".cat")
        if (i == 1){
		sgraph (tab_fil//" FWHM AREA", pointmo+, wl=1, wr=30, wb=5, wt=999, crvcol=k)
		} else {
        	sgraph (tab_fil//" FWHM AREA", pointmo+, append+, crvcol=k)
		}
	delete(tab_fil//".tab", ver-, >& "dev$null")
	#delete(tab_fil_tab, ver-, >& "dev$null")
	}

	sgraph ("sgraph.tbl", append+, pointmo-, crvcol=3)

        #tcreate (tab_fil, "source_class.head", tab_fil//".cat", uparfile="", nskip=1, nlines=0, nrows=0, hist=yes, extrapar=5, tbltype="default", extracol=0)
	
end
