procedure instat(infil)

string  infil   = "R04V"    	{prompt="Input image to find bg and rms or xylist"}
int     winsize = 20            {prompt="Stat window in pixels"}
int     stepsize= 20            {prompt="Sampling step in pixels"}
int     nclip   = 10            {prompt="Number of clipping iterations"}
bool    stimage = yes           {prompt="Store the median and rms image?"}
real    bgvalue = 0.0           {prompt="Output parameter containing BG value"}
real    rmsvalue= 0.0           {prompt="Output parameter containing RMS value"}
bool    verbose = yes           {prompt="Write BG and RMS on screen after every line?"}
#int     lines   = 1             {prompt="Image lines to be fit"}
#int     bands   = 1             {prompt="Image bands to be fit"}
#string  sample  = "3700:7600"   {prompt="Sample range in Ang for analysis 3700:7600"}
#bool    inter   = yes           {prompt="Fit continumm interactively?"}

begin
	string	imfil, imrms, immed, jsec, ijsec, imsec, sperange 
	string	xyfil, fulfile, trimsec, c1
        real    median, stddev, min, max, kclip, bg, rms
	real	x0, y0, dx, dy
	int	rmsstep, jstep, istep, npix1, npix2, npix, itclip, i, j  #, prog_pc
	int	i1, ix1, ix2, iy1, iy2
        bool    ask, wrimage
        struct  line

	imfil = infil; rmsstep = winsize; jstep = stepsize  #; ask = inter
	itclip = nclip; istep = jstep; wrimage = stimage; ask = verbose
	immed = imfil//"_bg"; imrms = imfil//"_rms"
	kclip = 3.0

        imdelete(imrms, ver-, >& "dev$null")
        imdelete(immed, ver-, >& "dev$null")

        imexpr ("a*0.0", imrms, imfil, verb-)
        imexpr ("a*0.0", immed, imfil, verb-)
        #hselect (imfil, "NAXIS1, NAXIS2", yes) 
        hselect (imfil, "NAXIS1, NAXIS2", yes) | scan (npix1, npix2)
        imstat (imfil, fields="midpt, stddev", nclip=3, format-) | scan(median, stddev)
	#prog_pc = 0
        for (j=1; j <= npix2-jstep; j +=jstep) {
	#if (prog_pc < 60) {prog_pc = int(100.*real(j)/real(npix2))}
        for (i=1; i <= npix1-istep; i +=istep) {
          if (i+rmsstep < npix1){ 
		imsec = "["//str(i)//":"//str(i+rmsstep-1) 
			} else {imsec = "["//str(npix1-rmsstep+1)//":"//str(npix1)
			}
          if (j+rmsstep < npix2){ 
		imsec = imsec//","//str(j)//":"//str(j+rmsstep-1)//"]" 
		#imsec = "["//str(j)//":"//str(j+rmsstep-1)//"]" 
                } else {
		imsec = imsec//","//str(npix2-rmsstep+1)//":"//str(npix2)//"]"
		#imsec = "["//str(j-rmsstep+1)//":"//str(j)//"]"
		}
          jsec = "["//str(j)//":"//str(j+jstep-1)//"]"
          ijsec = "["//str(i)//":"//str(i+istep-1)//","//str(j)//":"//str(j+jstep-1)//"]"
          min = median - 6.0*stddev; max = median + 6.0*stddev
          imstat (imfil//imsec, fields="midpt, stddev, npix", lower=min, upper=max, nclip=itclip, format-) | scan(median, stddev, npix)
          imrepl (imrms//ijsec, stddev)
          imrepl (immed//ijsec, median)
          #imstat (imfil//imsec, fields="midpt, stddev, npix", nclip=1, format-) 
        }
		if (ask){print(imsec, " ", median, stddev, npix)}
	#if (prog_pc >= 50 && ask){print(imsec, " ", median, stddev, npix, prog_pc); prog_pc = 0}
        }
	#imexpr ("a+b*"//str(kclip), spekrms, specont, sperms)
        imstat (immed, fields="midpt", nclip=3, format-) | scan (bg)
        imstat (imrms, fields="midpt", nclip=3, format-) | scan (rms)
	instat.bgvalue = bg; instat.rmsvalue = rms
	if (ask){print(instat.bgvalue, "+/- ", instat.rmsvalue)}
	
end
