procedure iras4 (ngcnum)
#procedure hires1 (ngcnum)
# Given the NGC number of the galaxy this procedures fits ellipses, sorts out 
# the resulting output, and then prepares two ascii tables containing profile 
# and position angle information. Following conventions are used in naming 
# files. 1. Derives input file names from ngc # alone assuming that the file
# names for 25, 60, 100 micron & 20cm are i#b2t1, i#b3t1, i#b4t1, r#b5t2
# respectively. Temporary STSDAS tables are named as tb2el, tb3el, tb4el and 
# tb5el. Finally "irprof" is also run, which creates the two ascii tables
# with names fir#.pro and fir#.pa

string  ngcnum                         {prompt="NGC number of the galaxy"}
#string  alfbeg =                       {prompt="Alphabet to prefix to NGC#"}
#string  alfend =                       {prompt="Ending alphabet"}
real    x0     =  "21"                 {prompt="Image x_center"}
real    y0     =  "21"                 {prompt="Image y_center"}
real    eps0   =  "0.1"                {prompt="Trial ellipticity"}
real    teta0  =  "90.0"               {prompt="Trial position angle"}
real    a0     =  "5.0"                {prompt="Starting major axis"}
real    mina   =  "1.0"                {prompt="Minimum major axis"}
real    maxa   =  "18.0"               {prompt="Minimum major axis"}
real    astep  =  "1.0"                {prompt="Interval along major axis"}
bool    hcen   =  "yes"                {prompt="Hold Center"}
bool    heps   =  "yes"                {prompt="Hold ellipticity"}
bool    hteta  =  "yes"                {prompt="Hold Position angle"}

begin

string   ngc, ok

ok = "yes"

ngc  = ngcnum
	x0 = 31
	y0 = 31
	maxa = 28
	if (ngc == "2403") {
	  eps0  = 1.0-0.562
	  teta0 = -53.0
	  x0 = 51
	  y0 = 51
	  maxa = 41 }
	else if (ngc == "4258") {
	  eps0  = 1.0-0.389
	  teta0 = -30.0
	  x0 = 51
	  y0 = 51
	  maxa = 41 }
	else if (ngc == "628") {
	  eps0  = 1.0-0.912
	  teta0 =  25.0  }
	else if (ngc == "2841") {
	  eps0  = 1.0-0.437
	  teta0 = -33.0  }
	else if (ngc == "3627") {
	  eps0  = 1.0-0.457
	  teta0 = -7.0  }
	else if (ngc == "4736") {
	  eps0  = 1.0-0.813
	  teta0 = -75.0  }
	else if (ngc == "6503") {
	  eps0  = 1.0-0.339
	  teta0 = -57.0  }
	else if (ngc == "7331") {
	  eps0  = 1.0-0.355
	  teta0 = -9.0  }
	else if (ngc == "5033") {
	  eps0  = 1.0-0.468
	  teta0 = -10.0  }
	else if (ngc == "4192") {
	  eps0  = 1.0-0.282
	  teta0 = -25.0  }
	else if (ngc == "4254") {
	  eps0  = 1.0-0.871
	  teta0 =  0.0  }
	else if (ngc == "4501") {
	  eps0  = 1.0-0.537
	  teta0 = -40.0  }
	else if (ngc == "4535") {
	  eps0  = 1.0-0.708
	  teta0 = 0.0  }
	else if (ngc == "4569") {
	  eps0  = 1.0-0.457
	  teta0 = 23.0  }
	else if (ngc == "5055") {
	  eps0  = 1.0-0.575
	  teta0 = -75.0  }
	else if (ngc == "2903") {
	  eps0  = 1.0-0.479
	  teta0 =  17.0  }
	else if (ngc == "3079") {
	  eps0  = 1.0-0.180
	  teta0 = -15.0  }
	else if (ngc == "3198") {
	  eps0  = 1.0-0.390
	  teta0 =  35.0  }
	else if (ngc == "3628") {
	  eps0  = 1.0-0.200
	  teta0 = -76.0  }
	else if (ngc == "4303") {
	  eps0  = 1.0-0.890
	  teta0 =   0.0  }
	else if (ngc == "4321") {
	  eps0  = 1.0-0.850
	  teta0 =  30.0  }
	else if (ngc == "4656") {
	  eps0  = 1.0-0.200
	  teta0 =  33.0  }
	else if (ngc == "6946") {
	  eps0  = 1.0-0.850
	  teta0 =  32.0  }
	else {
	  print("x0 y0 eps0 teta0 ",x0,y0,eps0,teta0 )
	  print ("Ellipse parameters ok? (yes|no) ") 
	  scan (ok)
	  if (ok == "no")goto exit
	}

# y2ell.cl FIT ellipses to 25,60,100 mic and 20cm images
#          sort the ellipse fit STSDAS output
#          put the data in an ascii table
#          Use all the above data to obatain profiles of Td,Q60 etc (irprof)
#          Finally fit expontial profile to disk
#
del ("tb*")

ellipse ("i"//ngc//"b2t1", "tb2el", a0=a0, mina=mina, maxa=maxa,\
sdas=yes, interactive=no, device="stdgraph", imcur="",\
gcur="", initfile="", samplef="", badpixel="", harmonics="", x0=x0, y0=y0,\
eps0=eps0, teta0=teta0, hcenter=hcen, heps=heps, hteta=hteta, astep=astep,\
linear=yes, minit=8, maxit=50, lslope=0., conver=0., clip=0., maxrit=INDEF,\
integrmode="bi-linear", mag0=0., refer=1., backgr=0., star=0.)

tsort ("tb2el.tab", "a", ascend=yes, casesens=yes)
tprint ("tb2el",\ 
prparam=no, prdata=yes, pwidth=80, plength=0, showrow=yes, showhdr=yes,\
columns="", rows="-", option="plain", align=yes, sp_col="", lgroup=0) \
| cat > "tb2el"

ellipse ("i"//ngc//"b3t1", "tb3el", a0=a0, mina=mina, maxa=maxa,\
sdas=yes, interactive=no, device="stdgraph", imcur="",\
gcur="", initfile="", samplef="", badpixel="", harmonics="", x0=x0, y0=y0,\
eps0=eps0, teta0=teta0, hcenter=hcen, heps=heps, hteta=hteta, astep=astep, 
linear=yes, minit=8, maxit=50, lslope=0., conver=0., clip=0., maxrit=INDEF,\
integrmode="bi-linear", mag0=0., refer=1., backgr=0., star=0.)

tsort ("tb3el.tab", "a", ascend=yes, casesens=yes)
tprint ("tb3el",\ 
prparam=no, prdata=yes, pwidth=80, plength=0, showrow=yes, showhdr=yes,\
columns="", rows="-", option="plain", align=yes, sp_col="", lgroup=0) \
| cat > "tb3el"

ellipse ("i"//ngc//"b4t1", "tb4el", a0=a0, mina=mina, maxa=maxa,\
sdas=yes, interactive=no, device="stdgraph", imcur="",\
gcur="", initfile="", samplef="", badpixel="", harmonics="", x0=x0, y0=y0,\
eps0=eps0, teta0=teta0, hcenter=hcen, heps=heps, hteta=hteta, astep=astep,\
linear=yes, minit=8, maxit=50, lslope=0., conver=0., clip=0., maxrit=INDEF,\
integrmode="bi-linear", mag0=0., refer=1., backgr=0., star=0.)

tsort ("tb4el.tab", "a", ascend=yes, casesens=yes)
tprint ("tb4el",\ 
prparam=no, prdata=yes, pwidth=80, plength=0, showrow=yes, showhdr=yes,\
columns="", rows="-", option="plain", align=yes, sp_col="", lgroup=0) \
| cat > "tb4el"

ellipse ("r"//ngc//"b5t2", "tb5el", a0=a0, mina=mina, maxa=maxa,\
sdas=yes, interactive=no, device="stdgraph", imcur="",\
gcur="", initfile="", samplef="", badpixel="", harmonics="", x0=x0, y0=y0,\
eps0=eps0, teta0=teta0, hcenter=hcen, heps=heps, hteta=hteta, astep=astep,\
linear=yes, minit=8, maxit=50, lslope=0., conver=0., clip=0., maxrit=INDEF,\
integrmode="bi-linear", mag0=0., refer=1., backgr=0., star=0.)

tsort ("tb5el.tab", "a", ascend=yes, casesens=yes)
tprint ("tb5el",\ 
prparam=no, prdata=yes, pwidth=80, plength=0, showrow=yes, showhdr=yes,\
columns="", rows="-", option="plain", align=yes, sp_col="", lgroup=0) \
| cat > "tb5el"

#	  print ("Is irprof required? (yes|no) ") 
#	  scan (ok)
#	  if (ok == "no")goto exit

irprof (ngc)

exit:

     if (ok != "no") print ("Galaxy ","NGC"//ngc//" done")
     if (ok == "no") print ("Galaxy ","NGC"//ngc//" Not done")
#    print ("You can try irproc(","n"//ngc//".in) now")

end
