procedure lfosc(input, refer)

string     input = ""                {prompt="Input images"}
string     refer = ""                {prompt="Reference LFOSC image"}
string     output = ""               {prompt="Output DSS aligned images"}
string     coords = "lfosc.coo"      {prompt="Reference coordinates file"}
string     shifts = "lfosc.shi"      {prompt="Initial shifts file"}
real       boxsize = "7"             {prompt="imalign boxsize"}
real       bigbox  = "11"            {prompt="imalign bigbox"}
string     dssdb  = "dsslfosc.db"    {prompt="Digitized Sky survey db file"}
string     dsscoo = "dsslfosc.coo"   {prompt="Digitized Sky survey coo file"}
#string     dssfil = "A3dss"          {prompt="Digitized Sky survey image file"}

begin
	string  infil, infil1, reffil, outfil, coofil, shifil, alfil
	real    time, sky

	infil = input
	reffil = refer
	outfil = infil//"a"
	coofil = coords
	shifil = shifts
	infil1 = "templfosc"
	alfil  = output

        imdelete(infil1, ver-, >& "dev$null")

print (" ----------- ", coofil)
type (coofil)
print (" ----------- ", shifil )
type (shifil)
print (" Displaying reference image in 1 and input image in 2")
print (" Edit ",coofil, " and ",shifil, "; shift=ref-input")

imstat (infil, fields="image,midpt,mean,stddev,min,max", lower=INDEF, 
upper=INDEF, binwidt=0.1, format=yes)

display (reffil, 1, fill+)
display (infil, 2, fill+)
imexam

imgets (infil, "EXPTIME")
time = real(imgets.value)
time = 1.0

print (" Exposure Time in seconds ")
scan(time)

print (" Enter median sky value ")
scan(sky)

print (infil, "--->",alfil," Median sky value=", sky, " Exptime=",time, 
  >> "dsslfosc.log" )
imstat (infil, fields="image,midpt,mean,stddev,min,max", lower=INDEF, 
upper=INDEF, binwidt=0.1, format=yes) | cat >> "dsslfosc.log")
print (" ----------- ", shifil,  >> "dsslfosc.log"
type (shifil, >> "dsslfosc.log")

print (" Median sky value=", sky, " Exptime=",time )

imarith (infil, "-", sky, infil1, title=" ", 
divzero=0., hparams="", pixtype="", calctype="", verbose=no, noact=no)

imarith (infil1, "/", time, infil1, title=" ", 
divzero=0., hparams="", pixtype="", calctype="", verbose=no, noact=no)


        print("Aligning images ")

        imdelete(outfil, ver-, >& "dev$null")

imalign (infil1, reffil, coofil, outfil, shifts=shifil,
boxsize=boxsize, bigbox=bigbox, negative=no, background=INDEF, lower=INDEF,
upper=INDEF, niterate=3, tolerance=0, shiftimages=yes, interp_type="linear",
boundary_typ="constant", consta=0., trimimages=no, verbose=yes, list="")

        imdelete(alfil, ver-, >& "dev$null")

geotran (outfil, alfil, dssdb, dsscoo)

#wcscopy (alfil, dssfil, ver=yes)

        imdelete(infil1, ver-, >& "dev$null")
        imdelete(outfil, ver-, >& "dev$null")

end

