procedure m81_stars_cmd(catal, object)

string  catal  = "../m81csc_bright.cat"      	{prompt="CSC Catalog name"}
string  object = "R06B06945"      	{prompt="Object name"}
string  starcat  = "../R2_R13_F2_F17_BRI_ed.cat"      	{prompt="Star Catalog name"}
string  filter = "V"			{prompt="Filter band to display"}
real    dispbox= 500      		{prompt="Box size for display in pixels"}
real    radius = 5.0      		{prompt="Box size for CMD in arcsec"}

begin
	string	cat_name, obj_name, fname, band, ttt_radec, ttt_xy, c1
	string  csc_name, sec, star_cat, zone_filt, galex_nuv, galex_fuv, spitzer_1 
	string  mass_j, sdss_g
	real	csc_ra, csc_dec, csc_biso, csc_bi, csc_br, csc_b, csc_i
	real	rad_deg, ra1, ra2, dec1, dec2, xym, disp_box_uv, disp_box_sp
	real    disp_box_2m, disp_box_sd, tv_rad, im_sca
	int     i2, disp_box, x1, x2, y1, y2, obj_x, obj_y
        struct  line

	cat_name = catal
	obj_name = object
	star_cat = starcat
	fname = "/home/ydm/iraf/m81/m81acs/"//substr(obj_name,1,3)
	galex_nuv = "/home/ydm/iraf/m81/h_m81-nd-int"
	galex_fuv = "/home/ydm/iraf/m81/h_m81-fd-int"
	spitzer_1 = "/home/ydm/iraf/m81/MESSIER_081:I:irac_36:wab2004"
	mass_j = "/home/ydm/iraf/m81/2MASS_MESSIER_081_J"
	sdss_g = "/home/ydm/iraf/m81/fpC-004294-g5-0234"
	band = filter
	ttt_radec = "ttt_radec.cat"
	ttt_xy = "ttt_xy.cat"
	disp_box = dispbox
	rad_deg = radius/3600.
	im_sca = 0.05

        delete(ttt_radec, ver-, >& "dev$null")
        delete(ttt_xy, ver-, >& "dev$null")

	list = cat_name
        while( fscan(list,line) != EOF ) {
        c1 = substr(line,1,1)
        if (c1!="#") {
          i2 = fscan(line, csc_name, csc_ra, csc_dec, csc_biso, csc_bi, csc_br, csc_b)
          #i2 = fscan(line, csc_name, csc_ra, csc_dec)
	  if (csc_name == obj_name)  { 
	  print (csc_ra, csc_dec, >> ttt_radec)
	  csc_i = csc_b - csc_bi
	  goto found_obj
	  #obj_ra = csc_ra; obj_dec = csc_dec; goto found_obj
	  }
	}
	}

found_obj:
	
wcsxymatch (fname//band, fname//band, ttt_xy, 
coords=ttt_radec, xmin=INDEF, xmax=INDEF,
ymin=INDEF, ymax=INDEF, nx=10, ny=10, wcs="world", transpose=no, xcolumn=1,
ycolumn=2, xunits="", yunits="", xformat="%10.3f", yformat="%10.3f",
wxformat="", wyformat="", min_sigdigit=7, verbose=yes)

	fields (ttt_xy, "1,2", lines=11) | scan (obj_x, obj_y)
	x1 = obj_x - disp_box; x2 = obj_x + disp_box
	y1 = obj_y - disp_box; y2 = obj_y + disp_box
	sec = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
	print (sec)
	
        imdelete(obj_name//"B", ver-, >& "dev$null")
        imdelete(obj_name//"V", ver-, >& "dev$null")
        imdelete(obj_name//"I", ver-, >& "dev$null")
	imcopy (fname//"B"//sec, obj_name//"B", verb-)
	imcopy (fname//"V"//sec, obj_name//"V", verb-)
	imcopy (fname//"I"//sec, obj_name//"I", verb-)
	#display (fname//band//sec, 1, fill+, zs-, zr+)
	xym = 0.25 #0.7
	tv_rad = 2.0/im_sca
	#display (obj_name//"B", 1, xc=0.15, yc=0.5, fill-, xm=0.7, ym=0.7, zs-, zr+)
	#display (obj_name//"B", 1, xc=0.15, yc=0.5, fill-, xm=xym, ym=xym, zs-, zr+)
	display (fname//"B"//sec, 1, xc=0.15, yc=0.5, fill-, xm=xym, ym=xym, zs+, zr+)
        tvmark (1, ttt_xy, mark="circle", radii=tv_rad, number-, nxoff=3, nyoff=3, txsize=2)
	display (fname//"V"//sec, 1, xc=0.45, yc=0.5, fill-, xm=xym, ym=xym, er-, zs+, zr+)
        tvmark (1, ttt_xy, mark="circle", radii=tv_rad, number-, nxoff=3, nyoff=3, txsize=2)
	display (fname//"I"//sec, 1, xc=0.75, yc=0.5, fill-, xm=xym, ym=xym, er-, zs+, zr+)
        tvmark (1, ttt_xy, mark="circle", radii=tv_rad, number-, nxoff=3, nyoff=3, txsize=2)

        delete(ttt_xy, ver-, >& "dev$null")
wcsxymatch (galex_nuv, galex_nuv, ttt_xy, coords=ttt_radec, verbose=yes)
#xmin=INDEF, xmax=INDEF,
#ymin=INDEF, ymax=INDEF, nx=10, ny=10, wcs="world", transpose=no, xcolumn=1,
#ycolumn=2, xunits="", yunits="", xformat="%10.3f", yformat="%10.3f",
#wxformat="", wyformat="", min_sigdigit=7, verbose=yes)

	im_sca = 1.5
	disp_box_uv = disp_box*0.05/im_sca
	fields (ttt_xy, "1,2", lines=11) | scan (obj_x, obj_y)
	x1 = obj_x - disp_box_uv; x2 = obj_x + disp_box_uv
	y1 = obj_y - disp_box_uv; y2 = obj_y + disp_box_uv
	sec = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
	print (sec)
	xym = 50.0/disp_box_uv  #5 
	display (galex_nuv//sec, 1, xc=0.10, yc=0.2, fill-, xm=xym, ym=xym, er-, zs+, zr+)
	tv_rad = 2.0/im_sca
        tvmark (1, ttt_xy, mark="circle", radii=tv_rad, number-, nxoff=3, nyoff=3, txsize=2)

        delete(ttt_xy, ver-, >& "dev$null")
	im_sca = 0.395837
        wcsxymatch (sdss_g, sdss_g, ttt_xy, coords=ttt_radec, verbose=yes)
        disp_box_sd = disp_box*0.05/0.395837
        fields (ttt_xy, "1,2", lines=11) | scan (obj_x, obj_y)
        x1 = obj_x - disp_box_sd; x2 = obj_x + disp_box_sd
        y1 = obj_y - disp_box_sd; y2 = obj_y + disp_box_sd
        sec = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
        print (sec)
        xym = 50.0/disp_box_sd  #1.5
        display (sdss_g//sec, 1, xc=0.35, yc=0.2, fill-, xm=xym, ym=xym, er-, zs+, zr+)
	tv_rad = 2.0/im_sca
        tvmark (1, ttt_xy, mark="circle", radii=tv_rad, number-, nxoff=3, nyoff=3, txsize=2)

        delete(ttt_xy, ver-, >& "dev$null")
	im_sca = 1.0 
        wcsxymatch (mass_j, mass_j, ttt_xy, coords=ttt_radec, verbose=yes)
        disp_box_2m = disp_box*0.05/im_sca
        fields (ttt_xy, "1,2", lines=11) | scan (obj_x, obj_y)
        x1 = obj_x - disp_box_2m; x2 = obj_x + disp_box_2m
        y1 = obj_y - disp_box_2m; y2 = obj_y + disp_box_2m
        sec = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
        print (sec)
        xym = 50.0/disp_box_2m #3
        display (mass_j//sec, 1, xc=0.60, yc=0.2, fill-, xm=xym, ym=xym, er-, zs+, zr+)
	tv_rad = 2.0/im_sca
        tvmark (1, ttt_xy, mark="circle", radii=tv_rad, number-, nxoff=3, nyoff=3, txsize=2)

        delete(ttt_xy, ver-, >& "dev$null")
	im_sca = 0.86256
	wcsxymatch (spitzer_1, spitzer_1, ttt_xy, coords=ttt_radec, verbose=yes)
	disp_box_sp = disp_box*0.05/im_sca
        fields (ttt_xy, "1,2", lines=11) | scan (obj_x, obj_y)
        x1 = obj_x - disp_box_sp; x2 = obj_x + disp_box_sp
        y1 = obj_y - disp_box_sp; y2 = obj_y + disp_box_sp
        sec = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
        print (sec)
        xym = 50.0/disp_box_sp   #3
        display (spitzer_1//sec, 1, xc=0.85, yc=0.2, fill-, xm=xym, ym=xym, er-, zs+, zr+)
	tv_rad = 2.0/im_sca
        tvmark (1, ttt_xy, mark="circle", radii=tv_rad, number-, nxoff=3, nyoff=3, txsize=2)

	ra1=csc_ra - rad_deg 
	ra2=csc_ra + rad_deg 
	dec1=csc_dec - rad_deg 
	dec2=csc_dec + rad_deg 
	zone_filt = "c23 > "//ra1//" && c23 < "//ra2//" && c24 > "//dec1//" && c24 < "//dec2
	#print (zone_filt)

tselect (star_cat, "STDOUT", zone_filt) | fields (fields="15,10") | sgraph (marker="circle", pointm+, yflip+, wl=-1.0, wr=5, wb=26, wt=18, crvcolo=1, xlabel="B-I", ylabel="I")
print (csc_bi, csc_i) | sgraph (marker="circle", szmarke=0.05, pointm+, crvcolo=2, app+)

end

