procedure  m82_spiral(input, output)

string  input 	   ="M82Kcen"		{prompt="Name of the input obserced image"}
string  output     ="M82_mod"		{prompt="Name of the output modeled image"}
#real	nxpix      = 673.		{prompt="Image size along X-axis "}
#real	nypix      = 673.		{prompt="Image size along Y-axis "}
real	xcen       = 337.		{prompt="X center"}
real	ycen       = 337.		{prompt="Y center"}
real	ellip      = 0.34		{prompt="Observed axis ratio b/a of the disk"}
real	pa         = 62.0		{prompt="Observed major axis P.A. [deg] "}
real	q0halo     = 0.10		{prompt="Axis ratio c/a of the halo"}
string  spiral_file="spirfaceonm8210kpc"	{prompt="Name of the spiral image (spiral_m2_cen)"}
string  disk_file  ="disk_exp50"	{prompt="Name of the Exponential disk image [name/new]"}
string  bar_file   ="bar_cen"		{prompt="Name of the Bar image [name/new]"}
string  ring_file  ="circum_ring"	{prompt="Name of the Circumnuclear ring image [name/new/ring/hotspot]"}
string  halo_file  ="disk_exp_inc34_rot" {prompt="Name of the Halo image [name/new/none]"}
#relative strengths
real	f_exp      = 150.		{prompt="Exponential Disk strength"}
real	f_bar      = 0.3		{prompt="Bar strength relative to disk"}
real	f_spiral   = 0.2		{prompt="Spiral arm strength relative to disk at 2 scalelengths"}
real	f_ring     = 0.4 		{prompt="Circumnuclear Ring strength relative to disk"}
real	f_nucleus  = 0.4		{prompt="Starburst nucleus strength relative to disk"}
#exponential disk
real	disc_scale = 50.		{prompt="Scalelength of the disk"}
#Spiral arm parameters
real	spir_rot   = -55.		{prompt="Angle of the spiral arm wrt bar"}
string  spir_decay = "exp"		{prompt="Intensity decay along the spiral arm [exp/power/none]"}
#Bar parameters
real	bar_major  = 60.		{prompt="Bar major axis length"}
real	bar_minor  = 15.		{prompt="Bar minor axis exponential scalelength"}
#Ring parameters
real	ring_inner = 20.		{prompt="Inner radius of the ring"}
real	ring_outer = 30.		{prompt="Outer radius of the ring"}
#Nuclear parameters
real	nuc_scale  = 13.		{prompt="Starburst nucleus scalelength"}
#Halo parameters
#Control parameters
bool	subexp     = no  		{prompt="Subtract the exponential disk?"}
bool	smobar     = no  		{prompt="Smooth the bar?"}
real	incang     = 0.00		{prompt="Observed Inclination Angle [0 for calc] "}
int 	dispix     = 250 		{prompt="Image halfwidth pixels to display "}
bool	verbose    = no  		{prompt="Verbose the results?"}

begin
	string	infile, fil_exp, fil_mod, fil_bar, fil_spiral, fil_ring, size
	string	tfile1, tfile2, tfile3, tfile4, comm1, com_deV, com_rad, fil_halo
	real	xc, yc, exp_sca, c1, c2, c3, c4, c5, nuc_sca, q, q0, pangle, theta
	real	bar_maj, bar_min, ring_in, ring_out, radius, q_true, spir_pa
	real	xcc, ycc, sca_hei, inc_ang
	int	i1, nx, ny, iy1, iy2, ny1, ix1, ix2, mx, my, ndis, nn
	bool	talk, smooth, sub_exp
	string  size_double, spir_dec, zh, temp1
	
	xc = xcen; yc = ycen; exp_sca=disc_scale  #nx = nxpix; ny = nypix 
	c1 = f_exp; nuc_sca=nuc_scale   #; c3=f_spiral*c1*exp(-2.0) 
	c2 = f_bar*c1; c3=f_spiral*c1; c4 = f_ring*c1; c5=f_nucleus*c1
	q = ellip; q0 = q0halo; pangle = pa - 90.0; spir_pa = spir_rot; spir_dec = spir_decay
	bar_maj=bar_major; bar_min=bar_minor; ring_in=ring_inner; ring_out=ring_outer
	infile = input; fil_mod=output; fil_halo = halo_file 
	fil_exp = disk_file; fil_bar=bar_file; fil_spiral=spiral_file; fil_ring=ring_file 
	smooth = smobar; sub_exp = subexp; inc_ang = incang
	talk = verbose; ndis = dispix

	hselect (infile, "i_naxis1, i_naxis2", expr+) | scan (nx, ny)
	size=str(nx)//","//str(ny)

	tfile2 = "tfile2"; tfile3 = "tfile3"; tfile4 = "tfile4"; tfile1 = "tfile1"
	temp1 = fil_mod//"_cut.gki"
	imdelete(tfile1, ver-, >& "dev$null")
	imdelete(tfile2, ver-, >& "dev$null")
	imdelete(tfile3, ver-, >& "dev$null")
	imdelete(fil_mod//"_inc", ver-, >& "dev$null")
	imdelete(fil_mod//"_inc_noi", ver-, >& "dev$null")
	imdelete(fil_mod//"_faceon", ver-, >& "dev$null")
	imdelete(temp1, ver-, >& "dev$null")

	q_true = sqrt( (q**2 - q0**2)/(1.0 - q0**2))
	print("Ellipticities (obs halo true): ",q," ",q0," ",q_true)
	if (inc_ang > 0.0) q_true = cos(inc_ang*3.14/180.)
	q = q_true

	if (fil_exp == "new") {
	#comm1 = "exp(-1.0*sqrt((I-"//str(xc)//")**2 + (J-"//str(yc)//")**2)/"//str(exp_sca)//")"
	fil_exp = "M82_disk_exp"
	imdelete(fil_exp, ver-, >& "dev$null")
	nn = 1./q_true
	#nn = 4.0
	mx = nn*nx; my = nn*ny
	size_double=str(mx)//","//str(my)
	#ix1 = nx/2 + 1; ix2 = ix1 + nx - 1
	#iy1 = ny/2 + 1; iy2 = iy1 + ny - 1
	#xc = xc*2.0; yc=yc*2.0 
	ix1 = (mx-nx)/2 + 1; ix2 = ix1 + nx - 1
	iy1 = (my-ny)/2 + 1; iy2 = iy1 + ny - 1
	xcc = ix1 + nx/2; ycc= iy1 + ny/2
	comm1 = "exp(-1.0*sqrt((I-"//str(xcc)//")**2 + (J-"//str(ycc)//")**2)/"//str(exp_sca)//")"
	#xc = xc/2.0; yc=yc/2.0 
	print ("Calculating exponential disk: ",fil_exp," ",comm1)
	imexpr (comm1, tfile1, dims=size_double, verb=talk)
	#imexpr (comm1, fil_exp, dims=size, verb=talk)
	comm1 = tfile1//"["//str(ix1)//":"//str(ix2)//","//str(iy1)//":"//str(iy2)//"]"
	print ("Calculating exponential disk: ",fil_exp," ",comm1)
	imcopy(comm1, fil_exp, verb=talk)
	imdelete(tfile1, ver-, >& "dev$null")
	}
	
	if (fil_bar == "new" || fil_bar=="exp" || fil_bar == "deV" || fil_bar == "gau") {
	#if (fil_bar == "new" || fil_bar=="exp" ) {
	#comm1 = "(abs(I-"//str(xc)//") <= "//str(bar_maj)//") ? exp(-abs(J-"//str(yc)//")/"//str(bar_min)//") : 0.0" 
	#} 
	if (fil_bar == "deV"){
	comm1 = "(abs(I-"//str(xc)//") <= "//str(bar_maj)//") ? exp(-7.67)*exp(-7.67*((abs(J-"//str(yc)//")/"//str(bar_min)//")**0.25 - 1.0)) : 0.0" 
	} else if (fil_bar == "gau"){
	comm1 = "(abs(I-"//str(xc)//") <= "//str(bar_maj)//") ? exp(-((J-"//str(yc)//")/"//str(bar_min)//")**2) : 0.0" 
	} else {
	comm1 = "(abs(I-"//str(xc)//") <= "//str(bar_maj)//") ? exp(-abs(J-"//str(yc)//")/"//str(bar_min)//") : 0.0" 
	}
	fil_bar = "M82_bar_flat" 
	print ("Calculating the bar: ",fil_bar," ",comm1)
	imdelete(fil_bar, ver-, >& "dev$null")
	imexpr (comm1, tfile1, dims=size, verb=talk)
	rotate (tfile1, tfile2, rotation=4, verb=talk)
	if (smooth) {
	gauss (tfile2, fil_bar, sigma=2., ratio=0.1, theta=0.0, nsigma=1.)
	} else {
	imcopy (tfile2, fil_bar, verb=talk)
	}
	imdelete(tfile1, ver-, >& "dev$null")
	imdelete(tfile2, ver-, >& "dev$null")
	#imexpr "(abs(I-b) <= d) ? exp(-abs(J-c)/e) : 0.0" bar_minor b=460. c=414. d=60.0 e=15.0 dims=797,797
	}

	if (fil_ring == "new" || fil_ring == "ring" || fil_ring == "hotspot") {
	com_rad = "sqrt((I-"//str(xc)//")**2 + (J-"//str(yc)//")**2)"
	radius = (ring_in + ring_out)/2.0
	if (fil_ring == "hotspot") {
	comm1 = "(abs(J-"//str(yc)//") <= 6.0) ? exp(-((abs(I-"//str(xc)//")-"//str(radius)//")/6.0)**2) : 0.0"
	#((J-c) = 0.0) && (abs(I-b) = radius)) ? exp(-((abs(I-b)-radius)/2.0)**2) : 0.0
	} else {
	comm1 = "("//com_rad//" <= "//str(ring_out)//" && "//com_rad//" >= "//str(ring_in)//")"
	#imexpr "(sqrt((I-b)**2 + (J-c)**2) <= d && sqrt((I-b)**2 + (J-c)**2) >= e)" circle 
	#b=460. c=414. d=30.0 e=20.0 dims=797,797
	}
	fil_ring = "M82_ring" 
	imdelete(fil_ring, ver-, >& "dev$null")
	print ("Calculating the ring: ",fil_ring, " ",comm1)
	imexpr (comm1, fil_ring, dims=size, verb=talk)
	}

	if (fil_halo == "new" || fil_halo == "none" || fil_halo == "sech" ) {
	#tfile4 = fil_mod//"_halo"
	imdelete(fil_mod//"_halo", ver-, >& "dev$null")
	comm1 = "repl(0.0,"//str(nx)//")" 
	print ("Preparing Halo : ",comm1)
	imexpr (comm1, tfile4, dim=size, verb=talk)
	if (fil_halo == "new" ) {
	ny1 = ny*q0; iy1 = (ny - ny1)/2 + 1; iy2 = iy1 + ny1 - 1
	magnify (fil_exp, tfile2, xmag=1.00, ymag=q0, logfile="magnify.log")
	imcopy (tfile2, tfile4//"[*,"//str(iy1)//":"//str(iy2)//"]", verb=talk)
	imdelete(tfile2, ver-, >& "dev$null")
	}
	if (fil_halo == "sech" ) {
	imdelete(tfile4, ver-, >& "dev$null")
	sca_hei = 25.0
	zh = "(J-"//str(yc)//")/"//str(sca_hei)
	#i0 = exp(-1.0*abs(I-"//str(xc)//"))
	comm1 = "(abs("//zh//") <= 1.0) ? "//str(c1)//"*exp(-1.0*abs(I-"//str(xc)//")/"//str(exp_sca)//")*(1.0 - ("//zh//"/2.0)**2) : "//str(c1)//"*4.0*exp(-1.0*abs(I-"//str(xc)//")/"//str(exp_sca)//")*exp(-2.0*abs("//zh//"))" 
	#comm1 = "(abs("//zh//") <= 1.0) ? 1.0 - ("//zh//"/2.0")**2 : exp(-2.0*abs("//zh//"))" 
	print ("Preparing Sech Halo : ",comm1)
        imexpr (comm1, tfile4, dims=size, verb=talk)
	}
	rotate (tfile4, fil_mod//"_halo", rotation=pangle, verb=talk)
	imdelete(tfile2, ver-, >& "dev$null")
	imdelete(tfile4, ver-, >& "dev$null")
	fil_halo = fil_mod//"_halo"
	}

	hselect (fil_spiral, "i_naxis1, i_naxis2", expr+) | scan (mx, my)
	if (mx != nx || my != ny) {
        imexpr ("(a <= 0.0) ? 0.001 : a", tfile2, fil_spiral, verb=talk)
	if (mx > nx || my > ny) {
	iy1 = (my - ny)/2 + 1; iy2 = iy1 + ny - 1
	ix1 = (mx - nx)/2 + 1; ix2 = ix1 + nx - 1
	comm1 = tfile2//"["//str(ix1)//":"//str(ix2)//","//str(iy1)//":"//str(iy2)//"]"
	print ("Centering the spiral image : ",comm1)
	imcopy (comm1, tfile3, verb=talk)
	} 
	if (mx < nx || my < ny) {
	#imexpr ("(a <= 0.0) ? 0.001 : a", tfile2, fil_spiral, verb=talk)
	iy1 = (ny - my)/2 + 1; iy2 = iy1 + my - 1
	ix1 = (nx - mx)/2 + 1; ix2 = ix1 + mx - 1
	comm1 = "repl(0.0,"//str(nx)//")" 
	imexpr (comm1, tfile3, dim=size, verb=talk)
	comm1 = tfile3//"["//str(ix1)//":"//str(ix2)//","//str(iy1)//":"//str(iy2)//"]"
	print ("Centering the spiral image : ",comm1)
	imcopy (tfile2, comm1, verb=talk)
	imdelete(tfile2, ver-, >& "dev$null")
	}
	fil_spiral = "SPIRAL_SCALED"
	imdelete(fil_spiral, ver-, >& "dev$null")

	if (spir_dec == "power"){
        comm1 = "a/((I-"//str(xc)//")**2 + (J-"//str(yc)//")**2)"
	imdelete(tfile2, ver-, >& "dev$null")
	imexpr(comm1, tfile2, tfile3, verb=talk)
	imdelete(tfile3, ver-, >& "dev$null")
	imrename (tfile2, tfile3, verb=talk)
	} else if (spir_dec == "exp") {
	imdelete(tfile2, ver-, >& "dev$null")
		imarith (tfile3, "*", fil_exp, tfile3, verb=talk)
	} else {
	c3=c3*exp(-2.0)
	}
	rotate (tfile3, fil_spiral, rotation=spir_pa, verb=talk)
	imdelete(tfile3, ver-, >& "dev$null")
	}

	com_deV = "exp(-7.67*((sqrt((I-"//str(xc)//")**2 + (J-"//str(yc)//")**2)/"//str(nuc_sca)//")**0.25 - 1.0))"
	comm1 = str(c1)//"*a+"//str(c2)//"*b+"//str(c3)//"*c+"//str(c4)//"*d+"//str(c5)//"*"//com_deV
	print ("Constructing the galaxy : ",fil_mod//"_faceon ",comm1)
	if (sub_exp) imarith (fil_exp, "*", 0.0, fil_exp, verb=talk)
	imexpr (comm1, fil_mod//"_faceon", fil_exp, fil_bar, fil_spiral, fil_ring, verb=talk)

	magnify (fil_mod//"_faceon", tfile2, xmag=1.00, ymag=q, logfile="magnify.log")
	comm1 = "repl(0.0,"//str(nx)//")" 
	print (comm1)
	imexpr (comm1, tfile4, dim=size, verb=talk)
	ny1 = ny*q; iy1 = (ny - ny1)/2 + 1; iy2 = iy1 + ny1 - 1
	imcopy (tfile2, tfile4//"[*,"//str(iy1)//":"//str(iy2)//"]", verb=talk)
	imdelete(tfile2, ver-, >& "dev$null")
	rotate (tfile4, fil_mod//"_inc", rotation=pangle, verb=talk)
	imarith (fil_mod//"_inc", "+", fil_halo, fil_mod//"_inc", verb=talk)
	mknoise (fil_mod//"_inc", output=fil_mod//"_inc_noi", poisson+)
	imcopy (fil_mod//"_faceon", tfile1, verb=talk)
	imdelete(fil_mod//"_faceon", ver-, >& "dev$null")
	rotate (tfile1, fil_mod//"_faceon", rotation=pangle, verb=talk)
	imdelete(tfile1, ver-, >& "dev$null")
	imdelete(tfile3, ver-, >& "dev$null")
	imdelete(tfile4, ver-, >& "dev$null")
	ix1 = xc-ndis; ix2 = xc+ndis; iy1 = yc-ndis; iy2 = yc+ndis
	comm1 = "["//str(ix1)//":"//str(ix2)//","//str(iy1)//":"//str(iy2)//"]"
	display (fil_mod//"_inc"//comm1, 1, zs-, zr-, z1=-1, z2=750, ztrans="log")
	display (infile//comm1, 2, zs-, zr-, z1=-1, z2=750, ztrans="log")
	display (fil_mod//"_inc_noi"//comm1, 3, zs-, zr-, z1=-1, z2=750, ztrans="log")
	display (fil_mod//"_faceon"//comm1, 4, zs-, zr-, z1=-1, z2=750, ztrans="log")
	pangle = pangle + 90.0; theta = pangle + 270.
	delete ("obs_major.txt", veri-, >& "dev$null")
	delete ("mod_major.txt", veri-, >& "dev$null")
	delete ("obs_minor.txt", veri-, >& "dev$null")
	delete ("mod_minor.txt", veri-, >& "dev$null")
	pvector (fil_mod//"_inc", xc=xc, yc=yc, theta=theta, width=5.0, vec_out="mod_major.txt", wx1=ix1, wx2=ix2)
	pvector (infile, xc=xc, yc=yc, theta=theta, width=5.0, vec_out="obs_major.txt", wx1=ix1, wx2=ix2)
	pvector (fil_mod//"_inc", xc=xc, yc=yc, theta=pangle, width=5.0, vec_out="mod_minor.txt", wx1=ix1, wx2=ix2)
	pvector (infile, xc=xc, yc=yc, theta=pangle, width=5.0, vec_out="obs_minor.txt", wx1=ix1, wx2=ix2)

	pvector (fil_mod//"_inc", xc=xc, yc=yc, theta=theta, width=5.0, vec_out="", wx1=ix1, wx2=ix2, logy+, >>G temp1)
	pvector (infile, xc=xc, yc=yc, theta=theta, width=5.0, vec_out="", wx1=ix1, wx2=ix2, pointmo+, logy+, app+, >>G temp1)
	pvector (fil_mod//"_inc", xc=xc, yc=yc, theta=pangle, width=5.0, vec_out="", wx1=ix1, wx2=ix2, logy+, >>G temp1)
	pvector (infile, xc=xc, yc=yc, theta=pangle, width=5.0, vec_out="", wx1=ix1, wx2=ix2, pointmo+, logy+, app+, >>G temp1)

	gkimosaic (temp1, rotate=no, fill=yes, interactive=no, nx=1, ny=2)

	print("***DONE***")

end	
