	procedure  noise(magnitude, medsky, rmssky, exptime, areapix)

	real	magnitude=-10.0		{prompt="Instrumental Magnitude"}
	real	medsky   =1000.0	{prompt="Sky median/pix/sec"}
	real	rmssky   =10.0		{prompt="Sky rms/pix/sec"}
	real	exptime  =1.0		{prompt="Total exposure time in secs"}
	real	areapix  =100.0		{prompt="Aperture Area in pixels"}
	real	fracsky  =0.004		{prompt="Uncertainty in the Sky median estimation"}
	real	ccdgain  =1.0		{prompt="CCD gain in ADUs/electron"}

begin
	real	mag, npix, skymd, skyrms, skyfrac, texp, gain, count, sigma, dm
	real	sig_sky_unc, sig_sky_noi, sig_obj_noi

	mag	= magnitude
	skymd	= medsky
	skyrms	= rmssky
	texp    = exptime
	npix	= areapix
	skyfrac = fracsky
	gain    = ccdgain

	count = 10**(-0.4*mag)
	sig_sky_unc = 0.0  #npix*skyfrac*skymd/count
	#make sure that skymd == 0.0 for optical and nonzero for NIR
	if (skymd == 0.0) {sig_sky_unc = skyrms*npix/count}
	#make sure that skymd = skyres < 10.0 for optical and > 10 for NIR
	#if (skymd < 10.0) {sig_sky_unc = skymd*npix/count}
	sig_sky_noi = sqrt(npix)*skyrms/count
	sig_obj_noi = 1.0/sqrt(count*gain*texp)        
	sigma = sqrt(sig_sky_unc**2 + sig_sky_noi**2 + sig_obj_noi**2)
	#sigma > 0.30 ==> signal=err, so the formula not valid,
	#so maximum signal = 2*signal = 2*error or log(err) = 0.30
	if (sigma > 0.30) {sigma=0.30}
	dm = 1.086*(sigma)

	printf ("%8.3f %8.3f %8.3f %8.3f \n", dm, sig_sky_unc, sig_sky_noi, sig_obj_noi)

end
