procedure  reduce(imfile,alig,alfil,clea,psff,xpos,ypos,xfwhm,yfwhm)

string imfile                          {prompt="Image to be psf matched"}
string clea  = "yes"                   {prompt="Clean the image?"}
string alig  = "yes"                   {prompt="Align the image?"}
string alfil                           {prompt="Align database rootname"}
string psff  = "yes"                   {prompt="Match the psfs? "}
real   xpos                            {prompt="X position of psf star" }
real   ypos                            {prompt="Y position of psf star" }
real   xfwhm = "6.5"                   {prompt="Gaussian FWHM along X" }
real   yfwhm = "6.5"                   {prompt="Gaussian FWHM along Y" }
real   xin   = "1"                     {prompt="Starting X for geomap" }
real   xout  = "385"                   {prompt="Ending X for geomap" }
real   yin   = "1"                     {prompt="Starting X for geomap" }
real   yout  = "578"                   {prompt="Ending X for geomap" }

begin

	string imfil, refpos, psftit, imfil1, imfil2, satisfy, coo
	string align, clean, psf
	real   x0, y0, Rx, Ry, x1, x2, y1, y2
	int    nx, ny

	imfil = imfile
	imfil1 = imfil//"ed" 
	imfil2 = imfil//"a" 
	align  = alig
	clean  = clea
	psf    = psff
	coo    = alfil
	x0 = xpos
	y0 = ypos
	Rx = xfwhm
	Ry = yfwhm
	x1 = xin
	x2 = xout
	y1 = yin
	y2 = yout
	refpos = str(x0)//" "//str(y0)
	psftit = "PSFs matched("//str(Rx)//" x "//str(Ry)//")"

	if (clean!="yes") {
        	print("Is the image already cleaned? [yes/no] " )
        	scan (satisfy)
        	if (satisfy!="yes") imfil1 = imfil
		if (align!="yes")  { 
        		print("Is the image already aligned? [yes/no] " )
        		scan (satisfy)
        		if (satisfy!="yes") imfil2 = imfil
			if (psf!="yes") goto exit
			goto psf
		} else {
			goto align 
		}
	}

clean:

imdelete (imfil//"cr", ver-)
cosmicrays (imfil, imfil//"cr", "yes", badpix="", ccdtype="", threshold=25.,
fluxratio=2.0, npasses=5, window="5", interactive=yes, train=no,
objects="", savefile="")

    print("Displaying cosmic ray cleaned image: ", imfil//"cr") 
	display (imfil//"cr")

        print("Is the cosmic ray removal satisfactory? [yes/no] " )
        scan (satisfy)
        if (satisfy!="yes") {
		imdelete (imfil//"cr", ver-)
		print("Re-running cosmic rays ....")
		goto clean
	}

imdelete (imfil//"ed", ver-)
imedit (imfil//"cr",
imfil//"ed", cursor="", logfile="", display=yes, autodisplay=yes,
autosurface=no, aperture="circular", radius=2., search=4., buffer=1.,
width=2., xorder=2, yorder=2, value=0., sigma=INDEF, angh=-33., angv=25.,
command="display $image 4 erase=$erase fill=no xmag=0.6 ymag=0.6 order=0 >& dev$null",
graphics="stdgraph", default="b", fixpix=no)

#imreplace (imfil//"ed[*,1:2]", -9.0, imaginary=0., lower=INDEF, upper=INDEF)
#imreplace (imfil//"ed[*,571:578]", -9.0, imaginary=0., lower=INDEF, upper=INDEF)

	if (align!="yes")  {
        	imfil2 = imfil1
		goto psf 
	}

align:

images.geomap (imfil//".coo",
 coo//".db", x1, x2, y1, y2, function="polynomial", xxorder=2,
xyorder=2, xxterms=no, yxorder=2, yyorder=2, yxterms=no, reject=0.,
calctype="real", verbose=yes, interactive=yes, graphics="stdgraph", cursor="")

imdelete (imfil//"a", ver-)
images.register (imfil1, imfil//"a", coo//".db", imfil//".coo", 
geometry="geometric", xmin=x1, xmax=x2, ymin=y1, ymax=y2, 
xscale=1., yscale=1., ncols=INDEF, nlines=INDEF, xsample=1., ysample=1., 
interpolant="linear",
boundary="constant", constant=-9.0, fluxconserve=yes, nxblock=256, nyblock=256)

    print("Displaying aligned image: ", imfil//"a") 
	display (imfil//"a")

if (psf!="yes") goto exit 

psf: 

if (psf!="yes") goto exit 

imgets (imfil2, "i_naxis1", value="")
        nx = int(imgets.value)
imgets (imfil2, "i_naxis2", value="")
        ny = int(imgets.value)
#imgets (imfil, "i_minpixval", value="")
imgets (imfil2, "i_title", value="")
        = (imgets.value)

imdelete ("tempgau", ver-)
imdelete ("temppsf", ver-)
imdelete ("ker"//imfil2, ver-)
imdelete (imfil//"psf", ver-)

mkgauss ("tempgau",
 nx, ny, x0, y0, 1., 0., 0., Rx, Ry, 0., seed=347951)

psfmatch (imfil2, "tempgau", refpos,
 "", output="temppsf", convolution="image",
dnx=31, dny=31, pnx=15, pny=15, center=yes, background="median",
loreject=INDEF, hireject=INDEF, apodize=0., fluxratio="INDEF",
filter="replace", sx1=INDEF, sx2=INDEF, sy1=INDEF, sy2=INDEF, radsym=no,
threshold=0.2, normfactor=1., boundary="nearest", constant=0., interactive=no,
verbose=yes, graphics="stdgraph", display="stdimage", gcommands="",
icommands="")

imcalc ("temppsf", imfil//"psf", "if im1 .gt. 0.0 then im1 else -9.0", pixtype="old", nullval=0., verbose=yes)

#moveheader (imfil, "temppsf", imfil//"psf")

hedit (imfil//"psf", "PSFMATCH", psftit, add=yes, delete=no, verify=no)
#show=yes, update=yes)

    print("Displaying PSF corrected image: ", imfil//"psf") 
	display (imfil//"psf")

exit:
        print(" Done *** " )

end

# The edge values in the image will be wrong due to the interpolations, during
# alignment. Reset them to -9.0 (inval) to ignore them in future reductions.

#imedit ("25an36r2psf",
#" ", cursor="25an36r2.edt", logfile="imedit.log", display=yes,
#autodisplay=yes, autosurface=no, aperture="circular", radius=2., search=2.,
#buffer=1., width=2., xorder=2, yorder=2, value=-9., sigma=INDEF, angh=-33.,
#angv=25.,
#command="display $image 1 erase=$erase fill=yes order=0 >& dev$null",
#graphics="stdgraph", default="b", fixpix=no)

