procedure	regtomask(regfil)

string  regfil  = "test.reg"     {prompt="Input ds9 region file"}
string  maskim   = "DEFAULT"     {prompt="Out mask image"}
string  refim   = ""     	{prompt="Reference image for coordinate system"}
bool    outfits = no        	{prompt="Mask file is .fits or .pl?"}
string	dims	= "500,500"     {prompt="Output image dimensions"}

begin
	string	regf, imfil, size, tfil, tline, com_rad, comm1
	string	immask, tmpmask, theta, ell_radius, extn
	real	xc, yc, radius, a, b, smaj, smin, pa
	int	ncir, j, i1, nx

	regf = regfil; imfil = refim; size = dims; immask = maskim
	extn = ".pl"
	if (outfits)extn = ".fits"

	#tfil = "temp_regtomask.lis"
        #delete(tfil, ver-, >& "dev$null")

	#if (immask == "DEFAULT" || !imaccess(immask))immask = "tttt_mask"
	if (immask == "")immask = "DEFAULT"
	if (immask == "DEFAULT" && !imaccess(imfil))immask = "tttt_mask"//extn

        #imdelete(immask, ver-, >& "dev$null")

	tmpmask = "temp_mask"//extn; imdelete(tmpmask//extn, ver-, >& "dev$null")
	i1 = strstr(",", size)
	nx = int(substr(size, 1, i1-1))
	if (!imaccess(imfil) || imfil == ""){
		imexpr("repl(0,"//str(nx)//")", tmpmask, dims=size, verb-)
		} else {
		imexpr("a*0", tmpmask, imfil, verb-)
        	if (immask == "DEFAULT"){immask = imfil//"_mask"//extn}
		}
	#imhead(tmpmask)

	regtoxy (regf, shape="circle", separ=",", entry=1, verb-)
	ncir = regtoxy.nshape
	if (ncir > 0) {
	print("Preparing circular mask at the following ", ncir, " positions: ")
        for (j=1; j <= ncir; j +=1) {
	  regtoxy (regf, shape="circle", separ=",", entry=j, verb-) 
	  print(regtoxy.values) | scan(xc, yc, radius)
	  print(j, xc, yc, radius)
          com_rad = "sqrt((I-"//str(xc)//")**2 + (J-"//str(yc)//")**2)"
          comm1 = "("//com_rad//" <= "//str(radius)//" || a=1 ? 1 : 0)"
          #print(comm1)
          imdelete(immask, ver-, >& "dev$null")
          #print ("Preparing circular mask ",comm1)
          imexpr (comm1, immask, tmpmask, verb-)
          imdelete(tmpmask, ver-, >& "dev$null")
          imrename(immask, tmpmask, verb-)
        }
        }

        regtoxy (regf, shape="ellipse", separ=",", entry=1, verb-)
        ncir = regtoxy.nshape
	if (ncir > 0) {
	print("Preparing elliptical mask at the following ", ncir, " positions: ")
        for (j=1; j <= ncir; j +=1) {
          regtoxy (regf, shape="ellipse", separ=",", entry=j, verb-) 
          print(regtoxy.values) | scan(xc, yc, a, b, pa)
	  #a = a/2.; b = b/2.
	  if (b > a){pa = pa - 90.0; smaj = b; smin = a} else { smaj = a; smin = b}
	  pa = pa - 90.0
	  if (pa > 180){pa = pa - 180.0}
	  print(j, xc, yc, smaj, smin, pa)
          #print(xc, yc, radius)
	  theta = "atan((I-"//str(xc)//")/(J-"//str(yc)//")) + "//str(rad(pa))
	  ell_radius = "sqrt("//str(smaj)//"**2*cos("//theta//")**2 + "//str(smin)//"**2*sin("//theta//")**2)"
	  #print(theta)
	  #print(ell_radius)
          com_rad = "sqrt((I-"//str(xc)//")**2 + (J-"//str(yc)//")**2)"
          comm1 = "("//com_rad//" <= "//ell_radius//" || a=1 ? 1 : 0)"
          #print(comm1)
          imdelete(immask, ver-, >& "dev$null")
          #print ("Preparing elliptical mask ",comm1)
          imexpr (comm1, immask, tmpmask, verb-)
          imdelete(tmpmask, ver-, >& "dev$null")
          imrename(immask, tmpmask, verb-)
          #imexpr (comm1, immask, dims=size, verb-)
        }
        }

        regtoxy (regf, shape="box", separ=",", entry=1, verb-)
        ncir = regtoxy.nshape
	if (ncir > 0) {
        print("Preparing elliptical box mask at the following ", ncir, " positions: ")
        for (j=1; j <= ncir; j +=1) {
          regtoxy (regf, shape="box", separ=",", entry=j, verb-)
          print(regtoxy.values) | scan(xc, yc, a, b, pa)
          a = a/2.; b = b/2.
          if (b > a){pa = pa - 90.0; smaj = b; smin = a} else { smaj = a; smin = b}
          pa = pa - 90.0
          if (pa > 180){pa = pa - 180.0}
          print(j, xc, yc, smaj, smin, pa)
          #print(xc, yc, radius)
          theta = "atan((I-"//str(xc)//")/(J-"//str(yc)//")) + "//str(rad(pa))
          ell_radius = "sqrt("//str(smaj)//"**2*cos("//theta//")**2 + "//str(smin)//"**2*sin("//theta//")**2)"
          #print(theta)
          #print(ell_radius)
          com_rad = "sqrt((I-"//str(xc)//")**2 + (J-"//str(yc)//")**2)"
          comm1 = "("//com_rad//" <= "//ell_radius//" || a=1 ? 1 : 0)"
          #print(comm1)
          imdelete(immask, ver-, >& "dev$null")
          #print ("Preparing elliptical mask ",comm1)
          imexpr (comm1, immask, tmpmask, verb-)
          imdelete(tmpmask, ver-, >& "dev$null")
          imrename(immask, tmpmask, verb-)
          #imexpr (comm1, immask, dims=size, verb-)
        }
        }

          imrename(tmpmask, immask, verb-)

end
