procedure s0prof (infileB,infileV,infileR,infileK,run)

string  infileB  = "ugc7880b_n"              {prompt="B image file name"}
string  infileV  = "ugc7880v_n"              {prompt="V image file name"}
string  infileR  = "ugc7880r_n"              {prompt="R image file name"}
string  infileK  = "u7880k_gau_n"            {prompt="K image file name"}
string  intable  = "ugc7880"                 {prompt="Input table name"}
string  imagdir  = "home$s0/aperture_phot/images/" {prompt="Image Directory"}
#string  calphas  = "22.88 23.49 22.45 20.15" {prompt="Zeropoints"}
#string  cbetas   = "-0.095 0.075 -0.408 0.0" {prompt="Color coefficients"}
string  cextin   = "0.20 0.11 0.07 0.03"     {prompt="Extinction coefficients"}
string  run      = "feb"                    {prompt="Month of the run(feb/oct)"}
bool    skip     = "no"            {prompt="Skip the aperture photometry part?"}

begin

	string  skyreg,imfile[4],statsec,obsdate[4],tabfil,filt[4],fitsdir
	string  ifile[4]
	real    radminb[99],magb[99],radminv[99],magv[99]
	real    radminr[99],magr[99],radmink[99],magk[99]
	real    airmass[4], obstime[4], ymean[4], yrms[4], ymed[4] 
	int     x1,x2,y1,y2,x,y,i1,i2
	real    mag0b[99],mag0v[99],mag0r[99],mag0k[99], a1, a2, a3, a4
	real    ext[4],alpha[4],beta[4],rad,apmag
	real    mag00b[99],mag00v[99],mag00r[99],mag00k[99]
	real    colbv[99],colvr[99],colbr[99],colvk[99],pix2arc
	real    sma,intensb,intensv,intensr,intensk
	real    intensb_err,intensv_err,intensr_err,intensk_err
	real    sb_b0,sb_v0,sb_r0,sb_k0,dmu,dmuerr,smalg
	real    sb_b,sb_v,sb_r,sb_k,sb_colbv,sb_colvr,sb_colvk,sb_colbr
        real    sky_bv,sky_vr,sky_b,sky_v,sky_r
	string  alphas,betas,extin,magtab,month,alphasfeb,alphasoct
        bool    skyerr

        skyerr = skip
	pix2arc = -0.35
	tabfil = intable
	fitsdir = imagdir
	#skyreg = skysec
	
  	ifile[1] = infileB
  	ifile[2] = infileV
  	ifile[3] = infileR
  	ifile[4] = infileK

  	imfile[1] = fitsdir//ifile[1]
  	imfile[2] = fitsdir//ifile[2]
  	imfile[3] = fitsdir//ifile[3]
  	imfile[4] = fitsdir//ifile[4]
	
        filt[1] = "b"
        filt[2] = "v"
        filt[3] = "r"
        filt[4] = "k"

	month  = run

	#alphas = calphas
	#betas  = cbetas
        extin  = cextin

	alphasfeb = "22.88 23.49 22.45 20.15"
	alphasoct = "22.60 23.21 22.15 20.15"
	betas     = "-0.095 0.075 -0.408 0.0"

	if (month == "feb") {
	  alphas = alphasfeb
	} else {
	  alphas = alphasoct
	}

        i2 = fscan(alphas, a1, a2, a3, a4)
	print(a1,a2,a3,a4)
	alpha[1] = a1 
	alpha[2] = a2 
	alpha[3] = a3
	alpha[4] = a4
        i2 = fscan(betas,a1,a2,a3,a4)
	print(a1,a2,a3,a4)
	beta[1] = a1
	beta[2] = a2
	beta[3] = a3
	beta[4] = a4
        i2 = fscan(extin,a1,a2,a3,a4)
	print(a1,a2,a3,a4)
	ext[1] = a1
	ext[2] = a2
	ext[3] = a3
	ext[4] = a4

	print(alpha[1],alpha[2],alpha[3],alpha[4])
	print(beta[1],beta[2],beta[3],beta[4])
	print(ext[1],ext[2],ext[3],ext[4])
	

  display (imfile[1])
  print ("**** select a region for measuring sky and hit spacebar")
  = fscan (imcur, x, y)
  x1=x-2
  y1=y-2
  x2=x+2
  y2=y+2
  skyreg = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
  print(skyreg)
  
for (i=1; i <=4; i +=1){
  imstat (imfile[i]//skyreg, fields="image,npix,mean,stddev,midpt", format- ) | cat >> imfile[1]//"_imstat.log"
  #del ("s0imstat.log", ver-, >& "dev$null")
  imstat (imfile[i]//skyreg, fields="mean,stddev,midpt", format- ) | scan (ymean[i], yrms[i], ymed[i])
  keypar (imfile[i], "AIRMASS")
  airmass[i] = real(keypar.value)
  keypar (imfile[i], "EXPTIME")
  obstime[i] = real(keypar.value)
  if (i == 4) {
  	keypar (imfile[i], "TIME")
	} else {
	keypar (imfile[i], "DATE-OBS")
	}
  obsdate[i] = (keypar.value)
  #print (imfile[i], " ", airmass[i], obstime[i], ymean[i], yrms[i], ymed[i]," ",obsdate[i])
  printf ("%7.4f %8.1f %10.3f %8.3f %10.3f %c %c %c \n",airmass[i], obstime[i], ymean[i], yrms[i], ymed[i], tabfil//filt[i]//".tbl", ifile[i], obsdate[i])
  printf ("%7.4f %8.1f %10.3f %8.3f %10.3f %c %c %c \n",airmass[i], obstime[i], ymean[i], yrms[i], ymed[i], tabfil//filt[i]//".tbl", ifile[i], obsdate[i]) | cat >> imfile[1]//"_imstat.log"
  del (tabfil//filt[i]//".tab", ver-, >& "dev$null")
  tcreate (tabfil//filt[i],"tabhead",tabfil//filt[i]//".tbl",nskip=7)

  if (i == 1) {
  del (tabfil//filt[i]//".ver", ver-, >& "dev$null")
  del (tabfil//filt[i]//".coo", ver-, >& "dev$null")
  elapert (tabfil//filt[i], tabfil//filt[i]//".ver", tabfil//filt[i]//".coo")
  }
  
  del (tabfil//filt[i]//".ply.1", ver- , >& "dev$null")
  if (i == 4) {
  polyphot (imfile[i], polygon=tabfil//filt[1]//".ver", coords=tabfil//filt[1]//".coo", output=tabfil//filt[i]//".ply.1", int-, salgori="constant", skyvalu=ymed[i], zmag=0, exposur=" ", itime=1.0)
	} else {
  polyphot (imfile[i], polygon=tabfil//filt[1]//".ver", coords=tabfil//filt[1]//".coo", output=tabfil//filt[i]//".ply.1", int-, salgori="constant", skyvalu=ymed[i], exposur="EXPTIME", zmag=0)
  }
  del (tabfil//filt[i]//".mag", ver-,  >& "dev$null")
  txdump (tabfil//filt[i]//".ply.1", "MINRAD MAG") | cat >> tabfil//filt[i]//".mag" 

}

if (skyerr) goto skyerr

for (i=1; i <=4; i +=1){
	i1 = 0
	list = tabfil//filt[i]//".mag"
        while( fscan(list, rad, apmag) != EOF ) {
                i1=i1+1
                if (i == 1)radminb[i1] = rad
                if (i == 1)magb[i1] = apmag
                if (i == 2)radminv[i1] = rad
                if (i == 2)magv[i1] = apmag
                if (i == 3)radminr[i1] = rad
                if (i == 3)magr[i1] = apmag
                if (i == 4)radmink[i1] = rad
                if (i == 4)magk[i1] = apmag
	}
}

  del (tabfil//".mag", ver-,  >& "dev$null")
for (j=1; j <=i1; j +=1){
	mag0b[j] = magb[j] - ext[1]*airmass[1]
	mag0v[j] = magv[j] - ext[2]*airmass[2]
	mag0r[j] = magr[j] - ext[3]*airmass[3]
	mag0k[j] = magk[j] - ext[4]*airmass[4]

	mag00b[j] = mag0b[j] + alpha[1] + beta[1]*(mag0b[j] - mag0v[j])
	mag00v[j] = mag0v[j] + alpha[2] + beta[2]*(mag0b[j] - mag0v[j])
	mag00r[j] = mag0r[j] + alpha[3] + beta[3]*(mag0v[j] - mag0r[j])
	mag00k[j] = mag0k[j] + alpha[4]

	colbv[j] = mag00b[j] - mag00v[j]
	colvr[j] = mag00v[j] - mag00r[j]
	colbr[j] = mag00b[j] - mag00r[j]
	colvk[j] = mag00v[j] - mag00k[j]

	tprint (tabfil//filt[1],rows=j+1,showrow-,showhdr-,showuni-,columns="SMA INTENS INT_ERR") | scan(sma, intensb, intensb_err)
	tprint (tabfil//filt[2],rows=j+1,showrow-,showhdr-,showuni-,columns="SMA INTENS INT_ERR") | scan(sma, intensv, intensv_err)
	tprint (tabfil//filt[3],rows=j+1,showrow-,showhdr-,showuni-,columns="SMA INTENS INT_ERR") | scan(sma, intensr, intensr_err)
	tprint (tabfil//filt[4],rows=j+1,showrow-,showhdr-,showuni-,columns="SMA INTENS INT_ERR") | scan(sma, intensk, intensk_err)
  sb_b0 = -2.5*log10((intensb - ymed[1])/obstime[1]) - ext[1]*airmass[1]
  sb_v0 = -2.5*log10((intensv - ymed[2])/obstime[2]) - ext[2]*airmass[2]
  sb_r0 = -2.5*log10((intensr - ymed[3])/obstime[3]) - ext[3]*airmass[3]
  sb_k0 = -2.5*log10(intensk - ymed[4]) - ext[4]*airmass[4]

  sb_b = sb_b0 + alpha[1] + beta[1]*(sb_b0 - sb_v0) + pix2arc
  sb_v = sb_v0 + alpha[2] + beta[2]*(sb_b0 - sb_v0) + pix2arc
  sb_r = sb_r0 + alpha[3] + beta[3]*(sb_v0 - sb_r0) + pix2arc
  sb_k = sb_k0 + alpha[4] + pix2arc

  sb_colbv = sb_b - sb_v
  sb_colvr = sb_v - sb_r
  sb_colbr = sb_b - sb_r
  sb_colvk = sb_v - sb_k
  smalg    = log10(sma)
  #fracb = (intensb/ymed[1]) - 1.0
  dmu = 1.0857*(0.0005*ymed[1])/(intensb - ymed[1])
  dmuerr = 1.0857*(intensb_err)/(intensb - ymed[1])


	printf ("%8.3f %7.3f %7.3f %7.3f %7.3f %7.3f %8.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f \n", radminb[j], mag00b[j], colbv[j], colvr[j], colbr[j], colvk[j],smalg, sb_b, sb_colbv,sb_colvr,sb_colbr,sb_colvk,dmu,dmuerr)  | cat >> tabfil//".mag"
  #print(radminb[j],mag00b[j]) | sgraph
}

skyerr:
  
  sky_bv = -2.5*log10(ymed[1]/obstime[1]) + 2.5*log10(ymed[2]/obstime[2])	
  sky_vr = -2.5*log10(ymed[2]/obstime[2]) + 2.5*log10(ymed[3]/obstime[3])	
  sky_b = -2.5*log10(ymed[1]/obstime[1]) + alpha[1] + beta[1]*sky_bv + pix2arc
  sky_v = -2.5*log10(ymed[2]/obstime[2]) + alpha[2] + beta[2]*sky_bv + pix2arc
  sky_r = -2.5*log10(ymed[3]/obstime[3]) + alpha[3] + beta[3]*sky_vr + pix2arc

  printf ("%7.3f %7.3f %7.3f \n", sky_b, sky_v, sky_r)

  magtab = tabfil//".mag.tab"
  del (magtab, ver-, >& "dev$null")
  tcreate (magtab,"tabhead.mag",tabfil//".mag",nskip=0)


  del (tabfil//".col1.coe", ver-, >& "dev$null")
  del (tabfil//".col2.coe", ver-, >& "dev$null")
  del (tabfil//".col3.coe", ver-, >& "dev$null")
  tprint (magtab, showrow-, columns="smalg sb_colvk") | nfit1d (output=tabfil//".col3.coe", functio="user")
  tprint (magtab, showrow-, columns="smalg sb_colbv") | nfit1d (output=tabfil//".col1.coe", functio="user")
  tprint (magtab, showrow-, columns="smalg sb_colbr") | nfit1d (output=tabfil//".col2.coe", functio="user")
  tprint (magtab, showrow-, columns="radmin sb_b") | sgraph
  #nfit1d ("magtab smalg sb_colbv", tabfil//".col1.coe", functio="user")
  #nfit1d ("magtab smalg sb_colbr", tabfil//".col2.coe", functio="user")
  #nfit1d ("magtab smalg sb_colvk", tabfil//".col3.coe", functio="user")

#for (j=1; j <=99; j +=1){
#	tprint (tabfil//filt[1],rows=j,showrow-,showhdr-,showuni-,columns="SMA INTENS INT_ERR") | scan(sma[j], intensb[j], intensb_err[j])
#print (sma[j], intensb[j], intensb_err[j]) | cat >> "temp.dat"
#}

#for (i=1; i <=4; i +=1){
#        i1 = 0
#        list = tabfil//filt[i]//".tbl"
#        while( fscan(list, rad, apmag) != EOF ) {
#                i1=i1+1
#                if (i == 1)radminb[i1] = rad
#                if (i == 1)magb[i1] = apmag
#                if (i == 2)radminv[i1] = rad
#                if (i == 2)magv[i1] = apmag
#                if (i == 3)radminr[i1] = rad
#                if (i == 3)magr[i1] = apmag
#                if (i == 4)radmink[i1] = rad
#                if (i == 4)magk[i1] = apmag
#	}
#}

  #txdump (tabfil//filt[3]//".ply.1", "MINRAD MAG") | sgraph 
  #txdump (tabfil//filt[1]//".ply.1", "MINRAD MAG") | sgraph app+
  #txdump (tabfil//filt[2]//".ply.1", "MINRAD MAG") | sgraph app+
  
  #txdump (tabfil//filt[2]//".ply.1", "MINRAD MAG") | cat >> tabfil//filt[1]//".mag" 

print ("DONE")

end
