procedure sbprof (infile)

string  infile   = "arp143.in"                {prompt="Input file name (.tab)"}
string  imagdir  = "home$roberto/"            {prompt="Input file Directory"}
string  trafile  = "trans_coef.dat"           {prompt="Transformation coefficient file(trans_coef.dat)"}
string  extfile  = "ext_coef.dat"           {prompt="Extinction coefficient file(ext_coef.dat)"}
#string  calphas  = "22.88 23.49 22.45 20.15" {prompt="Zeropoints"}
#string  cbetas   = "-0.095 0.075 -0.408 0.0" {prompt="Color coefficients"}
#string  ocextin   = "0.45 0.20 0.11 0.07 0.03 0.07"     {prompt="UBVRIHa Extinction coefficients"}
#string  icextin   = "0.03 0.04 0.03"     {prompt="JHK Extinction coefficients"}
#string  run      = "feb"                    {prompt="Month of the run(feb/oct)"}
#bool    skip     = "no"            {prompt="Skip the aperture photometry part?"}

begin

	string  ifile,tfile,efile,tabfil[9],galnam[9],fitsdir,ls1,ls2,filebase,tmp,hfil
	real 	skymed[9],skyrms[9],tsec[9],airmass[9],lr1, lr2, lr3, lr4, skyfrac
	real	sma, intensu, intensu_err, intensb, intensb_err, intensv, intensv_err 
	real	intensr, intensr_err, intensi, intensi_err, intensj, intensj_err 
	real	intensh, intensh_err, intensk, intensk_err, intensha, intensha_err 
        real    radminb[99],magu[99],magb[99],magv[99],magr[99],magi[99]
	real	magj[99],magh[99],magk[99],magha[99]
        real    mag0u[99],mag0b[99],mag0v[99],mag0r[99],mag0i[99],mag0j[99],mag0h[99],mag0k[99],mag0ha[99]
        real    mag00u[99],mag00b[99],mag00v[99],mag00r[99],mag00i[99],mag00j[99],mag00h[99],mag00k[99],mag00ha[99]
        real    colub[99],colbv[99],colbr[99],colvi[99],colvk[99],coljk[99],colhk[99],pix2arc
        real    mu0u[99],mu0b[99],mu0v[99],mu0r[99],mu0i[99],mu0j[99],mu0h[99],mu0k[99],mu0ha[99]
        real    mu00u[99],mu00b[99],mu00v[99],mu00r[99],mu00i[99],mu00j[99],mu00h[99],mu00k[99],mu00ha[99]
        real    mu_ub[99],mu_bv[99],mu_br[99],mu_vi[99],mu_vk[99],mu_jk[99],mu_hk[99]
	real	dmu[99],dmb[99],dmv[99],dmr[99],dmi[99],dmj[99],dmh[99],dmk[99]
	real	dmub[99],dmbv[99],dmbr[99],dmvi[99],dmvk[99],dmjk[99],dmhk[99],dmha[99]
	real	dIu[99],dIb[99],dIv[99],dIr[99],dIi[99],dIj[99],dIh[99],dIk[99],dIha[99]
	real	dIub[99],dIbv[99],dIbr[99],dIvi[99],dIvk[99],dIjk[99],dIhk[99]
	real	rad,apmag,area,sqN[99], h1, h2, h3, h4, h5, h6
	real    ext[9],alpha[9],beta[9], a1, a2, a3, a4, a5, a6, a7, a8, a9
	real    F_ha,dF_ha,F_ew,dF_ew,I_ha,dI_ha,I_ew,dI_ew
	real	dF_r,dI_r, K_ha,F_r_vega, Npix[99],count,sigma,datamin,gain
	int     i,j,i1,i2,i3,li1,runid[9],len,runno
	real	skyres[9], texp[9], lr5, lr6, sig1, sig2, sig3, flux, flux_cor
	bool    image[9]
        struct  line

	pix2arc = -0.35

	skyfrac = 0.01
	datamin = 1.0E-06
	gain = 5.0

	fitsdir = imagdir; ifile = infile; tfile = trafile; efile = extfile
	list = ifile
	len = strlen(ifile); filebase = substr(ifile, 1, len-3)
	#print(filebase)

        i1 = fscan(list, line)
	for (i=1; i <=9; i +=1){
        i1 = fscanf(list, "%s %g %g %g %g %d %s %g", ls1, lr1, lr2, lr3, lr4, li1, ls2, lr5, lr6) 
		galnam[i] = ls1; skyres[i] = lr1; skyrms[i] = lr2/lr3; tsec[i] = lr3
		airmass[i] = lr4; runid[i] = li1; texp[i] = lr5 
		if (i <= 5) skymed[i] = lr6/lr5
		if (i == 6 || i == 7 || i == 8) skymed[i] = lr6
		if (i == 9) skymed[i] = lr6/lr5
		if (i == 9)hfil=ls2
  		tabfil[i] = fitsdir//galnam[i]
		#skyfrac[i] = skyrms[i]/skymed[i]
	}

	list = efile
	i1 = fscan(list, a1,a2,a3,a4,a5,a6,a7,a8,a9)
        ext[1] = a1; ext[2] = a2; ext[3] = a3; ext[4] = a4; ext[5] = a5
        ext[6] = a6; ext[7] = a7; ext[8] = a8; ext[9] = a9

	list = tfile
        while( fscan(list, line) != EOF ) {
	tmp = substr (line, 1, 1)
	if (tmp != "#") {
	i1 = fscan(line, runno, a1,a2,a3,a4,a5,a6,a7,a8,h1,h2,h3,h4,h5,h6)
	if (runid[1] == runno){
        	alpha[1] = a1; alpha[2] = a2; alpha[3] = a3; alpha[4] = a4; alpha[5] = a5
        	alpha[6] = a6; alpha[7] = a7; alpha[8] = a8
		if (hfil == "H656") alpha[9] = h1
		if (hfil == "H662") alpha[9] = h2
		if (hfil == "H668") alpha[9] = h3
		if (hfil == "H674") alpha[9] = h4
		if (hfil == "H680") alpha[9] = h5
		if (hfil == "H686") alpha[9] = h6
	}
	i1 = fscan(list, runno, a1,a2,a3,a4,a5,a6,a7,a8,a9)
	if (runid[1] == runno){
        	beta[1] = a1; beta[2] = a2; beta[3] = a3; beta[4] = a4; beta[5] = a5
        	beta[6] = a6; beta[7] = a7; beta[8] = a8; beta[9] = a9
	}
	}
	}

	delete(filebase//"_ap.mag", ver-, >& "dev$null")
	delete(filebase//"_ap.col", ver-, >& "dev$null")
	delete(filebase//"_sb.mag", ver-, >& "dev$null")
	delete(filebase//"_sb.col", ver-, >& "dev$null")
	delete(filebase//"_ha.flu", ver-, >& "dev$null")
	if (galnam[9] != "null" && galnam[4] != "null") {
	printf("%1s %4s %5s %6s %7s %6s %12s  %6s %6s %6s %6s %7s %6s %7s %6s  %11s %6s %6s %6s  \n","#","Rad","B","db","B-V","dbv","F_Halpha","dF_Ha","EW_Ha","dEW","SMA","I_B","dIb","I_BV","dIbv","I_Ha","dI_Ha","I_EW","dEW")  | cat >> filebase//"_ha.flu"
	}
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n","#","Rad","U","du","B","db","V","dv","R","dr","I","di","J","dj","H","dh","K","dk","B-V","dbv")  | cat >> filebase//"_ap.mag"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n", "#","Rad","B","db","K","dk","U-B","dub","B-V","dbv","B-R","dbr","V-I","dvi","V-K","dvk","J-K","djk","H-K","dhk")  | cat >> filebase//"_ap.col"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n","#","SMA","U","du","B","db","V","dv","R","dr","I","di","J","dj","H","dh","K","dk","B-V","dbv")  | cat >> filebase//"_sb.mag"
	printf("%1s %4s %5s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s %7s %6s \n", "#","SMA","B","db","K","dk","U-B","dub","B-V","dbv","B-R","dbr","V-I","dvi","V-K","dvk","J-K","djk","H-K","dhk")  | cat >> filebase//"_sb.col"

	unlearn("tprint")
		tprint.showrow=no; tprint.showhdr=no; tprint.showuni=no
		tprint.columns="SMA INTENS INT_ERR TFLUX_E SAREA"
	unlearn ("noise")
		noise.fracsky = skyfrac
		noise.ccdgain = gain

        for (j=1; j <=i1; j +=1){

	# Read the intensity profiles
	intensu = datamin; intensb = datamin; intensv = datamin; intensr = datamin
	intensi = datamin; intensj = datamin; intensh = datamin; intensk = datamin 
        if (galnam[1] != "null")tprint (tabfil[1],rows=j+1) | scan(sma, intensu, intensu_err)
        if (galnam[2] != "null")tprint (tabfil[2],rows=j+1) | scan(sma, intensb, intensb_err)
        if (galnam[3] != "null")tprint (tabfil[3],rows=j+1) | scan(sma, intensv, intensv_err)
        if (galnam[4] != "null")tprint (tabfil[4],rows=j+1) | scan(sma, intensr, intensr_err)
        if (galnam[5] != "null")tprint (tabfil[5],rows=j+1) | scan(sma, intensi, intensi_err)
        if (galnam[6] != "null")tprint (tabfil[6],rows=j+1) | scan(sma, intensj, intensj_err)
        if (galnam[7] != "null")tprint (tabfil[7],rows=j+1) | scan(sma, intensh, intensh_err)
        if (galnam[8] != "null")tprint (tabfil[8],rows=j+1) | scan(sma, intensk, intensk_err)

	if (intensu < (skyres[1]+skyrms[1])) { intensu = skyres[1] + skyrms[1] + datamin }
	if (intensb < (skyres[2]+skyrms[2])) { intensb = skyres[2] + skyrms[2] + datamin }
	if (intensv < (skyres[3]+skyrms[3])) { intensv = skyres[3] + skyrms[3] + datamin }
	if (intensr < (skyres[4]+skyrms[4])) { intensr = skyres[4] + skyrms[4] + datamin }
	if (intensi < (skyres[5]+skyrms[5])) { intensi = skyres[5] + skyrms[5] + datamin }
	if (intensj < (skyres[6]+skyrms[6])) { intensj = skyres[6] + skyrms[6] + datamin }
	if (intensh < (skyres[7]+skyrms[7])) { intensh = skyres[7] + skyrms[7] + datamin }
	if (intensk < (skyres[8]+skyrms[8])) { intensk = skyres[8] + skyrms[8] + datamin }

	# Convert the intensity profiles into surface brightness in mag
        if (galnam[1] != "null") mu0u[j] = -2.5*log10(intensu - skyres[1]) - ext[1]*airmass[1]
        if (galnam[2] != "null") mu0b[j] = -2.5*log10(intensb - skyres[2]) - ext[2]*airmass[2]
        if (galnam[3] != "null") mu0v[j] = -2.5*log10(intensv - skyres[3]) - ext[3]*airmass[3]
        if (galnam[4] != "null") mu0r[j] = -2.5*log10(intensr - skyres[4]) - ext[4]*airmass[4]
        if (galnam[5] != "null") mu0i[j] = -2.5*log10(intensi - skyres[5]) - ext[5]*airmass[5]
        if (galnam[6] != "null") mu0j[j] = -2.5*log10(intensj - skyres[6]) - ext[6]*airmass[6]
        if (galnam[7] != "null") mu0h[j] = -2.5*log10(intensh - skyres[7]) - ext[7]*airmass[7]
        if (galnam[8] != "null") mu0k[j] = -2.5*log10(intensk - skyres[8]) - ext[8]*airmass[8]

	# Transform instrumental surface magnitudes to standard
	mu00u[j] = 35.00; mu00b[j] = 35.00; mu00v[j] = 35.00; mu00r[j] = 35.00; mu00i[j] = 35.00 
	mu00j[j] = 35.00; mu00h[j] = 35.00; mu00k[j] = 35.00; 
        if (galnam[1] != "null" && galnam[2] != "null") mu00u[j] = mu0u[j] + alpha[1] + beta[1]*(mu0u[j] - mu0b[j]) + pix2arc
        if (galnam[2] != "null") mu00b[j] = mu0b[j] + alpha[2] + beta[2]*(mu0b[j] - mu0v[j]) + pix2arc
        if (galnam[3] != "null") mu00v[j] = mu0v[j] + alpha[3] + beta[3]*(mu0b[j] - mu0v[j]) + pix2arc
        if (galnam[4] != "null") mu00r[j] = mu0r[j] + alpha[4] + beta[4]*(mu0v[j] - mu0r[j]) + pix2arc
        if (galnam[5] != "null") mu00i[j] = mu0i[j] + alpha[5] + beta[5]*(mu0v[j] - mu0i[j]) + pix2arc
        if (galnam[6] != "null") mu00j[j] = mu0j[j] + alpha[6] + pix2arc
        if (galnam[7] != "null") mu00h[j] = mu0h[j] + alpha[7] + pix2arc
        if (galnam[8] != "null") mu00k[j] = mu0k[j] + alpha[8] + pix2arc

	# Obtain useful colors from surface magnitudes
	mu_ub[j] = -5.00; mu_bv[j] =  -5.00; mu_br[j] =  -5.00; mu_vi[j] =  -5.00 
	mu_vk[j] =  -5.00; mu_jk[j] =  -5.00; mu_hk[j] =  -5.00
        if (galnam[1] != "null" && galnam[2] != "null") mu_ub[j] = mu00u[j] - mu00b[j]
        if (galnam[2] != "null" && galnam[3] != "null") mu_bv[j] = mu00b[j] - mu00v[j]
        if (galnam[2] != "null" && galnam[4] != "null") mu_br[j] = mu00b[j] - mu00r[j]
        if (galnam[3] != "null" && galnam[5] != "null") mu_vi[j] = mu00v[j] - mu00i[j]
        if (galnam[3] != "null" && galnam[8] != "null") mu_vk[j] = mu00v[j] - mu00k[j]
        if (galnam[6] != "null" && galnam[8] != "null") mu_jk[j] = mu00j[j] - mu00k[j]
        if (galnam[7] != "null" && galnam[8] != "null") mu_hk[j] = mu00h[j] - mu00k[j]

	# Calculate errors on the aperture magnitudes
	dmu[j] = 35.00; dmb[j] = 35.00; dmv[j] = 35.00; dmr[j] = 35.00; dmi[j] = 35.00 
	dmj[j] = 35.00; dmh[j] = 35.00; dmk[j] = 35.00; 

	if (image[1]) noise(magu[j],skymed[1],skyrms[1],texp[1],Npix[j]) | scan(dmu[j], sig1, sig2, sig3)
	if (image[2]) noise(magb[j],skymed[2],skyrms[2],texp[2],Npix[j]) | scan(dmb[j], sig1, sig2, sig3)
	if (image[3]) noise(magv[j],skymed[3],skyrms[3],texp[3],Npix[j]) | scan(dmv[j], sig1, sig2, sig3)
	if (image[4]) noise(magr[j],skymed[4],skyrms[4],texp[4],Npix[j]) | scan(dmr[j], sig1, sig2, sig3)
	if (image[5]) noise(magi[j],skymed[5],skyrms[5],texp[5],Npix[j]) | scan(dmi[j], sig1, sig2, sig3)
	if (image[6]) noise(magj[j],skymed[6],skyrms[6],texp[6],Npix[j]) | scan(dmj[j], sig1, sig2, sig3)
	if (image[7]) noise(magh[j],skymed[7],skyrms[7],texp[7],Npix[j]) | scan(dmh[j], sig1, sig2, sig3)
	if (image[8]) noise(magk[j],skymed[8],skyrms[8],texp[8],Npix[j]) | scan(dmk[j], sig1, sig2, sig3)
	#if (image[9]) noise(magha[j],skymed[9],skyrms[9],texp[9],Npix[j]) | scan(dmha[j], sig1, sig2, sig3)


	# Calculate errors on the surface magnitudes
	dIu[j] = 35.00; dIb[j] = 35.00; dIv[j] = 35.00; dIr[j] = 35.00; dIi[j] = 35.00 
	dIj[j] = 35.00; dIh[j] = 35.00; dIk[j] = 35.00; 
	if (image[1]) noise(mu0u[j],skymed[1],skyrms[1],texp[1],1.0) | scan(dIu[j], sig1, sig2, sig3)
	if (image[2]) noise(mu0b[j],skymed[2],skyrms[2],texp[2],1.0) | scan(dIb[j], sig1, sig2, sig3)
	if (image[3]) noise(mu0v[j],skymed[3],skyrms[3],texp[3],1.0) | scan(dIv[j], sig1, sig2, sig3)
	if (image[4]) noise(mu0r[j],skymed[4],skyrms[4],texp[4],1.0) | scan(dIr[j], sig1, sig2, sig3)
	if (image[5]) noise(mu0i[j],skymed[5],skyrms[5],texp[5],1.0) | scan(dIi[j], sig1, sig2, sig3)
	if (image[6]) noise(mu0j[j],skymed[6],skyrms[6],texp[6],1.0) | scan(dIj[j], sig1, sig2, sig3)
	if (image[7]) noise(mu0h[j],skymed[7],skyrms[7],texp[7],1.0) | scan(dIh[j], sig1, sig2, sig3)
	if (image[8]) noise(mu0k[j],skymed[8],skyrms[8],texp[8],1.0) | scan(dIk[j], sig1, sig2, sig3)

	# Calculate errors on the aperture colors
	 dmub[j] = -5.00;  dmbv[j] =  -5.00;  dmbr[j] =  -5.00;  dmvi[j] =  -5.00 
	 dmvk[j] =  -5.00;  dmjk[j] =  -5.00;  dmhk[j] =  -5.00
        if (galnam[1] != "null" && galnam[2] != "null") dmub[j] = 0.5*sqrt(dmu[j]**2 + dmb[j]**2)
        if (galnam[2] != "null" && galnam[3] != "null") dmbv[j] = 0.5*sqrt(dmb[j]**2 + dmv[j]**2)
        if (galnam[2] != "null" && galnam[4] != "null") dmbr[j] = 0.5*sqrt(dmb[j]**2 + dmr[j]**2)
        if (galnam[3] != "null" && galnam[5] != "null") dmvi[j] = 0.5*sqrt(dmv[j]**2 + dmi[j]**2)
        if (galnam[3] != "null" && galnam[8] != "null") dmvk[j] =     sqrt(dmv[j]**2 + dmk[j]**2)
        if (galnam[6] != "null" && galnam[8] != "null") dmjk[j] = 0.5*sqrt(dmj[j]**2 + dmk[j]**2)
        if (galnam[7] != "null" && galnam[8] != "null") dmhk[j] = 0.5*sqrt(dmh[j]**2 + dmk[j]**2)

	# Calculate errors on the surface colors
	 dIub[j] = -5.00;  dIbv[j] =  -5.00;  dIbr[j] =  -5.00;  dIvi[j] =  -5.00 
	 dIvk[j] =  -5.00;  dIjk[j] =  -5.00;  dIhk[j] =  -5.00
        if (galnam[1] != "null" && galnam[2] != "null") dIub[j] = 0.5*sqrt(dIu[j]**2 + dIb[j]**2)
        if (galnam[2] != "null" && galnam[3] != "null") dIbv[j] = 0.5*sqrt(dIb[j]**2 + dIv[j]**2)
        if (galnam[2] != "null" && galnam[4] != "null") dIbr[j] = 0.5*sqrt(dIb[j]**2 + dIr[j]**2)
        if (galnam[3] != "null" && galnam[5] != "null") dIvi[j] = 0.5*sqrt(dIv[j]**2 + dIi[j]**2)
        if (galnam[3] != "null" && galnam[8] != "null") dIvk[j] =     sqrt(dIv[j]**2 + dIk[j]**2)
        if (galnam[6] != "null" && galnam[8] != "null") dIjk[j] = 0.5*sqrt(dIj[j]**2 + dIk[j]**2)
        if (galnam[7] != "null" && galnam[8] != "null") dIhk[j] = 0.5*sqrt(dIh[j]**2 + dIk[j]**2)

	#K_ha = 1.0E-15
	K_ha = alpha[9]
	F_r_vega = 1.76E-09
	if (galnam[9] != "null" && galnam[4] != "null") {
          	F_ha = K_ha*(10**(-0.4*(magha[j] - ext[9]*airmass[9])))
          	F_ew = F_ha/(F_r_vega*10**(-0.4*(mag00r[j])))
          	tprint (tabfil[9],rows=j+1) | scan(sma, intensha, intensha_err)
		if (intensha < (skyres[9]+skyrms[9]) ) { intensha = skyres[9]+skyrms[9]+datamin }
		#skyrms[4] = intensr_err
		#skyrms[9] = intensha_err
          	I_ha = K_ha*(intensha-skyres[9])*10**(0.4*ext[9]*airmass[9] - pix2arc)
          	I_ew = I_ha/(F_r_vega*10**(-0.4*(mu00r[j])))
		#count = 10**(-0.4*(magha[j])); sigma = sqrt((Npix[j]*skyrms[9])**2 ); dF_ha = sigma/count
		#count = 10**(-0.4*(magr[j])); sigma = sqrt((Npix[j]*skyrms[4])**2 ); dF_r = sigma/count
                #sigma = sqrt((skyrms[9])**2 ) ; dI_ha = (sigma/intensha) 
         	#sigma = sqrt((skyrms[4])**2 ) ; dI_r = (sigma/intensr) 
		noise(magha[j],skymed[9],skyrms[9],texp[9],Npix[j]) | scan(dmha[j], sig1, sig2, sig3)
        	mu0ha[j] = -2.5*log10(intensha - skyres[9]) - ext[9]*airmass[9]
		noise(magha[j],skymed[9],skyrms[9],texp[9],Npix[j]) | scan(dmha[j], sig1, sig2, sig3)
		noise(mu0ha[j],skymed[9],skyrms[9],texp[9],1.0) | scan(dIha[j], sig1, sig2, sig3)
		dF_ha = dmha[j]/1.086; dF_r = dmr[j]/1.086; dI_ha = dIha[j]/1.086; dI_r = dIr[j]/1.086
         	dF_ew = F_ew*(dF_ha + dF_r); dI_ew = I_ew*(dI_ha + dI_r)

        #if (galnam[9] != "null") dF_ha[j] = sqN[j]*skyrms[9]/(10**(-0.4*(magha[j])))
	#dF_ha[j] = sqN[j]*skyfrac*skyrms[9]/(10**(-0.4*(magha[j])))
	#dF_r[j] = sqN[j]*skyfrac*skyrms[4]/(10**(-0.4*(magr[j])))

	printf("%6.1f %7.3f %6.3f %7.3f %6.3f %11.4e %6.3f %6.1f %6.2f %6.1f %7.3f %6.3f %7.3f %6.3f %11.4e %6.3f %6.1f %6.2f \n",radminb[j],mag00b[j],dmb[j],colbv[j],dmbv[j],F_ha,dF_ha,F_ew,dF_ew,sma,mu00b[j],dIb[j],mu_bv[j],dIbv[j],I_ha,dI_ha,I_ew,dI_ew)  | cat >> filebase//"_ha.flu"
			}

		printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", radminb[j], mag00u[j],dmu[j],mag00b[j],dmb[j],mag00v[j],dmv[j],mag00r[j],dmr[j],mag00i[j],dmi[j],mag00j[j],dmj[j],mag00h[j],dmh[j], mag00k[j],dmk[j],colbv[j],dmbv[j])  | cat >> filebase//"_ap.mag"
	printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", radminb[j], mag00b[j],dmb[j],mag00k[j],dmk[j],colub[j],dmub[j],colbv[j],dmbv[j],colbr[j],dmbr[j],colvi[j],dmvi[j],colvk[j],dmvk[j],coljk[j],dmjk[j],colhk[j],dmhk[j])  | cat >> filebase//"_ap.col"
	printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", sma, mu00u[j],dIu[j],mu00b[j],dIb[j],mu00v[j],dIv[j],mu00r[j],dIr[j],mu00i[j],dIi[j],mu00j[j],dIj[j],mu00h[j],dIh[j], mu00k[j],dIk[j],mu_bv[j],dIbv[j])  | cat >> filebase//"_sb.mag"
	printf ("%6.1f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f %7.3f %6.3f \n", sma, mu00b[j],dIb[j],mu00k[j],dIk[j],mu_ub[j],dIub[j],mu_bv[j],dIbv[j],mu_br[j],dIbr[j],mu_vi[j],dIvi[j],mu_vk[j],dIvk[j],mu_jk[j],dIjk[j],mu_hk[j],dIhk[j])  | cat >> filebase//"_sb.col"
	#printf ("%8.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f \n", radminb[j], magu[j],magb[j], magv[j], magk[j],sma,intensu,intensb,intensv,intensr,intensk)  | cat >> filebase//"_sb.mag"
	#printf ("%8.3f %7.3f %7.3f %7.3f %7.3f %7.3f %8.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f %7.3f \n", radminb[j], mag00b[j], colbv[j], colvr[j], colbr[j], colvk[j],smalg, sb_b, sb_colbv,sb_colvr,sb_colbr,sb_colvk,dmu,dmuerr)  | cat >> tabfil//".mag"
	}


print ("DONE")

end
