procedure sdss_to_ubvri(catfile)
#_RAJ2000        _DEJ2000        mode    q_mode  cl      SDSS8   Im      m_SDSS8 RAJ2000 DEJ2000 zsp     umag    e_umag  gmag    e_gmag  rmag    e_rmag  imag    e_imag  zmag    e_zmag  Q       ObsDate
#
string  catfile  = "grb090618sdss_stars"         {prompt="SDSS catalog name [default extn is .cat]"}
string  outfile  = "sdss_sel"          		{prompt="Output catalog name [default extn is .reg and .radec]"}
int     nmark    = 20                 		{prompt="Number of stars to mark"}
real	radmark  = 5				{prompt="Radius in arcsec of the marking circle"}

begin
	string cdata[999], catfil, regfil, radecfil, cid[999], c1, creg, imfil
	string	sdss8
	real	rad, a_ra[999], a_dec[999], B_JB, V_JB, R_JB, I_JB
	real	ra,dec,ra2,dec2,umag,eumag,gmag,egmag,rmag,ermag,imag,eimag,zmag,ezmag
	int 	 imark, i2, i3
        struct  line

	catfil = catfile//".cat"; imark = nmark; imfil = outfile
	print(catfil)
	rad = radmark
        regfil = imfil//".reg"
        radecfil = imfil//".radec"
        #radecfil1 = imfil//".radec"

        delete(regfil, ver-, >& "dev$null")
        delete(radecfil, ver-, >& "dev$null")
        #delete(radecfil1, ver-, >& "dev$null")
        print("#    RA          DEC       umag    gmag    rmag    imag      B_J      V_J      R_KC     I_KC  ID", >> radecfil)

        print("# Region file format: DS9 version 4.0", >> regfil)
        print("# Filename: ", imfil, >> regfil)
        print("global color=green font=\"helvetica 10 normal\" select=1 highlite=1 edit=1 move=1 delete=1 include=1 fixed=0 source \nfk5", >> regfil)
        i2 = 0
        i3 = 0
        list = catfil
        while( fscan(list,line) != EOF ) {
        c1 = substr(line,1,3)
        #print(line, >> radecfil)

        if (c1=="---") {
        while( fscan(list,line) != EOF ) {
        i2 = fscan(line,ra,dec,sdss8,ra2,dec2,umag,eumag,gmag,egmag,rmag,ermag,imag,eimag,zmag,ezmag)
          i3 = i3 + 1
          #cdata[i3] = line
          cid[i3] = str(i3)
          a_ra[i3] = ra; a_dec[i3] = dec 
	#print(i3,gmag)

	B_JB = gmag + 0.3130*(gmag - rmag) + 0.2271
	V_JB = gmag - 0.5784*(gmag - rmag) - 0.0038
	R_JB = rmag - 0.1837*(gmag - rmag) - 0.0971
	I_JB = imag - 0.3780*(imag - zmag) - 0.3974

        if (i3 <= imark) {
        creg = "# color=red text={"//cid[i3]//"}"
        printf("circle(%10f,%10f,%4f\") %s\n",a_ra[i3],a_dec[i3],rad, creg, >> regfil)
        printf("%15.7f %15.7f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %s\n",a_ra[i3],a_dec[i3],gmag,rmag,imag,B_JB,V_JB,R_JB,I_JB,cid[i3], >> radecfil)
        }

        }
        }
        }

end

