procedure varphot(image, coolist)

#the image should have WCS information (run cancalib before)
#DO differential photometry of stars in a list
#Star coordinates can be in radec or xy. 
#The first star in the list is considered as REFERENCE for differential photometry.
#Second star is the "object". Subsequent stars are taken as control stars
#The output differential magnitude is written with a time stamp, suitable for plotting light curves
#
string  image  	= "kuv034_B0001"        {prompt="Image Name"}
string  coolist = "varphot.coo"        {prompt="List containing xy or radec of stars to find photometry"}
string  listtyp = "radec"              	{prompt="Type of the List [xy/radec]"}
bool	process = no 			{prompt="Correct for BIAS and Flat-field?"}
string  biasfil = "biasmed"        	{prompt="Bias file"}
string  flatfil = "domoBmed_nor"        {prompt="Normalized flat-field file"}
string  resfile = "varphot.res"        {prompt="Output file containing data of light-curves"}
string  fitsext = ".FIT"               {prompt="Extensions of fits file [.fits]"}
string  instrum = "LFOSC"        	{prompt="LFOSC/CANICA"}
bool    header  = "yes"			{prompt="Header parameters are already included?"}
string  date    = "2010-11-05"         {prompt="Date of observation [2010-11-05] for LFOSC"}
string  photap  = "3,5,7,9,11"         {prompt="Radius of apertures for photometry [3,5,7,9,11]"}
real    skyradin=11.                   {prompt="Inner Radius of sky annulus [10.]"}
real    zeromag = 0.0                  {prompt="Zeropoint"}
real    deltmag = 0.2                  {prompt="maximum delta_mag for plot "}
string  statsect = "[170:180,370:380]" {prompt="Section for imstat"}
string  trimsect = "[16:420,80:692]" {prompt="Section for trimming"}
bool	display  = yes			{prompt="Display the image?"}


begin
	string  imfil, catfil, cootyp, c1, regfil, filt, creg,cid[999], c2, c3, c4
	string  daomag,photmag,photcoo, cref, obsdate, filthd, raobj,decobj,jd, jd1
	string	tsections1, tsections2, tcname, tcoords, imfiltemp, canres, dbfil
	string  eqtoxy, photcoo1, raunit, filnam[999], camara, aprad, biasim, flatim
	string	igifil, plotfil, statsec, trimsec, tmp, statfil, ut, uthr, utmin, ampm
	string	jd_frac, photrad, obsfecha
	real	zpmag, fwhmpsf, refmag, difmag, exptime, nadd, efftime,xin,yin, delm
	real	magobj, xobj,yobj,magctrl_1,magctrl_2,magctrl_3, magcor_av, skyin, skywid, rjd
	real	xmin, xmax, ymin, ymax, xlabpos, ylabpos, objmag, objrms, x1, y1, gain, rdnoi
	real	emagctrl_1, emagctrl_2, emagctrl_3, erefmag, emagobj, errobj, snr 
	real	stddev, cboxsiz, area, flux, stat_lo, stat_hi, jd_next, radskyin
	real    mag_lo, mag_hi, magcor_rms
        #real    raref,decref,xin,yin,mag_dif,exptime, nadd, refmag, jkcol, jhcol, raddist
	int     itv, nx, ny, nimages, i2, i1, len, i3, ix1, ix2, iy1, iy2, hour, jd_int, magcor_n
	bool	disp, proc, head
        struct  line

#	Read the parameters
	imfiltemp = image; catfil = coolist; cootyp = listtyp; zpmag = zeromag; delm = deltmag
	camara = instrum; disp = display; itv = 1; dbfil = "ccmap.db";  canres = resfile     
	#raunit = raunits; if (raunit != "hours") {raunit = "native"}
	head = header; photrad = photap; radskyin = skyradin
	#eqtoxy = "skyxy"     #"cctran"
	#if (cootyp == "xy") {eqtoxy = "xy"}
	trimsec = trimsect; statsec = statsect    #"[16:420,80:692]"
	biasim = biasfil; flatim = flatfil; proc = process
	#biasim = "biasmed"; flatim = "domoBmed_nor"

        plotfil = "light_curve.mag"; delete(plotfil, ver-, >& "dev$null")
	statfil = "varphotstat.tab"; delete(statfil, ver-, >& "dev$null")
	#rjd = 2455517.618125; rjd = rjd - int(rjd)

#	Get and store the xy origin if the images is to be trimmed
	x1 = 1; y1 = 1
	if (trimsec != "[*,*]") {
	i1 = stridx(":",trimsec); i3 = strldx(":",trimsec); i2 = strldx(",",trimsec)  #[16:420,80:692]
	x1 = real(substr(trimsec,2,i1-1)); y1 = real(substr(trimsec,i2+1,i3-1))
	i1 = stridx(":",statsec); i3 = strldx(":",statsec); i2 = strldx(",",statsec); len = strlen(statsec)  #[16:420,80:692]
	print(statsec)
	if (statsec != "[*,*]") { 
	ix1 = int(substr(statsec,2,i1)) - int(x1) + 1; iy1 = int(substr(statsec,i2+1,i3)) - int(y1) + 1
	ix2 = int(substr(statsec,i1+1,i2-1)) - int(x1) + 1; iy2 = int(substr(statsec,i3+1,len-1)) - int(y1) + 1
	#ix2 = int(substr(statsec,i1+1,i2-1)) - int(x1) + 1; iy2 = int(substr(statsec,i3+1,len-1))
	statsec = "["//str(ix1)//":"//str(ix2)//","//str(iy1)//":"//str(iy2)//"]"
	print(statsec)
	}
	#print(trimsec, " ", x1, " ", y1, " ", statsec)
	}

#	Get the image names and process (bias,flat,trim) the images
        tsections1 = mktemp ("tmps1")
        tsections2 = mktemp ("tmps2")
	sections (imfiltemp,  option="fullname", > tsections1)
        nimages = sections.nimages
	print(nimages)
	#see wregister.cl for the use of "sections" and "file" commands

	list = tsections1
	for (i = 1; i <= nimages; i = i + 1) {
	i2 = fscan(list, imfil) 
	#}

#	Do photometry on images one by one
	#for (i = 1; i <= nimages; i = i + 1) {
	#print(i, " of total ", nimages)

	#imfil = filnam[i]  
        imstat (imfil//statsec, fields = "stddev", format-) | scan (stddev)

	c1 = fitsext
	i1 = strlstr(c1,imfil); if (i1 > 0) {imfil = substr(imfil,1,i1-1)}
	#print (len,i1,imfil)
        photcoo1 = imfil//"_phot1.coo"; delete(photcoo1, ver-, >& "dev$null")
        photcoo = imfil//"_phot.coo"; delete(photcoo, ver-, >& "dev$null")

	if (proc) {
	imdelete(imfil//"bf", ver-, >& "dev$null")
        imexpr ("(a-b)/c", imfil//"bf", imfil//trimsec, biasim//trimsec, flatim//trimsec, >& "dev$null")
	filnam[i] = imfil//"bf"
	} else {
	filnam[i] = imfil   #//"bf"
	}


#	Get the header parameters for CANICA and LFOSC images
	if (camara == "CANICA") {
	hselect (imfil, "i_naxis1, i_naxis2, EXPTIME, FILTER2, DATE-OBS, COADDS", yes) | scan (nx, ny, exptime, filthd, obsdate, nadd)
	len = strlen(obsdate); c3 = substr(obsdate,len,len); c4 = substr(obsdate,len-1,len)
        c2 = obsdate; delete("cmds.tempjd", ver-, >& "dev$null")
	i1 = strlstr("-",obsdate); len = strlen(obsdate); i2 = strlstr("T",obsdate)
	if (i1 == 7) {c2 = substr(obsdate,1,5); c1=substr(obsdate,6,len); c2=c2//"0"//c1}
	if (i2-i1 == 2) {c1=substr(c2,9,len); c2=substr(c2,1,8); c2=c2//"0"//c1}
	obsdate = c2
	len = strlen(obsdate); if (len==18) {obsdate=obsdate//c3}; if (len==17) {obsdate=obsdate//c4}
	#print (i1, " ", i2, " ", len, " ", c2, obsdate )
	c2 = 'jd = julday ("'//obsdate//'")'
	print(c2, > "cmds.tempjd")
	asthedit (imfil, "cmds.tempjd", table="", colname="", verbose-)
	hselect (imfil, "jd", yes) | scan (jd)
	#print("Julian Date=",jd)
        c1 = substr(obsdate,1,4); 
	if (int(c1) < 2005) {nadd = 1; exptime = 1.0}

        if (filthd == "1"){filt = "J"} else if (filthd == "2") {filt = "H"} else if (filthd == "3") {filt = "K"} else {filt = "X"} 
        efftime = exptime*real(nadd)
        #print("Image size in ",imfil," is =",nx, ny, exptime, nadd, filthd,"=",filt, " ", obsdate)
        #inmag[i3] = apmag + 2.5*log10(efftime)
	} 

	if (camara == "LFOSC") {
	if (head) {
        hselect (imfil, "i_naxis1, i_naxis2, EXPTIME, FILTER, OBS-DATE", yes) | scan (nx, ny, exptime, filthd, obsdate)
        hselect (imfil, "PARAM25, TIME", yes) | scan (exptime, ut)
	exptime = exptime/1000.
        ut = substr(ut,2,9); ampm = substr(ut,11,14)
        uthr  = substr(ut,2,3); utmin = substr(ut,4,9)
        if (ampm == "p.m." && uthr != "12") {hour = int(uthr)+12; ut = str(hour)//utmin}
	obsfecha = substr(obsdate,1,10)
        obsdate = obsfecha//"T"//ut
	} else {
	obsdate = date   # "2010-11-05"
	hselect (imfil, "i_naxis1, i_naxis2, PARAM25, TIME", yes) | scan (nx, ny, exptime, ut)
	exptime = exptime/1000.
	ut = substr(ut,2,9); ampm = substr(ut,11,14)
	uthr  = substr(ut,2,3); utmin = substr(ut,4,9)
	if (ampm == "p.m." && uthr != "12") {hour = int(uthr)+12; ut = str(hour)//utmin}
	obsdate = obsdate//"T"//ut
	#print(obsdate, " ",ut, " ", exptime)
	filthd = " "
    	hedit (imfil, fields="FILTER", value=filthd, add+, delete-, verify-, show-, update+)
    	hedit (imfil, fields="OBS-DATE", value=obsdate, add+, delete-, verify-, show-, update+)
    	hedit (imfil, fields="EXPTIME", value=exptime, add+, delete-, verify-, show-, update+)
	}
        len = strlen(obsdate); c3 = substr(obsdate,len,len); c4 = substr(obsdate,len-1,len)
        c2 = obsdate; delete("cmds.tempjd", ver-, >& "dev$null")
        i1 = strlstr("-",obsdate); len = strlen(obsdate); i2 = strlstr("T",obsdate)
        if (i1 == 7) {c2 = substr(obsdate,1,5); c1=substr(obsdate,6,len); c2=c2//"0"//c1}
        if (i2-i1 == 2) {c1=substr(c2,9,len); c2=substr(c2,1,8); c2=c2//"0"//c1}
        obsdate = c2
        len = strlen(obsdate); if (len==18) {obsdate=obsdate//c3}; if (len==17) {obsdate=obsdate//c4}
	}

	#rjd = rjd + 1.0
	#jd = str(rjd)
	delete("cmds.tempjd", ver-, >& "dev$null")
	c2 = 'jd = julday ("'//obsdate//'")'
	print(c2, > "cmds.tempjd")
	asthedit (imfil, "cmds.tempjd", table="", colname="", verbose-)
	hselect (imfil, "jd", yes) | scan (jd)

	#print("Julian Date=",jd)

# If the coordinate list is in "radec", get the xy positions for each image

	if (cootyp == "radec") {
        wcsctran (catfil, photcoo, imfil, "world", "logical", verbose-)
	} else {
	list = catfil
        while( fscan(list, line) != EOF ) {
            tmp = substr (line, 1, 1)
            if (tmp != "#") {
                i2 = fscan(line,xin,yin)
		xin = xin - x1 - 1; yin = yin - y1 - 1
		print(xin, yin, >> photcoo )
                }
	}
	}

        photmag = imfil//"_phot.mag"; delete(photmag, ver-, >& "dev$null")
        daomag = imfil//"_dao.mag";   delete(daomag, ver-, >& "dev$null")
   
	#if (camara == "LFOSC") {aprad = "2,3,4,5,7"; skyin = 10; skywid = 5; gain = 1.0; rdnoi=3.0} 
	if (camara == "LFOSC") {aprad = photrad; skyin = skyradin; skywid = 5; gain = 1.0; rdnoi=3.0} 
                          else {aprad = "5,10,14,17,20"; skyin = 20; skywid = 10; gain = 10.0; rdnoi=3.0}
	#skyin = 10; skywid = 5 #skyin = 20; skywid = 10
	fwhmpsf = 5.5; cboxsiz = 10.0
        phot (imfil, skyfile="", coords=photcoo, output=photmag, plotfile="",
                scale=1.0, fwhmpsf=fwhmpsf, epadu=gain, readnoise=rdnoi, filter="FILTER",
                exposur="", airmass="", xairmas=1.0, itime=1.0, salgorithm="median",
                annulus =skyin, dannulus =skywid, cbox=cboxsiz, calgorithm="centroid",
                apertures=aprad, zmag=zpmag, interactive=no, radplots=no,
                verify=no, update=no, verbose=no, graphics="stdgraph", display="stdimage",
                icommands="", gcommands="")

        #txdump (photmag, "MAG[3] MAG[5] MERR[3] AREA[3]", "ID=2", headers-, paramet-) | scan (refmag,magcor,erefmag,area)
	#magcor = magcor - refmag 

	#edited 10/03/2011
	#replace  XINIT with "magcor"
        pcalc (photmag, "XINIT", "MAG[5]-MAG[3]")
        tstat.median=-0.05; tstat.stddev = 0.05
        for (j=1; j <= 4; j +=1) { 
        if (tstat.stddev < 0.03) tstat.stddev = 0.03
        mag_lo = -0.20; mag_hi = tstat.median+3.0*tstat.stddev
        txdump (photmag,"XINIT","yes") | tstat (lowlim=mag_lo, highlim=mag_hi, >& "dev$null") 
        #if (j < 4){ txdump (photmag,"XINIT","yes") | tstat (lowlim=mag_lo, highlim=mag_hi, >& "dev$null") 
	#	} else { txdump (photmag,"XINIT","yes") | tstat (lowlim=mag_lo, highlim=mag_hi)}
        }
	
        magcor_av = tstat.median; magcor_rms = tstat.stddev; magcor_n = tstat.nrows 

        txdump (photmag, "MAG[3] MERR[3] AREA[3]", "ID=2", headers-, paramet-) | scan (refmag,erefmag,area)
        #txdump (photmag, "MAG[3]", "ID=1", headers-, paramet-) | scan (magobj)
        txdump (photmag, "MAG[3] MERR[3] AREA[3] FLUX[3] XCENTER YCENTER", "ID=1", headers-, paramet-) | scan (magobj,emagobj,area,flux,xobj,yobj)

	#replace MAG[1] with the value of magnitude relative to the Refmag
	#cref = "MAG[3]-"//str(refmag)
	cref = "MAG[3]-"//str(magobj)
	pcalc (photmag, "MAG[1]", cref)
        txdump (photmag, "XCENTER YCENTER MAG[3]  ID", "MAG[3]!=INDEF", headers-, paramet-, >> daomag)
        txdump (photmag, "MAG[1] MERR[3]", "ID=3", headers-, paramet-) | scan (magctrl_1,emagctrl_1)
        txdump (photmag, "MAG[1] MERR[3]", "ID=4", headers-, paramet-) | scan (magctrl_2,emagctrl_2)
        txdump (photmag, "MAG[1] MERR[3]", "ID=5", headers-, paramet-) | scan (magctrl_3,emagctrl_3)
	#print ("==================================================")
        txdump (photmag, "MAG[1]", "ID=2", headers-, paramet-) | scan (difmag)
	#magobj = magobj + magcor
	refmag = refmag + magcor_av
	magobj = magobj + magcor_av
	emagobj = sqrt(emagobj**2 + erefmag**2)
	emagctrl_1 = sqrt(emagctrl_1**2 + erefmag**2)
	emagctrl_2 = sqrt(emagctrl_2**2 + erefmag**2)
	emagctrl_3 = sqrt(emagctrl_3**2 + erefmag**2)
	snr = gain*flux/(sqrt(area*(stddev*gain)**2 + gain*flux))
	errobj = 1.086/snr
	if (i == 1) {
	jd_int = int(jd); jd1 = jd
	print ("# ", jd_int, " ", obsdate, " EXPTIME=", exptime, " sec ", "Apertures=", aprad, >> plotfil)
	print ("# JD-",jd_int,"   MAG_OBJ   DIF_OBJ  DIF_S3   DIF_S4   DIF_S5  M[5]-M[3] e_CORR  e_OBJ    e_REF    e_S3     e_S4     e_S5  Image ", >> plotfil)
	print ("# JD+ ", jd_int, " ", obsdate, " EXPTIME=", exptime, " sec, Apertures=", aprad, "DIF=MAG[star]-MAG[obj]")
        print ("# JD- ",jd_int,"   MAG_OBJ   DIF_OBJ  M[5]-M[3]  e_CORR Nstar e_OBJ   e_REF    Image ")
	print ("# ", jd, " ", obsdate, " EXPTIME=", exptime, " sec ", " FILTER=", filthd, "Apertures=", aprad, >> canres)
	print ("# JD           ","   MAG_OBJ   DIF_OBJ  DIF_S3   DIF_S4   DIF_S5  M[5]-M[3] e_CORR Nstar e_OBJ    e_REF    e_S3     e_S4     e_S5  FILT Image ", >> canres)
	}
	jd_next = 0.0
	if (i == 2) {jd_next = real(jd)-real(jd1)}
	jd_frac = str(real(jd) - real(jd_int))
	printf ("%s %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %s \n", jd_frac, magobj, difmag, magctrl_1,magctrl_2,magctrl_3,magcor_av, magcor_rms, emagobj, erefmag, emagctrl_1, emagctrl_2, emagctrl_3, imfil, >> plotfil) 
	printf ("%s %8.3f %8.3f %8.3f %8.3f %3d %8.3f %8.3f %s \n", jd_frac, magobj, difmag, magcor_av, magcor_rms, magcor_n, emagobj, erefmag, imfil) 
	printf ("%s %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %8.3f %3d %8.3f %8.3f %8.3f %8.3f %8.3f %5s %s \n", jd, magobj, difmag, magctrl_1,magctrl_2,magctrl_3,magcor_av, magcor_rms, magcor_n, emagobj, erefmag, emagctrl_1, emagctrl_2, emagctrl_3, filthd, imfil, >> canres) 

        itv = 1
        if (disp){
                display (imfil, itv, zs+, fill+, >& "dev$null")
                tvmark (itv, daomag, mark="circle", radii=10, number+, nxoff=3, nyoff=3, txsize=2)
                }
	delete(daomag, ver-, >& "dev$null")
	}
        delete (tsections1, go_ahead+, verify-, default_action+, allversions+, subfiles+, > "dev$null")
        #delete (tsections2, go_ahead+, verify-, default_action+, allversions+, subfiles+, > "dev$null")

        igifil = imfil//"_light_curve.igi"; delete(igifil, ver-, >& "dev$null")
	# --------------------------------------------------|
	# --------------- OBJECT ---------------------------|
	# --------------------------------------------------|
	tstat (plotfil, "c2", outtabl=statfil, lowlim=INDEF, highlim=INDEF, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
	for (j=1; j <= 2; j +=1) { 
	stat_lo = min(tstat.vmin + tstat.stddev, tstat.median-3.0*tstat.stddev)
	stat_hi = max(tstat.vmax - tstat.stddev, tstat.median+3.0*tstat.stddev)
	tstat (plotfil, "c2", outtabl=statfil, lowlim=stat_lo, highlim=stat_hi, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
        } 
	tstat (plotfil, "c2", outtabl="STDOUT", lowlim=stat_lo, highlim=stat_hi, >& "dev$null")
	objmag = tstat.mean; objrms = tstat.stddev

	#tstat (plotfil, "c1"); xmin = tstat.vmin - tstat.nrows*0.08; xmax = tstat.vmax + tstat.nrows*0.08; xlabpos = tstat.vmin
	tstat (plotfil, "c1", outtabl=statfil, lowlim=INDEF, highlim=INDEF, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
	xmin = tstat.vmin - tstat.nrows*0.10*jd_next; xmax = tstat.vmax + tstat.nrows*0.10*jd_next; xlabpos = tstat.vmin

	tstat (plotfil, "c3", outtabl=statfil, lowlim=INDEF, highlim=INDEF, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
	for (j=1; j <= 2; j +=1) { 
	stat_lo = min(tstat.vmin + tstat.stddev, tstat.median-3.0*tstat.stddev)
	stat_hi = max(tstat.vmax - tstat.stddev, tstat.median+3.0*tstat.stddev)
	tstat (plotfil, "c3", outtabl=statfil, lowlim=stat_lo, highlim=stat_hi, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
        } 
	tstat (plotfil, "c3", outtabl="STDOUT", lowlim=stat_lo, highlim=stat_hi, >& "dev$null")
	ymin = tstat.median - delm; ymax = tstat.median + delm; ylabpos = ymax - delm*0.30 
        print ("data ",plotfil, >> igifil)

        print ("location .1 .95 .1 .30; xcolumn 1;  ycolumn 3; ecolumn 8; limits ", xmin, xmax, ymin, ymax,  >> igifil)
        print (" box; color 3; points; etype 1;  errorbar  2;  errorbar -2; color 1; number ", >> igifil)
        printf ("ltype 1; relocate %8.4f %8.4f ; draw %8.4f %8.4f \n", xmin, tstat.median, xmax, tstat.median, >> igifil)
        printf ('ltype 0; relocate %8.4f %8.4f ; label "OBJECT (star1 - star2) = %8.3f +/- %8.3f" \n', xlabpos, ylabpos,objmag,objrms, >> igifil)
	print ('color 1; xlabel "Julian Date (', jd_int,'+)" ; ylabel "DIF MAG"', >> igifil)

	# --------------------------------------------------|
	# --------------- STAR 3 ---------------------------|
	# --------------------------------------------------|
	tstat (plotfil, "c4", outtabl=statfil, lowlim=INDEF, highlim=INDEF, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
	for (j=1; j <= 2; j +=1) { 
	stat_lo = min(tstat.vmin + tstat.stddev, tstat.median-3.0*tstat.stddev)
	stat_hi = max(tstat.vmax - tstat.stddev, tstat.median+3.0*tstat.stddev)
	tstat (plotfil, "c4", outtabl=statfil, lowlim=stat_lo, highlim=stat_hi, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
        } 
	tstat (plotfil, "c4", outtabl="STDOUT", lowlim=stat_lo, highlim=stat_hi, >& "dev$null")
	ymin = tstat.median - delm; ymax = tstat.median + delm; ylabpos = ymax - delm*0.30 
        print ("location .1 .95 .30 .50; xcolumn 1;  ycolumn 4; ecolumn 10; limits ", xmin, xmax, ymin, ymax, >> igifil)
        print ("box 0 2; color 3; points; etype 1;  errorbar  2;  errorbar -2; color 1; number ", >> igifil)
        printf ("ltype 1; relocate %8.4f %8.4f ; draw %8.4f %8.4f \n", xmin, tstat.median, xmax, tstat.median, >> igifil)

	printf ('ltype 0; relocate %8.4f %8.4f ; label "Obj-star3"  \n', xlabpos, ylabpos, >> igifil)
	print ('ltype 0; color 1; ylabel "DIF MAG"', >> igifil)

	# --------------------------------------------------|
	# --------------- STAR 4 ---------------------------|
	# --------------------------------------------------|
	tstat (plotfil, "c5", outtabl=statfil, lowlim=INDEF, highlim=INDEF, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
	for (j=1; j <= 2; j +=1) { 
	stat_lo = min(tstat.vmin + tstat.stddev, tstat.median-3.0*tstat.stddev)
	stat_hi = max(tstat.vmax - tstat.stddev, tstat.median+3.0*tstat.stddev)
	tstat (plotfil, "c5", outtabl=statfil, lowlim=stat_lo, highlim=stat_hi, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
        } 
	tstat (plotfil, "c5", outtabl="STDOUT", lowlim=stat_lo, highlim=stat_hi, >& "dev$null")
	ymin = tstat.median - delm; ymax = tstat.median + delm; ylabpos = ymax - delm*0.30 
        print ("location .1 .95 .50 .70; xcolumn 1;  ycolumn 5; ecolumn 11; limits ", xmin, xmax, ymin, ymax, >> igifil)
        print ("box 0 2; color 3; points; etype 1;  errorbar  2;  errorbar -2; color 1; number ", >> igifil)
        printf ("ltype 1; relocate %8.4f %8.4f ; draw %8.4f %8.4f \n", xmin, tstat.median, xmax, tstat.median, >> igifil)
	print ('color 1; ylabel "DIF MAG"', >> igifil)
	printf ('ltype 0; relocate %8.4f %8.4f ; label "Obj-star4"  \n', xlabpos, ylabpos, >> igifil)

	# --------------------------------------------------|
	# --------------- STAR 5 ---------------------------|
	# --------------------------------------------------|
	tstat (plotfil, "c6", outtabl=statfil, lowlim=INDEF, highlim=INDEF, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
	for (j=1; j <= 2; j +=1) { 
	stat_lo = min(tstat.vmin + tstat.stddev, tstat.median-3.0*tstat.stddev)
	stat_hi = max(tstat.vmax - tstat.stddev, tstat.median+3.0*tstat.stddev)
	tstat (plotfil, "c6", outtabl=statfil, lowlim=stat_lo, highlim=stat_hi, >& "dev$null"); delete(statfil, ver-, >& "dev$null")
        } 
	tstat (plotfil, "c6", outtabl="STDOUT", lowlim=stat_lo, highlim=stat_hi, >& "dev$null")
	ymin = tstat.median - delm; ymax = tstat.median + delm; ylabpos = ymax - delm*0.30 
        print ("location .1 .95 .70 .90; xcolumn 1;  ycolumn 6; ecolumn 12; limits ", xmin, xmax, ymin, ymax, >> igifil)
        print ("box 0 2; color 3; points; etype 1;  errorbar  2;  errorbar -2; color 1; number ", >> igifil)
        printf ("ltype 1; relocate %8.4f %8.4f ; draw %8.4f %8.4f \n", xmin, tstat.median, xmax, tstat.median, >> igifil)
	printf ('ltype 0; relocate %8.4f %8.4f ; label "Obj-star5"  \n', xlabpos, ylabpos, >> igifil)
	print ('color 1; ylabel "DIF MAG"', >> igifil)
	type (igifil) | igi


end


