procedure wcsmosaic

string	imlist	= "m81acs_mosaic.lis"	{prompt="File containing images to mosaiced"}
string	ofile 	= "m81acs_V"		{prompt="Output mosaiced image"}
real    rasize	= 650.0     		{prompt="Output image size in RA in arcsecs"}
real    decsize	= 800.0     		{prompt="Output image size in DEC in arcsecs"}
real    raval 	= 148.87594   	{prompt="RA in degrees of the reference pixel"}
real    decval 	= 69.066839   	{prompt="RA in degrees of the reference pixel"}
real    rapix 	= 0.0   		{prompt="Reference pixel for RA [0 ===> middle]"}
real    decpix 	= 0.0   		{prompt="Reference pixel for Dec [0 ===> middle]"}
real    scale 	= 0.05   		{prompt="Image scale in arcsec/pixel"}
real    northpa	= 0.0   		{prompt="Angle of North in cw degrees wrt y-positive"}
real    epoch 	= 2000.0   		{prompt="Epoch of the coordinates"}
real    constant= 0.0   		{prompt="Constant for constant boundary extension"}
bool    mosaic  = yes   		{prompt="Mosaic the images after aligning?"}
bool    verbos  = yes   		{prompt="Print messages about progress of wregister?"}

begin

	string file_list, refimage, twcsmosaic, size, outfil 
	string twcsmosaic1, twcsmosaic2, file_olist  #, cuttt, file_olist2
	real   imsca, imsca_dec, imsca_ra, xra, ydec, pa, cd11, cd12, cd21, cd22
	int    nim, xsiz, ysiz
	bool	skip, verb

	file_list = imlist; outfil = ofile; verb = verbos
	imsca = scale; xsiz = rasize/imsca; ysiz = decsize/imsca
	imsca_dec = imsca/3600.0; imsca_ra  = -1.0*imsca_dec; const = constant
	#raref = raval; decref = decval; equinox = epoch
	xra = rapix; ydec = decpix
	if (xra < 1.0) {xra = xsiz/2}
	if (ydec < 1.0) {ydec = ysiz/2}
	twcsmosaic = "twcsmosaic"
	twcsmosaic1 = "twcsmosaic1"
	twcsmosaic2 = "twcsmosaic2"
	file_olist = "tttttt.lis"
	#file_olist2 = "tttttt2.lis"
        size = str(xsiz)//","//str(ysiz)
	pa = northpa*PI/180.
	cd22 = imsca_dec/sqrt(tan(pa)**2 + 1.0)
	#cd21 = sqrt(imsca_dec**2 - cd22**2)
	cd21 = cd22*tan(pa)
	cd11 = -cd22; cd12 = cd21 
	if (verb) {print(cd11, cd12, cd21, cd22)}

        imdelete(outfil, ver-, >& "dev$null")
        imdelete(twcsmosaic, ver-, >& "dev$null")
	fields (file_list, 1) | wc | scan (nim)
	fields (file_list, 1, lines=1) | scan (refimage)
	if (verb) {print(refimage, " ", nim, " ", size, " ",xra, " ",ydec)}
	skip = no  #yes
	if (!skip) {
	imexpr ("a*0", twcsmosaic, refimage, dims=size, verbose-)
        hedit (twcsmosaic, fields="CRVAL1", value=raval, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CRVAL2", value=decval, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CRPIX1", value=xra, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CRPIX2", value=ydec, add+, delete-, verify-, show-, update+)
        #hedit (twcsmosaic, fields="CDELT1", value=imsca_ra, add+, delete-, verify-, show-, update+)
        #hedit (twcsmosaic, fields="CDELT2", value=imsca_dec, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CDELT1", value="", add-, delete+, verify-, show-, update+)
        hedit (twcsmosaic, fields="CDELT2", value="", add-, delete+, verify-, show-, update+)
        hedit (twcsmosaic, fields="CTYPE1", value="RA---TAN", add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CTYPE2", value="DEC--TAN", add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="EQUINOX", value=epoch, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CD1_1", value=cd11, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CD1_2", value=cd12, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CD2_1", value=cd21, add+, delete-, verify-, show-, update+)
        hedit (twcsmosaic, fields="CD2_2", value=cd22, add+, delete-, verify-, show-, update+)
        #hedit (twcsmosaic, fields="CD1_1", value="", add-, delete+, verify-, show-, update+)
        #hedit (twcsmosaic, fields="CD1_2", value="", add-, delete+, verify-, show-, update+)
        #hedit (twcsmosaic, fields="CD2_1", value="", add-, delete+, verify-, show-, update+)
        #hedit (twcsmosaic, fields="CD2_2", value="", add-, delete+, verify-, show-, update+)

	#delete(file_olist2, ver-, >& "dev$null")
	delete(file_olist, ver-, >& "dev$null")
        for (j=1; j <= nim; j +=1) {print(outfil//"_wcsmosaic_aligned_"//str(j)//"_a", >> file_olist)}
        for (j=1; j <= nim; j +=1) {imdelete(outfil//"_wcsmosaic_aligned_"//str(j)//"_a", ver-, >& "dev$null")}
	#files ("@"//file_list//"//_a")
	#files ("@"//file_list//"//_a", >> file_olist)
	#cuttt = "cut -c1-32 "//file_olist
	#print (cuttt) | cl(, >> file_olist2)
        wregister ("@"//file_list, twcsmosaic, "@"//file_olist, wcs="world", transpose=no,
fitgeometry="general", function="polynomial", xxorder=3, xyorder=3,
xxterms="half", yxorder=3, yyorder=3, yxterms="half", reject=INDEF,
calctype="real", geometry="geometric", xsample=1., ysample=1.,
interpolant="linear", boundary="constant", constant=0., fluxconserve=yes,
nxblock=512, nyblock=512, wcsinherit=yes, verbose=verb, interactive=no,
graphics="stdgraph", gcommands="")

	}
	if (mosaic) {
	
        for (j=1; j <= nim; j +=1) {
	refimage = outfil//"_wcsmosaic_aligned_"//str(j)
	#fields (file_list, 1, lines=j) | scan (refimage)
        imdelete(refimage//"_mask", ver-, >& "dev$null")
        imdelete(refimage//"_b", ver-, >& "dev$null")
	imexpr ("a != b ? 1 : 0",  refimage//"_mask", refimage//"_a", const, verb-)
	imexpr ("a != b ? a : 0.0",  refimage//"_b", refimage//"_a", const, verb-)
        #imdelete(refimage//"_a", ver-, >& "dev$null")
	}

	delete(file_olist, ver-, >& "dev$null")
        for (j=1; j <= nim; j +=1) {print(outfil//"_wcsmosaic_aligned_"//str(j)//"_b", >> file_olist)}
	#files ("@"//file_list//"//_b", >> file_olist)
        imdelete(twcsmosaic1, ver-, >& "dev$null")
	print("Combining the aligned images = ")
	imcombine ("@"//file_olist, twcsmosaic1, combine="sum", scale="none", zero="none")
	delete(file_olist, ver-, >& "dev$null")
        for (j=1; j <= nim; j +=1) {print(outfil//"_wcsmosaic_aligned_"//str(j)//"_mask", >> file_olist)}
	#files ("@"//file_list//"//_mask", >> file_olist)
        imdelete(twcsmosaic2, ver-, >& "dev$null")
	print("Preparing the exposure mask image = ")
	imcombine ("@"//file_olist, twcsmosaic2, combine="sum", scale="none", zero="none")
        imdelete(outfil, ver-, >& "dev$null")
	print("Dividing the combined image by the exposure mask")
	imarith (twcsmosaic1, "/", twcsmosaic2, outfil, verbose-)

        for (j=1; j <= nim; j +=1) {
	refimage = outfil//"_wcsmosaic_aligned_"//str(j)
        #fields (file_list, 1, lines=j) | scan (refimage)
        imdelete(refimage//"_mask", ver-, >& "dev$null")
        imdelete(refimage//"_b", ver-, >& "dev$null")
	}

	}

end

