procedure xytoreg(xyfile)

string  xyfile  = "test.coo"     {prompt="Input Text file with X Y positions"}
string  regfile = "test.reg"     {prompt="Output ds9 region file"}
int	xcol	= 1		 {prompt="X column number"}
int	ycol	= 2		 {prompt="Y column number"}
int    	idcol   = 3		 {prompt="ID column number"}
string 	shape   = "circle"	 {prompt="Shape of the region [circle/box/ellipse]"}
real	cirrad  = 5.0     	 {prompt="Radius of the circle"}
real	xboxsiz = 5.0     	 {prompt="X box size if shape=box"}
real	yboxsiz = 5.0     	 {prompt="Y box size if shape=box"}
real	theta   = 0.0     	 {prompt="PA of the major axis if shape=[box, ellipse]"}
real	ellip   = 1.0     	 {prompt="Axis ratio b/a if shape=[box, ellipse]"}
string  color   = "green"     	 {prompt="Color of the circle"}
string  xyunit  = "pixel"     	 {prompt="Units of XY [pixel/degree/physical]"}
string  sizunit  = "pixel"     	 {prompt="Units of cirrad,xboxsiz,yboxsiz [pixel/arcsec]"}
#string  circol = "green"     	 {prompt="Color of the circle"}

begin

        string  xyfil, regfil, symcol, creg, c1 
	string	regshap, cid, posunit, lenunit, cosys, rs
	real	rad, xin, yin, xbox, ybox, pa, bbya, conv
	int	i1, i2, i3, ix, iy, iid, ixbox, iybox, imaj, imin, ipa, ibbya, irs, regcode, irad
        struct  line

	xyfil = xyfile; regfil = regfile; regshap = shape; posunit = xyunit; lenunit = sizunit 
	ix = xcol; iy = ycol; iid = idcol; irad = 0
	symcol = color; rad = cirrad; xbox = xboxsiz; ybox = yboxsiz; pa = theta; bbya = ellip 

	if (rad < 0.0){irad = abs(int(rad))}
	#irad = abs(int(rad))

	if (substr(posunit, 1, 1) == "d") {cosys = "fk5"} else {cosys = "image"}
	if (substr(posunit, 1, 3) == "phy") {cosys = "physical"}
	ixbox = 0; iybox = 0; imaj = 0; imin = 0; ipa = 0; ibbya = 0; irs = 0; regcode = 0
	if (xbox < 0.0){imaj = abs(int(xbox))}
	if (ybox < 0.0){imin = abs(int(ybox))}
	if (pa   < 0.0){ipa  = abs(int(pa))}
	if (bbya < 0.0){ibbya= abs(int(bbya))}
	rs = substr(regshap, 1,1)
	#if (rs != "b" && rs != "e" && rs != "c"){print(rs)}
        if (rs != "b" && rs != "e" && rs != "c"){irs = abs(int(regshap))} 
	if (substr(lenunit, 1, 1) == "a") {conv = 3600.} else {conv = 1.0}
	rad = rad/conv; xbox = xbox/conv; ybox = ybox/conv

        delete(regfil, ver-, >& "dev$null")

        print("# Region file format: DS9 version 4.0", >> regfil)
        #print("# Filename: IMAGE",  >> regfil)
        #print("global color=green font=\"helvetica 10 normal\" select=1 highlite=1 edit=1 move=1 delete=1 include=1 fixed=0 source \nfk5", >> regfil)
        #print("global color=green font=\"helvetica 10 normal\" select=1 highlite=1 edit=1 move=1 delete=1 include=1 fixed=0 source \nimage", >> regfil)
        print("global color=green font=\"helvetica 10 normal\" select=1 highlite=1 edit=1 move=1 delete=1 include=1 fixed=0 source \n"//cosys, >> regfil)

        i1 = 0; i2 = 0; i3 = 0; list = xyfil 
        while( fscan(list,line) != EOF ) {
	c1 = substr(line,1,1)
        if (c1!="#") {
          i3 = i3 + 1
        #i2 = fscan(line,xin,yin)
	print(line) | fields (fields=ix) | scan(xin)
	print(line) | fields (fields=iy) | scan(yin)
	#fields (line, fields=ix) | scan(xin)
	#fields (line, fields=iy) | scan(yin)
	if (iid != 0){print(line) | fields (fields=iid) | scan(cid)} else {cid = str(i3)}
        if (imaj != 0){print(line) | fields (fields=imaj) | scan(xbox); xbox = xbox/conv}
        if (imin != 0){print(line) | fields (fields=imin) | scan(ybox); ybox = ybox/conv}
        if (irad != 0){print(line) | fields (fields=irad) | scan(rad); rad = rad/conv}
	#if (substr(lenunit, 1, 1) == "a") {rad = rad/3600.; xbox = xbox/3600.; ybox = ybox/3600.}
        if (ipa  != 0){print(line) | fields (fields=ipa ) | scan(pa)}
        if (ibbya != 0){
		print(line) | fields (fields=ibbya) | scan(bbya)
		xbox = rad; ybox = xbox*bbya
		}
        #if (irs != 0){print(line) | fields (fields=irs) | scan(regshap)}
        if (irs != 0){
	print(line) | fields (fields=irs) | scan(regcode)
	switch (regcode) {case 1: rs = "c"; case 2: rs = "b"; case 3: rs = "e"; default: rs = "c"}
	}
	#print(regcode, rs)
	#rs = substr(regshap, 1,1)
	if (rs == "b"){regshap = "box"}
	if (rs == "e"){regshap = "ellipse"}
        #creg = "# color=green text={"//str(i3)//"}"
        #creg = "# color=green text={"//str(i3)//"}"
        creg = "# color="//symcol//" text={"//cid//"}"
        #if (substr(regshap, 1,1) == "b" || regshap, 1,1) == "e"){
        if (rs == "b" || rs == "e"){
		printf(regshap//"(%10f,%10f,%10f,%10f,%10f ) %s\n",xin, yin, xbox, ybox, pa, creg, >> regfil) 
			} else {
		printf("circle(%10f,%10f,%10f) %s\n",xin, yin, rad, creg, >> regfil)
			}
        }
        }

end
