procedure cluster_snr(magcl, musky)

real	magcl  = 20.00		{prompt="Cluster magnitude [mag] "}
real	musky  = 22.00		{prompt="Sky surface brightness [mag/arcsec2] "}
real 	imsca  = 1.0		{prompt="Image scale [arcsec/pix] "}
real 	psf    = 2.0		{prompt="FWHM of PSF [pix] "}
real	diatel = 400.0		{prompt="Diameter [cm] "}
real	eta    = 0.5  		{prompt="Detector efficiency [0-1.0]"}
real	exptime= 1.0		{prompt="Exposure [sec] "}
real	fvega  = 3.6E-09	{prompt="Vega flux [erg/cm2/s/ang] "}
real	lambda = 5550.0		{prompt="Wavelength [Ang] "}
real	dlam   = 1000.0		{prompt="Bandwidth [Ang] "}

begin

	real	mcl, msky, scale, lamang, signal, noise, cgsbyph, snr
	real	area, time, I0, dellam, nph_cl, nph_sk, eff, noi, sig
	real	peak_frac

	mcl = magcl; msky = musky; scale = imsca; lamang = lambda
	area = 0.85*3.14*(diatel**2/4)
	time = exptime
	I0 = fvega
	dellam = dlam
	eff = eta 
	sig = 1.2*psf/2.0
	peak_frac = 1/sig**2
	#peak_frac: fraction of the flux in the peak pixel

	cgsbyph = 6.25E-27*2.9979E+10/(lamang*1.0E-08*area*time*dellam*eff)

	signal = peak_frac*I0*10**(-0.4*mcl)
	noise  = sqrt(cgsbyph*I0*(10**(-0.4*mcl)+scale**2*(10**(-0.4*msky))))

	snr = signal/noise

	nph_cl = I0*10**(-0.4*mcl)/cgsbyph
	nph_sk = I0*scale**2*10**(-0.4*msky)/cgsbyph
	noi = sqrt(nph_cl + nph_sk)

	print ("SNR = ", snr, " S=",nph_cl, " N=",noi, " K=",cgsbyph, " Peak=", peak_frac)

end

