procedure	mfluxcalc(infile)

string  infile  = "fluxobs.dat"            {prompt="Input filename to measure flux"}
string  outfil  = "mfluxcalc.dat"          {prompt="Output filename containing calculated quantities"}
string  redcurve="spanal$data/ext_interp.dat"  {prompt="Extinction curve normalized to Av"}
string  exttype = "none"                {prompt="Av for extinction correction [none|Ha|Hg|Hd|He|mean|value in mag]"}
real    snrgood = 20.0                  {prompt="Minimum SNR of a line for velocity calculation"}
real    errfwhm = 20.0                  {prompt="Maximum error in FWHM wrt to Hbeta (in % units) for velocity calculation"}


begin
        string  filein, tmp, lineid[99], s1, extin, extcurve, datfil, chn, Bal[5] 
	string	dline[7]
	real	r1, r2, r3, r4, r5, r6, r7, r8, r9, siirat, oiirat, oiiirat, oiiirat_lo, oiiirat_hi
	real	goodsnr, fwhmerr, flux_ref, siirat_lo, siirat_hi, oiirat_lo, oiirat_hi, err_lo
	real	dens_sii, dens_sii_1, dens_sii_2
        real	wave[99], spe_snr[99], flux[99], ew[99], fwhm[99], fcont[99], uflux[99], flux_norm[99]
	real	tlam, Elam, E_hbeta  #, theo_rat, chbeta  #, chb3, chb4, chb_err, chb2_err, chb3_err, chb4_err
	real	uflux_norm[99], err_norm[99], spe_rms[99], flam[99]
	real	chb[5], chb_err[5], Av, flux_hb0_lg, Av_err, flux_norm0[99], Bal_rat[5]
	int	d1, i1, i2, i, tlines, ihb, nb, idline[7], ig
	bool	goodline[99], extcor
        struct  line


        filein = infile; datfil = outfil
        extin = strlwr(exttype); extcor = no
        if (extin != "none") {extcor = yes}
        extcurve = redcurve
        goodsnr = snrgood; fwhmerr = errfwhm
	dline[1] = "[OII]3726"; dline[2] = "[OII]3729"; dline[3] = "[SII]6717"; dline[4] = "[SII]6731"
	dline[5] = "[OIII]436"; dline[6] = "[OIII]495"; dline[7] = "[OIII]500"
        for (i=1; i <= 7; i +=1) {idline[i] = 0}

        print("##########################################################", >> datfil)
        date (, >> datfil)

	ihb = 0
        i1 = 0
        list = filein
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#" && tmp != "") {
          i1=i1+1
          goodline[i1] = yes
          i2 = fscanf(line, "%s %d %f %f %f %f %f %f %f %f %f \n", s1, d1, r1, r2, r3, r4, r5, r6, r7, r8, r9)
          lineid[i1] = substr(s1,strldx(" ",s1)+1, strlen(s1)); wave[i1] = r1
	  spe_snr[i1] = r3; flux[i1] = r6; ew[i1] = r7; fwhm[i1] = r8; fcont[i1] = r9 
          if (spe_snr[i1] < goodsnr) {goodline[i1] = no}

          #if (igood == 0) {goodline[i1] = no}
	  #printf("%12s  %8.2f \n", lineid[i1], wave[i1])
          #print(s1, " ", r1)
	  #if (stridx("Hb", s1) != 0){print(i1, s1)}
	  #if (strlwr(substr(lineid[i1], 1, 2)) == "hb"){ihb = i1; print(i1, lineid[i1])}
	  if (strlwr(substr(lineid[i1], 1, 2)) == "hb"){ihb = i1}
	  spe_rms[i1] = flux[i1]/spe_snr[i1]
	  uflux[i1] = goodsnr*spe_rms[i1]
          for (i=1; i <= 7; i +=1) {
	  	if (strupr(substr(lineid[i1], 1, 9)) == dline[i]){idline[i] = i1; print(i1, lineid[i1])}
		}
        }
        }

        if (extcor) { type(extcurve) | wc | scan(tlines) }

	flux_ref = flux[ihb]
	print(i1, "Hbeta index = ", ihb, " ", flux_ref)
        for (i=1; i <= i1; i +=1) {
        #if (gfwhm > max_fwhm || gfwhm < min_fwhm ) {goodline[i] = no}
	flux_norm[i] = 100.0*flux[i]/flux_ref    
	uflux_norm[i] = 100.0*uflux[i]/flux_ref
        properr(flux[i], flux_ref, "/", spe_rms[i], spe_rms[ihb], rab = 1.0, verb-)
        err_norm[i] = 100.0*properr.sig
	#printf("%d %12s %8.2f %8.3f %8.3f %d %8.1f\n", i, lineid[i], wave[i], flux_norm[i], uflux_norm[i], goodline[i], err_norm[i])
	}

        #--------------Extinction curve realted quantities
        for (j=1; j <= 4; j +=1) {chb[j] = 0.0; chb_err[j] = 0.0}
	Bal[1] = "Ha"; Bal[2] = "Hg"; Bal[3] = "Hd"; Bal[4] = "He"
	Bal_rat[1] = 2.870; Bal_rat[2] = 0.466; Bal_rat[3] = 0.256; Bal_rat[4] = 0.158

        if (extcor) {
        for (j=1; j <= i1; j +=1) {
        	delete("fluxcalc_temp.dat", ver-, >& "dev$null")
                print(wave[j], >> "fluxcalc_temp.dat")
                sinter (extcurve, "fluxcalc_temp.dat", tbl_siz=tlines) | scan (tlam, Elam)
                if (j == 1) {E_hbeta = Elam}
                flam[j] = Elam/E_hbeta

        	for (i=1; i <= 4; i +=1) {if (lineid[j] == Bal[i] && goodline[j]) { 
                        chb[i] = (log10(Bal_rat[i]) - log10(flux_norm[j]/100.))/(flam[j] - 1.0)
                        properr(Bal_rat[i], flux_norm[j]/100., "/", 0.0, err_norm[j]/100., rab = 1.0, verb-)
                        chb_err[i] = abs(properr.sig/(log(10.0)*Bal_rat[i]/(flux_norm[j]/100.))/(flam[j] - 1.0))
		} } 

        }
        print("Balmer  CHbeta  Err\n", >> datfil)
        print("Balmer  CHbeta  Err\n")
        for (i=1; i <= 4; i +=1) {printf("%3s %8.3f %8.3f\n", Bal[i], chb[i],  chb_err[i]) 
				  printf("%3s %8.3f %8.3f\n", Bal[i], chb[i],  chb_err[i], >> datfil}
        }
        #   -------------------------------------------------

        if (extcor && flux_ref > 0.0) {

	if (extin != "ha" && extin != "hg" && extin != "hd" && extin != "he") {
		nb = 5; chb[5] = 0.4*real(extin)*E_hbeta; chb_err[5] = 0.0
		}

	if (extin == "ha"){nb = 1}
	if (extin == "hg"){nb = 2}
	if (extin == "hd"){nb = 3}
	if (extin == "he"){nb = 4}
        Av = 2.5*chb[nb]/E_hbeta  #; print("CHb = ", chb, " Av=", Av)
        flux_hb0_lg = log10(flux_ref)+ chb[nb]
        Av_err = 2.5*chb_err[nb]/E_hbeta
        printf("CHb = %8.3f +/- %8.3f  Av = %8.3f +/- %8.3f  log(FHbeta) = %8.3f %8.3f\n", chb[nb], chb_err[nb], Av, Av_err, flux_hb0_lg, 1.0/spe_snr[ihb])
        printf("CHb = %8.3f +/- %8.3f  Av = %8.3f +/- %8.3f  log(FHbeta) = %8.3f +/- %8.3f\n", chb[nb], chb_err[nb], Av, Av_err, flux_hb0_lg, 1.0/spe_snr[ihb], >> datfil)

        #printf("CHb = %8.3f  Av = %8.3f log(FHbeta) = %8.3f %8.3f\n", chb[nb], Av, flux_hb0_lg, 1.0/spe_snr[ihb], >> datfil)
        #printf("CHb2, CHb3, CHb4 = %8.3f  %8.3f  %8.3f \n", chb2, chb3, chb4, >> datfil)
        print("Dederedded flux ratios written into ", datfil)
        print("          ID   LAMREST    Flam  FLUX_OBS  FLUX_COR   ERR_FLUX  SNR", >> datfil)
        for (j=1; j <= i1; j +=1) {
        if (flux_norm[j] < 1.0E-30) {flux_norm[j] = 1.0E-30}
        flux_norm0[j] = flux_norm[j]*10**(chb[nb]*(flam[j] - 1.0))

	#flux_ref0 = 10**flux_hb0_lg
	#flux0[j] = flux_norm0[j]*flux_ref0
        #properr(flux0[j], flux_ref0, "/", spe_rms[i], spe_rms[ihb], rab = 1.0, verb-)
        #err_norm[i] = 100.0*properr.sig

        if (goodline[j]){printf("%12s  %8.2f %8.3f %8.3f %8.3f %8.3f %7.1f\n", lineid[j], wave[j], flam[j], flux_norm[j], flux_norm0[j], err_norm[j], spe_snr[j], >> datfil)}
	#printf("%d %12s %8.2f %8.3f %8.3f %d %8.1f\n", i, lineid[i], wave[i], flux_norm[i], uflux_norm[i], goodline[i], err_norm[i])
        }
        }

	ig = idline[3]*idline[4]
	if (ig != 0){if (goodline[idline[3]] && goodline[idline[4]]){
	siirat = flux_norm0[idline[3]]/flux_norm0[idline[4]]
	siirat_lo = (flux_norm0[idline[3]] - err_norm[idline[3]])/(flux_norm0[idline[4]] + err_norm[idline[4]])
	siirat_hi = (flux_norm0[idline[3]] + err_norm[idline[3]])/(flux_norm0[idline[4]] - err_norm[idline[4]])
	temden("density", siirat, atom="sulfur", spectrum=2, assume=10000.)
	dens_sii = temden.result
	temden("density", siirat_lo, atom="sulfur", spectrum=2, assume=10000.)
	dens_sii_1 = dens_sii - temden.result
	temden("density", siirat_hi, atom="sulfur", spectrum=2, assume=10000.)
	dens_sii_2 = dens_sii - temden.result
	print("SII density is = ", dens_sii, "+", dens_sii_1, "-", dens_sii_2)
	} }

	ig = idline[1]*idline[2]
	if (ig != 0){if (goodline[idline[1]] && goodline[idline[2]]){
	oiirat = flux_norm0[idline[1]]/flux_norm0[idline[2]]
	oiirat_lo = (flux_norm0[idline[1]] - err_norm[idline[1]])/(flux_norm0[idline[2]] + err_norm[idline[2]])
	oiirat_hi = (flux_norm0[idline[1]] + err_norm[idline[1]])/(flux_norm0[idline[2]] - err_norm[idline[2]])
	temden("density", oiirat, atom="oxygen", spectrum=2, assume=10000.)
	temden("density", oiirat_lo, atom="oxygen", spectrum=2, assume=10000.)
	temden("density", oiirat_hi, atom="oxygen", spectrum=2, assume=10000.)
	print(temden.result)
	}}

	ig = idline[5]*idline[6]*idline[7]
	if (ig != 0){if (goodline[idline[5]] && goodline[idline[6]] && goodline[idline[7]]){
	oiiirat = (flux_norm0[idline[6]]+flux_norm0[idline[7]])/(flux_norm0[idline[5]])
	err_lo = err_norm[idline[6]] + err_norm[idline[7]]
	oiiirat_lo = (flux_norm0[idline[6]]+flux_norm0[idline[7]] - err_lo)/(flux_norm0[idline[5]] + err_norm[idline[5]])
	oiiirat_hi = (flux_norm0[idline[6]]+flux_norm0[idline[7]] + err_lo)/(flux_norm0[idline[5]] - err_norm[idline[5]])
	temden("temperature", oiiirat, atom="oxygen", spectrum=3, assume=100.)
	temden("temperature", oiiirat_lo, atom="oxygen", spectrum=3, assume=100.)
	temden("temperature", oiiirat_hi, atom="oxygen", spectrum=3, assume=100.)
	}}

	end
