procedure stdtab(datafil)

string  datafil  = "M81_SP_c3.cat"    	{prompt="File Name"}
string  colname  = "c4"    		{prompt="Column name or c1, c2 etc or x/y, x-y etc"}
string  outname  = "m81_gc_stat.log"    {prompt="Output file"}
real	mingood   = INDEF  		{prompt="Min good value"}
real	maxgood   = INDEF  		{prompt="Max good value"}
int	niter    = 3    		{prompt="Number of interations"}
int     xcol   = 4    			{prompt="X column name or 1, 2 etc"}
int     ycol   = 4    			{prompt="Y column name or 1, 2 etc"}
bool    log      = no     		{prompt="Take log before analyzing?"}
bool    clean    = yes    		{prompt="Clean data before tstat?"}

begin
	string	plotfil, statfil, cname, tempfil, temptab, dummy
	string  tempfil2, tmp, outfil
	real	stat_lo, stat_hi, objmag, objrms, lowlim, highlim, r1, r2
	int	j, nit, ncol, dcol, i2
	bool	deldata, lg
        struct  line

	plotfil = datafil; nit = niter-1; cname = colname; ncol = xcol; dcol = ycol
	lowlim = mingood; highlim = maxgood; deldata = clean; lg = log
	outfil = outname
	statfil = "stdtab.log"
	tempfil = "tempfil.log"
	tempfil2 = "tempfil2.log"
	temptab = "temptabfil"
	delete(statfil, ver-, >& "dev$null")
	delete(tempfil, ver-, >& "dev$null")
	delete(tempfil2, ver-, >& "dev$null")
	delete(temptab, ver-, >& "dev$null")
	#delete(, ver-, >& "dev$null")
	
	print("============================================= ", >> outfil)
	date | cat(, >> outfil)
	print(plotfil, " ", cname, " ", ncol, " ", dcol, >> outfil)

	if (substr(cname, 1, 1) != "c") {
	#if (cname == "ratio") {
	  if (deldata) {
		dummy = str(ncol)//","//str(dcol)
		fields(plotfil, field=dummy, >> tempfil2) 
	#----------------- remove bad lines ----
        list = tempfil2
        while(fscan(list, line) != EOF ) {tmp = substr (line, 1, 1)
	  if (tmp != "#" && tmp != "") {
          i2 = fscanf(line, "%g  %g", r1, r2)
	  if (r1 > lowlim && r1 < highlim && r2 > lowlim && r2 < highlim) { print(r1, r2, >> tempfil) }
        }
        }
        }
	#-----------------------
		tcreate (temptab, "columns.cd", tempfil)
		dummy = "if y > "//str(lowlim)//" && y < "//str(highlim)//" then "//cname//" else "//str(lowlim-1.0)
		#dummy = "if Y > "//str(lowlim)//" && Y < "//str(highlim)//" then X / Y else "//str(lowlim-1.0)
		#tcalc (temptab, "ratio", "if Y != 0 then X / Y else 0.")
		#tcalc (temptab, "ratio", "if Y != 0 then X / Y else 0.")
		tcalc (temptab, "result", dummy)
		#dummy = "if y > "//str(lowlim)//" && y < "//str(highlim)//" then 1.0 else 0.0"
		#dummy = "if result > "//str(lowlim-1.0)//" then 1.0 else 0.0"
		dummy = "if y > "//str(lowlim)//" && y < "//str(highlim)//" && x > "//str(lowlim)//" && y < "//str(highlim)//" then 1.0 else 0.0"
		tcalc (temptab, "weight", dummy)
		plotfil = temptab; cname = "result"; highlim = INDEF
		} else { 
	  if (deldata) {
		tprint (plotfil, prparam-, prdata+, showrow-, columns=cname, showhdr-, >> tempfil2)
	#----------------- remove bad lines ----
        list = tempfil2
        while(fscan(list, line) != EOF ) {tmp = substr (line, 1, 1)
	  if (tmp != "#" && tmp != "") {
          i2 = fscanf(line, "%g ", r1)
	  if (r1 > lowlim && r1 < highlim) {if (lg) {r1 = log10(r1)}; print(r1, >> tempfil) }
        }
        }
		plotfil = tempfil; cname = "c1"
	#-----------------------
		}
		}

        tstat (plotfil, cname, outtabl=statfil, lowlim=lowlim, highlim=highlim); delete(statfil, ver-, >& "dev$null")
        for (j=1; j <= nit; j +=1) {
        stat_lo = min(tstat.vmin + tstat.stddev, tstat.median-3.0*tstat.stddev)
        stat_hi = max(tstat.vmax - tstat.stddev, tstat.median+3.0*tstat.stddev)
        tstat (plotfil, cname, outtabl="STDOUT", lowlim=stat_lo, highlim=stat_hi)
        #tstat (plotfil, cname, outtabl=statfil, lowlim=stat_lo, highlim=stat_hi)
	#delete(statfil, ver-, >& "dev$null")
        }
	
        tstat (plotfil, cname, outtabl="STDOUT", lowlim=stat_lo, highlim=stat_hi, >> outfil)
        objmag = tstat.median; objrms = tstat.stddev
	if (cname == "result") {
	delete("straight_line.dat", ver-, >& "dev$null")
	tstat (plotfil, "y", outtabl="STDOUT", >> outfil)
	tstat (plotfil, "x", outtabl="STDOUT", >> outfil)
	#tstat (plotfil, "x")
	print(tstat.vmin, objmag*tstat.vmin, objmag*(1.0+objrms)*tstat.vmin, objmag*(1.0-objrms)*tstat.vmin, >> "straight_line.dat")
	print(tstat.vmax, objmag*tstat.vmax, objmag*(1.0+objrms)*tstat.vmax, objmag*(1.0-objrms)*tstat.vmax, >> "straight_line.dat")
	#print(tstat.vmin, objmag*tstat.vmin, objmag*(1.0+objrms)*tstat.vmin, objmag*objrms*tstat.vmin, >> "straight_line.dat")
	#print(tstat.vmax, objmag*tstat.vmax, objmag*(1.0+objrms)*tstat.vmax, objmag*objrms*tstat.vmax, >> "straight_line.dat")
	graph (plotfil, pointm+, logy=lg, logx=lg)
	fields ("straight_line.dat", fields="1,2") | graph (pointm-, app+, col=1, logy=lg, logx=lg)
	fields ("straight_line.dat", fields="1,3") | graph (pointm-, app+, col=2, logy=lg, logx=lg)
	fields ("straight_line.dat", fields="1,4") | graph (pointm-, app+, col=3, logy=lg, logx=lg)
	} else {
	  histogram(tempfil, colname="c1", nbin=12, logplot+, listout-)
	}

end
