procedure	osiris_check


begin
	real	lam, lam_sky1, lam_sky2, r1, r2, lamrat1, lamrat2, r1m, pix2min, r2m 
	real	lam1_cal, lam2_cal, tlamrat1, tlamrat2, ccc, kconst, lam0,  lam01, lam02
	real	f0, f1, rad2min, rbyf2sq, f0byf1sq, constant, const, slop, c2
	int	i, i1

	#6533.05 +- 0.5 6499.60 +- 0.5 6467.70 +- 0.5   values measured on GTC spectra & corrected
	#lam_sky1 = 6501.; lam_sky2 = 6469.    #values measured on M81 GTC spectra 
	lam_sky1 = 6499.60; lam_sky2 = 6467.70   #values measured on M81 GTC spectra & corrected
	#lam_sky1 = 6498.74; lam_sky2 = 6470.98  #from tables : http://www.eso.org/observing/dfo/quality/UVES/txt/sky/gident_580U.dat
	#lam_sky1 = 6504.0; lam_sky2 = 6465.9     #same as above, but fainter of the lines in the range
	const = 7.517E-4   #7.24E-4   #7.517E-4   #7.9520E-4
	f0 = 165.3; f1 = 1.275    #New values
	#f0 = 170.0; f1 = 1.240    #Nominal values
	rad2min = 1.0/(60.*180./PI)
	#print (rad2min)
	slop = 2.0   #2.11
	c2 = 0.0   #1.716874E-6
	ccc = lam_sky2/lam_sky1
	pix2min = 0.127/60.  #pix2min = 0.125/60.
	#f0byf1sq = (1.0/(0.127*1000./60./15.)/185.70)**2
	rbyf2sq = (1.0/(pix2min*1000./15.)/185.70)**2
	f0byf1sq = (rad2min*f0/f1)**2
	constant = f0byf1sq   #rbyf2sq
	print (f0byf1sq/2.0, rbyf2sq/2.0)
	delete("osiris_lam_cal.dat", ver-, >& "dev$null")
	#date ("+%S")
	for (i=2; i <= 6; i +=1) { 
	   fields ("osiris_lam.dat", "1-3", lines=i)  | scan (lam, r1, r2)
	   lamrat1 = (lam/lam_sky1)**2 #- 1.0   #- lam_sky1/lam
	   lamrat2 = (lam/lam_sky2)**2 #- 1.0   #- lam_sky2/lam
	   r1m = r1*pix2min
	   r2m = r2*pix2min
	   lam1_cal = lam/sqrt(1.0 + constant*r1m**2) - lam_sky1
	   lam2_cal = lam/sqrt(1.0 + constant*r2m**2) - lam_sky2
	   #lam1_cal = lam/sqrt(1.0 + (r1m*rad2min*f0/f1)**2) - lam_sky1
	   #lam2_cal = lam/sqrt(1.0 + (r2m*rad2min*f0/f1)**2) - lam_sky2
	   #lam1_cal = lam*(1.0 - const*r1m**slop+ c2*r1m**4) - lam_sky1
	   #lam2_cal = lam*(1.0 - const*r2m**slop+ c2*r2m**4) - lam_sky2
	   tlamrat1 =  (r1m*rad2min*f0/f1)**2 + 1.0 
	   tlamrat2 =  (r2m*rad2min*f0/f1)**2 + 1.0
	#plot lamrat1,lamrat2 (1-lam_sky/lam_cen) vs tlamrat1,tlamrat2 (k*r**2)
	#  or
	#plot lamrat1,lamrat2 (1-lam_sky/lam_cen) vs r1,r2 and fit it to obtain k and n[=2?] (k*r**n)

	#lam_cen estiamted based on the two sky lines
	   lam01 = lam_sky1*sqrt(1.0 + (r1m*rad2min*f0/f1)**2)
	   lam02 = lam_sky2*sqrt(1.0 + (r2m*rad2min*f0/f1)**2)
	   #lam01 = lam_sky1/(1.0 - const*r1m**slop + c2*r1m**4)   #7.9520E-4*r1m**2)
	   #lam02 = lam_sky2/(1.0 - const*r2m**slop + c2*r2m**4)   #7.9520E-4*r2m**2)

	   #kconst = (ccc - 1.0)/(ccc*r1m**slop - r2m**slop)
	   #lam0 = lam_sky1/(1.0 - kconst*r1m**slop)
	   #printf("%8.5g %8.5g %8.5g %8.5g %8.5g %8.5g %8.5g %10.7e %8.5g\n", lam1_cal, lam2_cal, lam01, lam02, tlamrat1, tlamrat2, ccc, kconst, lam0)
	   printf("%8.5g %8.5g %8.5g %8.5g %8.5g %8.5g %8.5g \n", r1m, r2m, lam1_cal, lam2_cal, lam01, lam02, lam)

	   #print(lamrat1,r1,r1m,r1m**2,lamrat2, r2, r2m,r2m**2, lam, >> "osiris_lam_cal.dat") 
	   print(lamrat1,r1,r1m,r1m**2,lamrat2, r2, r2m,r2m**2, tlamrat1, tlamrat2, lam, >> "osiris_lam_cal.dat") 
	}

	
plot1:
	#fields ("osiris_lam_cal.dat", "4,1") | graph (wx1=5, wx2=20, wy1=0.002, wy2=0.02, pointm+, marker="box", colo=1, szmarke=0.01, xlab="kr**2", ylab="1-lamsky/lamcen", app-)
	fields ("osiris_lam_cal.dat", "4,1") | graph (wx1=5, wx2=30, wy1=1.002, wy2=1.05, pointm+, marker="box", colo=1, szmarke=0.01, xlab="r**2", ylab="1-lamsky/lamcen or 7.952E-4r**2", app-)
	fields ("osiris_lam_cal.dat", "4,9") | graph (pointm-, ltype=1, app+)

	fields ("osiris_lam_cal.dat", "8,5") | graph (pointm+, marker="circle", colo=2, szmarke=0.01, app+)
	fields ("osiris_lam_cal.dat", "8,10") | graph (pointm-, ltype=2, colo=2, app+)
	scan(lam)
plot2:
	#fields ("osiris_lam_cal.dat", "3,1") | graph (wx1=2, wx2=6, wy1=0.002, wy2=0.025, pointm+, marker="box", colo=1, szmarke=0.01, xlab="kr**2", ylab="1-lamsky/lamcen", app-)

	#fields ("osiris_lam_cal.dat", "7,5") | graph (pointm+, marker="circle", colo=2, szmarke=0.01, app+)

	date

end
