procedure osiris_rings

begin
	real    lam, lam_sky1, lam_sky2, r1a, r1b, r1c, r2a, r2b, r2c
	real	lam01a, lam01b, lam01c, lam02a, lam02b, lam02c, const_use
	real	const_jairo, const_diva, const_cano, const_new, const_pix, scale
	real	err_lam01, err_lam02, x1, y1, x2, y2, lam0_best, lam0_err, lam0_diff
	real	rad_x1, rad_x2, rad_y1, rad_y2, y1_dif, y2_dif #, lam_sky1_calc, lam_sky2_calc
	string	ofile3

        lam_sky1 = 6499.60; lam_sky2 = 6467.70   #values measured on M81 GTC spectra & corrected
	scale = 0.125 
	const_jairo = 7.517E-4; const_diva = 7.240E-4; const_cano=7.95E-4; const_new = 7.65E-4
	const_use = const_jairo
	const_pix = const_use*2.0*(scale/60.)**2
	#const_pix =const_diva*2.0*(scale/60.)**2 
	#const_pix =const_jairo*2.0*(scale/60.)**2 
	#const_pix =const_cano*2.0*(scale/60.)**2 
	#const_pix = const_new*2.0*(scale/60.)**2 
	rad_x1 = 1.0; rad_x2=2700.0
	rad_y1 = const_pix*rad_x1**2; rad_y2 = const_pix*rad_x2**2

        delete("osiris_rings_fit.dat", ver-, >& "dev$null")
	print((rad_x1*scale/60.)**2, rad_y1, >> "osiris_rings_fit.dat")
	print((rad_x2*scale/60.)**2, rad_y2, >> "osiris_rings_fit.dat")

	ofile3 = "osiris_rings_lam.dat"
        delete(ofile3, ver-, >& "dev$null")

        delete("osiris_ydif.dat", ver-, >& "dev$null")
        delete("osiris_rings_cal.dat", ver-, >& "dev$null")

	printf("lam0 for P1 using C [R in armin]= %8.5g  [R in pixels] %12.7g  \n", const_use, const_pix)
	printf("#lam0 for P1 using C [R in armin]= %8.5g  [R in pixels] %12.7g  \n", const_use, const_pix, >> ofile3)
	#print("#lam0 for P1 using C [for R in pixels] ", const_pix, >> ofile3)
        for (i=3; i <= 6; i +=1) { 
           fields ("osiris_rings.dat", "1-7", lines=i)  | scan (lam, r1a, r1b, r1c, r2a, r2b, r2c)
	   #lam = lam + 8.5
	   lam01b = lam_sky1*sqrt(1.0+const_pix*r1b**2)
	   lam02b = lam_sky2*sqrt(1.0+const_pix*r2b**2)

	   err_lam01 = 2.0*lam01b*const_pix*r1b*(r1c-r1a)/4.0 #err_perc*r1b
	   err_lam02 = 2.0*lam02b*const_pix*r2b*(r2c-r2a)/4.0 #err_perc*r2b

	lam0_best = (lam01b + lam02b)/2.0; lam0_err = abs(lam01b - lam0_best); lam0_diff = lam0_best - lam
	y1 = (lam0_best/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	y2 = (lam0_best/lam_sky2)**2 - 1.0; x2 = (r2b*scale/60.0)**2
	#y1 = (lam/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	#y2 = (lam/lam_sky2)**2 - 1.0; x2 = (r2b*scale/60.0)**2
	#fit_val1 = const_pix*r1b**2; fit_val2 = const_pix*r2b**2
	#y1_dif = 1.0 - y1/(const_pix*r1b**2); y2_dif = 1.0 - y2/(const_pix*r2b**2) 
	y1_dif = abs(1.0 - y1/(const_pix*r1b**2)); y2_dif = abs(1.0 - y2/(const_pix*r2b**2)) 
	print(y1_dif, >> "osiris_ydif.dat"); print(y2_dif, >> "osiris_ydif.dat")
	#lam_sky1_calc = lam0_best/sqrt(1.0+const_pix*r1b**2) - lam_sky1
	#lam_sky2_calc = lam0_best/sqrt(1.0+const_pix*r2b**2) - lam_sky2
	#printf("%8.5g %8.5g %8.5g %8.5g %8.5g %8.5g %8.5g \n", lam, lam_sky1, sqrt(x1), lam_sky1_calc, lam_sky2, sqrt(x2), lam_sky2_calc)
	printf ("%8.5g %8.5g %8.5g %8.5g \n",x1, y1, x2, y2, >> "osiris_rings_cal.dat")
        printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g   %8.5g  +/- %4.2g \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01, lam02b, err_lam02)
        printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g   %8.5g  +/- %4.2g \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01, lam02b, err_lam02, >> ofile3)
	}

        for (i=7; i <= 8; i +=1) { 
	   fields ("osiris_rings.dat", "1-4", lines=i)  | scan (lam, r1a, r1b, r1c)
	   #lam = lam + 8.5
	   lam01b = lam_sky1*sqrt(1.0+const_pix*r1b**2)
	   err_lam01 = 2.0*lam01b*const_pix*r1b*(r1c-r1a)/4.0 #err_perc*r1b

	lam0_best = lam01b; lam0_diff = lam0_best - lam; lam0_err = abs(lam01b - lam0_best)
	y1 = (lam0_best/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	#y1 = (lam/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	printf ("%8.5g %8.5g \n",x1, y1, >> "osiris_rings_cal.dat" )
	printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g     ------  ---  ---  \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01)
	printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g     ------  ---  ---  \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01, >> ofile3)
	}

	printf("lam0 for P2 using C [R in armin]= %8.5g  [R in pixels] %12.7g  \n", const_use, const_pix)
	printf("#lam0 for P2 using C [R in armin]= %8.5g  [R in pixels] %12.7g  \n", const_use, const_pix, >> ofile3)

        for (i=10; i <= 14; i +=1) { 
           fields ("osiris_rings.dat", "1-7", lines=i)  | scan (lam, r1a, r1b, r1c, r2a, r2b, r2c)
	   #lam = lam - 3.0
	   lam01b = lam_sky1*sqrt(1.0+const_pix*r1b**2)
	   lam02b = lam_sky2*sqrt(1.0+const_pix*r2b**2)

	   err_lam01 = 2.0*lam01b*const_pix*r1b*(r1c-r1a)/4.0 #err_perc*r1b
	   err_lam02 = 2.0*lam02b*const_pix*r2b*(r2c-r2a)/4.0 #err_perc*r2b

	lam0_best = (lam01b + lam02b)/2.0; lam0_err = abs(lam01b - lam0_best); lam0_diff = lam0_best - lam
	y1 = (lam0_best/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	y2 = (lam0_best/lam_sky2)**2 - 1.0; x2 = (r2b*scale/60.0)**2
	#y1 = (lam/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	#y2 = (lam/lam_sky2)**2 - 1.0; x2 = (r2b*scale/60.0)**2
	y1_dif = abs(1.0 - y1/(const_pix*r1b**2)); y2_dif = abs(1.0 - y2/(const_pix*r2b**2)) 
	print(y1_dif, >> "osiris_ydif.dat"); print(y2_dif, >> "osiris_ydif.dat")
	printf ("%8.5g %8.5g %8.5g %8.5g \n",x1, y1, x2, y2, >> "osiris_rings_cal.dat")
	printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g   %8.5g  +/- %4.2g \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01, lam02b, err_lam02)
	printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g   %8.5g  +/- %4.2g \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01, lam02b, err_lam02, >> ofile3)
        }

	   fields ("osiris_rings.dat", "1-4", lines=15)  | scan (lam, r1a, r1b, r1c)
	   #lam = lam - 3.0
	   lam01b = lam_sky1*sqrt(1.0+const_pix*r1b**2)
	   err_lam01 = 2.0*lam01b*const_pix*r1b*(r1c-r1a)/4.0 #err_perc*r1b

	lam0_best = lam01b; lam0_diff = lam0_best - lam; lam0_err = abs(lam01b - lam0_best)
	y1 = (lam0_best/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	#y1 = (lam/lam_sky1)**2 - 1.0; x1 = (r1b*scale/60.0)**2
	printf ("%8.5g %8.5g \n",x1, y1, >> "osiris_rings_cal.dat" )
	   #printf("%8.5g %8.5g +/- %4.2g     ------  ---  ---   %8.5g \n", lam, lam01b, err_lam01, lam0_best)
	printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g     ------  ---  ---   \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01)
	printf("%8.5g %8.5g %8.5g %8.5g   %8.5g +/- %4.2g     ------  ---  ---   \n", lam, lam0_best, lam0_diff, lam0_err, lam01b, err_lam01, >> ofile3)

	fields(ofile3, "4", lines="2-5,9-13") | tstat
	fields(ofile3, "4", lines="2-5,9-13") | tstat (, >> ofile3)
	tstat ("osiris_ydif.dat")
	tstat ("osiris_ydif.dat", >> ofile3)

	#------------------------------------------------------------
	#----------------  plot the results ----
	#------------------------------------------------------------
        delete("test.mc", ver-, >& "dev$null")
        delete("temp.dat", ver-, >& "dev$null")
	print("6400.0 0.0", > "temp.dat")
	print("6500.0 0.0", >> "temp.dat")
	print("6600.0 0.0", >> "temp.dat")
	print("6700.0 0.0", >> "temp.dat")

	fields("osiris_rings_cal.dat", "1,2", lines="1-6") | graph (wx1=5, wx2=30, wy1=0.002, wy2=0.05, pointm+, marker="box", colo=1, szmarke=0.01, xlab="r**2", ylab="(lam0/lam)**2 - 1 ", app-, >G "test.mc")
	fields("osiris_rings_cal.dat", "3,4", lines="1-4") | graph (pointm+, marker="circle", colo=2, szmarke=0.01, app+, >>G "test.mc")
	fields ("osiris_rings_fit.dat", "1,2") | graph (pointm-, ltype=2, vx1=0.10, vx2=0.45, vy1=0.55, vy2=0.95, app+, >>G "test.mc")
        fields("osiris_rings_cal.dat", "1,2", lines="7-12") | graph (pointm+, marker="box", colo=3, szmarke=0.02, app+, >>G "test.mc")
	fields("osiris_rings_cal.dat", "3,4", lines="7-11") | graph (pointm+, marker="circle", colo=3, szmarke=0.02, app+, >>G "test.mc")

	fields(ofile3, "1,3,4", lines="2-7") | graph (wx1=6520, wx2=6690, wy1=-14.0, wy2=14.0, pointm+, marker="circle", colo=1, szmarke=0.02, xlab="lambda [Ang]", ylab="Delta lam0", app-, >>G "test.mc") 
	fields(ofile3, "1,3,4", lines="2-7") | graph (pointm+, marker="vebar", colo=1, szmarke=-2, app+) 
	fields("temp.dat", "1,2") | graph (pointm-, ltype=3, app+, >>G "test.mc")
	fields(ofile3, "1,3,4", lines="9-14") | graph (pointm+, marker="vebar", colo=1, szmarke=-2, app+, >>G "test.mc") 
	fields(ofile3, "1,3,4", lines="9-14") | graph (pointm+, marker="box", colo=1, szmarke=0.02, app+, >>G "test.mc") 

	gkimos ("test.mc", device="stdgraph", output="", nx=1, ny=2, rotate-, fill+, inter+, cursor="")
end
