procedure phot_comp(image, coofile)

string  image      ="tf_comb_Ha_fin" 	{prompt="Input fits filename(s)[first file is reference]"}
string  coofile    ="M101_phot_HII_radec.coo" {prompt="Input coordinate file name"}
string  scahead    ="CDELT2" 		{prompt="Header keyword name for the image scale"}
real    scale      = 0.5         	{prompt="Image scale in arcsec/pixel"}
string	coosys     = "world" 		{prompt="Input coordinate system (logical,tv,physical,world)"}
string  apertur    = "4,6,8,10,12"	{prompt="List of aperture radii in scale units"}
real    skyannu    = 15.0		{prompt="Inner radius of sky annulus in scale units"}
real    skydannu   = 5.		{prompt="Width of sky annulus in scale units"}
real    skyvalu    = 0.                 {prompt="Sky value if salgori=constant"}
string	flux   	   = "FLUX[3]"		{prompt="FLUX col name to be extracted [FLUX[3],FLUX[4] etc"}
string	calgori	   = "none"		{prompt="Centering algorithm (centroid|gauss|none|ofilter)"}
string  salgori    = "median"		{prompt="Sky fitting algorithm (median|constant)"}


begin
	string 	old_aper, old_calgori, old_salgori, infil, coofil, cootyp, comm
	string	tsections1, tsections2, imfil, filnam[99], tfile, cflux, tfile1
	string  scalekey, fluxtyp, cradius
	real	old_scale, old_annulus, old_dannulus, old_skyvalu, flux_cal
	real	exptime, wx1, wx2, wy1, wy2, imsca, xc, yc
	int	nimages, i2, nap
	bool	plot
        struct  line

	infil = image; coofil = coofile; cootyp = coosys; scalekey = scahead

	plot = yes; fluxtyp = flux    #"FLUX[3]"; nap=3 
	xc=486.7; yc=492.0   #xc = 461.; yc=523.
	#print(skyannu, skydannu, apertur)
	#save the existing phot pset parameters and replace them with the new ones
	old_scale    = datapars.scale;     datapars.scale    = scale
	old_aper     = photpars.apertur;   photpars.apertur  = apertur
	old_annulus  = fitskypars.annulus;   fitskypars.annulus  = skyannu
	old_dannulus = fitskypars.dannulus;  fitskypars.dannulus = skydannu
	old_skyvalu  = fitskypars.skyvalu;  fitskypars.skyvalu  = skyvalu 
        old_calgori  = centerpars.calgori; centerpars.calgori= calgori 
	old_salgori  = fitskypars.salgori; fitskypars.salgori= salgori
	##photpars.apertur="4,6,8,10,12";   photpars.annulus = 15.0; photpars.dannulus=5.0

#       Get the image names and process (bias,flat,trim) the images
        tsections1 = mktemp ("tmps1")
        tsections2 = mktemp ("tmps2")

	#tsections1 = "tsections1.lis"
	#tsections2 = "tsections2.lis"
	#delete(tsections1, ver-, >& "dev$null")
	#delete(tsections2, ver-, >& "dev$null")

        sections (infil,  option="fullname", > tsections1)
        nimages = sections.nimages
        print("Number of images ",nimages)

        list = tsections1
        for (i = 1; i <= nimages; i = i + 1) {
        i2 = fscan(list, imfil)
	filnam[i] = imfil
        print("Image name ",i, " ",filnam[i])
        }

	#First do the photometry for the FIRST file, next do it for the rest
	imsca = 1.0
	hselect (filnam[1], scalekey, yes) | scan (imsca)
	if (imsca != 1.0) { datapars.scale = imsca*3600.;  print(imsca, datapars.scale) }
	delete(filnam[1]//".mag.1", ver-, >& "dev$null")
	phot(filnam[1], coords=coofil, interac-, wcsin=cootyp, verify-, verbose-)

	if (nimages < 2) goto exit
	delete(filnam[1]//".mag", ver-, >& "dev$null")
	txdump (filnam[1]//".mag.1", "ID XCEN YCEN "//fluxtyp, "yes", headers-, parameters=yes, > filnam[1]//".mag")

	for (i=2; i <= nimages; i +=1) {
	imsca = 1.0
	hselect (filnam[i], scalekey, yes) | scan (imsca)
	if (imsca == 1) { hselect (filnam[i], "CD2_2", yes) | scan (imsca) }
	#{datapars.scale = 2.0;  print(imsca, datapars.scale)} 
	if (imsca != 1.0) { datapars.scale = imsca*3600.;  print(imsca, datapars.scale) }

	delete(filnam[i]//".mag.1", ver-, >& "dev$null")
	phot(filnam[i], coords=coofil, interac-, wcsin=cootyp, verify-, verbose-)

	#copy the required columns into header-less text files using txdump
	delete(filnam[i]//".mag", ver-, >& "dev$null")
	#txdump (filnam[i]//".mag.1", "ID FLUX[3]", "yes", headers-, parameters=yes, > filnam[i]//".mag")
	txdump (filnam[i]//".mag.1", "ID "//fluxtyp, "yes", headers-, parameters=yes, > filnam[i]//".mag")
	}

	flux_cal = 1.0; exptime = 1.0
	#hselect (filnam[1], "FLUX_CAL", yes) | scan (flux_cal)
	hselect (filnam[1], "FLUX_RIG", yes) | scan (flux_cal)
	hselect (filnam[1], "EXPTIME", yes) | scan (exptime)
	#print (flux_cal, exptime)
	#if (flux_cal = 0.0) {flux_cal = 6.5860000000000E-18}
	#flux_cal = 6.5860000000000E-18/180.
	flux_cal = flux_cal/exptime

	#join the columns from different files using the tjoin
	tfile = "phot_comp.result"
	delete(tfile, ver-, >& "dev$null")
	tjoin (filnam[1]//".mag", filnam[2]//".mag", tfile, "c1", "c1", extrarows="neither",
tolerance="0.0", casesens=yes)

	if (nimages == 3){
	tfile1 = "phot_comp1.result"
	delete(tfile1, ver-, >& "dev$null")
	tjoin (tfile, filnam[3]//".mag", tfile1, "c1", "c1", extrarows="neither",
tolerance="0.0", casesens=yes)
	delete(tfile, ver-, >& "dev$null")
	rename (tfile1, tfile, field="all")
	}

	#Do arithmatics on the columns using tcalc
	#tcalc temp.coo "" "c2+100"
	cflux = "C4*"//str(flux_cal)
	cradius = "sqrt((C2_1-"//str(xc)//")**2+(C3-"//str(yc)//")**2)"
	print(cradius)
	#cflux = "C6*"//str(flux_cal)
	tcalc (tfile, "RefFlux", cflux, datatype="real", colunits="", colfmt="")
	#tcalc (tfile, "ratio1", "C2_2 / C4/0.005", datatype="real", colunits="", colfmt="")
	tcalc (tfile, "ratio1", "C2_2 / C4", datatype="real", colunits="", colfmt="")
	tcalc (tfile, "ratio2", "C2 / C4", datatype="real", colunits="", colfmt="")
	tcalc (tfile, "RADIUS", cradius, datatype="real", colunits="", colfmt="")
	#tcalc (tfile, "RADIUS", "sqrt(C2_1**2+C3**2)", datatype="real", colunits="", colfmt="")
	#tcalc (tfile, "ratio1", "C4_2 / C6", datatype="real", colunits="", colfmt="")
	#tcalc (tfile, "ratio2", "C4 / C6", datatype="real", colunits="", colfmt="")

	#plot the ratios against the value in the first file

	#tprint tempp.mag showrow- showhdr- columns="C6 ratio1" | graph  pointmo+ marker="box" logx+
	tstat (tfile, "RefFlux", >& "dev$null") 
	wx1 = 0.9*tstat.vmin; wx2 = 1.1*tstat.vmax
	tstat (tfile, "ratio1", >& "dev$null") 
	wy1 = 0.9*tstat.vmin; wy2 = 1.1*tstat.vmax
        #tprint (tfile, prparam=no, prdata=yes, pwidth=80, plength=0, showrow=no, orig_row=yes,
        #showhdr=no, showunits=no, columns="RefFlux ratio1", rows="-", option="plain", align=yes,
        #sp_col="", lgroup=0) | 
	
	if (!plot) goto exit
	delete("test.mc", ver-, >& "dev$null")
	comm = tfile//" RefFlux ratio1"
	sgraph (comm, wl=0., wr=0., wb=0., wt=0., pointmo+, marker="circle", szmarke=0.03, xlabel="Reference Flux", ylabel="Ratio", logx+, left=0.15, right=0.95, bott=0.15, top=0.90, margin=0.1, title="", sysid-, >G "test.mc") 
	comm = tfile//" RefFlux ratio2"
	sgraph (comm, wl=0., wr=0., wb=0., wt=0., pointmo+, marker="circle", szmarke=0.03, xlabel="Reference Flux", ylabel="Ratio", logx+, left=0.15, right=0.95, bott=0.15, top=0.90, margin=0.1, title="", sysid-, >>G "test.mc")

	gkimos ("test.mc", device="stdgraph", output="", nx=1, ny=2, rotate-, fill+, inter+, cursor="")

        #tprint (tfile, prparam=no, prdata=yes, pwidth=80, plength=0, showrow=no, orig_row=yes,
        #showhdr=no, showunits=no, columns="RefFlux ratio2", rows="-", option="plain", align=yes,
        #sp_col="", lgroup=0) | sgraph (append+, wl=wx1, wr=wx2, wb=wy1, wt=wy2, pointmo+, marker="circle", szmarke=0.01, xlabel="Reference Flux", ylabel="Ratio", logx+, left=0.15, right=0.95, bott=0.1, top=0.45, margin=0.1)
        #sp_col="", lgroup=0) | graph (wx1=wx1, wx2=wx2, wy1=wy1, wy2=wy2, pointmo+, marker="circle", szmarke=0.01, xlabel="Reference MAG", ylabel="Ratio", logx+)

exit:

	#Return the old phot pset parameters
	datapars.scale    = old_scale;   photpars.apertur  = old_aper
	fitskypars.annulus  = old_annulus; fitskypars.dannulus = old_dannulus
	fitskypars.skyvalu = old_skyvalu
	centerpars.calgori= old_calgori; fitskypars.salgori= old_salgori

	#print(tsections1, tsections2)
	delete(tsections1, ver-, >& "dev$null")
	delete(tsections2, ver-, >& "dev$null")

end

