procedure tf_simul(lam0, lamda)

real    lam0       = 6608.0      {prompt="Wavelength in Ang at XY center of the TF"}
real    lamda     = 6568.0      {prompt="Wavelength in Ang of interest"}
real    dellam     = 20.         {prompt="Width of TF in Ang "}
real    veloc      = 0.0         {prompt="Radial Velocity of the object (km/s) "}
string  output     ="tf_simul"   {prompt="Name of the output monochromatic image"}
real    xcen       = -100.       {prompt="X center of the TF wrt the image"}
real    ycen       = 2000.       {prompt="X center of the TF wrt the image"}
int     xsize      = 2048        {prompt="X center of the TF wrt the image"}
int     ysize      = 4102        {prompt="X center of the TF wrt the image"}
real    scale      = 0.125       {prompt="Image scale in arcsec/pixel"}


begin
	string out, ofile1, ofile2, size, comm1
        real    xc, yc, lamin, lam_mon, lamout, dlam, vel, pixsec, pixmin2
	int	nx, ny

	lamin = lam0; lamout=lamda; dlam=dellam; vel = veloc; out = output
	xc = xcen; yc = ycen; pixsec = scale; nx = xsize; ny = ysize
        ofile1=out//"_"//str(int(lamin))
        ofile2=out//"_"//str(int(lamin))//"_"//str(int(lamout))
        size=str(nx)//","//str(ny)

	imdelete(ofile1, ver-, >& "dev$null")
	imdelete(ofile2, ver-, >& "dev$null")

        pixmin2 =(pixsec/60.0)**2 
        lam_mon = lamout*(1.0 + vel/2.9997E+05)
	print("Doppler shifted wavelength [velocity=",vel, " km/s] is = ",lam_mon)

        comm1 = str(lam0)//"*(1.0-7.9520E-04*"//str(pixmin2)//"*((real(I)-"//str(xc)//")**2 + (real(J)-"//str(yc)//")**2))"
        imexpr (comm1, ofile1, dims=size, verb=yes)

        comm1 = "1.0/(1.0 + 2.0*((a-b)/"//str(dlam)//")**2)"
        comm1 = "1.0/(1.0 + 2.0*(("//str(lam_mon)//"-a)/"//str(dlam)//")**2)"

        imexpr(comm1, ofile2, ofile1, dims=size, verb=yes)

	#hedit (ofile, fields="CRVAL1", value=lam0, add+, ver-, show-, update+)
	#hedit (ofile, fields="CRPIX1", value=xc, add+, ver-, show-, update+)
	#hedit (ofile, fields="CDELT1", value=1.0, add+, ver-, show-, update+)

	print("Output image names are: ",ofile1,".fits and ",ofile2,".fits" )

end
