procedure tf_simul_obs(lam0)

real    lam0       = 6608.0      {prompt="Wavelength in Ang at XY center of the TF"}
#real    lamda     = 6568.0      {prompt="Wavelength in Ang of interest"}
real    dellam     = 20.         {prompt="Width of TF in Ang "}
#real    veloc      = 0.0         {prompt="Radial Velocity of the object (km/s) "}
string  output     ="aa_tf_simul"   {prompt="Name of the output monochromatic image"}
real    xcen       = -100.       {prompt="X center of the TF wrt the image"}
real    ycen       = 2000.       {prompt="X center of the TF wrt the image"}
int     xsize      = 2048        {prompt="X center of the TF wrt the image"}
int     ysize      = 4102        {prompt="X center of the TF wrt the image"}
#real    scale      = 0.125       {prompt="Image scale in arcsec/pixel"}


begin
	string out, ofile1, ofile2, size, comm1
	string 	ofile_cont, ofile_line, ofile_csky, ofile_emsky, ofile_Ha, ofile_lamin
	string	ofile2_sky, ofile2_6548, ofile2_6584, ofile2_Ha
        real    xc, yc, lamin, lam_mon, lamout, dlam 
	real    mean, resp_sum
	int	nx, ny, npix

	lamin = lam0; xc = xcen; yc = ycen; nx = xsize; ny = ysize
        size=str(nx)//","//str(ny)

	#----------------------------------------------------------
	out = output     #"tf_simul"
	ofile_cont = out//"_cont"
	ofile_line = out//"_line"
	ofile_csky  = out//"_csky"
	ofile_emsky  = out//"_emsky"
	ofile_Ha   = out//"_Ha"
	ofile_lamin= out//"_"//str(int(lamin))//"_obs"
	imdelete(ofile_cont, ver-, >& "dev$null")
	imdelete(ofile_line, ver-, >& "dev$null")
	imdelete(ofile_csky, ver-, >& "dev$null")
	imdelete(ofile_emsky, ver-, >& "dev$null")
	imdelete(ofile_Ha, ver-, >& "dev$null")
	imdelete(ofile_lamin, ver-, >& "dev$null")

	#Continuum
	comm1 = "((mod(I+200,200) < 20) && (mod(J+200,200) < 20)) ? 0.1 : 0.0"
	imexpr (comm1, ofile_cont, dims=size, verb=yes)

	#Line  (int=1 for Ha, 0.1 for NII6584 and 0.03 for NII6548 
	comm1 = "((mod(I+250,250) < 50) && (mod(J+250,250) < 50)) ? 1.0 : 0.0"
	imexpr (comm1, ofile_line, dims=size, verb=yes)
	
        ofile1=out//"_"//str(int(lamin))
        ofile2_Ha=out//"_"//str(int(lamin))//"_"//str(6563)
	imdelete(ofile1, ver-, >& "dev$null")
	imdelete(ofile2_Ha, ver-, >& "dev$null")
	tf_simul (lamin, 6563., dellam=20., output=out, xcen=xc)

	#Integral of the normalized response function of delta_lam=20 is 633
	imstat (ofile2_Ha//".fits[1:2000,2000:2000]", fields="npix, mean", format-) | scan (npix, mean)
	resp_sum = real(npix)*mean
	print ("6563: ",npix, mean, resp_sum)

	#sky     uniform (int=0.1) with a line (int=1) at 6530 Ang 
        #comm1 = "abs(a-6530.0) <= 5.0 ? 1.0 : 0.1"
	imexpr ("0.1+a*0.0", ofile_csky, ofile1, dims=size, verb=yes)
        comm1 = "abs(a-6530.0) <= 3.0 ? 1.0 : 0.0"
	imexpr (comm1, ofile_emsky, ofile1, dims=size, verb=yes)

        ofile2_6584=out//"_"//str(int(lamin))//"_"//str(6584)
	imdelete(ofile1, ver-, >& "dev$null")
	imdelete(ofile2_6584, ver-, >& "dev$null")
	tf_simul (lamin, 6584., dellam=20., output=out, xcen=xc)

        ofile2_6548=out//"_"//str(int(lamin))//"_"//str(6548)
	imdelete(ofile1, ver-, >& "dev$null")
	imdelete(ofile2_6548, ver-, >& "dev$null")
	tf_simul (lamin, 6548., dellam=20., output=out, xcen=xc)

        ofile2_sky=out//"_"//str(int(lamin))//"_"//str(6530)
        imdelete(ofile1, ver-, >& "dev$null")
        imdelete(ofile2_sky, ver-, >& "dev$null")
        tf_simul (lamin, 6530., dellam=20., output=out, xcen=xc)

	#Halpha theoretical image: Line + Cont + Sky 
        comm1 = "a+(0.1*"//str(resp_sum)//")*b+c"
	imexpr (comm1, ofile_Ha, ofile_line, ofile_cont, ofile_csky, dims=size, verb=yes)

	#Observed image at "lamin"
        #comm1 = "ofile_line*(ofile2_Ha + 0.1*ofile2_6584 + 0.033*ofile2_6548) + ofile_sky*ofile2_sky + (ofile_cont+ofile_sky)*resp_sum" 
        #comm1 = "a*(b+ 0.1*c+ 0.033*d) + e*f + (g+h)*"//str(resp_sum) 
        comm1 = "a*b+ shift(a,50)*0.1*c+ shift(a,-50)*0.033*d + e*f + (g+h)*"//str(resp_sum) 
        #                              a           b          c            d            e             f           g           h
	imexpr (comm1, ofile_lamin, ofile_line, ofile2_Ha, ofile2_6584, ofile2_6548, ofile_emsky, ofile2_sky, ofile_cont, ofile_csky, dims=size, verb=yes)

	#Halpha observed image: Line + Cont + Sky 
        #comm1 = "abs(e-6530.0) <= 5.0 ? d*(a+c)+b*"//str(resp_sum)//" : d*a+(b+c)*"//str(resp_sum)
	#imexpr (comm1, ofile_Haobs, ofile_line, ofile_cont, ofile_sky, ofile2, ofile1, dims=size, verb=yes)

	#NII6584 observed image: Line + Cont + Sky 
        #comm1 = "abs(e-6530.0) <= 5.0 ? d*(a*0.1+c)+b*"//str(resp_sum)//" : d*a*0.1+(b+c)*"//str(resp_sum)
	#imexpr (comm1, ofile_6584obs, ofile_line, ofile_cont, ofile_sky, ofile2, ofile1, dims=size, verb=yes)

	#NII6548 observed image: Line + Cont + Sky 
        #comm1 = "abs(e-6530.0) <= 5.0 ? d*(a*0.033+c)+b*"//str(resp_sum)//" : d*a*0.033+(b+c)*"//str(resp_sum)
	#imexpr (comm1, ofile_6548obs, ofile_line, ofile_cont, ofile_sky, ofile2, ofile1, dims=size, verb=yes)

        #Lambda 6528 cont observed image: Line + Cont + Sky
        #comm1 = "abs(e-6530.0) <= 5.0 ? d*(a*0.033+c)+b*"//str(resp_sum)//" : d*a*0.033+(b+c)*"//str(resp_sum)
        #imexpr (comm1, ofile_6528cont, ofile_line, ofile_cont, ofile_sky, ofile2, ofile1, dims=size, verb=yes)

end
