procedure	apcreate(image)

#A task to aperture file to be used by apall to extract spectra of multiple
#objects based on a few ref objects where tracings have been already carried out.
#It is basically meant for use with OSIRIS spectra reduced using GTCMOS pipeline, but
#could be used for other spectra as well.

string  image  = "gtc16bob001_object_630to636_wl_cal_obj_cut"           {prompt="Image name"}
string  apdata = "gtc16bob001_object_630to636_head.dat"            	{prompt="Slit data file"}
string  refap  = "gtc16bob001_object_630to636_wl_cal_obj_cut_ref54"     {prompt="Reference trace file"}
string  dbase  = "database/"            {prompt="Directory to store apall database file"}
bool	gtcmos = yes			{prompt="Is the apdata file from gtcmos tasks"}

begin
	string	infil, imname, datadir, apref, apfile, c1, imroot, stype
	real	xcen, ycut, slitx, slity, slityx, slito
	int	i1, slit_no, apno, nslits, i
        int     ix1, ix2, islit, nslice, is, is1, is2, isl
	bool	osirishead
        struct  line, date

	#nslits = 75
	#slit_no = 10

        infil = apdata; imroot = image; datadir = dbase
        apref  = datadir//"ap"//refap
	osirishead = gtcmos

        delete ("tmp_table", ver-, >& "dev$null")
        list = apref 
        #c1 = " "
	i1 = 0
        while( fscan(list,line) != EOF) {
        #c1 = substr(line,1,1)
        if (substr(line,1,1) == "#") i1 = 0
        #fields (line, "1,4", lines=1) | scan(dummy, nap)
	#if (dummy == "begin") apno_ref = nap
	#if (i1 == 0) {i1 = strstr ("center", line)} else {print (line, >> "tmp_table_"//str(apno_ref))}
	if (i1 == 0) {i1 = strstr ("center", line)} else {print (line, >> "tmp_table")}
        }

        fields (apref, "6", lines=2) | scan(ycut)
	imname = imroot   #//"_"//str(i)
        apfile = datadir//"ap"//imname
        delete (apfile, ver-, >& "dev$null")

        #omslits (imroot, verb-)
        #nslits = omslits.nslitlets
        #list = omslits.out

	list = infil
        i1 = 0; i = 0
        #for (i = 1; i <= nslits; i = i + 1) {
        while( fscan(list,line) != EOF) {
	i = i + 1
        i1 = fscan(line, islit, ix1, ix2, slitx, slity, slityx, stype, slito)
        if (stype != "circular") {
        #sec[i] = "["//str(ix1)//":"//str(ix2)//",*]"
        #if (slitid == "all") {slice[i] = yes}
        #if (slice[i]){
        #imdelete (filin//"_"//str(i), ver-, >& "dev$null")
        #imcopy (filin//sec[i], filin//"_"//str(i), ver-)
        #}   #if (slice[i])

	apno = islit   #1
	xcen = slitx   #9.0
        ##llim = -5.0; ulim = 4.0
        ##xmin = -10.0; xmax = 10.0
	#for (i = 1; i <= nslits; i = i + 1) {
	#imname = imroot//"_"//str(i)
        #apfile = datadir//"ap"//imname
        #delete (apfile, ver-, >& "dev$null")
        date | scan (date)
        print("# ",date, >> apfile)
        print("begin   aperture ", imname, " ", apno, xcen, ycut, >> apfile)
        print("        image   ", imname, >> apfile)
        print("        aperture       ", apno, >> apfile)
        print("        beam   ", apno, >> apfile)
        print("        center  ", xcen, ycut, >> apfile)
        #print("        low     ", llim, -ycut, >> apfile)
        #print("        high    ", ulim, ycut, >> apfile)
        #print("        background", >> apfile)
        #print("                xmin ", xmin, >> apfile)
        #print("                xmax ", xmax, >> apfile)
        #print("                function ", bg_func, >> apfile)
        #print("                order ", bg_ord, >> apfile)
        #print("                sample ", bg_samp1, " ",bg_samp2, >> apfile)
        #print("                naverage ", -3, >> apfile)
        #print("                niterate ", 0, >> apfile)
        #print("                low_reject ", 3.0, >> apfile)
        #print("                high_reject ", 3.0, >> apfile)
        #print("                grow ", 0., >> apfile)

        type ("tmp_table", >> apfile)
        #print("      ", >> apfile)
        #}
        }   #!= "circular"
        }   #i = 1; i <= nslits

end

