procedure findspe(catal, object)

#Finds whether the OBJECT has entered any of the slits in the images listed in SPELIS. 
#OBJECT should be in CATAL 
#A region of DXBOX x DYBOX around the OBJECT coordinate is searched 

string  catal  = "../m81csc_bright.cat"         {prompt="CSC Catalog name"}
string  object = "R06B06945"            {prompt="Object name"}
#bool    findspe= no                     {prompt="Find out whether observed spectrum exists?"}
string  spelis = "spectra_files.lis"    {prompt="File containing WCS-corrected acquisition image names"}
real    dxbox  = 0.25                  {prompt="X search box size around the object in arcsec"}
real    dybox  = 0.25                  {prompt="Y search box size around the object in arcsec"}

begin
        string  cat_name, obj_name, imlis, ttt_radec, ttt_xy, c1
        string  csc_name, sec, tfil, dum1, dum2, dum3, dum4, sec2
	string	name[999], ttt_coo, ttt_slitim, ttt_slitim2
        real    csc_ra, csc_dec, dx, dy, im_sca, rms, bgflx, objflx, krms, snrobj
	real	obj_x, obj_y, dxarc, dyarc, contrast, objflx2, ra[999], dec[999]
	real	distance, maxval
	int	nx, ny, i2, i3, x1, x2, y1, y2 , npix, npix2, iobj, nobj, idobj
	#int	nx, ny, i2, i3, nimages, x1, x2, y1, y2 , npix, npix2, iobj, nobj, idobj
	bool	inimage

        cat_name = catal; obj_name = object; imlis = spelis 
	dxarc = dxbox; dyarc = dybox
	krms = 300.0

        ttt_radec = "ttt_radec.cat"
        ttt_xy = "ttt_xy.cat"
        ttt_coo = "ttt_coo.cat"
        ttt_slitim = "ttt_slitim"
        ttt_slitim2 = "ttt_slitim2"
        delete(ttt_radec, ver-, >& "dev$null")
        delete(ttt_xy, ver-, >& "dev$null")
        delete(ttt_coo, ver-, >& "dev$null")
        imdelete(ttt_slitim, ver-, >& "dev$null")
        imdelete(ttt_slitim2, ver-, >& "dev$null")

	iobj = 0
        list = cat_name
        while( fscan(list,line) != EOF ) {
        c1 = substr(line,1,1)
        if (c1!="#") {
          i2 = fscan(line, csc_name, csc_ra, csc_dec)
	  iobj = iobj + 1; name[iobj] = csc_name; ra[iobj] = csc_ra; dec[iobj] = csc_dec
          if (csc_name == obj_name)  {idobj = iobj; print (csc_ra, csc_dec, >> ttt_radec) }
        }
        }

	if (obj_name == "all"){nobj = iobj} else {nobj = 1}
	print("#Object       X       Y      RA         DEC        flux          rms   dist_arcsec")


	for (iobj=1; iobj <= nobj; iobj +=1) {

	if (obj_name == "all"){
		csc_name=name[iobj]; csc_ra=ra[iobj]; csc_dec=dec[iobj]
        	delete(ttt_radec, ver-, >& "dev$null")
        	#delete(ttt_xy, ver-, >& "dev$null")
          	print (csc_ra, csc_dec, >> ttt_radec)
	} else {csc_name=name[idobj]; csc_ra=ra[idobj]; csc_dec=dec[idobj]}
	#print(idobj, csc_name, " ", csc_ra, csc_dec)

        i3 = 0
        list = imlis
        while( fscan(list,line) != EOF ) {c1 = substr(line,1,1)
        if (c1!="#") { i2 = fscan(line, dum1, dum2, dum3, dum4)
	i3 = i3 + 1
	tfil = dum1//"/"//dum2

	im_sca = 0.257578
	dx = dxarc/im_sca/2.0; dy = dyarc/im_sca/2.0
	hselect (tfil, "NAXIS1 NAXIS2", yes) | scan (nx, ny)
        delete(ttt_xy, ver-, >& "dev$null")
        delete(ttt_coo, ver-, >& "dev$null")
        imdelete(ttt_slitim, ver-, >& "dev$null")
        imdelete(ttt_slitim2, ver-, >& "dev$null")
        wcsxymatch (tfil, tfil, ttt_xy, coords=ttt_radec, verbose-)
        fields (ttt_xy, "1,2", lines=11) | scan (obj_x, obj_y)
        fields (ttt_xy, "1,2", lines=11, > ttt_coo)
        x1 = obj_x - dx; x2 = obj_x + dx; y1 = obj_y - dy; y2 = obj_y + dy
	inimage = no
	if (x1 >= 1 && x2 <= nx && y1 >= 1 && y2 <= ny){inimage = yes}
        sec = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
	dx = 1.0; dy = 1.0
        x1 = obj_x - dx; x2 = obj_x + dx; y1 = obj_y - dy; y2 = obj_y + dy
        sec2 = "["//str(x1)//":"//str(x2)//","//str(y1)//":"//str(y2)//"]"
	#print(tfil//sec, " ", inimage)
	
	if (inimage){
	tfil = dum1//"/"//dum3
	#print(tfil//sec, " ", inimage, " ", obj_x, obj_y)
	imstat (tfil, fields="stddev, midpt", nclip=5, format-) | scan (rms, bgflx)
	imexpr ("a-"//str(bgflx)//">"//str(krms)//"*"//str(rms)//"? a : 0.0", ttt_slitim, tfil//sec, verb-)
	imstat (ttt_slitim, fields="midpt, npix, max", nclip=0, format-) | scan (objflx, npix, maxval)
	#imexpr ("a-"//str(maxval)//"=0.0 ? sqrt((I**2) + (J**2)): 0.0", ttt_slitim2, ttt_slitim, verb-)
	imexpr ("a-"//str(maxval)//"=0.0 ? sqrt((I-"//str(dx)//")**2 + (J-"//str(dy)//")**2): 0.0", ttt_slitim2, ttt_slitim, verb-)
	imstat (ttt_slitim2, fields="max", nclip=0, format-) | scan (distance)
	distance = distance*im_sca
	
	if (objflx > 0.0){
	printf("%s %7.1f %7.1f %11.6f %11.6f %6.1f %12.5e %6.3f %s \n", csc_name, obj_x, obj_y, csc_ra, csc_dec, objflx, rms, distance, dum2)}
	}

                    }}
        #nimages = i3
        #print("Number of images ",nimages)
	}

end
