procedure fluxcalc(infile)

string  infile	= "wr1_new1"    	{prompt="Input filename to measure flux"}
string  linelist="spanal$data/nebular_lines.dat"	{prompt="List containing lines to be measured"}
int     apno 	= 1             	{prompt="Aperture no spectrum to measure"}
int     bands   = 1             	{prompt="Image bands to be fit"}
bool    inter   = yes           	{prompt="Fit continumm interactively?"}
real    lammin  = 3700.0        	{prompt="Minimum good lambda in Ang"}
real    lammax  = 7600.0        	{prompt="Maximum good lambda in Ang"}
bool    skyrms  = yes			{prompt="Add Sky rms to the continuum rms? [If yes band=2 is assumed to be sky]"}
string  veltype = "none"         	{prompt="Velocity for Doppler correction [none|mean|median|value in km/s]"}
string  redcurve="spanal$data/ext_interp.dat"  {prompt="Extinction curve normalized to Av"}
string  exttype = "none"         	{prompt="Av for extinction correction [none|hbeta|mean|value in mag]"}
bool    skyshi  = yes           	{prompt="Shift wavelength of spectrum using sky lines?"}
string  skyline ="spanal$data/skyline.dat"     {prompt="List containing sky lines to be measured"}
real    snrgood = 20.0          	{prompt="Minimum SNR of a line for velocity calculation"}
real    errfwhm = 20.0          	{prompt="Maximum error in FWHM wrt to Hbeta (in % units) for velocity calculation"}
bool    wtext   = no			{prompt="Write text file [wav flux rms]?"}

begin
	string	filein, inlist, tmp, s1, lineid[99], dopfil, velo, extin
	string	splotfillog, sample, nebfil, splotfilcur, cdisp, datfil
	string	extcurve, skylist, blend[99], s2, skyfil, imsec
	real	r1, wave[99], velocity, spe_rms, spe_snr, cont_rms, npix, flux_ref, chb_err, theo_rat
        real   center, cont, flux, eqw, core, gfwhm, lfwhm, xmin, xmax, fcont, disp
	real	flux_norm[99], flux_hbeta, fluxobs[99], tlam, Elam, flam[99], E_hbeta, chb, Av
	real	goodsnr, min_fwhm, max_fwhm, fwhmerr, flux_norm0, flux_hb0_lg, est_flux
	real	chb2, chb3, chb4, err_norm[99], rms_ref, rms_hbeta, chb2_err, chb3_err, chb4_err, Av_err
        int     i1, i2, nap, j, band, i, igood, tlines, lineno, ngoodline, niter
	bool	ask, dopcor, goodline[99], extcor, skycor, ans, addskyrms
        struct  line

	filein = infile; inlist = linelist; skylist = skyline
	nap = apno; xmin = lammin; xmax = lammax; band = bands
	ask = inter; velo = strlwr(veltype); dopcor = no; addskyrms = skyrms
	extin = strlwr(exttype); extcor = no; skycor = skyshi
	if (velo != "none") {dopcor = yes}
	if (extin != "none") {extcor = yes}
	extcurve = redcurve
	goodsnr = snrgood; fwhmerr = errfwhm
	#dopcor = dopshi
        sample = str(xmin)//":"//str(xmax)

        disp = 1.0; cdisp = "1.0"; ngoodline = 0
	chb = 0.0; chb2 = 0.0; chb3 = 0.0; chb4 = 0.0
	chb_err = 0.0; chb2_err = 0.0; chb3_err = 0.0; chb4_err = 0.0
        hselect (filein, "CDELT2", expr+) | scan(cdisp)
        if (cdisp == "1.0") { hselect (filein, "CD1_1", expr+) | scan(cdisp) 
				disp = real(cdisp)}
        if (cdisp != " " && real(cdisp) > 0.01) {disp = real(cdisp)}

	if (extcor) { type(extcurve) | wc | scan(tlines) }

        i1 = 0
        list = inlist
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#" && tmp != "") {
          i1=i1+1
	  goodline[i1] = yes
	  i2 = fscanf(line, "%s  %g  %d  %s ", s1, r1, igood, s2)
	  lineid[i1] = s1; wave[i1] = r1; blend[i1] = s2
	  if (igood == 0) {goodline[i1] = no}
	  #print(s1, " ", r1, " ", igood, " ", blend[i1])
	}
	}

        delete("fluxcalc.vel", ver-, >& "dev$null")
	i = 0
        datfil = filein//"_ap"//str(nap)//"_"//str(band)//"_flux.dat"
        nebfil = filein//"_ap"//str(nap)//"_"//str(band)
        imdelete(nebfil, ver-, >& "dev$null")
        if (skycor) {skyshift(filein, apnum=nap, skyline=skylist)}
	#imsec = "["//str(j)//":"//str(j+rmsstep-1)//"]" #; print(imsec)
	imsec = "[*,"//str(nap)//","//str(band)//"]" 
        scopy (filein//imsec, nebfil, w1=xmin, w2=xmax, rebin+)
        #scopy (filein, nebfil, w1=xmin, w2=xmax, apertur=nap, band=band, rebin+)
	
	omsperms(nebfil, sample=sample, inter=ask)

        imdelete(nebfil//"_totrms", ver-, >& "dev$null")
	if (addskyrms){
        skyfil = filein//"_ap"//str(nap)//"_"//str(2)
        imdelete(skyfil, ver-, >& "dev$null")
	imsec = "[*,"//str(nap)//","//str(2)//"]" 
        scopy (filein//imsec, skyfil, w1=xmin, w2=xmax, rebin+)
        #scopy (filein, skyfil, w1=xmin, w2=xmax, apertur=nap, band=2, rebin+)
        omsperms(skyfil, sample=sample, inter=ask)
        imexpr ("sqrt(a**2 + b**2)", nebfil//"_totrms", nebfil//"_rms", skyfil//"_rms", verb-)
	} else {
	imcopy (nebfil//"_rms", nebfil//"_totrms", verb-)
	}
        imdelete(nebfil//"_snr", ver-, >& "dev$null")
	imarith (nebfil, "/", nebfil//"_totrms", nebfil//"_snr", verbose-)
	niter = 0

repeat:
	niter = niter + 1
        for (j=1; j <= i1; j +=1) {
        splotfilcur = "splot_auto_cont.cursor"
        splotfillog = "splot_auto_stat.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")
        print (wave[j], " 0.0  1 <space>", >> splotfilcur)
        splot (nebfil//"_cont", cursor=splotfilcur, > splotfillog)
        splot (nebfil//"_totrms", cursor=splotfilcur, >> splotfillog)
        #splot (nebfil//"_rms", cursor=splotfilcur, >> splotfillog)
        fields (splotfillog, fields="4", lines=1) | scan (fcont)
        fields (splotfillog, fields="4", lines=2) | scan (cont_rms)

        splotfillog = "splot_auto_gaussfit.log"
	if (blend[j] == "0") {
        omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0)
	lineno = 4
	} else {
        if (strlen(blend[j])>1){
		if (!access(blend[j])){  
		print("Deblending file ",blend[j], " absent. Press Enter to copy from database")
		scan(ans)
		copy ("spanal$data/"//blend[j], blend[j], verbose+)
		}
		omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0, cursor=blend[j])
		lineno = 4 
		} else { lineno = lineno + 1 }
	}

        fields (splotfillog, fields="1-7", lines=lineno) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
        velocity = 2.9979E+05 * (center - wave[j])/wave[j]
	fluxobs[j] = flux
	eqw = flux/fcont; npix = 2.0*gfwhm/disp 
	est_flux = 2.0*npix + eqw/disp 
	if (est_flux <= 1.0) {est_flux = 1.0}
	#spe_rms = cont_rms*disp*sqrt(2.0*npix + eqw/disp)
	spe_rms = cont_rms*disp*sqrt(est_flux) 
	spe_snr = flux/spe_rms
	if (abs(spe_snr) < goodsnr) {goodline[j] = no}
	#if (j == 1) {flux_hbeta = flux; min_fwhm = gfwhm*(1.-fwhmerr/100.); max_fwhm = gfwhm*(1.+fwhmerr/100.)}
	if (j == 1 && niter == 1) {flux_ref = flux; flux_hbeta = flux; min_fwhm = gfwhm*(1.-fwhmerr/100.); max_fwhm = gfwhm*(1.+fwhmerr/100.); rms_ref = spe_rms; rms_hbeta = spe_rms}
	if (!goodline[1] && niter == 1) {flux_ref = 1.0}
	if (lineid[j] == "Ha" && !goodline[1]) {flux_ref = flux; min_fwhm = gfwhm*(1.-fwhmerr/100.); max_fwhm = gfwhm*(1.+fwhmerr/100.); rms_ref = spe_rms}
	if (flux_ref != 1.0 && niter == 1) {goto repeat}
	#if (lineid[j] == Lineref) {flux_ref = flux; min_fwhm = gfwhm*(1.-fwhmerr/100.); max_fwhm = gfwhm*(1.+fwhmerr/100.)}
	#if (Lineref == "Hb"){flux_hbeta = flux_ref} else {flux_halfa = flux_ref}
	flux_norm[j] = 100.0*flux/flux_ref
	properr(flux, flux_ref, "/", spe_rms, rms_ref, rab = 1.0, verb-)
	err_norm[j] = 100.0*properr.sig
	#flux_norm[j] = 100.0*flux/flux_hbeta
	if (gfwhm > max_fwhm || gfwhm < min_fwhm ) {goodline[j] = no}
	if (goodline[j]) {print(velocity, >> "fluxcalc.vel"); ngoodline = ngoodline +1}

	#--------------Extinction curve realted quantities
        delete("fluxcalc_temp.dat", ver-, >& "dev$null")
	if (extcor) {
		print(wave[j], >> "fluxcalc_temp.dat")
		sinter (extcurve, "fluxcalc_temp.dat", tbl_siz=tlines) | scan (tlam, Elam)
		if (j == 1) {E_hbeta = Elam}
		flam[j] = Elam/E_hbeta

		if (lineid[j] == "Ha" && goodline[j]) {theo_rat = 2.87}
		if (lineid[j] == "Hg" && goodline[j]) {theo_rat = 0.466}
		if (lineid[j] == "Hd" && goodline[j]) {theo_rat = 0.256}
		if (lineid[j] == "He" && goodline[j]) {theo_rat = 0.158}
		if ((lineid[j] == "Ha" || lineid[j] == "Hg" || lineid[j] == "Hd" && lineid[j] == "He") && goodline[j]) {

			chb = (log10(theo_rat) - log10(flux_norm[j]/100.))/(flam[j] - 1.0)
			properr(theo_rat, flux_norm[j]/100., "/", 0.0, err_norm[j]/100., rab = 1.0, verb-)
			chb_err = abs(properr.sig/(log(10.0)*theo_rat/(flux_norm[j]/100.))/(flam[j] - 1.0)) 
			#print(chb, chb_err)
			if (lineid[j] == "Hg") {chb2 = chb; chb2_err = chb_err}
			if (lineid[j] == "Hd") {chb2 = chb; chb3_err = chb_err}
			if (lineid[j] == "He") {chb2 = chb; chb4_err = chb_err}
		}

		#if (lineid[j] == "Ha" && goodline[j]) {	chb = (log10(2.870) - log10(flux_norm[j]/100.))/(flam[j] - 1.0)}
		#if (lineid[j] == "Hg" && goodline[j]) {chb2 = (log10(0.466) - log10(flux_norm[j]/100.))/(flam[j] - 1.0)}
		#if (lineid[j] == "Hd" && goodline[j]) {chb3 = (log10(0.256) - log10(flux_norm[j]/100.))/(flam[j] - 1.0)}
		#if (lineid[j] == "He" && goodline[j]) {chb4 = (log10(0.158) - log10(flux_norm[j]/100.))/(flam[j] - 1.0)}
	}
	#-------------------------------------------------

	if (j==1) {print("          ID FLAG  LAMREST     RMS       SNR  LAMOBS    VELOCITY    FLUX   FLUX_NORM     EW    FWHM  FLAM")}
	if (j==1) {print("          ID FLAG  LAMREST     RMS       SNR  LAMOBS    VELOCITY    FLUX   FLUX_NORM  ERR_NORM    EW    FWHM  FLAM", >> datfil)}
        printf("%12s  %2d  %8.2f %10.4e %6.1f %8.2f %8.1f %10.4e %8.1f %8.1f %7.2f %6.3f\n", lineid[j], goodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, flux_norm[j], eqw, gfwhm, flam[j])

	           #print("          ID FLAG  LAMREST   RMS       SNR    LAMOBS   VELOCITY    FLUX   FLUX_NORM    EW      FWHM  FLAM")
        printf("%12s  %2d  %8.2f %10.4e %6.1f %8.2f %8.1f %10.4e %8.1f %8.1f %8.1f %7.2f %6.3f\n", lineid[j], goodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, flux_norm[j], err_norm[j], eqw, gfwhm, flam[j], >> datfil)

	}
	print("          ID FLAG  LAMREST     RMS       SNR  LAMOBS    VELOCITY    FLUX    FLUX_NORM    EW     FWHM  FLAM")

	tstat("fluxcalc.vel") 
	tstat("fluxcalc.vel", >> datfil) 

        if (dopcor) {
	if (velo == "median") {velocity = tstat.median} 
             else if (velo == "mean") {velocity = tstat.mean} else {velocity = real(velo)}
	#velocity = tstat.median
        dopfil = filein//"_dop"//str(nap)//"_"//str(band)
	#print("Doppler shifted by = ", velocity, " km/s. Output image ", dopfil)
        imdelete(dopfil, ver-, >& "dev$null")
        imdelete(dopfil//"_snr", ver-, >& "dev$null")
        dopcor (nebfil, dopfil, redsh=velocity, isvel+, add-, disp+, flux-, verb+)
        dopcor (nebfil//"_snr", dopfil//"_snr", redsh=velocity, isvel+, add-, disp+, flux-, verb+)
	}

	#if (extcor) {Av = 2.5*chb/E_hbeta; print("CHb = ", chb, " Av=", Av)}
	if (extcor && flux_hbeta > 0.0) {
	Av = 2.5*chb/E_hbeta  #; print("CHb = ", chb, " Av=", Av)
	flux_hb0_lg = log10(flux_hbeta)+ chb
	#flux_hb0_lg = log10(flux_hbeta + 1.0E-30)+ chb
	Av_err = 2.5*chb_err/E_hbeta
	printf("CHb = %8.3f +/- %8.3f  Av = %8.3f +/- %8.3f  log(FHbeta) = %8.3f \n", chb, chb_err, Av, Av_err, flux_hb0_lg)
	printf("CHb = %8.3f +/- %8.3f  Av = %8.3f +/- %8.3f  log(FHbeta) = %8.3f \n", chb, chb_err, Av, Av_err, flux_hb0_lg, >> datfil)

	printf("CHb2, CHb3, CHb4 = %8.3f +/- %8.3f  %8.3f +/- %8.3f  %8.3f +/- %8.3f \n", chb2, chb2_err, chb3, chb3_err, chb4, chb4_err)
	printf("CHb2, CHb3, CHb4 = %8.3f +/- %8.3f  %8.3f +/- %8.3f  %8.3f +/- %8.3f \n", chb2, chb2_err, chb3, chb3_err, chb4, chb4_err, >> datfil)
	#printf("CHb = %8.3f  Av = %8.3f log(FHbeta) = %8.3f \n", chb, Av, flux_hb0_lg, >> datfil)
	#printf("CHb2, CHb3, CHb4 = %8.3f  %8.3f  %8.3f \n", chb2, chb3, chb4, >> datfil)
	print("Dederedded flux ratios written into ", datfil)
	print("          ID   LAMREST    Flam  FLUX_OBS  FLUX_COR", >> datfil)
	for (j=1; j <= i1; j +=1) {
	if (flux_norm[j] < 1.0E-30) {flux_norm[j] = 1.0E-30}
	#flux_norm0_lg = log10(flux_norm[j]) + chb*(flam[j] - 1.0)
	flux_norm0 = flux_norm[j]*10**(chb*(flam[j] - 1.0))
        if (goodline[j]){printf("%12s  %8.2f %8.3f %8.3f %8.3f \n", lineid[j], wave[j], flam[j], flux_norm[j], flux_norm0, >> datfil)}
	}
	if (wtext){
        if (!dopcor) {dopfil = nebfil}
        delete(dopfil//"1.txt", ver-, >& "dev$null")
        delete(dopfil//"2.txt", ver-, >& "dev$null")
        delete(dopfil//"3.txt", ver-, >& "dev$null")
        delete(dopfil//".txt", ver-, >& "dev$null")
	
        skyfil = filein//"_ap"//str(nap)//"_"//str(2)
        #imdelete(skyfil, ver-, >& "dev$null")
        #imdelete(nebfil//"_totrms", ver-, >& "dev$null")
        #scopy (filein, skyfil, w1=xmin, w2=xmax, apertur=nap, band=2, rebin+)
	#omsperms(skyfil, sample=sample, inter=ask)
	#imexpr ("sqrt(a**2 + b**2)", nebfil//"_totrms", nebfil//"_rms", skyfil//"_rms", verb-) 
	wspectext (dopfil, dopfil//"1.txt", header-, wformat="%0.2f")
	wspectext (nebfil//"_totrms", dopfil//"2.txt", header-, wformat="%0.2f")
	fields (dopfil//"2.txt", fields=2, > dopfil//"3.txt")
	join (dopfil//"1.txt", dopfil//"3.txt", output = dopfil//".txt", delim="   ")
	print("Output text file [wav flux rms] is = ", dopfil//".txt")
	}
	}

end

