procedure fluxerr(objfil)

#Input file should have the subtracted sky spectrum in band2 of each aperture
#Necessary to give the sensitivity curve
# Method:  Fit a smooth continuum to the object spectrum using omsperms or directly continuum
#         Use the formula   ferr = sqrt((fcont + 2 fsky)*fconv )

string  objfil  = "obj_spectrum"          {prompt="Extracted object spectrum"}
string  skyfil  = ""          		  {prompt="Extracted sky    spectrum"}
string  sensfil = "gtc_sens_curve"        {prompt="Sensitivity function"}  
string  expkey  ="EXPTIME"                {prompt="Header keyword name for exposure time/frame"}
string  ncombkey="NCOMBINE"               {prompt="Header keyword name for Number of images combined"}
string  gainkey ="GAIN"                {prompt="Header keyword name for GAIN parameter"}
int     apno    = 1                     {prompt="Aperture no spectrum to measure"}
bool    inter   = yes                   {prompt="Fit continumm interactively?"}
real    lammin  = 3700.0                {prompt="Minimum good lambda in Ang"}
real    lammax  = 9999.0                {prompt="Maximum good lambda in Ang"}


begin
        string  filein, filobj, filsky, filsens, keyexp, keynim, sample, filcal, keygain, objcal
	real	exptime, xmin, xmax, lam1, lamdelt, lam2, gain, multfact
	int	ncomb, nap, naxis, npix
	bool	ask

	filein = objfil; filsky = skyfil; filsens = sensfil
	keyexp = expkey; keynim = ncombkey; keygain = gainkey 
	nap = apno; xmin = lammin; xmax = lammax; ask = inter
	filobj = filein//"_"//str(nap); imdelete(filobj, ver-, >& "dev$null")

	naxis = 1; lamdelt = 0.0
        hselect (filein, "NAXIS", yes) | scan (naxis)
        hselect (filein, "NAXIS1 CRVAL1 CDELT1", yes) | scan (npix, lam1, lamdelt)
	if (lamdelt == 0.0){hselect (filein, "CD1_1", yes) | scan (lamdelt)}
	lam2 = lam1 + real(npix-1)*lamdelt
	if (xmin < lam1) {xmin = lam1}
	if (xmax > lam2) {xmax = lam2}
        sample = str(xmin)//":"//str(xmax)
	if (naxis > 1) {
        #imsec = "[*,"//str(nap)//",1]"
        scopy (filein//"[*,"//str(nap)//",1]", filobj, w1=xmin, w2=xmax, rebin+)
	if (filsky == ""){
	filsky = filein//"_sky"//str(nap); imdelete(filsky, ver-, >& "dev$null")
		scopy (filein//"[*,"//str(nap)//",2]", filsky, w1=xmin, w2=xmax, rebin+)
			}
	} else {scopy (filein, filobj, w1=xmin, w2=xmax, rebin+)}

	exptime = 1.0; ncomb = 1
        hselect (filobj, keyexp, yes) | scan (exptime)
        hselect (filobj, keynim, yes) | scan (ncomb)
        hselect (filein, keygain, yes) | scan (gain)
	multfact = exptime*ncomb*gain

	print(filobj, " ", naxis, exptime, ncomb, gain, " ", sample)

        omsperms(filobj, sample=sample, inter=ask)

	filcal = filsens//"_cgs"; imdelete(filcal, ver-, >& "dev$null")
	objcal = filobj//"_invcgs"; imdelete(objcal, ver-, >& "dev$null")
	imexpr ("10**(-0.4*a)", filcal, filsens, verb-)
	imexpr ("a/b", objcal, multfact, filcal, verb-)
	imdelete(filobj//"_therms", ver-, >& "dev$null")
        imexpr ("sqrt((a + 2.0*b)*c)/c", filobj//"_therms", filobj//"_cont", filsky, objcal, verb-)
        #imexpr ("sqrt((a + 2.0*b)*c)/c", filobj//"_therms", filobj//"_cont", filsky, 1.0E18, verb-)
        #imexpr ("sqrt(a**2 + b**2)", nebfil//"_totrms", nebfil//"_rms", skyfil//"_rms", verb-)

end
