procedure hexfill(infile, xyfile)

#Given a list of xy positions and "flux" at these positions, the task
#spreads these "fluxes" into hexagonal areas of side "rad". The input
#image is used only for positional references.
#Output is written into a new image

string  infile  = ""     	 {prompt="Image name"}
string  xyfile  = "test.coo"     {prompt="Input Text file with X Y positions"}
string  outfil  = "DEFAULT"    	 {prompt="Image name"}
string  regfile = "hexfill.reg"     {prompt="Output ds9 region file"}
int     xcol    = 1              {prompt="X column number"}
int     ycol    = 2              {prompt="Y column number"}
int     idcol   = 3              {prompt="ID column number"}
int 	fluxcol = 4              {prompt="Flux Column number"}
real    radius  = 15.0            {prompt="Radius of the circle [manalyze nsamp/2]"}
string  color   = "green"        {prompt="Color of the circle"}

begin

	string  filin, filout, filtmp1, comm1, xyfil 
        string  regshap, cid, rs, cosys, regfil, symcol, creg, c1
        real    rad, xin, yin, xhex[6], yhex[6], flux, hexang, c30, r30, r60
        int     i1, i2, i3, ix, iy, iid, irad, nx, ny, iflux
        struct  line
	bool	logflux

	filin = infile; xyfil = xyfile; regfil = regfile; regshap = "hexagon"
        ix = xcol; iy = ycol; iid = idcol; irad = 0; iflux = fluxcol
        symcol = color; rad = radius
	logflux = no
	if (iflux < 0){logflux = yes; iflux = abs(iflux)}

        irad = abs(int(rad))

        hselect (filin, "NAXIS1 NAXIS2", expr+) | scan (nx, ny)

            delete (regfil, ver-, >& "dev$null")
            filout = outfil     #filin//"_hex"
	    if (filout == "DEFAULT"){filout = filin//"_hex"}
            filtmp1 = filin//"_tmp1"
            imdelete (filout, ver-, >& "dev$null")
            imdelete (filtmp1, ver-, >& "dev$null")
            imexpr ("a*0.0", filout, filin, dim=str(nx)//","//str(ny), verb-)

	cosys = "image"
        rs = substr(regshap, 1,1)

        i1 = 0; i2 = 0; i3 = 0; list = xyfil
        while( fscan(list,line) != EOF ) {
        c1 = substr(line,1,1)
        if (c1!="#") {
          i3 = i3 + 1
        print(line) | fields (fields=ix) | scan(xin)
        print(line) | fields (fields=iy) | scan(yin)
        print(line) | fields (fields=iflux) | scan(flux)
	if (logflux){flux = 10**flux}

        if (iid != 0){print(line) | fields (fields=iid) | scan(cid)} else {cid = str(i3)}
        if (irad != 0){print(line) | fields (fields=irad) | scan(rad)}   #; rad = rad/conv}

        creg = "# color="//symcol//" text={"//cid//"}"
	hexang = rad(30.0)
        if (rs == "h"){regshap = "hexagon"
                xhex[1] = xin -rad; yhex[1] = yin + 0
                xhex[2] = xin -rad*sin(hexang); yhex[2] = yin + rad*cos(hexang)
                xhex[3] = xin +rad*sin(hexang); yhex[3] = yin + rad*cos(hexang)
                xhex[4] = xin +rad; yhex[4] = yin + 0
                xhex[5] = xin +rad*sin(hexang); yhex[5] = yin -rad*cos(hexang)
                xhex[6] = xin -rad*sin(hexang); yhex[6] = yin -rad*cos(hexang)

	c30 = cos(rad(30.)); r30 = rad(30.); r60= 2.0*r30
	#comm1 = "sqrt((I - "//str(xin)//")**2 + (J-"//str(yin)//")**2) <= "//str(rad)//"*0.866/(cos(0.523599-mod((atan(abs(J-"//str(yin)//"),abs(I - "//str(xin)//"))), 1.047198))) ? "//str(flux)//" : a"
	#comm1 = "sqrt((I - "//str(xin)//")**2 + (J-"//str(yin)//")**2) <= "//str(rad*c30)//"/(cos("//str(r30)//"-mod((atan(abs(J-"//str(yin)//"),abs(I - "//str(xin)//"))), "//str(r60)//"))) ? "//str(flux)//" : a"
	#comm1 = "sqrt(((I - "//str(xin)//")-1.0)**2 + ((J-"//str(yin)//")-1.0)**2) <= "//str(rad*c30)//"/(cos("//str(r30)//"-mod((atan(abs(J-"//str(yin)//"),abs(I - "//str(xin)//"))), "//str(r60)//"))) ? "//str(flux)//" : a"
	comm1 = "sqrt((I - "//str(xin)//")**2 + (J-"//str(yin)//")**2) -1.0 < "//str(rad*c30)//"/(cos("//str(r30)//"-mod((atan(abs(J-"//str(yin)//"),abs(I - "//str(xin)//"))), "//str(r60)//"))) ? "//str(flux)//" : a"

	#print (comm1)

        imexpr (comm1, filtmp1, filout, dim=str(nx)//","//str(ny), verb-)
        imdelete (filout, ver-, >& "dev$null")
        imrename (filtmp1, filout, verb-) 
                printf("polygon(%10f,%10f,%10f,%10f,%10f,%10f,%10f,%10f,%10f,%10f,%10f,%10f) %s\n",xhex[1], yhex[1], xhex[2], yhex[2], xhex[3], yhex[3], xhex[4], yhex[4], xhex[5], yhex[5], xhex[6], yhex[6], creg, >> regfil)
                }

        }
        }

	print("Output image= ", filout, " Reg file= ", regfil, " ===>No of hexagons=", i3)

end

