procedure mfibflux(infile)

#for each spectrum fit the continuum and subtract it
#for the sky-subtracted spectrum, obtain Gaussian line fluxes
#make a table of # space_pix  line_fluxes

string  infile	= "ngc1569_lrb_cal_final_rss"   	{prompt="Input filename to measure flux"}
string  linelist="lrb_neblines.dat"	{prompt="List containing lines to be measured"}
real    basepix = 5.0          		{prompt="Basewidth of a line in pixeles"}
int     spamin   = 1             	{prompt="Min pixel no of the spatial axis"}
int     spamax   = 1             	{prompt="Max pixel no of the spatial axis"}
int     nsum     = 1             	{prompt="Number of rows to sum"}
bool    inter   = yes           	{prompt="Fit continumm interactively?"}
real    lammin  = 4320.0        	{prompt="Minimum good lambda in Ang"}
real    lammax  = 5300.0        	{prompt="Maximum good lambda in Ang"}
real    spscale = 0.62          	{prompt="arcsec/pix along the spatial axis"}
string  function= "spline3"     {prompt="Function to be fit to the continuum"}
int     order   = 5            {prompt="Order of the function to be fit"}
string  sample  = "4331:4335 4345:4353 4381:4608 4813:4842 4881:4895 4973:4997 5029:5191"   {prompt="Sample range in Ang for analysis 3700:7600"}
bool    plot    = yes           	{prompt="Plot the Gaussian fit for each line?"}
string  filtband= ""     	{prompt="Filter bands appropriate for the sband command"}

begin
	string	filein, inlist, splotfillog, sect, spefil, splotfilcur
	string  lineid[99], blend[99], s2, tmp, cdisp, specsub, datfil
        string  graphtyp, vdmfil, bands, filt[3]
	real	xmin, xmax, r1, wave[99], spe_rms, spe_snr, cont_rms, npix 
	real	filtmag[3], filtflux, basewidpix
        real   center, cont, flux, eqw, core, gfwhm, lfwhm, fcont, disp
	real   fluxobs[99], est_flux, goodsnr, velocity, area, slitwid
	int	lpix, rpix, spasum, i1, i2, i, j, igood, nap, lineno, nfil
	bool	ask, goodline[99], test, lplot, broadband
        struct  line, apnum, comment

	filein = infile; inlist = linelist; basewidpix = basepix
	lpix = spamin; rpix = spamax; spasum = nsum
	slitwid = 1.0
        #hselect (filein, "NAXIS1 SLITW", yes) | scan (npix, slitwid)
        hselect (filein, "NAXIS1 NAXIS2", yes) | scan (npix, nap)
	if (lpix < 1 || rpix < 1 || rpix < (lpix + spasum - 1) ){lpix = 1; rpix = nap}
	xmin = lammin; xmax = lammax
	ask = inter; lplot = plot; graphtyp = "stdgraph"
	goodsnr = 3.0
        #sample = str(xmin)//":"//str(xmax)
	area = slitwid*spscale*spasum
	area = 3.0*sqrt(3.0)*spscale**2/2.0    #for MEGARA area of Hexagon of side=spscale
	print("AREA = ", area)
	bands = filtband
	broadband = no
	if (bands != "" && access(bands)){broadband = yes}
	test = no   #yes

        disp = 1.0; cdisp = "1.0"
        hselect (filein, "CDELT2", expr+) | scan(cdisp)
        if (cdisp == "1.0") { hselect (filein, "CD1_1", expr+) | scan(cdisp)
                                disp = real(cdisp)}
        if (cdisp != " " && real(cdisp) > 0.01) {disp = real(cdisp)}

        i1 = 0
        list = inlist
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#" && tmp != "") {
          i1=i1+1
	  goodline[i1] = yes
	  i2 = fscanf(line, "%s  %g  %d  %s ", s1, r1, igood, s2)
	  lineid[i1] = s1; wave[i1] = r1; blend[i1] = s2
	  if (igood == 0) {goodline[i1] = no}
	  #print(s1, " ", r1, " ", igood, " ", blend[i1])
	}
	}

        #sect = str(lpix+spasum)//"-"//str(rpix)//"x"//str(spasum)
        ##spefil = filein//"_out"
        #spefil = filein//"_"//sect
        #imdelete(spefil, ver-, >& "dev$null")
	##nsum_old = onedspec.nsum
	#onedspec.nsum = spasum
        #scopy (filein, spefil, w1=xmin, w2=xmax, apertur=sect, rebin+)
	#nap = (rpix - lpix)/spasum
	spefil = filein
	if (test) goto final

        if (!lplot) { delete (spefil//"_splot.mc", ver-, >& "dev$null")
                        set stdvdm = vdmfil; graphtyp = "stdvdm" }

	onedspec.nsum = 1
	if (!imaccess(spefil//"_rms") && !imaccess(spefil//"_cont") && !imaccess(spefil//"_csub")){
	omsperms(spefil, sample=sample, lines="*", bands=1, inter=ask, functio=function, order=order)
	}

	if (broadband) {
        imdelete(spefil//"_temp", ver-, >& "dev$null")
	imexpr ("a<b ? b : a", spefil//"_temp",  spefil//"_cont", spefil//"_rms", verb-) 
        imdelete(spefil//"_cont", ver-, >& "dev$null")
        imrename(spefil//"_temp", spefil//"_cont", verb-)
        delete(spefil//".mag", ver-, >& "dev$null")
	sbands (spefil//"_cont", spefil//".mag", bands, apertures="", normalize+, mag-, magzero = 0.0, verb-)  
	}

        datfil = spefil//"_flux.dat"
        delete(datfil, ver-, >& "dev$null")

	printf("%s", "#DATE ", >> datfil); date (, >> datfil)
        #datfil = filein//"_"//sect//"_flux.dat"
	#print (i1, nap)
        #for (i=1; i <= nap; i +=1) {
        for (i=lpix; i <= rpix; i +=1) {
        hselect (spefil, "APNUM"//str(i), expr+) | scan(apnum)
	
        delete("fluxcalc.vel", ver-, >& "dev$null")

	nfil = 0; comment = "0  "
	if (broadband) {
	match (","//str(i)//"]", spefil//".mag", stop-, print_file_n+, metacharacte+) | fields (field="2-3") | wc | scan(nfil)
        for (j=1; j <= nfil; j +=1) {
	match (","//str(i)//"]", spefil//".mag", stop-, print_file_n+, metacharacte+) | fields (field="2-3", line=j) | scan(filt[j], filtflux)
	if (filt[j] == "B"){filtmag[j] = -2.5*log10(filtflux/area/7.20E-9)}
	if (filt[j] == "V"){filtmag[j] = -2.5*log10(filtflux/area/3.92E-9)}
	if (filt[j] == "R"){filtmag[j] = -2.5*log10(filtflux/area/1.76E-9)}
	}
	
	#printf("%3s %6.2f %3s %6.2f %3s %6.2f\n", filt[1], filtmag[1], filt[2], filtmag[2], filt[3], filtmag[3]) | scan(comment)
	printf("%3d %6.2f %6.2f %6.2f\n", nfil, filtmag[1], filtmag[1]-filtmag[2], filtmag[1]-filtmag[3]) | scan(comment)
	#print(comment)
	}

        for (j=1; j <= i1; j +=1) {
        splotfilcur = "splot_auto_cont.cursor"
        splotfillog = "splot_auto_stat.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")
        print (wave[j], " 0.0  1 <space>", >> splotfilcur)
        splot (spefil//"_cont", line=i, cursor=splotfilcur, graphic=graphtyp, > splotfillog)
        splot (spefil//"_rms", line=i, cursor=splotfilcur, graphic=graphtyp, >> splotfillog)
        fields (splotfillog, fields="4", lines=1) | scan (fcont)
        fields (splotfillog, fields="4", lines=2) | scan (cont_rms)

        splotfillog = "splot_auto_gaussfit.log"
        #omlinefit(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0)

	if (blend[j] == "0") {
        omspestat(spefil//"_csub", xpos=i, yposlit=wave[j], contflux=0.0, basepix=basewidpix, graphics=graphtyp)
	lineno = 4
	} else {
        if (strlen(blend[j])>1){
		if (!access(blend[j])){  
		print("Deblending file ",blend[j], " absent. Press Enter to copy from database")
		scan(ans)
		copy ("spanal$data/"//blend[j], blend[j], verbose+)
		}
		#print(lineid[j])
	        if (lineid[j] == "[NII]6549"){splot.linelist = "deblend_ha.file"}
	        if (lineid[j] == "[SII]6717"){splot.linelist = "deblend_sii.file"}
		omspestat(spefil//"_csub", xpos=i, yposlit=wave[j], contflux=0.0, basepix=basewidpix, cursor=blend[j], graphics=graphtyp)
		lineno = 4 
		} else { lineno = lineno + 1 }
	}

        fields (splotfillog, fields="1-7", lines=lineno) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
        velocity = 2.9979E+05 * (center - wave[j])/wave[j]

	fluxobs[j] = flux
	eqw = flux/fcont; npix = 2.0*gfwhm/disp 
	est_flux = 2.0*npix + eqw/disp 
	if (est_flux <= 1.0) {est_flux = 1.0}
	#spe_rms = cont_rms*disp*sqrt(2.0*npix + eqw/disp)
	spe_rms = cont_rms*disp*sqrt(est_flux) 
	spe_snr = flux/spe_rms; spe_snr = max(abs(spe_snr), 0.1)
	#if (spe_rms > 0.0){spe_snr = flux/spe_rms} else {print(i,j,spe_rms); spe_snr = 1.0}

	#if (j == 1) {flux_hbeta = flux; min_fwhm = gfwhm*(1.-fwhmerr/100.); max_fwhm = gfwhm*(1.+fwhmerr/100.)}
	#flux_norm[j] = 100.0*flux/flux_hbeta
	if (spe_snr < goodsnr) goodline[j] = no
	#if (gfwhm > max_fwhm || gfwhm < min_fwhm ) goodline[j] = no
	if (goodline[j]) {print(velocity, >> "fluxcalc.vel") }
        if (j==1) {print("#FIBER ", i, " ", spasum, area, apnum, " ", comment, " ", spefil)}
        if (j==1) {print("#FIBER ", i, " ", spasum, area, apnum, " ", comment, " ", spefil, >> datfil)}
        if (j==1) {print("#         ID FLAG  LAMREST       RMS      SNR   LAMOBS   VELOCITY      FLUX        EW     FWHM  FCONT        I")}
        printf("%12s  %2d  %8.2f %12.5e %6.1f %8.2f %8.1f %12.5e %8.3f %7.2f %10.4e %4d\n", lineid[j], goodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, eqw, gfwhm, fcont, i)
        if (j==1) {print("#         ID FLAG  LAMREST       RMS      SNR   LAMOBS   VELOCITY      FLUX        EW     FWHM  FCONT        I", >> datfil)}
        printf("%12s  %2d  %8.2f %12.5e %6.1f %8.2f %8.1f %12.5e %8.3f %7.2f %10.4e %4d\n", lineid[j], goodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, eqw, gfwhm, fcont, i, >> datfil)

	}
        #if (dopcor) {
        if (access("fluxcalc.vel")) {
        tstat("fluxcalc.vel", >& "dev$null")
        printf("Velocity%d: mean= %8.1f =/- %8.1f median= %8.1f lines= %d\n", i,tstat.mean, tstat.stddev, tstat.median, tstat.nrows)
        printf("#Velocity: lines= %d mean= %8.1f =/- %8.1f median= %8.1f\n", tstat.nrows, tstat.mean, tstat.stddev, tstat.median, >> datfil)
	} else {
          printf("#Velocity: lines= 0 \n", >> datfil)
	}
	#}
	}

final:
        if (access("vdmfil")) {rename("vdmfil", spefil//"_splot.mc", field = "all")}
	print("Done")

end

