procedure       mfluxanal(infile)

string  infile  = "fluxobs.dat"            	{prompt="Input filename to measure flux"}
int     fibnum  = 0                     	{prompt="Fiber number to analyze [0=all]"}
string  parfil  = "mfluxanal.par"            	{prompt="File with Physical parameters to be calculated"}
string  outfil  = "DEFAULT"          		{prompt="Output filename containing calculated quantities"}
string  redcurve="spanal$data/ext_interp.dat"  {prompt="Extinction curve normalized to Av"}
string  exttype = "none"                       {prompt="Av for extinction correction [none|calc|value in mag]"}
#real    snrgood = 3.0     	               {prompt="Minimum SNR of a GOOD line"}
#real    errfwhm = 2.0                          {prompt="Good FWHM range is FW_Hb/errfw to FW_Hb*errfw for a GOOD line"}
real    ksigvel = 3.0                  {prompt="Acceptance level of velocity difference [3sigma] for HeI lines"}
real    Teo3    = 10000.0              {prompt="Electron Te in the OIII zone"}
real    density = 100.0                {prompt="Electron density in the nebula"}
#real    obyh    = 8.70                 {prompt="Abundance=12+log(O/H)"}
real    tauHe   = 0.00                 {prompt="Tau for the He lines"}
string  heabsfil="home$helines_abs.dat"  {prompt="File containing underlying He absorption EWs"}
bool    silent  = no                   	{prompt="Run without on-screen messages?"}

begin
        string  filein, tmp, phyfil, lineid[99], extin, extcurve, datfil1, datfil2
	string  phypar[9], pp1[9], pp2[9], pp3[9], pp4[9], s1, s2, s3, s4
        string  dline[9,9], Bal[5], refline, filhe, dens_atom, ohmethod, s5
	string  datfil[99], datfil3, filroot
        real    r1, r2, r3, r4, r5, r6, r7, r8, r9
	real	chb0, sum_sq, chb0_err, velav, velrms, velmed, flux_ref, Te4, ne
        #real    goodsnr, fwhmerr, lgobyh
        real    wave[99], spe_snr[99], flux[99], ew[99], fwhm[99], fcont[99], uflux[99], flux_norm[99]
        real    tlam, Elam, E_hbeta, max_fwhm, min_fwhm, eflux_hb0_lg
	real    chb[5], chb_err[5], Av, flux_hb0_lg, Av_err, flux_norm0[99], Bal_rat[5]
        real    uflux_norm[99], err_norm[99], spe_rms[99], flam[99], velo[99]
	real	oiiirat, err_lo, oiiirat_lo, oiiirat_hi, temp_o3, temp_o3_1, temp_o3_2, temp_o3_hi, temp_o3_lo
	real	Fem4686, ftauHeI, y1, y2_4686, y_abund_err
	real	y_tot, o_abund, n_abund, z_tot, y_abund, flux0, eflux, y_tot_err, e4471, e6678, e4686
	real	ftau3889, ftau4026, ftau4471, ftau5876, ftau6678, ftau7065, aEW_hb, aEW_ha, aEW_hg, aEW_hd
	real	Fem3889, Fem4026, Fem4471, Fem5876, Fem6678, Fem7065, aEW, abscor, tau
	real	err_y1_He[99], y1_He[99], FemHe[99], y1_weight, y1_av, y1_av_err, ksig
	real	dens_res, dens_rat, nbyo, nbyo_hi, nbyo_lo, err_N2R2
	real	densrat_lo, densrat_hi, dens_hi, dens_1, dens_lo, dens_2
	int	nlin_HeI, num_HeI, idens_ion, ndens1, ndens2, phy_flag
	int	d1, d2, i1, i, npar, nl, i2, nc[9], iq, il, ihb, idline[9,9], k, velnum
	int	iob, ifib0, ifib, fibno[999], tlines, nchb, n4363, n4959, n5007, n6583, n3727, n6717, n6731
	real	R3, N2, N2_lg, err_R3, err_N2, R2, err_R2, err_R3R2, S2, err_S2, err_R3S2, obyh, obyh_hi, obyh_lo
        bool    goodline[99], extcor, extline[5], HeI, goodvel, quiet
	struct  line #phyline


	filein = infile; phyfil = parfil; ifib0 = fibnum

        extin = strlwr(exttype); extcor = no; quiet = silent
        if (extin != "none") {extcor = yes}
        extcurve = redcurve; filhe = heabsfil
        #goodsnr = snrgood; fwhmerr = errfwhm; 
	ksig = ksigvel

	Te4 = Teo3/10000.0; ne = density  #; lgobyh = obyh
	tau = 0.0; aEW = 0.0

	y_abund = 0.0; y_abund_err = 0.0

	type(extcurve) | wc | scan(tlines) 

	filroot = outfil
	#if (filroot == "DEFAULT"){filroot = " "
        list = filein
        #while(fscan(list, line) != EOF ) {
        while(fscan(list, line) != EOF && filroot == "DEFAULT") {
        tmp = substr (line, 1, 1)
        if (tmp == "#"){
                if (substr (line, 2, 6) == "FIBER" || substr (line, 2, 5) == "APER") {
                filroot = substr (line, 11,40)

	}}}
	#print (filroot)
	#datfil3 = outfil; datfil2 = datfil3//".dat"; datfil1 = datfil3//".log"
	datfil2 = filroot//"_fluxpar.dat"; datfil1 = filroot//"_fluxlog.dat"; datfil3=filroot

        delete(datfil2, ver-, >& "dev$null")
        delete(datfil1, ver-, >& "dev$null")
        print("##########################################################", >> datfil1)
        date (, >> datfil1)

	#----------------- READ the Physical parameter input list --------------
	#allowed parameters and their values: (example file = mfluxanal.par)
	# "DOPVEL"  = Doppler velocity   [Hb [OIII]5007 etc]
	# "NEBEXT"  = Nebular Extinction [Hb Hg etc]
	# "NEBTEMP" = Nebular temperature [O3, N2 or S3]
	# "NEBDENS" = Nebular density [O2, S2, or Ar4]
	# "ABUN_He" = Helium abundance [HeI4471 HeII4686 etc]
	# "ABUN_O " = Oxygen abundance [OIII5007 etc]
	#------------------------------------------------------------------------
	i1 = 0
        list = phyfil
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#" && tmp != "") {
          i1=i1+1
	  s1 = " "; s2 = " "; s3 = " "; s4 = " "; s5 = " "
	  print(line) | wc | scan(nl, npar)
	  if (npar == 1){i2 = fscanf(line, "%s \n", s1)}
	  if (npar == 2){i2 = fscanf(line, "%s %s\n", s1, s2)}
	  if (npar == 3){i2 = fscanf(line, "%s %s %s\n", s1, s2, s3)}
	  if (npar == 4){i2 = fscanf(line, "%s %s %s %s\n", s1, s2, s3, s4)}
	  if (npar == 5){i2 = fscanf(line, "%s %s %s %s %s\n", s1, s2, s3, s4, s5)}
	  nc[i1]=npar - 1; phypar[i1] = s1; pp1[i1] = s2; pp2[i1] = s3; pp3[i1] = s4; pp4[i1] = s5
	}
	}
	iq = i1
	#----------------- READ the Physical parameter input list end ----------

	#----------------- Store the Physical parameter inputs into variables ----------
	il = 0
        for (i=1; i <= iq; i +=1) {
	  il = il + 1
	  datfil[i] = filroot//"_"//phypar[i]//"_"//pp1[i]//".dat"
	  #print(datfil[i])
        	delete(datfil[i], ver-, >& "dev$null")
	  if (phypar[i] == "REFLINE"){refline = pp1[i] }
	  if (phypar[i] == "NEBTEMP" && pp1[i] == "O3"){  
		nc[i] = 3; pp1[i] = "[OIII]4363"; pp2[i] = "[OIII]4959"; pp3[i] = "[OIII]5007" } 
	  if (phypar[i] == "NEBDENS" && pp1[i] == "O2"){
		nc[i] = 2; pp1[i] = "[OII]3726"; pp2[i] = "[OII]3729"; dens_atom = "oxygen"; idens_ion = 2} 
	  if (phypar[i] == "NEBDENS" && pp1[i] == "S2"){
		nc[i] = 2; pp1[i] = "[SII]6717"; pp2[i] = "[SII]6731"; dens_atom = "sulfur"; idens_ion = 2 } 
	  if (phypar[i] == "NEBDENS" && pp1[i] == "Ar4"){
		nc[i] = 2; pp1[i] = "[ArIV]4711"; pp2[i] = "[ArIV]4740"; dens_atom = "argon"; idens_ion = 4 } 
	  if (phypar[i] == "ABUN_O" && pp1[i] == "R3R2"){
		nc[i] = 3; pp1[i] = "[OIII]5007"; pp2[i] = "[NII]6583"; pp3[i] = "[OII]3727"} 
	  if (phypar[i] == "ABUN_O" && pp1[i] == "R3S2"){
		nc[i] = 4; pp1[i] = "[OIII]5007"; pp2[i] = "[NII]6583"; pp3[i] = "[SII]6717"; pp4[i] = "[SII]6731"} 
	    dline[1, i] = pp1[i]
	    if (pp2[i] != " "){dline[2, i] = pp2[i]}
	    if (pp3[i] != " "){dline[3, i] = pp3[i]}
	    if (pp4[i] != " "){dline[4, i] = pp4[i]}
	}
	if (!quiet){print("Reference line for flux normalization = ", refline)}

	#----------------------------------------------------------------------------------------------------
	#----- READ the observed line measurements from splot Gaussian fit and processed by mfluxcalc -------
	#All measurements for an OBJECT should lie between lines #FIBER and #Velocity
	#fibnum <= 0 : do it for all OBJECTs; otherwise do it only for the fibnum
	#Should have Hb flux, which is used for normalizing fluxes
	#----------------------------------------------------------------------------------------------------
        delete("fluxcalc.vel", ver-, >& "dev$null")
        ihb = 0
        i1 = 0
	iob = 0
        list = filein
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp == "#"){
		if (substr (line, 2, 6) == "FIBER" || substr (line, 2, 5) == "APER") {
		iob = iob + 1; fibno[iob] = int(substr (line, 7,10))
		ifib = ifib0
		if (ifib <= 0){ifib = fibno[iob]}
        	i1 = 0
		} else if (substr (line, 2, 9) == "Velocity") {
	  	  #print("Velocity  ", i1)
		  goto calculate
		} 
	  goto skip
	} else {
	#-------------------------------------------------------------------------------------------
	#-------------- Read all the measurements for the selected OBJECT (i1) ---------------------
	#...............Identify all diagostic lines and store their lineno
	#-------------------------------------------------------------------------------------------
	  if (fibno[iob] != ifib) {goto skip}
          i1=i1+1
	  #print(iob, " =OBJ ", i1)
          goodline[i1] = yes
          i2 = fscanf(line, "%s %d %f %f %f %f %f %f %f %f %f %d \n", s1, d1, r1, r2, r3, r4, r5, r6, r7, r8, r9, d2)
          lineid[i1] = substr(s1,strldx(" ",s1)+1, strlen(s1)); wave[i1] = r1
          spe_rms[i1] = r2; spe_snr[i1] = r3; velo[i1] = r5; flux[i1] = r6; ew[i1] = r7; fwhm[i1] = r8; fcont[i1] = r9
          #if (spe_snr[i1] < goodsnr) {goodline[i1] = no}
          if (d2 == 0) {goodline[i1] = no}
          if (substr(lineid[i1], 1, 2) == refline){ihb = i1}
	  if ((abs(fwhm[i1]/fwhm[ihb] - 1.0) < 0.20) && spe_snr[i1] > 10.0 && goodline[i1] && d1 == 1){
	  		print(lineid[i1], " ", velo[i1]) 
	  		print(velo[i1], >> "fluxcalc.vel") 
	  }
	  #print(strlwr(substr(lineid[i1], 1, 2)), " ", ihb, " ", i1)
          #uflux[i1] = goodsnr*spe_rms[i1]
          for (i=1; i <= iq; i +=1) {
		#print(i, " = ", dline[1, i], " ", dline[2, i], " ", lineid[i1])
	        for (k=1; k <= nc[i]; k +=1) { if (lineid[i1] == dline[k, i]){idline[k, i] = i1} } #k nc
                } #i iq  over iq quantities
        }   #tmp
	goto skip

calculate:
        if (access("fluxcalc.vel")) {
          tstat("fluxcalc.vel", >& "dev$null")
          velmed = tstat.median; velav = tstat.mean; velrms = tstat.stddev; velnum = tstat.nrows
          if (!quiet){printf("===> %d %d: Velocity mean= %8.1f +/- %8.1f median= %8.1f lines= %d\n", iob, fibno[iob], velav, velrms, velmed, velnum)}
          printf("#Velocity %d %d: lines= %d mean= %8.1f +/- %8.1f median= %8.1f\n", iob, fibno[iob], velnum, velav, velrms, velmed, >> datfil1)
          } 

	if (flux[ihb] < 0 || !goodline[ihb]) {goto skip}
	match (refline, filhe) | fields (field=2, line=1) | scan(aEW_hb)
	#print("aEW_hb=", aEW_hb)
	temp_o3 = 0.0
	temp_o3_hi = 0.0
	temp_o3_lo = 0.0
	#-------------------------------------------------------------------------
	#Normalize fluxes wrt Hb (Reference line)
	#-------------------------------------------------------------------------
        	delete("fluxcalc_temp.dat", ver-, >& "dev$null")
		#print(ihb)
                print(wave[ihb], >> "fluxcalc_temp.dat")
                sinter (extcurve, "fluxcalc_temp.dat", tbl_siz=tlines) | scan (tlam, Elam)
                E_hbeta = Elam

        #flux_ref = flux[ihb]
        flux_ref = (ew[ihb]+aEW_hb)*fcont[ihb]      
	aEW_ha = 0.0; aEW_hg = 0.0; aEW_hd = 0.0 
	#max_fwhm = fwhm[ihb]*fwhmerr; min_fwhm = fwhm[ihb]/fwhmerr
        #if (fwhm[i] > max_fwhm || fwhm[i] < min_fwhm ) {goodline[i] = no}
	  #if (i == 3){print (lineid[i], " ", spe_rms[i], flux[i], flux_norm[i]}
        for (i=1; i <= i1; i +=1) {
	if (lineid[i] == "Ha"){match (lineid[i], filhe) | fields (field=2, line=1) | scan(aEW_ha); flux[i] = (ew[i]+aEW_ha)*fcont[i]}
	if (lineid[i] == "Hb"){match (lineid[i], filhe) | fields (field=2, line=1) | scan(aEW_hb); flux[i] = (ew[i]+aEW_hb)*fcont[i]}
	if (lineid[i] == "Hg"){match (lineid[i], filhe) | fields (field=2, line=1) | scan(aEW_hg); flux[i] = (ew[i]+aEW_hg)*fcont[i]}
	if (lineid[i] == "Hd"){match (lineid[i], filhe) | fields (field=2, line=1) | scan(aEW_hd); flux[i] = (ew[i]+aEW_hd)*fcont[i]}
        flux_norm[i] = 100.0*flux[i]/flux_ref
        #uflux_norm[i] = 100.0*uflux[i]/flux_ref
        properr(flux[i], flux_ref, "/", spe_rms[i], spe_rms[ihb], rab = 1.0, verb-)
        err_norm[i] = 100.0*properr.sig
        	delete("fluxcalc_temp.dat", ver-, >& "dev$null")
                print(wave[i], >> "fluxcalc_temp.dat")
		#print(tlines)
                sinter (extcurve, "fluxcalc_temp.dat", tbl_siz=tlines) | scan (tlam, Elam)
                flam[i] = Elam/E_hbeta
        }  #end normalizing fluxes to that of Hb (ref line)
        #printf("%d %12s %8.2f %8.3f %8.3f %d %8.1f %8.3f\n", i, lineid[i], wave[i], flux_norm[i], uflux_norm[i], goodline[i], err_norm[i], flam[i], >> datfil1)
	
	#----------------------------------------------------------------------------
	#    Calculate the requested physical quantities
	#.................start with DOPVEL
	#----------------------------------------------------------------------------
        for (j=1; j <= iq; j +=1) { 
	  if (phypar[j] == "DOPVEL"){
             delete("fluxcalc.vel", ver-, >& "dev$null")
	     for (k=1; k <= nc[j]; k +=1) {
		nl = idline[k, j]
		#print("nl=", nl, " k=", k, " j=", j)
		print(iob, " ", fibno[iob], " ", phypar[j], " ", lineid[nl], " ", velo[nl], >> datfil1)
                 if (goodline[nl]) {print(velo[nl], >> "fluxcalc.vel") }
		}  #k nc
	
        if (access("fluxcalc.vel")) {
          tstat("fluxcalc.vel", >& "dev$null")
	  velmed = tstat.median; velav = tstat.mean; velrms = tstat.stddev; velnum = tstat.nrows
          if (!quiet){printf("===> %d %d: Velocity mean= %8.1f +/- %8.1f median= %8.1f lines= %d\n", iob, fibno[iob], velav, velrms, velmed, velnum)}
          printf("#Velocity %d %d: lines= %d mean= %8.1f +/- %8.1f median= %8.1f\n", iob, fibno[iob], velnum, velav, velrms, velmed, >> datfil1)
          } else { printf("#Velocity: lines= 0 \n", >> datfil1) }
	  } #phypar == DOPVEL
	}  #j

	#-------------------------------------------
	# Calculate or read Av
	#-------------------------------------------

	print (iq)
        for (j=1; j <= iq; j +=1) { 
	  if (phypar[j] == "NEBEXT"){
		if (dline[1, j] == "Av"){
			chb0 = 0.4*real(dline[2, j])*E_hbeta 
			chb0_err = 0.4*real(dline[3, j])*E_hbeta; nchb = 0
			} else {
        	for (i=1; i <= 4; i +=1) {chb[i] = 0.0; chb_err[i] = 0.0; extline[i] = no}
        	Bal[1] = "Ha"; Bal[2] = "Hg"; Bal[3] = "Hd"; Bal[4] = "He"
        	Bal_rat[1] = 2.870; Bal_rat[2] = 0.466; Bal_rat[3] = 0.256; Bal_rat[4] = 0.158
                print("Underlying Balmer absorption EWs: Ha, Hb, Hg, Hd = ", aEW_ha, aEW_hb, aEW_hg, aEW_hd, >> datfil1)

             for (k=1; k <= nc[j]; k +=1) {
                nl = idline[k, j]
                print(iob, " ", fibno[iob], " ", phypar[j], " ", lineid[nl], " ", flux_norm[nl], " ", err_norm[nl], >> datfil1)
                for (i=1; i <= 4; i +=1) {
		    if (lineid[nl] == Bal[i] && goodline[nl]) {
                        chb[i] = (log10(Bal_rat[i]) - log10(flux_norm[nl]/100.))/(flam[nl] - 1.0)
                        properr(Bal_rat[i], flux_norm[nl]/100., "/", 0.0, err_norm[nl]/100., rab = 1.0, verb-)
                        chb_err[i] = abs(properr.sig/(log(10.0)*Bal_rat[i]/(flux_norm[nl]/100.))/(flam[nl] - 1.0))
			extline[i] = yes
			if (chb[i] < 0){chb[i] = 0.0}
                } }    #i and if
              }  #k nc

        print("Balmer  CHbeta  Err", >> datfil1)
	nchb = 0; chb0 = 0.0; sum_sq = 0.0; chb0_err = 0.0
        for (i=1; i <= 4; i +=1) {if (extline[i]){   #printf("%3s %8.3f %8.3f\n", Bal[i], chb[i],  chb_err[i])
             nchb = nchb + 1; chb0 = chb0 + chb[i]; sum_sq = sum_sq + chb[i]**2; chb0_err = chb_err[i]
	     printf("%3s %8.3f %8.3f\n", Bal[i], chb[i],  chb_err[i], >> datfil1)}} 
	     #if (nchb > 1){chb0 = chb0/real(nchb); chb0_err = sqrt(sum_sq/real(nchb) - chb0)}
	     if (nchb > 1){chb0 = chb0/real(nchb); chb0_err = sqrt(sum_sq/real(nchb)) - chb0}
	  }  #Av
	Av = 2.5*chb0/E_hbeta
        Av_err = 2.5*chb0_err/E_hbeta
        flux_hb0_lg = log10(flux_ref) + chb0
	eflux_hb0_lg = 1.0/spe_snr[ihb]

        printf("#CHbeta %d %d: ratios = %d mean= %8.3f +/- %8.3f\n", iob, fibno[iob], nchb, chb0, chb0_err, >> datfil1)
        if (!quiet){printf("CHbeta %d %d: ratios = %d mean= %8.3f +/- %8.3f\n", iob, fibno[iob], nchb, chb0, chb0_err)}
        printf("#CHb = %8.3f +/- %8.3f  Av = %8.3f +/- %8.3f  log(FHbeta) = %8.3f +/- %8.3f\n", chb0, chb0_err, Av, Av_err, flux_hb0_lg, eflux_hb0_lg, >> datfil1)

        print("#         ID   LAMREST    Flam  FLUX_OBS  FLUX_COR ERR_FLUX    SNR FWHM_Ang  EW_Ang FLAG", >> datfil1)
        for (i=1; i <= i1; i +=1) {
        if (flux_norm[i] < 1.0E-30) {flux_norm[i] = 1.0E-30}
        flux_norm0[i] = flux_norm[i]*10**(chb0*(flam[i] - 1.0))
        printf("%12s  %8.2f %8.3f %8.3f %8.3f %8.3f %7.1f %7.2f %8.3f %3d\n", lineid[i], wave[i], flam[i], flux_norm[i], flux_norm0[i], err_norm[i], spe_snr[i], fwhm[i], ew[i], goodline[i], >> datfil1)
	}
	  } #phypar == NEBEXT
	} #j


	#-------------------------------------------
	# Calculate NEBTEMP
	#-------------------------------------------

        for (j=1; j <= iq; j +=1) { 
	if (phypar[j] == "NEBTEMP" && dline[1, j] == "[OIII]4363"){
	  n4363 = idline[1, j]; n4959 = idline[2, j]; n5007 = idline[3, j]
        oiiirat = (flux_norm0[n4959]+flux_norm0[n5007])/(flux_norm0[n4363])
        err_lo = err_norm[n4959] + err_norm[n5007]
        oiiirat_lo = (flux_norm0[n4959]+flux_norm0[n5007] - err_lo)/(flux_norm0[n4363] + err_norm[n4363])
        oiiirat_hi = (flux_norm0[n4959]+flux_norm0[n5007] + err_lo)/(flux_norm0[n4363] - err_norm[n4363])
        temden("temperature", oiiirat, atom="oxygen", spectrum=3, assume=100., verbo-, >> datfil1)
	temp_o3    = temden.result
        temden("temperature", oiiirat_lo, atom="oxygen", spectrum=3, assume=100., verbo-, >> datfil1)
	temp_o3_hi = temden.result
	temp_o3_1  = temden.result - temp_o3
        temden("temperature", oiiirat_hi, atom="oxygen", spectrum=3, assume=100., verbo-, >> datfil1)
	temp_o3_lo = temden.result
	temp_o3_2  = temp_o3 - temden.result
        #print("OIII temperature is = ", temp_o3, "+", abs(temp_o3_1), "-", abs(temp_o3_2))
        printf("OIII temperature is = %8.1f (+%6.1f -%6.1f)\n", temp_o3, abs(temp_o3_1), abs(temp_o3_2))
        printf("OIII temperature is = %8.1f (+%6.1f -%6.1f)\n", temp_o3, abs(temp_o3_1), abs(temp_o3_2), >> datfil1)
	phy_flag = 1; datfil3 = datfil[j]
	if (!goodline[n4363]){phy_flag = 0; printf ("*** %12s not detected. Using 3sigma upper limit \n", dline[1, j])}
	if (!goodline[n4363]){phy_flag = 0; printf ("*** %12s not detected. Using 3sigma upper limit \n", dline[1, j], >> datfil1)}
	printf("%3d %5d %7.1f %7.1f %3d %6.3f %6.3f %7.3f %6.3f %6.0f %6.0f %6.0f %2d \n", iob, fibno[iob], velmed, velrms, velnum, Av, Av_err, flux_hb0_lg, eflux_hb0_lg, temp_o3, temp_o3_hi, temp_o3_lo, phy_flag, >> datfil3)

	}  ##phypar == NEBTEMP
	} #j iq  over iq quantities

        #-------------------------------------------
        # Calculate NEBTEMP
        #-------------------------------------------

        for (j=1; j <= iq; j +=1) {
        if (phypar[j] == "NEBDENS") {   # && dline[1, j] == "[OII]3726"){
          ndens1 = idline[1, j]; ndens2 = idline[2, j]
        dens_rat = flux_norm0[ndens1]/flux_norm0[ndens2]
        densrat_lo = (flux_norm0[ndens1] - err_norm[ndens1])/(flux_norm0[ndens2] + err_norm[ndens2])
        densrat_hi = (flux_norm0[ndens1] + err_norm[ndens1])/(flux_norm0[ndens2] - err_norm[ndens2])
        temden("density", dens_rat, atom=dens_atom, spectrum=idens_ion, assume=10000.0, verbo-, >> datfil1)
        dens_res    = temden.result
        temden("density", densrat_lo, atom=dens_atom, spectrum=idens_ion, assume=10000.0, verbo-, >> datfil1)
        dens_hi = temden.result
        dens_1  = temden.result - dens_res
        temden("density", densrat_hi, atom=dens_atom, spectrum=idens_ion, assume=10000.0, verbo-, >> datfil1)
        dens_lo = temden.result
        dens_2  = dens_res - temden.result 
	if (dens_res == INDEF){dens_res = 0.0}
	if (dens_hi  == INDEF){dens_hi  = 0.0}
	if (dens_lo  == INDEF){dens_lo  = 0.0}
        printf("%10s / %10s density is = %8.1f\n", dline[1,j], dline[2,j], dens_res)
        #printf("density is = %8.1f (+%6.1f -%6.1f)\n", dens_res, abs(dens_1), abs(dens_2))
        printf("density is = %8.1f (+%6.1f -%6.1f) %8.1f %8.1f\n", dens_res, abs(dens_1), abs(dens_2), dens_hi, dens_lo)
        printf("density is = %8.1f (+%6.1f -%6.1f) %8.1f %8.1f\n", dens_res, abs(dens_1), abs(dens_2), dens_hi, dens_lo, >> datfil1)
	phy_flag = 1; datfil3 = datfil[j]
	  if (!goodline[ndens1]){phy_flag = 0; printf ("*** %12s not detected. Using 3sigma upper limit \n", dline[1, j])}
	  if (!goodline[ndens2]){phy_flag = 0; printf ("*** %12s not detected. Using 3sigma upper limit \n", dline[2, j])}
	  if (!goodline[ndens1]){phy_flag = 0; printf ("*** %12s not detected. Using 3sigma upper limit \n", dline[1, j], >> datfil1)}
	  if (!goodline[ndens2]){phy_flag = 0; printf ("*** %12s not detected. Using 3sigma upper limit \n", dline[2, j], >> datfil1)}

	printf("%3d %7.1f %7.1f %3d %5d %6.3f %6.3f %7.3f %6.3f %6.0f %6.0f %6.0f %2d \n", iob, fibno[iob], velmed, velrms, velnum, Av, Av_err, flux_hb0_lg, eflux_hb0_lg, dens_res, dens_hi, dens_lo, phy_flag, >> datfil3)

        }  ##phypar == NEBTEMP
        } #j iq  over iq quantities


	#-------------------------------------------
	# Calculate ABUN_He
	#-------------------------------------------

	if (temp_o3 > 0.0){Te4 = temp_o3/10000.0}
	    temp_o3 = Te4*10000.0
	    o_abund = 8.70 + log10(1.0/3.0)
	    n_abund = o_abund + log10(0.1)
	    #z_tot = 16.0*10**(o_abund-12.0) + 14.0*10**(n_abund-12.0)
	    z_tot = 20.0*10**(o_abund-12.0) 
	ftauHeI = 1.0
	#Emission and optical depth coefficients for HeI lines from Olive and Skillman (2004) ApJ 617, 29
	#ftau3889 = 1.0 + (tau/2.0)*(-0.106 + (5.14E-5 - 4.20E-07*ne + 1.97E-10*ne**2)*Te4)
	#ftau4026 = 1.0 + (tau/2.0)*(0.00143 + (4.05E-4 - ne*3.63E-08)*Te4)
	#ftau4471 = 1.0 + (tau/2.0)*(0.00274 + (8.81E-4 - ne*1.21E-06)*Te4)
	#ftau5876 = 1.0 + (tau/2.0)*(0.00470 + (2.23E-3 - ne*2.51E-06)*Te4)
	#ftau6678 = 1.0
	#ftau7065 = 1.0 + (tau/2.0)*(0.359 + (-3.46E-2 - 1.84E-04*ne + 3.039E-7*ne**2)*Te4)

	#Fem3889 = 0.904*Te4**(-0.173-0.00054*ne)/ftau3889
	#Fem4026 = 4.297*Te4**(0.090-0.0000063*ne)/ftau4026
	#Fem4471 = 2.010*Te4**(0.127-0.00041*ne)/ftau4471
	#Fem5876 = 0.735*Te4**(0.230-0.00063*ne)/ftau5876
	#Fem6678 = 2.580*Te4**(0.249-0.00020*ne)/ftau6678
	#Fem7065 = 12.45*Te4**(-0.917)/(3.4940 - (0.793 - 0.0015*ne + 000000696*ne**2)*Te4)/ftau7065

	#Fem4471 = (2.0301 + ne*1.50E-05)*Te4**(0.1463-0.0005*ne)/ftauHeI
	#Fem6678 = (2.6120 - ne*1.46E-04)*Te4**(0.2355-0.1550*ne)/ftauHeI

	Fem4686 = 0.0416*Te4**(-0.146)     #Perez-Montero

	#print (Fem4471, " ", Te4)
	#y1_4471 = 0.0; y1_6678 = 0.0; y2_4686 = 0.0
	y2_4686 = 0.0
        for (j=1; j <= iq; j +=1) { 
	  if (phypar[j] == "ABUN_He"){
		nlin_HeI = 0
		y1_weight = 0.0; y1_av = 0.0
            for (i=1; i <= i1; i +=1) {
		#if (goodline[i]){print(lineid[i], spe_snr[i], ew[i])}
		goodvel = yes
		if (abs(velo[i] - velmed) > ksig*velrms){goodvel = no}
		if (goodline[i]){
	if (i == 1){print("#  LineID  IHe/IHb    SNR   FWHM     EW     Velocity   GamHe     y+       err_y+  Abs_cor  f_tau")}
		  flux0 = (1.0 - aEW/ew[i])*flux_norm0[i]/100.0; eflux = 1.0/spe_snr[i]; HeI = no
		  if (substr(lineid[i], 1, 3) == "HeI" && substr(lineid[i], 1, 4) != "HeII"){HeI = yes}
	#if (HeI){printf("%s %7.3f %6.2f %8.3f %8.3f %8.3f %d\n", lineid[i], flux0, spe_snr[i], fwhm[i], ew[i], velo[i], HeI)}
			#; abscor = (1.0 - aEW/ew[i])
		  #if (lineid[i] == "HeI4471"){y1_4471 = abscor*flux0*Fem4471; e4471 = eflux}
		  if (HeI && goodvel){
			nlin_HeI = nlin_HeI + 1
			aEW = 0.00
			nebgama (lineid[i], ne, temp_o3, tau=tau, verb-) | scan(FemHe[nlin_HeI], ftauHeI)
			match (lineid[i], filhe) | fields (field=2, line=1) | scan(aEW)
			abscor = (1.0 + aEW/ew[i])/(1.0 + aEW_hb/ew[ihb])
			y1_He[nlin_HeI] = flux0*FemHe[nlin_HeI]*abscor/ftauHeI 
			#y1_He[nlin_HeI] = 4.0*flux0*FemHe[nlin_HeI] 
			#err_He = eflux*flux0
			err_y1_He[nlin_HeI] = eflux*y1_He[nlin_HeI]; num_HeI = i
			y1_weight = y1_weight + 1.0/err_y1_He[nlin_HeI]**2
			y1_av = y1_av + y1_He[nlin_HeI]/err_y1_He[nlin_HeI]**2
			#Heline = "HeI4471"; nebgama (Heline, ne, temp_o3, verb-) | scan(FemHe)
	printf("%d %s %8.5f %7.2f %6.2f %8.3f %8.3f %8.3f %8.5f +/- %7.5f %7.4f %7.4f\n", nlin_HeI, lineid[i], flux0, spe_snr[i], fwhm[i], ew[i], velo[i], FemHe[nlin_HeI], y1_He[nlin_HeI], err_y1_He[nlin_HeI], abscor, ftauHeI)
			#if (lineid[i] == "HeI4471"){y1_4471 = y1_He[nlin_HeI]; e4471 = eflux}
			}
		  #if (lineid[i] == "HeI6678"){y1_6678 = abscor*flux0*Fem6678; e6678 = eflux}
		  if (lineid[i] == "HeII4686"){
			#y2_4686 = 4.0*flux0*Fem4686; e4686 = eflux*y2_4686
			y2_4686 = flux0*Fem4686; e4686 = eflux*y2_4686
	printf("1 %s %7.5f %7.2f %6.2f %8.3f %8.3f %8.3f %8.5f +/- %7.5f  1.0000  1.0000\n", lineid[i], flux0, spe_snr[i], fwhm[i], ew[i], velo[i], Fem4686, y2_4686, e4686)
			}
		}
  	    }
	    #if (nlin_HeI > 0){y1_av = y1_av/y1_weight; y1_av_err = sqrt(1.0/(y1_weight/real(nlin_HeI)))}
	    if (nlin_HeI > 0){y1_av = y1_av/y1_weight; y1_av_err = sqrt(1.0/(y1_weight/real(nlin_HeI)))
	    #print(nlin_HeI, z_tot, y1_av, y1_av_err)

	    #y_tot = 4.0*(y1_4471 + y2_4686)
	    y_tot = 4.0*(y1_av + y2_4686)
	    #y_tot_err = 4.0*sqrt((e4471*y1_4471)**2 + (e4686*y2_4686)**2)/y_tot    #fractional error
	    y_tot_err = 4.0*sqrt(y1_av_err**2 + e4686**2)/y_tot    #fractional error
	    y_abund = y_tot*(1.0 - z_tot)/(1.0+y_tot)
	    y_abund_err = y_tot_err*y_abund    # y = y_abund +/- y_abund_err
	    printf("%s y+ =%7.4f +/- %6.4f y++ =%7.4f +/- %6.4f y_tot =%7.4f +/- %6.4f y_abund =%7.4f +/- %6.4f \n", phypar[j], y1_av, y1_av_err, y2_4686, e4686, y_tot, y_tot_err, y_abund, y_abund_err)
		}
	  }
	}

        for (j=1; j <= iq; j +=1) {
          if (phypar[j] == "ABUN_O"){
             for (k=1; k <= nc[j]; k +=1) {
                nl = idline[k, j]
	  n5007 = idline[1, j]; n6583 = idline[2, j]
        R3  = 1.30*flux_norm0[n5007]/100.;  err_R3 = err_norm[n5007]/100.
        N2  = 1.30*flux_norm0[n6583]/100.;  err_N2 = err_norm[n6583]/100.
	N2_lg = log10(N2)

	    if (pp3[j] == "[OII]3727"){
		n3727 = idline[3, j]
        	R2 = flux_norm0[n3727]/100.; err_R2 = err_norm[n3727]/100.
        	#R3byR2 = R3/R2
		properr(R3, R2, "/", err_R3, err_R2, rab=0.0, verb-)
		err_R3R2 = properr.sig
		properr(N2, R2, "/", err_N2, err_R2, rab=0.0, verb-)
		err_N2R2 = properr.sig
		}
	    if (pp3[j] == "[SII]6717"){
		n6717 = idline[3, j]; n6731 = idline[4, j]
		S2 = (flux_norm0[n6717]+flux_norm0[n6731])/100. 
		err_S2 = sqrt((err_norm[n6717]/100.)**2 + (err_norm[n6731]/100.)**2)
        	#R3byS2 = R3/S2
		properr(R3, S2, "/", err_R3, err_S2, rab=0.0, verb-)
		err_R3S2 = properr.sig
		}
                }  #k nc
            if (pp3[j] == "[OII]3727"){
		ohmethod = "R3R2 Pilyugin & Grebel 2016"
                if (N2_lg >= -0.6) {
                obyh = 8.589 + 0.022*log10(R3/R2) + 0.399*log10(N2)+ (-0.137 + 0.164*log10(R3/R2) + 0.589*log10(N2))*log10(R2)
                obyh_hi = 8.589 + 0.022*log10(R3/R2+err_R3R2) + 0.399*log10(N2+err_N2) + (-0.137 + 0.164*log10(R3/R2+err_R3R2) + 0.589*log10(N2+err_N2))*log10(R2+err_R2) - obyh
                obyh_lo = obyh - (8.589 + 0.022*log10(R3/R2-err_R3R2) + 0.399*log10(N2-err_N2) + (-0.137 + 0.164*log10(R3/R2-err_R3R2) + 0.589*log10(N2-err_N2))*log10(R2-err_R2))
                } else {
                obyh = 7.932 + 0.944*log10(R3/R2) + 0.695*log10(N2) + (0.970 - 0.291*log10(R3/R2) - 0.019*log10(N2))*log10(R2)
                obyh_hi = 7.932 + 0.944*log10(R3/R2+err_R3R2) + 0.695*log10(N2+err_N2) + (0.970 - 0.291*log10(R3/R2+err_R3R2) - 0.019*log10(N2+err_N2))*log10(R2+err_R2) - obyh
                obyh_lo = obyh - (7.932 + 0.944*log10(R3/R2-err_R3R2) + 0.695*log10(N2-err_N2) + (0.970 - 0.291*log10(R3/R2-err_R3R2) - 0.019*log10(N2-err_N2))*log10(R2-err_R2))
                }
		nbyo = -0.657 - 0.201*log10(N2) + (0.742 - 0.075*log10(N2))*log10(N2/R2)
		nbyo_hi = -0.657 - 0.201*log10(N2+err_N2) + (0.742 - 0.075*log10(N2+err_N2))*log10(N2/R2+err_N2R2) - nbyo
		nbyo_lo = nbyo - (-0.657 - 0.201*log10(N2-err_N2) + (0.742 - 0.075*log10(N2-err_N2))*log10(N2/R2-err_N2R2))
                printf("%8s O/H %8.3f + %8.3f - %8.3f N/O %8.3f + %8.3f - %8.3f %15s\n", phypar[j], obyh, obyh_hi, obyh_lo, nbyo, nbyo_hi, nbyo_lo, ohmethod)
                printf("%8s O/H %8.3f + %8.3f - %8.3f N/O %8.3f + %8.3f - %8.3f %15s\n", phypar[j], obyh, obyh_hi, obyh_lo, nbyo, nbyo_hi, nbyo_lo, ohmethod, >> datfil1)
                #printf("%8s O/H %8.3f + %8.3f - %8.3f %15s\n", phypar[j], obyh, obyh_hi, obyh_lo, ohmethod, >> datfil1)
                #print(iob, " ", fibno[iob], " ", phypar[j], " ", ohmethod, " ", obyh, "+", obyh_hi, "-", obyh_lo, >> datfil1)
                }
            if (pp3[j] == "[SII]6717"){
		ohmethod = "R3S2 Pilyugin & Grebel 2016"
                if (N2_lg >= -0.6) {
                obyh = 8.424 + 0.030*log10(R3/S2) + 0.751*log10(N2) + (-0.349 + 0.182*log10(R3/S2) + 0.508*log10(N2))*log10(S2)
                obyh_hi = 8.424 + 0.030*log10(R3/S2+err_R3S2) + 0.751*log10(N2+err_N2) + (-0.349 + 0.182*log10(R3/S2+err_R3S2) + 0.508*log10(N2+err_N2))*log10(S2+err_S2) - obyh
                obyh_lo = obyh - (8.424 + 0.030*log10(R3/S2-err_R3S2) + 0.751*log10(N2-err_N2) + (-0.349 + 0.182*log10(R3/S2-err_R3S2) + 0.508*log10(N2-err_N2))*log10(S2+err_S2))
                } else {
                obyh = 8.072 + 0.789*log10(R3/S2) + 0.726*log10(N2) + (1.069 - 0.170*log10(R3/S2) - 0.022*log10(N2))*log10(S2)
                obyh_hi = 8.072 + 0.789*log10(R3/S2+err_R3S2) + 0.726*log10(N2+err_N2) + (1.069 - 0.170*log10(R3/S2+err_R3S2) - 0.022*log10(N2+err_N2))*log10(S2+err_S2) - obyh
                obyh_hi = obyh - (8.072 + 0.789*log10(R3/S2-err_R3S2) + 0.726*log10(N2-err_N2) + (1.069 - 0.170*log10(R3/S2-err_R3S2) - 0.022*log10(N2-err_N2))*log10(S2-err_S2))
                }
                printf("%8s O/H %8.3f + %8.3f - %8.3f %15s\n", phypar[j], obyh, obyh_hi, obyh_lo, ohmethod)
                printf("%8s O/H %8.3f + %8.3f - %8.3f %15s\n", phypar[j], obyh, obyh_hi, obyh_lo, ohmethod, >> datfil1)
                }

          } #phypar == ABUN_O
        }  #j


	if (!quiet){print("#-------------------------------------------")}
	print("#-------------------------------------------", >> datfil1)
	#printf("%3d %5d %7.1f %7.1f %3d %6.3f %6.3f %7.3f %6.3f %6.0f %6.0f %6.0f %8.4f %8.4f\n", iob, fibno[iob], velmed, velrms, velnum, Av, Av_err, flux_hb0_lg, eflux_hb0_lg, temp_o3, temp_o3_hi, temp_o3_lo, y_abund, y_abund_err, >> datfil2)
        #printf("#CHb = %8.3f +/- %8.3f  Av = %8.3f +/- %8.3f  log(FHbeta) = %8.3f +/- %8.3f\n", chb0, chb0_err, Av, Av_err, flux_hb0_lg, 1.0/spe_snr[ihb], >> datfil1)
        #}   #Velocity
skip:
        }   #fscan


end

