procedure mfluxcalc(infile)

#the original script fluxcalc changed to measure only flux and write it to a file
#the script mfluxanal reads the output of mfluxcalc and obtains physical quantities (not done yet)

string  infile	= "wr1_new1"    	{prompt="Input filename to measure flux"}
string  linelist="spanal$data/nebular_lines.dat"	{prompt="List containing lines to be measured"}
int     apno 	= 1             	{prompt="Aperture no spectrum to measure"}
int     bands   = 1             	{prompt="Image bands to be fit"}
bool    inter   = yes           	{prompt="Fit continumm interactively?"}
bool    watchfit= no            	{prompt="Watch each Gaussian Fit?"}
real    fwhmline= 1.0                   {prompt="Expected FWHM of a resolved line [Ang]"}
real    snrgood = 3.0          		{prompt="Minimum SNR of a line for velocity calculation"}
real    errfwhm = 2.0      	    	{prompt="Maximum error in FWHM wrt to Hbeta (in % units) for velocity calculation"}
string  veltype = "none"         	{prompt="Velocity for Doppler correction [none|mean|median|value in km/s]"}
string  dispkey = "CDELT1"         	{prompt="Dispersion Keyword [CDELT1/CD1_1 etc]"}
real    lammin  = 3500.0        	{prompt="Minimum good lambda in Ang"}
real    lammax  = 10000.0        	{prompt="Maximum good lambda in Ang"}
#string  sample  = "4331:4335 4345:4353 4381:4608 4813:4842 4881:4895 4973:4997 5029:5191"   {prompt="Sample range in Ang for analysis 3700:7600"}
string  sample  = "*"   {prompt="Sample range in Ang for analysis 3700:7600"}
real    rmswin  = 25.0                  {prompt="Window size for rms in units of fwhmline"}
real    rmsstep = 5.0                   {prompt="Step size for rms in units of fwhmline"}
bool    skyrms  = no			{prompt="Add Sky rms to the continuum rms? [If yes band=2 is assumed to be sky]"}
bool    skyshi  = no	           	{prompt="Shift wavelength of spectrum using sky lines?"}
string  skyline ="spanal$data/skyline.dat"     {prompt="List containing sky lines to be measured"}
bool    wtext   = no			{prompt="Write text file [wav flux rms]?"}
bool    append  = no			{prompt="Append fluxdata to an existing file?"}
int     ilevel  = 1             	{prompt="Interaction level"}
string  graphics="stdgraph"     {prompt="Output graphics device [stdgraph/stdplot/stdvdm]"}
#real    basepix = 1.0                   {prompt="Basewidth of a line in pixeles"}

begin
	string	filein, inlist, tmp, s1, lineid[99], dopfil, velo  #, extin
	string	splotfillog, nebfil, splotfilcur, cdisp, datfil, datobs, dispkeyw
	string	extcurve, skylist, blend[99], s2, skyfil, imsec, na, headkey
	real	r1, wave[99], velocity, spe_rms, spe_snr, cont_rms, npix
        real   center, cont, flux, eqw, core, gfwhm, lfwhm, xmin, xmax, fcont, disp
	real	fluxobs[99]
			#, tlam, Elam, flam[99], E_hbeta, Av
	real	goodsnr, min_fwhm, max_fwhm, fwhmerr, est_flux
	real	typ_fwhm
	real	invelocity, basewidpix, crpix1, crval1, naxis1, lam1, lam2
        int     i1, i2, nap, j, band, i, igood, tlines, lineno, ngoodline, naxis
	int	irmswin, irmsstepi, ilev
	bool	ask, dopcor, goodline[99], skycor, ans, addskyrms, watch, igoodline[99]
	bool	append_yes
        struct  line


	filein = infile; inlist = linelist; skylist = skyline; dispkeyw = dispkey
	nap = apno; xmin = lammin; xmax = lammax; band = bands
	ask = inter; velo = strlwr(veltype); dopcor = no; addskyrms = skyrms
	skycor = skyshi; watch = watchfit; append_yes = append
        goodsnr = snrgood; fwhmerr = errfwhm 
	if (velo != "none") {dopcor = yes}
	invelocity = 0.0; basewidpix = fwhmline    #basepix
	ilev = ilevel

        #sample = str(xmin)//":"//str(xmax)

	ngoodline = 0
        hselect (filein, "NAXIS", expr+) | scan(naxis)
	if (naxis == 1){nap = 1; band=1; skycor = no; addskyrms = no}
	if (naxis == 2 && nap == 0){band=1; skycor = no; addskyrms = no}

	#Find the sampling in Ang/pix
	#-----------------------------------------------------------
        disp = 0.001; cdisp = "0.001"
        hselect (filein, dispkeyw, expr+) | scan(cdisp)
        if (cdisp != " " && real(cdisp) > 0.001) {disp = real(cdisp)} else {
		print (" *** Error: Dispersion header KEYWORD ", dispkeyw, " not found *** Check dispkey value"); goto exit}
        if (ilev>1){print(dispkeyw, "  ",disp)}

	#headkey = "CRPIX"//na//" CRVAL"//na//" NAXIS"//na//" "//" CDELT"//na
	headkey = "CRPIX1 CRVAL1 NAXIS1" 
        #hselect (nebfil, headkey, expr+) | scan(crpix1, crval1, naxis1, disp)
        hselect (filein, headkey, expr+) | scan(crpix1, crval1, naxis1)
        #hselect (nebfil, headkey, expr+) | scan(crpix1, crval1, naxis1)
	lam1 = crval1 + (1-crpix1)*disp + basewidpix*disp
	lam2 = crval1 + (naxis1-crpix1)*disp - basewidpix*disp 
	if (xmin < lam1 ){xmin = lam1}
	if (xmax > lam2 ){xmax = lam2}
	#print (lam1, lam2, crpix1, crval1, naxis1, disp)
	irmswin = nint(rmswin*basewidpix/disp)
	irmsstep= nint(rmsstep*basewidpix/disp)
	if (ilev>1){print (irmswin, irmsstep)}

	#goto exit

	#-----------------------------------------------------------

	#Read the linelist
	#-----------------------------------------------------------
        i1 = 0
        list = inlist
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#" && tmp != "") {
          i1=i1+1
	  igoodline[i1] = yes
	  i2 = fscanf(line, "%s  %g  %d  %s ", s1, r1, igood, s2)
	  lineid[i1] = s1; wave[i1] = r1; blend[i1] = s2
	  if (igood == 0) {igoodline[i1] = no}
	  #print(s1, " ", r1, " ", igood, " ", blend[i1])
	}
	}
	#-----------------------------------------------------------

        delete("fluxcalc.avvel", ver-, >& "dev$null")
        delete("fluxcalc.vel", ver-, >& "dev$null")
	i = 0
        datobs = filein//"_ap"//str(nap)//"_"//str(band)//"_fluxobs.dat"
        datfil = filein//"_ap"//str(nap)//"_"//str(band)//"_flux.dat"
        nebfil = filein//"_ap"//str(nap)//"_"//str(band)
        imdelete(nebfil, ver-, >& "dev$null")
        if (!append_yes){delete(datobs, ver-, >& "dev$null")}
	#print("##########################################################", >> datfil)
	#date (, >> datfil)

	#Correct the wavelength calibration using the sky lines if asked to do so
	#-----------------------------------------------------------
        if (skycor) {skyshift(filein, apnum=nap, skyline=skylist)}
	#-----------------------------------------------------------

	imsec = "[*,"//str(nap)//","//str(band)//"]" 
        scopy (filein, nebfil, w1=xmin, w2=xmax, apertur=nap, band=band, rebin+)
	
	#Doppler correct the spectrum if the velocity in km/s given in veltype
	#-----------------------------------------------------------
        if (dopcor && velo != "median" && velo != "mean") {
			invelocity = real(velo); velo = "median"
        dopfil = filein//"_dop"//str(nap)//"_"//str(band)
        #print("Doppler shifted by = ", invelocity, " km/s. Output image ", dopfil)
        imdelete(dopfil, ver-, >& "dev$null")
        imdelete(dopfil//"_snr", ver-, >& "dev$null")
        dopcor (nebfil, dopfil, redsh=invelocity, isvel+, add-, disp+, flux-, verb-)
        nebfil = filein//"_dop"//str(nap)//"_"//str(band)
        }
	#-----------------------------------------------------------
	
	#Fit the continuum and obtain rms at every wavelength
	#-----------------------------------------------------------

	omsperms(nebfil, winsize=irmswin, stepsize=irmsstep, sample=sample, inter=ask, function = "spline3", order = 5)

        imdelete(nebfil//"_totrms", ver-, >& "dev$null")
	if (addskyrms){
        skyfil = filein//"_ap"//str(nap)//"_"//str(2)
        imdelete(skyfil, ver-, >& "dev$null")
	imsec = "[*,"//str(nap)//","//str(2)//"]" 
        scopy (filein, skyfil, w1=xmin, w2=xmax, apertur=nap, band=2, rebin+)
        if (invelocity != 0.0) {
        	imdelete(skyfil//"_1", ver-, >& "dev$null")
		dopcor (skyfil, skyfil//"_1", redsh=invelocity, isvel+, add-, disp+, flux-, verb+)
        	imdelete(skyfil, ver-, >& "dev$null")
		imrename (skyfil//"_1", skyfil)
	}
        omsperms(skyfil, sample=sample, inter=ask)
        imexpr ("sqrt(a**2 + b**2)", nebfil//"_totrms", nebfil//"_rms", skyfil//"_rms", verb-)
	} else {
	imcopy (nebfil//"_rms", nebfil//"_totrms", verb-)
	}
        imdelete(filein//"_ap"//str(nap)//"_"//str(band)//"_snr", ver-, >& "dev$null")
	imarith (nebfil, "/", nebfil//"_totrms", filein//"_ap"//str(nap)//"_"//str(band)//"_snr", verbose-)
	#-----------------------------------------------------------

	#goto exit

	#Recalculate the lam1 and lam2 after Doppler correction
        hselect (nebfil, headkey, expr+) | scan(crpix1, crval1, naxis1)
	lam1 = crval1 + (1-crpix1)*disp + basewidpix*disp
	lam2 = crval1 + (naxis1-crpix1)*disp - basewidpix*disp 

	#
	#-----------------------------------------------------------
        for (j=1; j <= i1; j +=1) {
	if (lam1 < wave[j] && lam2 > wave[j]) {
        splotfilcur = "splot_auto_cont.cursor"
        splotfillog = "splot_auto_stat.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")
        print (wave[j], " 0.0  1 <space>", >> splotfilcur)
        splot (nebfil//"_cont", cursor=splotfilcur, > splotfillog)
        splot (nebfil//"_totrms", cursor=splotfilcur, >> splotfillog)
        fields (splotfillog, fields="4", lines=1) | scan (fcont)
        fields (splotfillog, fields="4", lines=2) | scan (cont_rms)
        splot (nebfil//"_csub", cursor=splotfilcur)

        splotfillog = "splot_auto_gaussfit.log"
	if (blend[j] == "0") {
        #omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=basewidpix, graphics=graphics)
        spestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=basewidpix, graphics=graphics)
		if (watch){=gcur}
	lineno = 4
	} else {
        if (strlen(blend[j])>1){
		if (!access(blend[j])){  
		print("Deblending file ",blend[j], " absent. Press Enter to copy from database")
		scan(ans)
		copy ("spanal$data/"//blend[j], blend[j], verbose+)
		}
		#omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0, cursor=blend[j])
		   spestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0, cursor=blend[j])
		#omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0, cursor=blend[j])
		if (watch){=gcur}
		lineno = 4 
		} else { lineno = lineno + 1 }
	}

        fields (splotfillog, fields="1-7", lines=lineno) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
        velocity = 2.9979E+05 * (center - wave[j])/wave[j] + invelocity
	fluxobs[j] = flux
	#print (fcont, eqw, disp)
	eqw = flux/fcont; npix = 2.0*gfwhm/disp 
	est_flux = 2.0*npix + eqw/disp 
	if (est_flux <= 1.0) {est_flux = 1.0}
	#spe_rms = cont_rms*disp*sqrt(2.0*npix + eqw/disp)
	spe_rms = cont_rms*disp*sqrt(est_flux) 
	if (spe_rms > 0.0){spe_snr = flux/spe_rms} else {spe_snr = 1.0}
	goodline[j] = yes
	if (abs(spe_snr) < goodsnr) {goodline[j] = no}
	#if (j == 1) {min_fwhm = gfwhm*(1.-fwhmerr/100.); max_fwhm = gfwhm*(1.+fwhmerr/100.)}
	if (j == 1) {typ_fwhm = gfwhm; min_fwhm = typ_fwhm/fwhmerr; max_fwhm = typ_fwhm*fwhmerr}
	if (j == 1 && spe_snr < goodsnr) {typ_fwhm = basewidpix; min_fwhm = typ_fwhm/fwhmerr; max_fwhm = typ_fwhm*fwhmerr}
	if (gfwhm > max_fwhm || gfwhm < min_fwhm ) {goodline[j] = no}
	if (!goodline[j]){
	  #npix = 2.0*gfwhm[1]/disp; flux_3sig = 3.0*cont_rms*sqrt(npix); 
	  npix = 2.0*typ_fwhm/disp; spe_rms = cont_rms*sqrt(npix); flux = 3.0*spe_rms
	}
	#if (igoodline[j]) {print(velocity, >> "fluxcalc.vel"); ngoodline = ngoodline +1}
	if (goodline[j]) {print(velocity, >> "fluxcalc.vel"); ngoodline = ngoodline +1}

	#-------------------------------------------------

        if (j==1) {printf("%s", "#DATE ", >> datobs); date (, >> datobs)}
        if (j==1 && ilev > 1) {print("#APER  ", nap)}
        if (j==1) {print("#APER  ", nap, " ", filein, >> datobs)}
	if (j==1 && ilev != 0) {print("          ID VFLAG LAMREST     RMS       SNR  LAMOBS    VELOCITY    FLUX       EW     FWHM  FCONT     FLAG  APNO")}
	if (ilev>1){
        printf("%12s  %2d  %8.2f %10.4e %6.1f %8.2f %8.1f %10.4e %8.3f %7.2f %10.4e %3d %5d\n", lineid[j], igoodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, eqw, gfwhm, fcont, goodline[j], nap)
	}
	if (ilev ==1 && goodline[j]){
        printf("%12s  %2d  %8.2f %10.4e %6.1f %8.2f %8.1f %10.4e %8.3f %7.2f %10.4e %3d %5d\n", lineid[j], igoodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, eqw, gfwhm, fcont, goodline[j], nap)
	}
	if (j==1) {print("#         ID VFLAG LAMREST     RMS       SNR  LAMOBS    VELOCITY    FLUX       EW    FWHM  FCONT     FLAG  APNO", >> datobs)}
        printf("%12s  %2d  %8.2f %10.4e %6.1f %8.2f %8.1f %10.4e %8.3f %7.2f %10.4e %3d %5d\n", lineid[j], igoodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, eqw, gfwhm, fcont, goodline[j], nap, >> datobs)
	}      #end good lam range
	}      #end line measure

        if (access("fluxcalc.vel")) {
        tstat("fluxcalc.vel", >& "dev$null")
         if (ilev != 0){printf("Velocity%d: mean= %8.1f =/- %8.1f median= %8.1f lines= %d\n", nap,tstat.mean, tstat.stddev, tstat.median, tstat.nrows)}
        printf("#Velocity: lines= %d mean= %8.1f =/- %8.1f median= %8.1f\n", tstat.nrows, tstat.mean, tstat.stddev, tstat.median, >> datobs)
        } else {
          printf("#Velocity: lines= 0 \n", >> datfil)
        }

        if (dopcor) {
	if (velo == "median" || velo == "mean") {
        	nebfil = filein//"_ap"//str(nap)//"_"//str(band)
        	dopfil = filein//"_dop"//str(nap)//"_"//str(band)
		if (velo == "median") {velocity = tstat.median} 
             	if (velo == "mean") {velocity = tstat.mean}      #} else {velocity = tstat.median}
	if (ilev > 1){print("Doppler shifted by = ", velocity, " km/s. Output image ", dopfil)}
        imdelete(dopfil, ver-, >& "dev$null")
        imdelete(dopfil//"_snr", ver-, >& "dev$null")
        dopcor (nebfil, dopfil, redsh=velocity, isvel+, add-, disp+, flux-, verb+)
        dopcor (nebfil//"_snr", dopfil//"_snr", redsh=velocity, isvel+, add-, disp+, flux-, verb-)
	}
	}

        if (wtext){
        if (!dopcor) {dopfil = nebfil}
        delete(dopfil//"1.txt", ver-, >& "dev$null")
        delete(dopfil//"2.txt", ver-, >& "dev$null")
        delete(dopfil//"3.txt", ver-, >& "dev$null")
        delete(dopfil//".txt", ver-, >& "dev$null")

        skyfil = filein//"_ap"//str(nap)//"_"//str(2)
        wspectext (dopfil, dopfil//"1.txt", header-, wformat="%0.2f")
        wspectext (dopfil//"_totrms", dopfil//"2.txt", header-, wformat="%0.2f")
        fields (dopfil//"2.txt", fields=2, > dopfil//"3.txt")
        join (dopfil//"1.txt", dopfil//"3.txt", output = dopfil//".txt", delim="   ")
        print("Output text file [wav flux rms] is = ", dopfil//".txt")
        delete(dopfil//"1.txt", ver-, >& "dev$null")
        delete(dopfil//"2.txt", ver-, >& "dev$null")
        delete(dopfil//"3.txt", ver-, >& "dev$null")
        }

exit:
	if (ilev > 0){print (" ---------------------------------------- ")}

end

