procedure mfluxcalc(infile)

#the original script fluxcalc changed to measure only flux and write it to a file
#the script mfluxanal reads the output of mfluxcalc and obtains physical quantities (not done yet)

string  infile	= "wr1_new1"    	{prompt="Input filename to measure flux"}
string  linelist="spanal$data/nebular_lines.dat"	{prompt="List containing lines to be measured"}
int     apno 	= 1             	{prompt="Aperture no spectrum to measure"}
int     bands   = 1             	{prompt="Image bands to be fit"}
bool    inter   = yes           	{prompt="Fit continumm interactively?"}
real    basepix = 1.0                   {prompt="Basewidth of a line in pixeles"}
real    lammin  = 3700.0        	{prompt="Minimum good lambda in Ang"}
real    lammax  = 7600.0        	{prompt="Maximum good lambda in Ang"}
bool    skyrms  = yes			{prompt="Add Sky rms to the continuum rms? [If yes band=2 is assumed to be sky]"}
string  sample  = "4331:4335 4345:4353 4381:4608 4813:4842 4881:4895 4973:4997 5029:5191"   {prompt="Sample range in Ang for analysis 3700:7600"}
string  veltype = "none"         	{prompt="Velocity for Doppler correction [none|mean|median|value in km/s]"}
string  redcurve="spanal$data/ext_interp.dat"  {prompt="Extinction curve normalized to Av"}
string  exttype = "none"         	{prompt="Av for extinction correction [none|hbeta|mean|value in mag]"}
bool    skyshi  = yes           	{prompt="Shift wavelength of spectrum using sky lines?"}
string  skyline ="spanal$data/skyline.dat"     {prompt="List containing sky lines to be measured"}
real    snrgood = 3.0          		{prompt="Minimum SNR of a line for velocity calculation"}
real    errfwhm = 20.0          	{prompt="Maximum error in FWHM wrt to Hbeta (in % units) for velocity calculation"}
bool    wtext   = no			{prompt="Write text file [wav flux rms]?"}

begin
	string	filein, inlist, tmp, s1, lineid[99], dopfil, velo, extin
	string	splotfillog, nebfil, splotfilcur, cdisp, datfil, datobs, dispkey
	string	extcurve, skylist, blend[99], s2, skyfil, imsec, na, headkey
	real	r1, wave[99], velocity, spe_rms, spe_snr, cont_rms, npix, flux_ref, chb_err, theo_rat
        real   center, cont, flux, eqw, core, gfwhm, lfwhm, xmin, xmax, fcont, disp
	real	flux_norm[99], flux_hbeta, fluxobs[99], tlam, Elam, flam[99], E_hbeta, chb, Av
	real	goodsnr, min_fwhm, max_fwhm, fwhmerr, flux_norm0, flux_hb0_lg, est_flux
	real	chb2, chb3, chb4, err_norm[99], rms_ref, rms_hbeta, chb2_err, chb3_err, chb4_err, Av_err
	real	invelocity, basewidpix, crpix1, crval1, naxis1, lam1, lam2
        int     i1, i2, nap, j, band, i, igood, tlines, lineno, ngoodline, naxis
	bool	ask, dopcor, goodline[99], extcor, skycor, ans, addskyrms
        struct  line

	filein = infile; inlist = linelist; skylist = skyline
	nap = apno; xmin = lammin; xmax = lammax; band = bands
	ask = inter; velo = strlwr(veltype); dopcor = no; addskyrms = skyrms
	extin = strlwr(exttype); extcor = no; skycor = skyshi
	if (velo != "none") {dopcor = yes}
	if (extin != "none") {extcor = yes}
	extcurve = redcurve
	goodsnr = snrgood; fwhmerr = errfwhm
	#dopcor = dopshi
        #sample = str(xmin)//":"//str(xmax)
	invelocity = 0.0; basewidpix = basepix

        disp = 1.0; cdisp = "1.0"; ngoodline = 0
	chb = 0.0; chb2 = 0.0; chb3 = 0.0; chb4 = 0.0
	chb_err = 0.0; chb2_err = 0.0; chb3_err = 0.0; chb4_err = 0.0
        hselect (filein, "NAXIS", expr+) | scan(naxis)
	#if (naxis == 1){nap = 1; band=1; skycor = no; addskyrms = no; na = "1"}
	if (naxis == 1){nap = 1; band=1; skycor = no; addskyrms = no}
        #hselect (filein, "CDELT2", expr+) | scan(cdisp)
	na = str(onedspec.dispaxis)
        dispkey = "CDELT"//str(onedspec.dispaxis)
        hselect (filein, dispkey, expr+) | scan(cdisp)

        if (cdisp == "1.0") { hselect (filein, "CD1_1", expr+) | scan(cdisp); disp = real(cdisp)}
        if (cdisp != " " && real(cdisp) > 0.01) {disp = real(cdisp)}
        print(dispkey, "  ",disp)

	if (extcor) { type(extcurve) | wc | scan(tlines) }

        i1 = 0
        list = inlist
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#" && tmp != "") {
          i1=i1+1
	  goodline[i1] = yes
	  i2 = fscanf(line, "%s  %g  %d  %s ", s1, r1, igood, s2)
	  lineid[i1] = s1; wave[i1] = r1; blend[i1] = s2
	  if (igood == 0) {goodline[i1] = no}
	  #print(s1, " ", r1, " ", igood, " ", blend[i1])
	}
	}

        delete("fluxcalc.avvel", ver-, >& "dev$null")
        delete("fluxcalc.vel", ver-, >& "dev$null")
	i = 0
        datobs = filein//"_ap"//str(nap)//"_"//str(band)//"_fluxobs.dat"
        datfil = filein//"_ap"//str(nap)//"_"//str(band)//"_flux.dat"
        nebfil = filein//"_ap"//str(nap)//"_"//str(band)
        imdelete(nebfil, ver-, >& "dev$null")
	#print("##########################################################", >> datfil)
	#date (, >> datfil)
        #if (skycor) {skyshift(filein, apnum=nap, skyline=skylist); type(filein//"_shi.dat", >> datfil)}
        if (skycor) {skyshift(filein, apnum=nap, skyline=skylist)}
	imsec = "[*,"//str(nap)//","//str(band)//"]" 
        #scopy (filein//imsec, nebfil, w1=xmin, w2=xmax, rebin+)
        scopy (filein, nebfil, w1=xmin, w2=xmax, apertur=nap, band=band, rebin+)
	
        if (dopcor && velo != "median" && velo != "mean") {
			invelocity = real(velo); velo = "median"
        dopfil = filein//"_dop"//str(nap)//"_"//str(band)
        #print("Doppler shifted by = ", invelocity, " km/s. Output image ", dopfil)
        imdelete(dopfil, ver-, >& "dev$null")
        imdelete(dopfil//"_snr", ver-, >& "dev$null")
        dopcor (nebfil, dopfil, redsh=invelocity, isvel+, add-, disp+, flux-, verb+)
        #dopcor (nebfil//"_snr", dopfil//"_snr", redsh=invelocity, isvel+, add-, disp+, flux-, verb+)
	#dopcor = no
        #imdelete(nebfil, ver-, >& "dev$null")
        nebfil = filein//"_dop"//str(nap)//"_"//str(band)
        }
	#headkey = "CRPIX"//na//" CRVAL"//na//" NAXIS"//na//" "//" CDELT"//na
	headkey = "CRPIX1 CRVAL1 NAXIS1" 
        #hselect (nebfil, headkey, expr+) | scan(crpix1, crval1, naxis1, disp)
        hselect (nebfil, headkey, expr+) | scan(crpix1, crval1, naxis1)
	lam1 = crval1 + (1-crpix1)*disp + basewidpix*disp
	lam2 = crval1 + (naxis1-crpix1)*disp - basewidpix*disp 
	#print (lam1, lam2, crpix1, crval1, naxis1, disp)
	
	omsperms(nebfil, sample=sample, inter=ask, function = "spline3", order = 5)

        imdelete(nebfil//"_totrms", ver-, >& "dev$null")
	if (addskyrms){
        skyfil = filein//"_ap"//str(nap)//"_"//str(2)
        imdelete(skyfil, ver-, >& "dev$null")
	imsec = "[*,"//str(nap)//","//str(2)//"]" 
        #scopy (filein//imsec, skyfil, w1=xmin, w2=xmax, rebin+)
        scopy (filein, skyfil, w1=xmin, w2=xmax, apertur=nap, band=2, rebin+)
        omsperms(skyfil, sample=sample, inter=ask)
        imexpr ("sqrt(a**2 + b**2)", nebfil//"_totrms", nebfil//"_rms", skyfil//"_rms", verb-)
	} else {
	imcopy (nebfil//"_rms", nebfil//"_totrms", verb-)
	}
        #imdelete(nebfil//"_snr", ver-, >& "dev$null")
	#imarith (nebfil, "/", nebfil//"_totrms", nebfil//"_snr", verbose-)
        imdelete(filein//"_ap"//str(nap)//"_"//str(band)//"_snr", ver-, >& "dev$null")
	imarith (nebfil, "/", nebfil//"_totrms", filein//"_ap"//str(nap)//"_"//str(band)//"_snr", verbose-)
	#imrename(nebfil//"_snr", filein//"_ap"//str(nap)//"_"//str(band)//"_snr", verb-)

        for (j=1; j <= i1; j +=1) {
	if (lam1 < wave[j] && lam2 > wave[j]) {
        splotfilcur = "splot_auto_cont.cursor"
        splotfillog = "splot_auto_stat.log"
        delete (splotfilcur, ver-, >& "dev$null")
        delete (splotfillog, ver-, >& "dev$null")
        print (wave[j], " 0.0  1 <space>", >> splotfilcur)
        splot (nebfil//"_cont", cursor=splotfilcur, > splotfillog)
        splot (nebfil//"_totrms", cursor=splotfilcur, >> splotfillog)
        #splot (nebfil//"_rms", cursor=splotfilcur, >> splotfillog)
        fields (splotfillog, fields="4", lines=1) | scan (fcont)
        fields (splotfillog, fields="4", lines=2) | scan (cont_rms)

        splotfillog = "splot_auto_gaussfit.log"
	if (blend[j] == "0") {
        #omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0)
        omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=basewidpix)
	lineno = 4
	} else {
        if (strlen(blend[j])>1){
		if (!access(blend[j])){  
		print("Deblending file ",blend[j], " absent. Press Enter to copy from database")
		scan(ans)
		copy ("spanal$data/"//blend[j], blend[j], verbose+)
		}
		#omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0, cursor=blend[j])
		#spestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0, cursor=blend[j])
		omspestat(nebfil//"_csub", xpos=1, yposlit=wave[j], contflux=0.0, basepix=5.0, cursor=blend[j])
		lineno = 4 
		} else { lineno = lineno + 1 }
	}

        fields (splotfillog, fields="1-7", lines=lineno) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
        velocity = 2.9979E+05 * (center - wave[j])/wave[j] + invelocity
	fluxobs[j] = flux
	eqw = flux/fcont; npix = 2.0*gfwhm/disp 
	est_flux = 2.0*npix + eqw/disp 
	if (est_flux <= 1.0) {est_flux = 1.0}
	#spe_rms = cont_rms*disp*sqrt(2.0*npix + eqw/disp)
	spe_rms = cont_rms*disp*sqrt(est_flux) 
	spe_snr = flux/spe_rms
	if (abs(spe_snr) < goodsnr) {goodline[j] = no}
	if (j == 1) {min_fwhm = gfwhm*(1.-fwhmerr/100.); max_fwhm = gfwhm*(1.+fwhmerr/100.)}
	if (gfwhm > max_fwhm || gfwhm < min_fwhm ) {goodline[j] = no}
	if (goodline[j]) {print(velocity, >> "fluxcalc.vel"); ngoodline = ngoodline +1}

	#-------------------------------------------------

        if (j==1) {printf("%s", "#DATE ", >> datobs); date (, >> datobs)}
        if (j==1) {print("#APER  ", nap)}
        if (j==1) {print("#APER  ", nap, " ", filein, >> datobs)}
	if (j==1) {print("          ID FLAG  LAMREST     RMS       SNR  LAMOBS    VELOCITY    FLUX       EW    FWHM  FCONT")}
        printf("%12s  %2d  %8.2f %10.4e %6.1f %8.2f %8.1f %10.4e %8.3f %7.2f %10.4e\n", lineid[j], goodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, eqw, gfwhm, fcont)
	if (j==1) {print("#         ID FLAG  LAMREST     RMS       SNR  LAMOBS    VELOCITY    FLUX       EW    FWHM  FCONT", >> datobs)}
        printf("%12s  %2d  %8.2f %10.4e %6.1f %8.2f %8.1f %10.4e %8.3f %7.2f %10.4e\n", lineid[j], goodline[j], wave[j], spe_rms, spe_snr, center, velocity, flux, eqw, gfwhm, fcont, >> datobs)
	}      #end good lam range
	}      #end line measure

        if (access("fluxcalc.vel")) {
        tstat("fluxcalc.vel", >& "dev$null")
        printf("Velocity%d: mean= %8.1f =/- %8.1f median= %8.1f lines= %d\n", nap,tstat.mean, tstat.stddev, tstat.median, tstat.nrows)
        printf("#Velocity: lines= %d mean= %8.1f =/- %8.1f median= %8.1f\n", tstat.nrows, tstat.mean, tstat.stddev, tstat.median, >> datobs)
        } else {
          printf("#Velocity: lines= 0 \n", >> datfil)
        }

        if (dopcor) {
	#tstat("fluxcalc.vel") 
	#tstat("fluxcalc.vel", >> datfil) 
	#tstat("fluxcalc.vel", >> "fluxcalc.avvel") 
	#type ("fluxcalc.avvel")
	#tstat("fluxcalc.vel", >& "dev$null") 
	#printf("%8.1f %8.1f %8.1f\n", "Velocity: mean = ", tstat.mean, "=/-", tstat.stddev, " median=", tstat.median)
	#printf("Velocity: mean = %8.1f =/- %8.1f median= %8.1f lines= %d\n", tstat.mean, tstat.stddev, tstat.median, tstat.nrows)

	if (velo == "median") {velocity = tstat.median} 
             else if (velo == "mean") {velocity = tstat.mean} else {velocity = tstat.median}
             #else if (velo == "mean") {velocity = tstat.mean} else {velocity = real(velo)}
	#velocity = tstat.median
        nebfil = filein//"_ap"//str(nap)//"_"//str(band)
        dopfil = filein//"_dop"//str(nap)//"_"//str(band)
	#print("Doppler shifted by = ", velocity, " km/s. Output image ", dopfil)
        imdelete(dopfil, ver-, >& "dev$null")
        imdelete(dopfil//"_snr", ver-, >& "dev$null")
        dopcor (nebfil, dopfil, redsh=velocity, isvel+, add-, disp+, flux-, verb+)
        dopcor (nebfil//"_snr", dopfil//"_snr", redsh=velocity, isvel+, add-, disp+, flux-, verb+)
	}

        if (wtext){
        if (!dopcor) {dopfil = nebfil}
        delete(dopfil//"1.txt", ver-, >& "dev$null")
        delete(dopfil//"2.txt", ver-, >& "dev$null")
        delete(dopfil//"3.txt", ver-, >& "dev$null")
        delete(dopfil//".txt", ver-, >& "dev$null")

        skyfil = filein//"_ap"//str(nap)//"_"//str(2)
        #imdelete(skyfil, ver-, >& "dev$null")
        #imdelete(nebfil//"_totrms", ver-, >& "dev$null")
        #scopy (filein, skyfil, w1=xmin, w2=xmax, apertur=nap, band=2, rebin+)
        #omsperms(skyfil, sample=sample, inter=ask)
        #imexpr ("sqrt(a**2 + b**2)", nebfil//"_totrms", nebfil//"_rms", skyfil//"_rms", verb-)
        wspectext (dopfil, dopfil//"1.txt", header-, wformat="%0.2f")
        wspectext (dopfil//"_totrms", dopfil//"2.txt", header-, wformat="%0.2f")
        #wspectext (nebfil//"_totrms", dopfil//"2.txt", header-, wformat="%0.2f")
        fields (dopfil//"2.txt", fields=2, > dopfil//"3.txt")
        join (dopfil//"1.txt", dopfil//"3.txt", output = dopfil//".txt", delim="   ")
        print("Output text file [wav flux rms] is = ", dopfil//".txt")
        delete(dopfil//"1.txt", ver-, >& "dev$null")
        delete(dopfil//"2.txt", ver-, >& "dev$null")
        delete(dopfil//"3.txt", ver-, >& "dev$null")
        }

end

