procedure nebgama(linenam, Teneb, density)

string  linenam = "HeI4471"               	{prompt="File with Physical parameters to be calculated"}
real    Teneb   = 10000.0              		{prompt="Electron Te of the nebula"}
real    density = 100.0                		{prompt="Electron density in the nebula"}
string  infile  = "home$Porter_lines_fixed.dat" {prompt="Input filename to measure flux"}
real    tauHe   = 0.0                		{prompt="Tau for the He lines"}
bool    verbose = yes				{prompt="Verbose output?"}

begin
	string	id, datfil, tfil1, tfil2, col_id, dens_id, lam, ion, rec, cat_lam
	real	Te, lgne, gama, gama1, gama2, dens1, dens2, Te1, Te04, ne
	real	gamaHbbyHe, gamaHelg, gamaHblg, ftau, tau
	int	i, ibeg, nlines, ibeg1, ibeg2
	bool	talk

	id = linenam; datfil = infile; talk = verbose; tau = tauHe
	Te = Teneb; lgne = log10(density)
	tfil1 = "nebgama_tfil1.dat"
	tfil2 = "nebgama_tfil2.dat"
        delete(tfil1, ver-, >& "dev$null")
        delete(tfil2, ver-, >& "dev$null")

	col_id = "1,3"
	dens_id = "103-123"

	if (Teneb < 5000.0){Teneb = 5000.0}
	if (Teneb > 25000.0){Teneb = 25000.0}

	print (Teneb, >> tfil2)

	ion = "HeI"
	if (substr (id, 1, 2) == "He" && substr (id, 3, 4) != "II"){lam = substr (id, 4, strlen(id))}
	if (substr (id, 1, 4) == "HeII"){ion = "HeII"; lam = substr (id, 5, strlen(id))}

	if (lgne < 1.0){lgne = 1.0}
        for (i=1; i <= 14; i +=1) {
	  #if (abs(real(i) - lgne) <= 0.5){ibeg=57+(i-1)*23; dens_id = str(ibeg)//"-"//str(ibeg+20) }
	  if (real(i) <= lgne) {
		ibeg1=57+(i-1)*23; ibeg2=57+i*23; dens1 = real(i)
		if (real(i) - lgne == 0.0){ibeg2=ibeg1} 
		}
	}
	dens_id = str(ibeg1)//"-"//str(ibeg1+20)
	if (talk){print(ibeg1, ibeg2)}
	
	if (ion == "HeI"){
	#col 1 = Te; col2 = log_ne col3-46 He lines
	rec = "2945   3188   3614   3889   3965   4026   4121   4388   4438   4471   4713   4922   5016   5048   5876   6678   7065   7281   9464   10830  11013  11969  12527  12756  12785  12790  12846  12968  12985  13412  15084  17003  18556  18685  18697  19089  19543  20427  20581  20602  21118  21130  21608  21617"
	nlines = 44
	}

	for (i=1; i <= nlines; i +=1) {
	  print(rec) | fields (fields=i, lines=1) | scan(cat_lam)
	  if (cat_lam == lam){col_id="1,"//str(i+2)}
	}

	if (talk){print(lam, " ", dens_id, " ", col_id)}
	fields (datfil, fields=col_id, lines=dens_id, >> tfil1)
	sinter (tfil1, tfil2, image="", curve_gen-, tbl_size=1024, make_image-)  | scan(Te1, gama1)
	if (talk){print (Te1, gama1)}
	if (ibeg1 != ibeg2){
	  dens_id = str(ibeg2)//"-"//str(ibeg2+20)
	  fields (datfil, fields=col_id, lines=dens_id, >> tfil1)
	  sinter (tfil1, tfil2, image="", curve_gen-, tbl_size=1024, make_image-) | scan(Te1, gama2)
	  dens2 = dens1 + 1.0
	  gama = gama1 + (lgne - dens1)*(gama2 - gama1)/(dens2 - dens1)
	  if (talk){print (lgne, gama1, gama2, gama)}
	  gama1 = gama
	}

	Te04 = Teneb/10000.0
	gamaHelg = gama1
	gamaHblg = log10(1.37) - 0.982*log10(Te04) + 0.43429448190325*(-0.104/Te04) - 25.0
	#galaHb = 1.37*Te04**(-0.982)*exp(-0.104/Te04)   #Monreal-Ibero
	gamaHbbyHe = 10**(gamaHblg - gamaHelg)
	if (talk) {print("lgGama",id, "=", gamaHelg, " lgGamaHb=", gamaHblg, "GamaHb/GamaHe=", gamaHbbyHe)}
	#print(gamaHbbyHe)

	#He radiative transfer effects tau  Olive and Skillman 2004  Ana Monreal + 2013
	ftau = 1.0; ne = 10**lgne
	if (id == "HeI3889"){ftau = 1.0 + (tau/2.0)*(-0.106 + (5.14E-5 - 4.20E-07*ne + 1.97E-10*ne**2)*Te04)}
	if (id == "HeI4026"){ftau = 1.0 + (tau/2.0)*(0.00143 + (4.05E-4 - ne*3.63E-08)*Te04)}
	if (id == "HeI4471"){ftau = 1.0 + (tau/2.0)*(0.00274 + (8.81E-4 - ne*1.21E-06)*Te04)}
	if (id == "HeI4492"){ftau = 1.0}
	if (id == "HeI5016"){ftau = 1.0}
	if (id == "HeI5048"){ftau = 1.0}
	if (id == "HeI5876"){ftau = 1.0 + (tau/2.0)*(0.00470 + (2.23E-3 - ne*2.51E-06)*Te04)}
	if (id == "HeI7065"){ftau = 1.0 + (tau/2.0)*(0.359 + (-3.46E-2 - 1.84E-04*ne + 3.039E-7*ne**2)*Te04)}
	if (id == "HeI6678"){ftau = 1.0}
	#if (id == "HeI"){ftau = }

	print(gamaHbbyHe, ftau)

end
