procedure omsperms(infil)

string  infil   = "wr1_new1"    {prompt="Input spectrum for continuum fit and rms"}
int     winsize = 100           {prompt="Spectrum window in pixels"}
int     stepsize= 20            {prompt="Spectrum sampling in pixels"}
int     nclip   = 10            {prompt="Number of clipping iterations"}
string  lines   = 1             {prompt="Image lines to be fit"}
string  bands   = 1             {prompt="Image bands to be fit"}
string  sample  = "3700:7600"   {prompt="Sample range in Ang for analysis 3700:7600"}
bool    inter   = yes           {prompt="Fit continumm interactively?"}
string  function= "spline3"     {prompt="Function to be fit to the continuum"}
int     order   = 3             {prompt="Order of the function to be fit"}

begin
	string	spefil, sperms, specont, specsub, jsec, imsec, sperange, spekrms
	string  line, band
        real    stddev, min, max, kclip
	int	rmsstep, jstep, npix, itclip, i, j, nspe, j1, j2
        bool    ask

	spefil = infil; rmsstep = winsize; jstep = stepsize; ask = inter
	line = lines; band = bands; itclip = nclip; sperange = sample
	sperms = spefil//"_rms"; specont = spefil//"_cont"; specsub = spefil//"_csub"
        spekrms = spefil//"_krms"
	kclip = 3.0

        imdelete(sperms, ver-, >& "dev$null")
        imdelete(specont, ver-, >& "dev$null")
        imdelete(specsub, ver-, >& "dev$null")
        imdelete(spekrms, ver-, >& "dev$null")

        continuum (spefil, specont, lines=line, bands=band, type="fit", high_rej=2.5,
           wavesca+, sample=sperange, low_rej=3, functio=function, order=order,
           naverag=1, niterat=10, ask=ask)
#           wavesca+, sample=sperange, low_rej=3, functio="spline3", order=3,

        imexpr ("a*0.0", sperms, specont, verb-)
        #imexpr ("a-b", specsub, spefil, specont, verb-)
        imsec = "[*,"//str(line)//","//str(band)//"]" #; print(imsec)
        sarith (spefil//imsec, "-", specont, specsub, verb-)
	#print(spefil//imsec, specont, specsub)
        #sarith (spefil, "-", specont, specsub, verb-, aper=line, bands=band)
	nspe = 1
        hselect (specont, "NAXIS1, NAXIS2", yes) | scan (npix, nspe)
        #hselect (specont, "NAXIS1", yes) | scan (npix)
        #rmsstep = 100; jstep = 20
        imstat (specsub, fields="stddev", nclip=3, format-) | scan(stddev)
        for (i=1; i <= nspe; i +=1) {
        for (j=1; j <= npix-jstep; j +=jstep) {
          #if (j+rmsstep < npix){
          #imsec = "["//str(j)//":"//str(j+rmsstep-1)//","//str(i)//"]" 
          #      } else {imsec = "["//str(j-rmsstep+1)//":"//str(j)//","//str(i)//"]"}

          if (j+rmsstep < npix){j1 = j; j2 = j+rmsstep-1} else {j1 = j-rmsstep+1; j2 = j}

	  imsec = "["//str(j1)//":"//str(j2)//","//str(i)//"]"
          jsec = "["//str(j)//":"//str(j+jstep-1)//","//str(i)//"]"

          min = 0.0 - 3.0*stddev; max = 0.0 + 3.0*stddev
          imstat (specsub//imsec, fields="stddev", lower=min, upper=max, nclip=itclip, format-) | scan(stddev)
          imrepl (sperms//jsec, stddev)
        }
        }
	#imexpr ("a+b*"//str(kclip), spekrms, specont, sperms)
end
