procedure plotfunc(filnam)

string  filnam    = "gtc14a_mos1abc" 	{prompt="File Name"}
string  dsource   = "ap" 		{prompt="Data source [id/ap]"}
int     step      = 50			{prompt="Step size for aperture box"}
int     recno     = 1 			{prompt="Record number"}
string  database  = "database/" 	{prompt="Database directory name [database/]"}
string  output    = "plotfunc" 		{prompt="File to store calculated function [.reg, .dat]"}
int     ybeg      = 0 			{prompt="Min value independent variable to plot"}
int     yend      = 0 			{prompt="Max value independent variable to plot"}
string  regtype   = "polygon" 		{prompt="Data source [polygon/box]"}
bool    verbose   = yes                 {prompt="Print output for each plot"}

begin
        string  datadir, suffix, fnam, dfile, ans, func, comm1 
	string	ofil, datfil, regfil, cline, comm_left, comm_right, boxtyp, ystr
	real	y, ymin, ymax, yfit, cc[19], s, zz[19], n, aa, bb
	real	center, low, high, refpix, shift
	int	ncoef, k, j, i, norder, id, nfunc, istep, irec, ibegin, nlines 
	int	ipix, y1, y2, i1, i2, is1, is2, is, ii
	bool	verb
        struct  line

	fnam = filnam; datadir = database; suffix = dsource; y1 = ybeg; y2 = yend
	irec = recno; ofil = output; boxtyp = regtype
	verb = verbose
	istep = max(50,step)

	regfil = ofil//".reg"; delete (regfil, ver-, >& "dev$null")

	if (substr(boxtyp, 1, 1) != "b"){boxtyp = "polygon"}
	i1 = 1
	is1 = strstr("[", fnam); is2 = strstr(",", fnam)
	if (is1 != is2){
	  is = strstr(":", fnam) 
	  i1 = int(substr(fnam, is1+1, is-1))
	  i2 = int(substr(fnam, is+1, is2-1))
	  fnam = substr(fnam, 1, is1-1)//"_"//str(i1)//"_"//str(i2)//"___"
	}
	dfile = datadir//suffix//fnam
	print(dfile)
	center=0.0; low=0.0; high=0.0; shift = 0.0

	ii = 0; id = 0
	list = dfile
	while (fscan (list, line) != EOF) {
        ii = ii+1
        if (substr(line, 1, 1) != "#") {
	fields (dfile, fields="1", lines=ii) | scan (ans) 
	if (ans == "begin") {ibegin = ii}
	if (ans == "coefficients" || ans == "curve") {
	id = id + 1 
	if (id == irec || irec == 0) {
	if (ans == "curve") {
		fields (dfile, fields="2,3", lines=ii-15) | scan (center, refpix)
		fields (dfile, fields="2", lines=ii-14) | scan (low)
		fields (dfile, fields="2", lines=ii-13) | scan (high)
		if (verb) print("Center=", center, " Low=", low, " High=", high, " Refpix=", refpix, " Step=", istep)
		}
	if (ans == "coefficients") {
		fields (dfile, fields="2", lines=ibegin+5) | scan (nlines)
        	cline=str(ibegin+6)//"-"//str(ibegin+5+nlines)
	}
	fields (dfile, fields="2", lines=ii) | scan (ncoef) 
	ncoef = ncoef - 4
	fields (dfile, fields="1", lines=ii+1) | scan (nfunc) 
	fields (dfile, fields="1", lines=ii+2) | scan (norder) 
	fields (dfile, fields="1", lines=ii+3) | scan (ymin) 
	fields (dfile, fields="1", lines=ii+4) | scan (ymax) 
	if (y1 != 0) {ymin = real(y1)}
	if (y2 != 0) {ymax = real(y2)}
        for (k=1; k <= ncoef; k = k + 1) {
        fields (dfile, fields="1", lines=ii+4+k) | scan (cc[k])
	if (verb) print(k, " ",cc[k])
        }
	switch (nfunc) {
	case 1:
		func = "chebyshev"
	case 2:
		func = "legendre"
	case 3:
		func = "spline3"
	case 4:
		func = "spline1"
	}
	#} 
	#} }
	if (verb) print("ID=", id, " Function=", func, " Line=",ii, " norder=",norder, " MinMax=[", ymin, ymax,"]")

	datfil = ofil//".dat"; delete (datfil, ver-, >& "dev$null")
	if (suffix == "ap"){
	print("# Region file format: DS9 version 4.1", >> regfil)
	print("global color=green dashlist=8 3 width=1 select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1", >> regfil)
	print("image", >> regfil)
	}
	ipix = 0
	#procedure calcfunc(func, cc, norder, ymin, ymax, istep, center, low, high, suffix)
        for (k = int(ymin)-1; k <= int(ymax)-1; k = k + 1) {
	ipix = ipix + 1
        y = real(k)
	if (ipix == 1 && suffix == "ap"){y = refpix}
        n = (2.0*y - (ymax + ymin))/(ymax - ymin)
        yfit = 0.0

	if (func == "spline3" || func == "spline1"){
        s = real(norder)*(y - ymin)/(ymax - ymin); j = int(s)
        aa = real(j)+1.0 - s; bb = s - real(j)
	}
	if (func == "spline1"){yfit = cc[j+1]*aa + cc[j+1+1]*bb}
	if (func == "spline3"){
        zz[1] = aa**3
        zz[2] = 1.0 + 3.0*aa*(1.0 + aa*bb)
        zz[3] = 1.0 + 3.0*bb*(1.0 + aa*bb)
        zz[4] = bb**3
        for (i = 1; i <= 4; i = i + 1) { yfit = yfit + cc[i+j]*zz[i] }
	}

	if (func == "chebyshev") {
        zz[1] = 1; zz[2] = n 
        for (i = 1; i <= norder; i = i + 1) {
		if (i>2){zz[i] = 2.0*n*zz[i-1] - zz[i-2]}
                yfit = yfit + cc[i]*zz[i]
        }
        }

	if (func == "legendre") {
        zz[1] = 1; zz[2] = n 
        for (i = 1; i <= norder; i = i + 1) {
		#if (i>2){zz[i] = (2.0*real(i-3))*n*zz[i-1] - real(i-2)*zz[i-2]/real(i-1)}
		#if (i>2){zz[i] = ((2.0*real(i-3))*n*zz[i-1] - real(i-2)*zz[i-2])/real(i-1)}
		if (i>2){zz[i] = ((2.0*real(i)-3.0)*n*zz[i-1] - real(i-2)*zz[i-2])/real(i-1)}
                yfit = yfit + cc[i]*zz[i]
        }
        }

	if (ipix == 1 && suffix == "ap"){shift = center - yfit} else {
	yfit = shift + yfit + real(i1) - 1.0
        print (y, yfit, >> datfil)

	if (suffix == "ap"){
        if (boxtyp == "box" && mod(k, istep) == 0){comm1 = "box("//str(yfit+low+high)//","//str(y)//","//str(high-low)//","//str(istep)//","//str(0)//")";   print(comm1, >> regfil) } 

	}
	}    #ipix!=1

	}    #k

	if (verb) {
        graph (datfil, wx1=ymin*0.9, wx2=1.1*ymax, wy1 = INDEF, wy2=INDEF, pointmode-,szmarke=0.02, marker = "circle")
	if (suffix == "id"){
	fields (dfile, fields="1,2", lines=cline) | graph (append+,  pointmode+, szmarke=0.02, marker = "circle")} else { print("The function stored in XY table = ", datfil, " and ds9 region ", boxtyp, " file = ",regfil)}
	}

	#----------------------  popygon generator
	if (suffix == "ap" && boxtyp != "box"){
	if (verb) print(k, low, high)
        comm1 = "polygon("
        comm_left = ""
        comm_right = ""
        for (k = int(ymin); k <= int(ymax)-1; k = k + istep) {
        fields (datfil, fields="2", lines=k) | scan (yfit)
	y = yfit+low; printf("%6.1f", y) | scan(ystr)
	#print(k, yfit, y, ystr)
        comm_left = comm_left//ystr//","//str(k)//","
	}
        comm_left = comm_left//ystr//","//str(ymax)//","

        for (k = int(ymax); k >= int(ymin)+istep; k = k - istep) {
        fields (datfil, fields="2", lines=k) | scan (yfit)
	y = yfit+high; printf("%6.1f", y) | scan(ystr)
	#print(k, yfit, y, ystr)
        comm_right = comm_right//ystr//","//str(k)//","
	}
	comm1 = "polygon("//comm_left//comm_right//ystr//","//str(ymin)//")"
	#print("polygon("//comm_left, >> regfil)
	#print(comm_right//str(y)//","//str(ymin)//")", >> regfil)
	print(comm1, >> regfil)
	}

	}  # id=irec
	}}}    # coeff, line, EOF  

        if (suffix == "ap"){
        print("The function stored in XY table = ", datfil, " and ds9 region ", boxtyp, " file = ",regfil)}

end
