procedure  plotspe(spelist)

string  spelist	= "spe.lis"   		{prompt="List File containing spectra to plot"}
int	window 	= 3   			{prompt="Smoothing window size in pixels"}
real	wx1 	= 4000.0		{prompt="First wavelength [Ang] to plot"}
real	wx2 	= 6000.0		{prompt="Last wavelength [Ang] to plot"}
real	wy1 	= 0.0			{prompt="Lowest flux to plot"}
real	wy2 	= 0.0			{prompt="Highest flux to plot"}
real	frac	= 0.05			{prompt="Fractional separation"}
bool	ylog	= no			{prompt="Plot y-axis log flux?"}


begin
	string	fillis, infil, tfil, tfil1, tmp
	int	i1, xw, ic, ip
	real	fcont_ref, fcont, fact, ff
	bool	fluxlog, append
	real	wxl, wxr, wyb, wyt


	fillis = spelist; xw = window; ff = frac; fluxlog = ylog
	append = yes
	wxl = wx1; wxr = wx2; wyb = wy1; wyt = wy2
	if (fluxlog) {wyb = log10(wyb); wyt = log10(wyt)}
	tfil = "plotspe_boxcar_smooth"
	tfil1 = "plotspe_boxcar_smooth1"

        i1 = 0; ip = 0
        list = fillis
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (tmp != "#") {
	        ip = ip + 1
		ic = mod(ip-1, 9) + 1
		i1 = fscanf(line, "%s ", infil)
        	imdelete (tfil, ver-, >& "dev$null")
		boxcar(infil, tfil, xw=xw, yw=1)
		if (fluxlog) {
        		imdelete (tfil1, ver-, >& "dev$null")
			sarith (tfil, "log", "", tfil1, verbose-) 
			imdelete (tfil, ver-, >& "dev$null"); imrename(tfil1, tfil, verbose-)
			}
		imstat (tfil, fields="midpt", nclip=9, format-) | scan(fcont)
		if (ip == 1){
			append = no; fcont_ref = fcont; fact = 1.0 
			if (fluxlog) {fact = log10(fact)}
			#if (fluxlog) {fcont_ref = 10**fcont; fact = 10**(fact)}
			} else {
			append = yes
			#fact = (1.0-ff*real(ip))*fcont/fcont_ref
			#fact = ((1.0-ff)**real(ip))*fcont_ref/fcont
			if (fluxlog) {
			fact = real(ip-1)*log10(1.0-ff) + fcont_ref - fcont; sarith (tfil, "+", fact, tfil1, verbose-)
			} else {
			fact = ((1.0-ff)**real(ip))*fcont_ref/fcont; sarith (tfil, "*", fact, tfil1, verbose-)
			}
			imdelete (tfil, ver-, >& "dev$null"); imrename(tfil1, tfil, verbose-)
			}

		if (ip == 1){print("#   fact    fcont     fcont_ref    spectrum")}
		if (fluxlog) {
		   printf("%d %7.3f %8.3f %8.3f %s \n", ip, fact, fcont, fcont_ref, infil)
		} else {
		   printf("%d %7.3f %12.5e %12.5e %s \n", ip, fact, fcont, fcont_ref, infil)
		}

		graph (tfil, wx1=wxl, wx2=wxr, wy1=wyb, wy2=wyt, app=append, colors=ic, logy-, wcs="world")

		#imstat (tfil, fields="midpt", nclip=5, format-) | scan(fcont_ref)
		#graph (tfil, wx1=wx1, wx2=wx2, wy1=wy1, wy2=wy2, app-, colors=ic, logy=fluxlog)
		#	} else {
		#imstat (tfil, fields="midpt", nclip=5, format-) | scan(fcont)
		#fact = (1.0-ff*real(ip))*fcont/fcont_ref
        	#imdelete (tfil1, ver-, >& "dev$null")
		#sarith (tfil, "*", fact, tfil1, verbose-)
		#graph (tfil1, app+, colors=ic, logy=fluxlog)
		#}
	
	}}

end
