procedure rd_mflux(fitsroot, beg, last)

#Fits file names are expected to be cartwheel_spec_1, cartwheel_spec_2 etc..

string  fitsroot  = "cartwheel_spec_"           {prompt="Input root filename to measure flux"}
int     beg     = 1                     	{prompt="Start object no"}
int     last    = 1                     	{prompt="Last object no"}
string  fitsout = "cartwheel_mfluxanal_"        {prompt="Output root filename"}
bool    inter   = yes                   	{prompt="Fit the continuum interactively?"}
string  linelist="neblines_cartwheel.dat"       {prompt="List containing lines to be measured"}
string  parfil  = "mfluxanal.par"               {prompt="File with Physical parameters to be calculated"}
string  veltype = "9090"                	{prompt="Velocity for Doppler correction [none|mean|median|value in km/s]"}
real    snrgood = 3.0                  		{prompt="Minimum SNR of a GOOD line"}
real    errfwhm = 2.0                 		{prompt="Good FWHM range is FW_Hb/errfw to FW_Hb*errfw for a GOOD line"}
#real    basepix = 5.0                   	{prompt="Basewidth of a line in pixeles"}
real	fwhmlin  = 3.0                 		{prompt="Expected FWHM of a resolved line [Ang]"}
string  dispkey = "CD1_1"              		{prompt="Dispersion Keyword [CDELT1/CD1_1 etc]"}
bool    skip_calc=no                    	{prompt="Skip mfluxcalc?"}
bool    skip_anal=no                    	{prompt="Skip mfluxanal?"}
bool    resetpar =yes                   	{prompt="Reset mfluxcalc and mfluxanal parameters?"}

begin

	string	filin, filout, para[30], tmp, datfil, vel_type, parfile
	string	s1 #, s2, s3, s4, s5, s6, s7, s8, s9
	real	snr, fw, ew, pp[33], pe[33]
	int	i1, i2, j, i, iob, ib, nlin, pf[33]
	bool	ask, parset, no_calc, no_anal, obj_found
	struct	line

	i1 = beg; i2 = last; filin = fitsroot; filout = fitsout; ask = inter
	no_calc = skip_calc; no_anal = skip_anal
	parset = resetpar; vel_type = veltype

	datfil = "mflux_lines.dat"
	delete(datfil, ver-, >& "dev$null")

	parfile = parfil
	if (!access(parfile)){print (" PARFIL=", parfile, " not found. Enter a valid filname: "); scan(parfile)}
	if (parset){
	  mfluxcalc.snrgood=snrgood.; mfluxcalc.errfwhm=errfwhm; mfluxcalc.lammin=INDEF; mfluxcalc.lammax=INDEF 
	  mfluxcalc.skyshi=no; mfluxcalc.sample="*"; mfluxcalc.fwhmlin=fwhmlin; mfluxcalc.dispkey=dispkey
	  #mfluxcalc.exttype="hbeta"; mfluxcalc.skyshi=no; mfluxcalc.sample="*"; mfluxcalc.basepix=basepix
	  mfluxanal.fibnum=1; mfluxanal.parfil=parfile 
	}

	#mfluxcalc.linelis="neblines_cartwheel.dat"; mfluxcalc.veltype=9090.

	para[1] = "5007"
	para[2] = "HeII"
	para[3] = "4658"
	para[4] = "4711"
	para[5] = "4740"
	para[6] = "5200"
	para[7] = "5755"
	para[8] = "5876"
	para[9] = "6300"
	para[10] = "6312"
	para[11] = "Ha"
	para[12] = "6583"
	para[13] = "6678"
	para[14] = "6717"
	para[15] = "6731"
	para[16] = "7135"
	para[17] = "7319"
	para[18] = "7330"
	para[19] = "7751"
	para[20] = "P10"
	para[21] = "9069"
	nlin = 21

	for (j=i1; j <= i2; j +=1) {
	#print (j)
	if (!no_calc){
		delete(filin//str(j)//"_ap1_1_fluxobs.dat", ver-, >& "dev$null") 
		mfluxcalc (filin//str(j), inter=ask, linelis=linelist, veltype=vel_type, watch-)
		match ("Velocity", filin//str(j)//"_ap1_1_fluxobs.dat") | scan (s1, s1, s1, s1, s1, s1, s1, s1, vel_type)
		#print (s1, s2, s3, s4, s5, s6, s7, " ", s8, " ", s9, " ", s1, " ", s2)
		delete(filin//str(j)//"_ap1_1_fluxobs.dat", ver-, >& "dev$null") 
		mfluxcalc (filin//str(j), inter=ask, linelis=linelist, veltype=vel_type)
		}
	#if (!no_anal){mfluxanal (filin//str(j)//"_ap1_1_fluxobs.dat", outfil=filout//str(j), silent+, snrgood=snrgood, errfwhm=errfwhm)
	if (!no_anal){mfluxanal (filin//str(j)//"_ap1_1_fluxobs.dat", outfil=filout//str(j), silent+)
	#} 
	  for (i=1; i <= nlin+3; i +=1) {
	    pp[i] = 0.0; pe[i] = 0.0; pf[i] = 0.0
	  }

	iob = 0; ib = 999
		obj_found = no
        #datfil2 = filroot//"_fluxpar.dat"; datfil1 = filroot//"_fluxlog.dat"; datfil3=filroot
        list = filout//str(j)//"_fluxlog.dat"
	if (!access(list)){print ("File ", list, " not found")}
        #list = filout//str(j)//".log"
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
	iob = iob + 1
        if (tmp == "#"){
          if (substr(line, 2, 9) == "Velocity"){
		print(substr(line, 2, strlen(line))) | fields (fields="7,9", line=1) | scan (pp[1], pe[1])
		} 
          if (substr(line, 2, 6) == "CHb ="){
		ib=iob+1 
		print(substr(line, 2, strlen(line))) | fields (fields="8,10", line=1) | scan (pp[2], pe[2])
		print(substr(line, 2, strlen(line))) | fields (fields="13,15", line=1) | scan (pp[3], pe[3])
		#print (pp[2], pe[2], pp[3], pe[3])
		} 
	} else if (iob > ib) {
	  print(substr(line, 2, strlen(line))) | match ("Hb") | fields (fields="7-9", line=1) | scan (snr, fw, ew)
	  for (i=1; i <= nlin; i +=1) {
	    #print(substr(line, 2, strlen(line))) | match (para[i]) | fields (fields="5-6", line=1) | scan (pp[3+i], pe[3+i])
	    print(substr(line, 2, strlen(line))) | match (para[i]) | fields (fields="5-6,10", line=1) | scan (pp[3+i], pe[3+i], pf[3+i])
	    if (pf[3+i] == 0){pp[3+i] = 0.0}
	  }
		obj_found = yes
		}
	}

	if (j == 1){print ("Obj Velo   eVel   Av   eAv     f_Hb   eHb    snr_Hb  FWHM    EW     F5007   eF ")}
	printf ("%d %8.1f %4.1f %5.2f %5.2f %8.3f %6.3f %7.1f %5.2f %7.1f %7.1f %4.1f \n", j, pp[1], pe[1], pp[2], pe[2], pp[3], pe[3], snr, fw, ew, pp[4], pe[4])
	if (j == 1){
	print ("#Columns 1-10 Basic parameters; Columns 11-12 [OIII]5007", >> datfil)
	printf ("#Ob Velo   eVel   Av   eAv     f_Hb   eHb    snr_Hb  FWHM    EW     F5007   eF  13=%s 15=%s 17=%s 19=%s 21=%s 23=%s 25=%s 27=%s 29=%s 31=%s 33=%s 35=%s 37=%s 39=%s 41=%s 43=%s 45=%s 47=%s 49=%s 51=%s \n", para[2], para[3], para[4], para[5], para[6], para[7], para[8], para[9], para[10], para[11], para[12], para[13], para[14], para[15], para[16], para[17], para[18], para[19], para[20], para[21], >> datfil)}
		#print (obj_found)
	if (obj_found){
	printf ("%d %8.1f %4.1f %5.2f %5.2f %8.3f %6.3f %7.1f %5.2f %7.1f %7.1f %4.1f", j, pp[1], pe[1], pp[2], pe[2], pp[3], pe[3], snr, fw, ew, pp[4], pe[4], >> datfil)
	printf ("%7.3f %5.3f %7.3f %5.3f %7.3f %5.3f %7.3f %5.3f %7.3f %5.3f", pp[5], pe[5], pp[6], pe[6], pp[7], pe[7], pp[8], pe[8], pp[9], pe[9], >> datfil)
	printf ("%7.3f %5.3f %7.3f %5.3f %7.3f %5.3f %7.3f %5.3f %7.2f %5.2f", pp[10], pe[10], pp[11], pe[11], pp[12], pe[12], pp[13], pe[13], pp[14], pe[14], >> datfil)
	printf ("%7.2f %5.2f %7.3f %5.3f %7.3f %5.3f %7.3f %5.3f %7.3f %5.3f", pp[15], pe[15], pp[16], pe[16], pp[17], pe[17], pp[18], pe[18], pp[19], pe[19], >> datfil)
	printf ("%7.3f %5.3f %7.3f %5.3f %7.3f %5.3f %7.3f %5.3f %7.3f %5.3f \n", pp[20], pe[20], pp[21], pe[21], pp[22], pe[22], pp[23], pe[23], pp[24], pe[24], >> datfil)
	}
	}
	}

end
