procedure rdsbands(logfil)

string  logfil   = "powr_sbands_gal_wc.log" 	{prompt="Sbands log file Name"}
real	lummin   = 30.0					{prompt="Min bump luminosity [erg/s]"}
string  filout   = "sbands_wr.log" 			{prompt="Output filename"}

begin
	string	bbsplog, output, header
	real	powr_lbol, powr_Mbol, vflux_vega, powr_vmag, powr_bc, fluxmin, lumfaclg, lumzero
	real	f555w, bbflux, bcont, bindex, bew, rbflux, rcont, rindex, rew
	real	logTeff, logRt, bbflux1, bblum1, rbflux1, rblum1  
	int     i, k, nrowbb, niter, nTb, nRb, i1
	#real	center, cont, flux, eqw, logTeff, logRt 
	#real	fluxbb, fluxrb, fluxmin, lumfaclg, lumzero
	#int 	i, k, i1, nTb, nRb, nTr, nRr, nrowbb, nrowrb, niter
	#struct  header

	bbsplog = logfil; lumzero = lummin; output = filout
	vflux_vega = 3.63E-09; powr_lbol = 5.3
	powr_Mbol = -2.5*powr_lbol + 4.83
	#lumfac = 4.0*PI*(10.0*3.0857E18)**2
	lumfaclg = log10(4.0*PI) + 2.0*log10(10.0*3.086E+18)
	fluxmin = 10**(lumzero - lumfaclg)

	wc (bbsplog) | scan(nrowbb)
	if (mod(nrowbb,16) != 0){
          print("Number of lines in the input not multiple of 16. Check the input file.")
          goto exit
        }
	niter = nrowbb/16
	print(nrowbb, niter)

	i = 0
        for (k = 1; k <= niter; k = k + 1) {
	#while( fscan(list, line) != EOF ) {
	i = i + 14
        fields (bbsplog, fields="1,3", lines=i) | scan (header, f555w)
        i1 = strstr("-", header)
        nTb = int(substr(header, i1-2, i1-1))
        nRb = int(substr(header, i1+1, i1+2))
        logTeff = (4.9 + 0.05*real(nTb-11))
        logRt = (1.5 - 0.1*real(nRb-6))

	i = i + 1
        fields (bbsplog, fields="3,5-7", lines=i) | scan (bbflux, bcont, bindex, bew)
	i = i + 1
        fields (bbsplog, fields="3,5-7", lines=i) | scan (rbflux, rcont, rindex, rew)
        #fields (bbsplog, fields="1-", lines=i) | fields (fields="3,5-7", lines=1) | scan (rbflux, rcont, rindex, rew)

	powr_vmag = -2.5*log10(f555w/vflux_vega)
	powr_bc = powr_Mbol - powr_vmag

	bbflux1 = abs(bew)*bcont
	rbflux1 = abs(rew)*rcont
	bblum = log10(max(bbflux1, fluxmin)) + lumfaclg
	rblum = log10(max(rbflux1, fluxmin)) + lumfaclg

	#print (center, cont, flux, eqw, logTeff, logRt, nT, nR)
	printf ("%10.5e %10.5e %10.5e  %9.5f %9.4f %10.5e %10.5e  %9.5f %9.4f %8.3f %8.3f %3d %3d %8.3f %8.3f \n", f555w, bbflux, bcont, bindex, bew, rbflux, rcont, rindex, rew, powr_vmag, powr_bc, nTb, nRb, bblum, rblum, >> output)
	}
exit:
	print ("Done")

end
