procedure rdsplot(filbb, filrb)

string  filbb    = "gal_wne_bb_splot_auto_lineflux.log" {prompt="Blue bump File Name"}
string  filrb    = "gal_wne_rb_splot_auto_lineflux.log" {prompt="Red  bump File Name"}
real	lummin   = 30.0					{prompt="Min bump luminosity [erg/s]"}
string  filout   = "splot_lum.log" 			{prompt="Output filename"}

begin
	string	bbsplog, rbsplog, output
	real	center, cont, flux, eqw, logTeff, logRt 
	real	fluxbb, fluxrb, fluxmin, lumfaclg, lumzero
	int 	i, k, i1, nTb, nRb, nTr, nRr, nrowbb, nrowrb, niter
	struct  header

	bbsplog = filbb; rbsplog = filrb; lumzero = lummin
	output = filout
	#lumfac = 4.0*PI*(10.0*3.0857E18)**2
	lumfaclg = log10(4.0*PI) + 2.0*log10(10.0*3.086E+18)
	fluxmin = 10**(lumzero - lumfaclg)

	wc (bbsplog) | scan(nrowbb)
	wc (rbsplog) | scan(nrowrb)
	if (nrowbb != nrowrb || mod(nrowbb,4) != 0){
          print("Blue and Red bump files do not correspond to the same Teff and Rt")
          goto exit
        }
	niter = nrowbb/4
	print(nrowbb, nrowrb)

	i = 0
        for (k = 1; k <= niter; k = k + 1) {
	#while( fscan(list, line) != EOF ) {
	i = i + 2
        fields (bbsplog, fields="1-", lines=i) | scan (header)
	i1 = strstr("-", header)
	nTb = int(substr(header, i1-2, i1-1))
	nRb = int(substr(header, i1+1, i1+2))
        fields (rbsplog, fields="1-", lines=i) | scan (header)
	i1 = strstr("-", header)
	nTr = int(substr(header, i1-2, i1-1))
	nRr = int(substr(header, i1+1, i1+2))
	if (nTb != nTr || nRb != nRr) {
	  print("Blue and Red bump files do not correspond to the same Teff and Rt")
	  goto exit
	}
	#Teff = 10**(4.9 + 0.05*real(nT-11))
	logTeff = (4.9 + 0.05*real(nTb-11))
	logRt = (1.5 - 0.1*real(nRb-6))
	#print(i, " ",header)
	i = i + 2
        fields (bbsplog, fields="1-4", lines=str(i)) | scan (center, cont, flux, eqw)
	#fluxbb = max(flux, fluxmin)
	fluxbb = log10(max(flux, fluxmin)) + lumfaclg
        fields (rbsplog, fields="1-4", lines=str(i)) | scan (center, cont, flux, eqw)
	fluxrb = log10(max(flux, fluxmin)) + lumfaclg

	#print (center, cont, flux, eqw, logTeff, logRt, nT, nR)
	printf ("%8.3f %8.3f %8.2f %8.2f %3d %3d \n", fluxbb, fluxrb, logTeff, logRt, nTb, nRb, >> output)
	}
exit:
	print ("Done")

end
