procedure rdwrbumps(filbb, filrb, logfil)

string  filbb    = "gal_wne_bb_splot_auto_lineflux.log" {prompt="Blue bump File Name"}
string  filrb    = "gal_wne_rb_splot_auto_lineflux.log" {prompt="Red  bump File Name"}
string  logfil   = "powr_sbands_gal_wne.log"     	{prompt="Sbands log file Name"}
real	lummin   = 30.0					{prompt="Min bump luminosity [erg/s]"}
string  filout   = "powr_bumps_lum.dat" 			{prompt="Output filename"}

begin
	string	bbsplog, rbsplog, bbsband, output, header1
	real	center, cont, flux, eqw, logTeff, logRt 
	real	fluxbb, fluxrb, fluxmin, lumfaclg, lumzero
        real    powr_lbol, powr_Mbol, vflux_vega, powr_vmag, powr_bc
        real    f555w, bbflux, bcont, bindex, bew, rbflux, rcont, rindex, rew
        real    bbflux1, bblum1, rbflux1, rblum1
	int 	i, k, i1, nTb, nRb, nTr, nRr, nrowbb, nrowrb, niter
	int	nT, nR, niter_sb, nrowsb, i2, i3
	struct  header

	bbsplog = filbb; rbsplog = filrb; lumzero = lummin
	output = filout; bbsband = logfil
        vflux_vega = 3.63E-09; powr_lbol = 5.3
        powr_Mbol = -2.5*powr_lbol + 4.83
	#lumfac = 4.0*PI*(10.0*3.0857E18)**2
	lumfaclg = log10(4.0*PI) + 2.0*log10(10.0*3.086E+18)
	fluxmin = 10**(lumzero - lumfaclg)

	wc (bbsplog) | scan(nrowbb)
	wc (rbsplog) | scan(nrowrb)
	if (nrowbb != nrowrb || mod(nrowbb,4) != 0){
          print("Blue and Red bump files do not correspond to the same Teff and Rt")
          goto exit
        }
	niter = nrowbb/4

	wc (bbsband) | scan(nrowsb)
        niter_sb = nrowsb/16
        if (niter != niter_sb && mod(nrowsb,16) != 0){
          print("Number of lines in the input not multiple of 16 OR splot and sbands files not compatible. Check the input file.")
          goto exit
        }


	print(nrowbb, nrowrb, nrowsb, niter, niter_sb)
	print ("#BB_splot  RB_splot  lgTeff    lgRt  nT  nR   BB_sb    RB_sb     Mv     BC_v  BBEW_sb RBEW_sb   Mbol", >> output)
	#print ("#BB_splot RB_splot lgTeff lgRt nT nR BB_sband RB_sband  Mv  BC_v  BBEW_sband RBEW_sband Mbol", >> output)

	i = 0
	i2 = 0
        for (k = 1; k <= niter; k = k + 1) {
	i = i + 2
        fields (bbsplog, fields="1-", lines=i) | scan (header)
	i1 = strstr("-", header)
	nTb = int(substr(header, i1-2, i1-1))
	nRb = int(substr(header, i1+1, i1+2))
        fields (rbsplog, fields="1-", lines=i) | scan (header)
	i1 = strstr("-", header)
	nTr = int(substr(header, i1-2, i1-1))
	nRr = int(substr(header, i1+1, i1+2))
	if (nTb != nTr || nRb != nRr) {
	  print("Blue and Red bump files do not correspond to the same Teff and Rt")
	  goto exit
	}

        i2 = i2 + 14
        fields (bbsband, fields="1,3", lines=i2) | scan (header1, f555w)
        i3 = strstr("-", header1)
        nT = int(substr(header1, i3-2, i3-1))
        nR = int(substr(header1, i3+1, i3+2))
        i2 = i2 + 1
        fields (bbsband, fields="3,5-7", lines=i2) | scan (bbflux, bcont, bindex, bew)
        i2 = i2 + 1
        fields (bbsband, fields="3,5-7", lines=i2) | scan (rbflux, rcont, rindex, rew)
        if (nTb != nT || nRb != nR) {
          print("splot and sbands files do not correspond to the same Teff and Rt")
          goto exit
        }

	logTeff = (4.9 + 0.05*real(nTb-11))
	logRt = (1.5 - 0.1*real(nRb-6))
	i = i + 2
        fields (bbsplog, fields="1-4", lines=str(i)) | scan (center, cont, flux, eqw)
	fluxbb = log10(max(flux, fluxmin)) + lumfaclg
        fields (rbsplog, fields="1-4", lines=str(i)) | scan (center, cont, flux, eqw)
	fluxrb = log10(max(flux, fluxmin)) + lumfaclg

        powr_vmag = -2.5*log10(f555w/vflux_vega)
        powr_bc = powr_Mbol - powr_vmag

        bbflux1 = abs(bew)*bcont
        rbflux1 = abs(rew)*rcont
        bblum = log10(max(bbflux1, fluxmin)) + lumfaclg
        rblum = log10(max(rbflux1, fluxmin)) + lumfaclg

	#print (center, cont, flux, eqw, logTeff, logRt, nT, nR)
	printf ("%8.3f %8.3f %8.2f %8.2f %3d %3d %8.3f %8.3f %7.3f %7.3f %7.2f %7.2f %7.3f\n", fluxbb, fluxrb, logTeff, logRt, nTb, nRb, bblum, rblum, powr_vmag, powr_bc, bew, rew, powr_Mbol, >> output)
	}
exit:
	print ("Done")

end
