procedure       sfluxanal(infile)

string  infile  = "fluxobs.dat"            {prompt="Input filename to measure flux"}
string  outfil  = "sfluxcalc"          {prompt="Output filename containing calculated quantities"}
string  reflin  = "Ha"          	   {prompt="Reference line [Ha|Hb]"}
#string  redcurve="spanal$data/ext_interp.dat"  {prompt="Extinction curve normalized to Av"}
#string  exttype = "none"                {prompt="Av for extinction correction [none|Ha|Hg|Hd|He|mean|value in mag]"}
real    snrgood = 3.0                  {prompt="Minimum SNR of a line for velocity calculation"}
real    errfwhm = 20.0                  {prompt="Maximum error in FWHM wrt to Hbeta (in % units) for velocity calculation"}
real    absew   = 0.0                  {prompt="EW of absorption at the Reference line [eg. 2 Ang]"}
	
begin
	string	filein, datfil, dline[7], tmp, s1, lineid[99], refline
	string  datfil1, datfil2
        real    r1, r2, r3, r4, r5, r6, r7, r8, r9, spasum, lpix, rpix, ewcor
	real	bmag, bvmag, brmag
        real    goodsnr, fwhmerr, flux_ref, rr1, rr2, flux_ref_em, err_flux_ref_em
        real    wave[99], spe_snr[99], flux[99], ew[99], fwhm[99], fcont[99], uflux[99], flux_norm[99]
        real    uflux_norm[99], err_norm[99], spe_rms[99], flam[99], vel[99], vel_em, vel_ab
	real	area, rr3, rr4, rr5, rr6
	int	d1, i1, i2, i, iref, nb, idline[7], ig, spno, pixcen, ilin, nfil
	int	dd1, dd2, dd3, dd4, ihd, ngoodemline, ngoodabline, ihg, ihb
        bool    goodline[99]
        struct  line, comment

        filein = infile; datfil = outfil
	datfil1 = datfil//"_lin.dat"
	datfil2 = datfil//"_rad.dat"
        goodsnr = snrgood; fwhmerr = errfwhm; refline = strlwr(reflin); ewcor = absew

        #dline[1] = "[OII]3727"; dline[2] = "[SII]6717"; dline[3] = "[SII]6731"
        #dline[4] = "[OIII]500"; dline[5] = "[NII]6583"; dline[6] = "[OI]6300"   #dline[6] = "[NII]5755"
        dline[1] = "[SII]6717"; dline[2] = "[SII]6731"
        dline[3] = "[OIII]500"; dline[4] = "[NII]6583"   #; dline[5] = "Hb"   #dline[6] = "[NII]5755"
        for (i=1; i <= 6; i +=1) {idline[i] = 0}

        delete(datfil1, ver-, >& "dev$null")
        delete(datfil2, ver-, >& "dev$null")

        print("##########################################################", >> datfil1)
        #date (, >> datfil1)
        printf("%s", "#DATE ", >> datfil1); date (, >> datfil1)
	type (datfil1, map_cc+, device = "terminal", >> datfil2)
	#copy (datfil1, datfil2, verbose-)

        iref = 0
        i1 = 0
	ngoodemline = 0; ngoodabline = 0
	spno = 0  #; spasum = 0; pixcen = 0; d1 = 0; lpix = 0.0; rpix = 0.0
	#d2 = 0; d3 = 0; d4 = 0; r1 = 0.0; r2 = 0.0
        list = filein
        while(fscan(list, line) != EOF ) {
        tmp = substr (line, 1, 1)
        if (substr (line, 1, 5) == "#SLIT") {
	  i2 = fscanf(line, "%s %d %d %f %d %d %f %f %f %f %d\n", s1, dd1, dd2, rr1, dd3, dd4, rr2, rr3, rr4, rr5, nfil)
	  if (nfil == 3){
	  i2 = fscanf(line, "%s %d %d %f %d %d %f %f %f %f %d %f %f %f\n", s1, dd1, dd2, rr1, dd3, dd4, rr2, rr3, rr4, rr5, nfil, rr4, rr5, rr6)
	  }
	  #print("Spectrum no = ", spno, pixcen, lpix, rpix)
	  #print("Spectrum no = ", d1, d2, d3, r1, r2)
	  i1 = 0
	  #i1 = 1

	  }
	  #print("Spectrum no = ", d1, d2, d3, r1, r2)
          if (tmp != "#" && tmp != "") {
          i1=i1+1
	  if (i1 == 1){
	  spno = dd1; spasum = dd2; pixcen = dd3; lpix = rr2; rpix = rr3; area = rr1
	  if (nfil == 3){bmag = rr4; bvmag = rr5; brmag = rr6; printf("%6.2f %6.2f %6.2f\n", bmag, bvmag, brmag) | scan(comment); print(comment)}
	  }
          goodline[i1] = yes
          i2 = fscanf(line, "%s %d %f %f %f %f %f %f %f %f %f \n", s1, d1, r1, r2, r3, r4, r5, r6, r7, r8, r9)
          lineid[i1] = substr(s1,strldx(" ",s1)+1, strlen(s1)); wave[i1] = r1
          spe_snr[i1] = r3; flux[i1] = r6/area; ew[i1] = r7; fwhm[i1] = r8; fcont[i1] = r9/area
	  vel[i1] = r5
          if (spe_snr[i1] < goodsnr) {goodline[i1] = no}
          if (strlwr(substr(lineid[i1], 1, 2)) == "hd"){ihd = i1}
          if (strlwr(substr(lineid[i1], 1, 2)) == "hg"){ihg = i1}
          if (strlwr(substr(lineid[i1], 1, 2)) == "hb"){ihb = i1}
          #if (strlwr(substr(lineid[i1], 1, 2)) == "ha"){iref = i1}
          if (strlwr(substr(lineid[i1], 1, 2)) == refline){iref = i1}
	#print (iref)
	#print(line)
          spe_rms[i1] = flux[i1]/spe_snr[i1]
          uflux[i1] = goodsnr*spe_rms[i1]
        if (goodline[i1] && ew[i1] > 2.0) {print(vel[i1], >> "sfluxanal_em.vel"); ngoodemline = ngoodemline +1}
        if (goodline[i1] && ew[i1] < -2.0) {print(vel[i1] , >> "sfluxanal_ab.vel"); ngoodabline = ngoodabline +1}

          #for (i=1; i <= 6; i +=1) {
          for (i=1; i <= 4; i +=1) {
                if (strupr(substr(lineid[i1], 1, 9)) == dline[i]){idline[i] = i1}  #; print(i1, lineid[i1])}
                }
	ilin = i1
        }
	if (i1 == 0 && iref != 0){

	if (access("sfluxanal_em.vel")) {
	  tstat("sfluxanal_em.vel", >& "dev$null"); vel_em = tstat.median
          printf("Emission   Velocity: mean = %8.1f =/- %8.1f median= %8.1f lines= %d\n", tstat.mean, tstat.stddev, tstat.median, tstat.nrows)
	} else {vel_em = 0.0}

        if (access("sfluxanal_ab.vel")) {
	tstat("sfluxanal_ab.vel", >& "dev$null"); vel_ab = tstat.median
        printf("Absorption Velocity: mean = %8.1f =/- %8.1f median= %8.1f lines= %d\n", tstat.mean, tstat.stddev, tstat.median, tstat.nrows)
	} else {vel_ab = 0.0}

        #flux_ref = flux[iref]
	flux_ref = (ew[iref] + ewcor)*fcont[iref]
	if (flux_ref == 0.0){flux_ref = flux[iref]}
        flux_ref_em = flux_ref/2.0E-18
        err_flux_ref_em = spe_rms[iref]/2.0E-18
        #print(i1, "Hbeta index = ", iref, " ", flux_ref)
        #print(i1, refline, " index = ", iref, " ", flux_ref)
	  print("Spectrum ## = ", spno, pixcen, lpix, rpix, iref, ilin, refline, " ", flux_ref, flux_ref_em, comment)
	  print("#Spectrum no = ", spno, pixcen, lpix, rpix, iref, ilin, refline, " ", flux_ref, flux_ref_em, comment, >> datfil1)
        for (i=1; i <= ilin; i +=1) {
        #if (gfwhm > max_fwhm || gfwhm < min_fwhm ) {goodline[i] = no}
        flux_norm[i] = 100.0*flux[i]/flux_ref
        uflux_norm[i] = 100.0*uflux[i]/flux_ref
        properr(flux[i], flux_ref, "/", spe_rms[i], spe_rms[iref], rab = 1.0, verb-)
        err_norm[i] = 100.0*properr.sig
	if (flux_norm[i] > 999.0){flux_norm[i] = 999.0}
	if (err_norm[i] > 999.0){err_norm[i] = 999.0}
	if (i == iref){err_norm[i] = 100.0*spe_rms[iref]/flux[iref]}
        if (goodline[i])printf("%d %12s %8.2f %8.3f %8.3f %8.1f %8.3f %d\n", i, lineid[i], wave[i], flux_norm[i], err_norm[i], vel[i], uflux_norm[i], goodline[i], >> datfil1)
	}
	#printf("%d %d %12.4e %8.2f %8.2f %8.2f %8.2f %8.2f %8.2f \n", spno, pixcen, flux_ref, flux_norm[idline[1]], flux_norm[idline[2]], flux_norm[idline[3]], flux_norm[idline[4]], flux_norm[idline[5]], flux_norm[idline[6]], >> datfil2)
	#printf("%3d %4d %10.3e %6.1f %6.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %5.1f %5.1f %5.1f %s\n", spno, pixcen, flux_ref, flux_ref_em, err_flux_ref_em, flux_norm[idline[1]], err_norm[idline[1]], flux_norm[idline[2]], err_norm[idline[2]], flux_norm[idline[3]], err_norm[idline[3]], flux_norm[idline[4]], err_norm[idline[4]], flux_norm[idline[5]], err_norm[idline[5]], flux_norm[idline[6]], err_norm[idline[6]], vel_em, vel_ab, ew[ihd], ew[ihg], ew[ihb], comment, >> datfil2)
	#printf("%3d %4d %10.3e %6.1f %6.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %5.1f %s\n", spno, pixcen, flux_ref, flux_ref_em, err_flux_ref_em, flux_norm[idline[1]], err_norm[idline[1]], flux_norm[idline[2]], err_norm[idline[2]], flux_norm[idline[3]], err_norm[idline[3]], flux_norm[idline[4]], err_norm[idline[4]], vel_em, vel_ab, ew[ihb], comment, >> datfil2)
        printf("%3d %4d %10.3e %6.1f %6.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %5.1f %s\n", spno, pixcen, flux_ref, flux_ref_em, err_flux_ref_em, flux_norm[idline[1]], err_norm[idline[1]], flux_norm[idline[2]], err_norm[idline[2]], flux_norm[idline[3]], err_norm[idline[3]], flux_norm[idline[4]], err_norm[idline[4]], flux_norm[idline[ihb]], err_norm[idline[ihb]], vel_em, vel_ab, ew[ihb], comment, >> datfil2)

        iref = 0
	  delete("sfluxanal_em.vel", ver-, >& "dev$null")
	  delete("sfluxanal_ab.vel", ver-, >& "dev$null")
	  ngoodemline = 0; ngoodabline = 0
	  comment = ""
        }

        }

        print("Spectrum ## = ", spno, pixcen, lpix, rpix, iref, ilin, refline, " ", flux_ref, flux_ref_em, comment)
        print("#Spectrum no = ", spno, pixcen, lpix, rpix, iref, ilin, refline, " ", flux_ref, flux_ref_em, comment, >> datfil1)
        #flux_ref = flux[iref]
	flux_ref = (ew[iref] + ewcor)*fcont[iref]
	if (flux_ref == 0.0){flux_ref = flux[iref]}
        flux_ref_em = flux_ref/2.0E-18
        err_flux_ref_em = spe_rms[iref]/2.0E-18
        for (i=1; i <= ilin; i +=1) {
        flux_norm[i] = 100.0*flux[i]/flux_ref
        uflux_norm[i] = 100.0*uflux[i]/flux_ref
        properr(flux[i], flux_ref, "/", spe_rms[i], spe_rms[iref], rab = 1.0, verb-)
        err_norm[i] = 100.0*properr.sig
        if (goodline[i])printf("%d %12s %8.2f %8.3f %8.3f %8.1f %8.3f %d\n", i, lineid[i], wave[i], flux_norm[i], err_norm[i], vel[i], uflux_norm[i], goodline[i], >> datfil1)
	}
	#printf("%3d %4d %10.3e %6.1f %6.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %5.1f %5.1f %5.1f %s\n", spno, pixcen, flux_ref, flux_ref_em, err_flux_ref_em, flux_norm[idline[1]], err_norm[idline[1]], flux_norm[idline[2]], err_norm[idline[2]], flux_norm[idline[3]], err_norm[idline[3]], flux_norm[idline[4]], err_norm[idline[4]], flux_norm[idline[5]], err_norm[idline[5]], flux_norm[idline[6]], err_norm[idline[6]], vel_em, vel_ab, ew[ihd], ew[ihg], ew[ihb], comment, >> datfil2)
	printf("%3d %4d %10.3e %6.1f %6.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %7.1f %5.1f %s\n", spno, pixcen, flux_ref, flux_ref_em, err_flux_ref_em, flux_norm[idline[1]], err_norm[idline[1]], flux_norm[idline[2]], err_norm[idline[2]], flux_norm[idline[3]], err_norm[idline[3]], flux_norm[idline[4]], err_norm[idline[4]], flux_norm[idline[ihb]], err_norm[idline[ihb]], vel_em, vel_ab, ew[ihb], comment, >> datfil2)

end
