procedure wr_model(wrfile)

string  wrfile  = "wr3_new_wr_n3_clean" {prompt="Observed WR filename"}
string  outmod  = "C2006_mod_mix_wr3"   {prompt="Mixed Output Model filename"}
string  wcemod  = "LMC_WC4a"    	{prompt="Model WCE filename"}
string  wnlmod  = "LMC_WN7_9"    	{prompt="Model WCN filename"}
string  wclmod  = "GAL_WC7_8"    	{prompt="Model WCE filename"}
real	mfunits	= 1.0E+35		{prompt="Model flux units"}
real	distance= 3.63 			{prompt="Distance in Mpc"}
real	contflux= 2.20E-16		{prompt="Continuum flux level"}
real    contslop= -8.5E-20      	{prompt="Continuum slope"}
real    contpix = 1782          	{prompt="Continuum pixel"}
real    nwce    = 1             	{prompt="No of WCEs"}
real    nwnl    = 1             	{prompt="No of WNLs"}
real    nwcl    = 0             	{prompt="No of WCEs"}
real    lammin  = 4400.0        	{prompt="Minimum lambda to plot in Ang"}
real    lammax  = 5990.0        	{prompt="Maximum lambda to plot in Ang"}
real    fluxmin = 1.0E-16        	{prompt="Minimum lambda to plot in Ang"}
real    fluxmax = 5.0E-16        	{prompt="Maximum lambda to plot in Ang"}
bool    ylog    = yes        		{prompt="Plot flux in log units?"}

begin
	string	wc4mod, wn79mod, wc78mod, outfil, wrfil, comm
	real	unit, dist, cflux, cslope, cpix, nwc4, nwn79, nwc78, fact
	real	xmin, xmax, ymin, ymax
	bool	flog

	wc4mod = wcemod; wn79mod = wnlmod; wc78mod = wclmod; outfil = outmod; wrfil = wrfile
	unit = mfunits; dist = distance; cflux = contflux
	cslope = contslop; cpix = contpix 
	xmin = lammin; xmax = lammax; ymin = fluxmin; ymax = fluxmax
	nwc4 = nwce; nwn79 = nwnl; nwc78 = nwcl; flog = ylog

	fact = unit/(4.0*PI*(3.0857E+24*dist)**2) 
	# =1.0E+35/(4.0*PI*(3.0857*3.63E+24)**2) + 3.0E-16

        imdelete(outfil, ver-, >& "dev$null")
	#comm = "("//str(nwc4)//"*a+"//str(nwn79)//"*b)*"//str(fact)//" + "//str(cflux)//" + "//str(cslope)//"*(I-"//str(cpix)//")"
	comm = "("//str(nwc4)//"*a+"//str(nwn79)//"*b+"//str(nwc78)//"*c)*"//str(fact)//" + "//str(cflux)//" + "//str(cslope)//"*(I-"//str(cpix)//")"
	print (comm)
	#imexpr (comm, outfil, wc4mod, wn79mod, verb-)
	imexpr (comm, outfil, wc4mod, wn79mod, wc78mod, verb-)
	graph (wrfil, wcs="world", pointmo-, ltypes=1, colors=1, append-, wx1=xmin, wx2=xmax, wy1=ymin, wy2=ymax, logy=flog)
	graph (outfil, wcs="world", pointmo-, ltypes=1, colors=2, logy=flog, append+)
end
