procedure wrnebsub(wrfile, nebfil, wrapno, nebapno)

string	wrfile	= "wr1_new1"	{prompt="Input WR filename"}
string	nebfil	= "wr1_new1"	{prompt="Input Nebular filename"}
int 	wrapno  = 1		{prompt="Aperture no of WR spectrum in wrfile"}
int 	nebapno = 2		{prompt="Aperture no of nebular spectrum in nebfile"}
real	lambda  = 5007.0	{prompt="Line lambda for normalizing flux"}
string  subtyp  = "scale"    	{prompt="Continuum subtraction type [scale|none]"}
real	ksigma  = 5.0		{prompt="Cutoff in units of sigma for good line pixels"}
real	lammin  = 3700.0	{prompt="Minimum good lambda in Ang"}
real	lammax  = 7600.0	{prompt="Maximum good lambda in Ang"}
bool	dopshi  = yes		{prompt="Correct for Doppler shift?"}
bool	inter   = yes		{prompt="Fit continumm interactively?"}
bool	skyshi  = yes		{prompt="Shift wavelength of spectrum using sky lines?"}
string  skyline	="spanal$data/skyline.dat"       {prompt="List containing sky lines to be measured"}

begin
	string	infile[2], wrfil, nebfil1, nebfil2, comm, sample
	string	splotfillog, ans, dopfil[3], csubtyp, jsec, imsec, outfil
	string	skylist
	real	xmin, xmax, krms, fact, factc, kclip, spe_snr[3]
        real   center, cont, flux, eqw, core, gfwhm, lfwhm, stddev, min, max
	real	spe_rms[3], rms1, rms2, flux_neb[3], wavnorm, velocity
	int 	rmsstep, jstep, npix, apno[2], i, j
	bool	dopcor, ask, skycor
        struct  line

	infile[1] = wrfile; infile[2] = nebfil; skylist = skyline 
	apno[1] = wrapno; apno[2] = nebapno; csubtyp = subtyp
	xmin = lammin; xmax = lammax; skycor = skyshi
	wavnorm = lambda; kclip = ksigma; ask = inter; dopcor = dopshi
	wrfil = infile[1]//"_wr"; outfil = wrfil//"_n"//str(apno[2])
	nebfil1 = infile[2]//"_ap"//str(apno[2])
	#nebfil1 = infile[2]//"_neb"//"_"//str(apno[2])
	#nebfil1 = infile//"_neb1" #nebfil2 = infile//"_neb2"
	#xmin=3700.0; xmax=7580.0
	sample = str(xmin)//":"//str(xmax)
	#----------------------------------------------------------------
        imdelete(wrfil, ver-, >& "dev$null")
        imdelete(nebfil1, ver-, >& "dev$null")
        #imdelete(nebfil2, ver-, >& "dev$null")

        for (j=1; j <= 2; j +=1) {
	if (skycor) {skyshift(infile[j], apnum=apno[j], skyline=skylist)}
	omlinefit(infile[j], xpos=apno[j], yposlit=wavnorm)
        splotfillog = "splot_auto_cont.log"
        fields (splotfillog, fields="4,6", lines=3) | scan (rms1, snr1)
        fields (splotfillog, fields="4,6", lines=4) | scan (rms2, snr2)
	spe_rms[j] = min(rms1, rms2)
	spe_snr[j] = max(rms1, rms2)
        splotfillog = "splot_auto_gaussfit.log"
        fields (splotfillog, fields="1-7", lines=4) | scan (center, cont, flux, eqw, core, gfwhm, lfwhm)
	print (spe_rms[j], spe_snr[j], center, flux, gfwhm)
	flux_neb[j] = flux
	if (dopcor) {
	dopfil[j] = infile[j]//"_dop"//str(j)
        imdelete(dopfil[j], ver-, >& "dev$null")
	velocity = 2.9979E+05 * (center - wavnorm)/wavnorm
	#print(velocity)
	dopcor (infile[j], dopfil[j], redsh=velocity, isvel+, add-, disp+, flux-, aper=apno[j], verb+)
	}
	}

	#scan(ans)
	scopy (dopfil[1], wrfil, w1=xmin, w2=xmax, apertur=apno[1], band=1, rebin+)
	scopy (dopfil[2], nebfil1, w1=xmin, w2=xmax, apertur=apno[2], band=1, rebin+)

        imdelete(dopfil[1], ver-, >& "dev$null")
        imdelete(dopfil[2], ver-, >& "dev$null")

	omsperms (wrfil, sample=sample, inter=ask)
	omsperms (nebfil1, sample=sample, inter=ask)

	#--------------------------------------------------
	fact = flux_neb[1]/flux_neb[2]
	factc = fact
	if (spe_snr[2] < 20.0) {factc = 1.0}
	if (csubtyp != "scale") {factc = 0.0}
	krms = kclip*spe_rms[2]
        #imdelete(wrfil//"_n1", ver-, >& "dev$null")
        imdelete(nebfil1//"_norm", ver-, >& "dev$null")
        imdelete(outfil, ver-, >& "dev$null")
	comm = "a>"//str(kclip)//"*b ? a*"//str(fact)//" + c*"//str(factc)//" : c*"//str(factc)
	#comm = "a>"//str(kclip)//"*b ? c-a*"//str(fact)//" : c-d*"//str(factc)
	#comm = "(a-b)>"//str(krms)//" ? c-a*"//str(fact)//" : c-b*"//str(factc)
	
	print(comm)
	imexpr (comm, nebfil1//"_norm", nebfil1//"_csub", nebfil1//"_rms", nebfil1//"_cont", verb-)
	imexpr("a-b", outfil, wrfil, nebfil1//"_norm", verb-)

	#imexpr("a-b-c", outfil, wrfil, nebfil1//"_norm", wrfil//"_cont")
	#imexpr (comm, outfil, nebfil1//"_csub", nebfil1//"_rms", wrfil, nebfil1//"_cont")
	#imexpr (comm, wrfil//"_n1", nebfil1, nebfil1//"_cont", wrfil)

	##splot (wrfil//"_n1", next_im=wrfil//"_n2")
	#splot (outfil, next_im=wrfil)
	speflag(wrfil, outfil)
	splot (outfil//"_clean", next_im=outfil)
	
end
